
ACLOCAL=
AUTOCONF=
AUTOMAKE=

# Check for aclocal-1.5

if [ -n "/usr/bin/aclocal-1.5" ] 
then
	ACLOCAL="/usr/bin/aclocal-1.5"
else
	ACLOCAL="NULL"
fi

# Check for autoconf-2.53

if [ -n "/usr/bin/autoconf-2.53" ]
then
	AUTOCONF="/usr/bin/autoconf-2.53"
else
	AUTOCONF="NULL"
fi

# Check for automake-1.5

if [ -n "/usr/bin/automake-1.5" ]
then
	AUTOMAKE="/usr/bin/automake-1.5"
else
	AUTOMAKE="NULL"
fi

# Now check if any of these variable are equal to null.
# If so, then we install our own autotools.

if [ "$ACLOCAL" = "NULL" ] || [ "$AUTOCONF" = "NULL" ] || [ "$AUTOMAKE" = "NULL" ]
then
	echo "ERROR: One or more component(s) is missing"
	echo "	aclocal: $ACLOCAL"
	echo "	autoconf: $AUTOCONF"
	echo "	automake: $AUTOMAKE"
	echo ""
	exit 0
else
	echo "All autotools components found"
fi

# Path is set, run aclocal,autoconf,automake

$ACLOCAL;$AUTOCONF;$AUTOMAKE --add-missing --copy

# Now execute the configure script
$PWD/configure

