## libtool.m4 - Configure libtool for the target system. -*-Shell-script-*-
## Copyright (C) 1996-1999, 2000 Free Software Foundation, Inc.
## Originally by Gordon Matzigkeit <gord@gnu.ai.mit.edu>, 1996
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
##
## As a special exception to the GNU General Public License, if you
## distribute this file as part of a program that contains a
## configuration script generated by Autoconf, you may include it under
## the same distribution terms that you use for the rest of that program.

# serial 40 AC_PROG_LIBTOOL
AC_DEFUN(AC_PROG_LIBTOOL,
[AC_REQUIRE([AC_LIBTOOL_SETUP])dnl

# Save cache, so that ltconfig can load it
AC_CACHE_SAVE

# Actually configure libtool.  ac_aux_dir is where install-sh is found.
CC="$CC" CFLAGS="$CFLAGS" CPPFLAGS="$CPPFLAGS" \
LD="$LD" LDFLAGS="$LDFLAGS" LIBS="$LIBS" \
LN_S="$LN_S" NM="$NM" RANLIB="$RANLIB" \
DLLTOOL="$DLLTOOL" AS="$AS" OBJDUMP="$OBJDUMP" \
${CONFIG_SHELL-/bin/sh} $ac_aux_dir/ltconfig --no-reexec \
$libtool_flags --no-verify $ac_aux_dir/ltmain.sh $lt_target \
|| AC_MSG_ERROR([libtool configure failed])

# Reload cache, that may have been modified by ltconfig
AC_CACHE_LOAD

# This can be used to rebuild libtool when needed
LIBTOOL_DEPS="$ac_aux_dir/ltconfig $ac_aux_dir/ltmain.sh"

# Always use our own libtool.
LIBTOOL='$(SHELL) $(top_builddir)/libtool'
AC_SUBST(LIBTOOL)dnl

# Redirect the config.log output again, so that the ltconfig log is not
# clobbered by the next message.
exec 5>>./config.log
])

AC_DEFUN(AC_LIBTOOL_SETUP,
[AC_PREREQ(2.13)dnl
AC_REQUIRE([AC_ENABLE_SHARED])dnl
AC_REQUIRE([AC_ENABLE_STATIC])dnl
AC_REQUIRE([AC_ENABLE_FAST_INSTALL])dnl
AC_REQUIRE([AC_CANONICAL_HOST])dnl
AC_REQUIRE([AC_CANONICAL_BUILD])dnl
AC_REQUIRE([AC_PROG_RANLIB])dnl
AC_REQUIRE([AC_PROG_CC])dnl
AC_REQUIRE([AC_PROG_LD])dnl
AC_REQUIRE([AC_PROG_NM])dnl
AC_REQUIRE([AC_PROG_LN_S])dnl
dnl

case "$target" in
NONE) lt_target="$host" ;;
*) lt_target="$target" ;;
esac

# Check for any special flags to pass to ltconfig.
#
# the following will cause an existing older ltconfig to fail, so
# we ignore this at the expense of the cache file... Checking this 
# will just take longer ... bummer!
#libtool_flags="--cache-file=$cache_file"
#
test "$enable_shared" = no && libtool_flags="$libtool_flags --disable-shared"
test "$enable_static" = no && libtool_flags="$libtool_flags --disable-static"
test "$enable_fast_install" = no && libtool_flags="$libtool_flags --disable-fast-install"
test "$ac_cv_prog_gcc" = yes && libtool_flags="$libtool_flags --with-gcc"
test "$ac_cv_prog_gnu_ld" = yes && libtool_flags="$libtool_flags --with-gnu-ld"
ifdef([AC_PROVIDE_AC_LIBTOOL_DLOPEN],
[libtool_flags="$libtool_flags --enable-dlopen"])
ifdef([AC_PROVIDE_AC_LIBTOOL_WIN32_DLL],
[libtool_flags="$libtool_flags --enable-win32-dll"])
AC_ARG_ENABLE(libtool-lock,
  [  --disable-libtool-lock  avoid locking (might break parallel builds)])
test "x$enable_libtool_lock" = xno && libtool_flags="$libtool_flags --disable-lock"
test x"$silent" = xyes && libtool_flags="$libtool_flags --silent"

# Some flags need to be propagated to the compiler or linker for good
# libtool support.
case "$lt_target" in
*-*-irix6*)
  # Find out which ABI we are using.
  echo '[#]line __oline__ "configure"' > conftest.$ac_ext
  if AC_TRY_EVAL(ac_compile); then
    case "`/usr/bin/file conftest.o`" in
    *32-bit*)
      LD="${LD-ld} -32"
      ;;
    *N32*)
      LD="${LD-ld} -n32"
      ;;
    *64-bit*)
      LD="${LD-ld} -64"
      ;;
    esac
  fi
  rm -rf conftest*
  ;;

*-*-sco3.2v5*)
  # On SCO OpenServer 5, we need -belf to get full-featured binaries.
  SAVE_CFLAGS="$CFLAGS"
  CFLAGS="$CFLAGS -belf"
  AC_CACHE_CHECK([whether the C compiler needs -belf], lt_cv_cc_needs_belf,
    [AC_TRY_LINK([],[],[lt_cv_cc_needs_belf=yes],[lt_cv_cc_needs_belf=no])])
  if test x"$lt_cv_cc_needs_belf" != x"yes"; then
    # this is probably gcc 2.8.0, egcs 1.0 or newer; no need for -belf
    CFLAGS="$SAVE_CFLAGS"
  fi
  ;;

ifdef([AC_PROVIDE_AC_LIBTOOL_WIN32_DLL],
[*-*-cygwin* | *-*-mingw*)
  AC_CHECK_TOOL(DLLTOOL, dlltool, false)
  AC_CHECK_TOOL(AS, as, false)
  AC_CHECK_TOOL(OBJDUMP, objdump, false)
  ;;
])
esac
])

# AC_LIBTOOL_DLOPEN - enable checks for dlopen support
AC_DEFUN(AC_LIBTOOL_DLOPEN, [AC_BEFORE([$0],[AC_LIBTOOL_SETUP])])

# AC_LIBTOOL_WIN32_DLL - declare package support for building win32 dll's
AC_DEFUN(AC_LIBTOOL_WIN32_DLL, [AC_BEFORE([$0], [AC_LIBTOOL_SETUP])])

# AC_ENABLE_SHARED - implement the --enable-shared flag
# Usage: AC_ENABLE_SHARED[(DEFAULT)]
#   Where DEFAULT is either `yes' or `no'.  If omitted, it defaults to
#   `yes'.
AC_DEFUN(AC_ENABLE_SHARED, [dnl
define([AC_ENABLE_SHARED_DEFAULT], ifelse($1, no, no, yes))dnl
AC_ARG_ENABLE(shared,
changequote(<<, >>)dnl
<<  --enable-shared[=PKGS]  build shared libraries [default=>>AC_ENABLE_SHARED_DEFAULT],
changequote([, ])dnl
[p=${PACKAGE-default}
case "$enableval" in
yes) enable_shared=yes ;;
no) enable_shared=no ;;
*)
  enable_shared=no
  # Look at the argument we got.  We use all the common list separators.
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:,"
  for pkg in $enableval; do
    if test "X$pkg" = "X$p"; then
      enable_shared=yes
    fi
  done
  IFS="$ac_save_ifs"
  ;;
esac],
enable_shared=AC_ENABLE_SHARED_DEFAULT)dnl
])

# AC_DISABLE_SHARED - set the default shared flag to --disable-shared
AC_DEFUN(AC_DISABLE_SHARED, [AC_BEFORE([$0],[AC_LIBTOOL_SETUP])dnl
AC_ENABLE_SHARED(no)])

# AC_ENABLE_STATIC - implement the --enable-static flag
# Usage: AC_ENABLE_STATIC[(DEFAULT)]
#   Where DEFAULT is either `yes' or `no'.  If omitted, it defaults to
#   `yes'.
AC_DEFUN(AC_ENABLE_STATIC, [dnl
define([AC_ENABLE_STATIC_DEFAULT], ifelse($1, no, no, yes))dnl
AC_ARG_ENABLE(static,
changequote(<<, >>)dnl
<<  --enable-static[=PKGS]  build static libraries [default=>>AC_ENABLE_STATIC_DEFAULT],
changequote([, ])dnl
[p=${PACKAGE-default}
case "$enableval" in
yes) enable_static=yes ;;
no) enable_static=no ;;
*)
  enable_static=no
  # Look at the argument we got.  We use all the common list separators.
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:,"
  for pkg in $enableval; do
    if test "X$pkg" = "X$p"; then
      enable_static=yes
    fi
  done
  IFS="$ac_save_ifs"
  ;;
esac],
enable_static=AC_ENABLE_STATIC_DEFAULT)dnl
])

# AC_DISABLE_STATIC - set the default static flag to --disable-static
AC_DEFUN(AC_DISABLE_STATIC, [AC_BEFORE([$0],[AC_LIBTOOL_SETUP])dnl
AC_ENABLE_STATIC(no)])


# AC_ENABLE_FAST_INSTALL - implement the --enable-fast-install flag
# Usage: AC_ENABLE_FAST_INSTALL[(DEFAULT)]
#   Where DEFAULT is either `yes' or `no'.  If omitted, it defaults to
#   `yes'.
AC_DEFUN(AC_ENABLE_FAST_INSTALL, [dnl
define([AC_ENABLE_FAST_INSTALL_DEFAULT], ifelse($1, no, no, yes))dnl
AC_ARG_ENABLE(fast-install,
changequote(<<, >>)dnl
<<  --enable-fast-install[=PKGS]  optimize for fast installation [default=>>AC_ENABLE_FAST_INSTALL_DEFAULT],
changequote([, ])dnl
[p=${PACKAGE-default}
case "$enableval" in
yes) enable_fast_install=yes ;;
no) enable_fast_install=no ;;
*)
  enable_fast_install=no
  # Look at the argument we got.  We use all the common list separators.
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}:,"
  for pkg in $enableval; do
    if test "X$pkg" = "X$p"; then
      enable_fast_install=yes
    fi
  done
  IFS="$ac_save_ifs"
  ;;
esac],
enable_fast_install=AC_ENABLE_FAST_INSTALL_DEFAULT)dnl
])

# AC_ENABLE_FAST_INSTALL - set the default to --disable-fast-install
AC_DEFUN(AC_DISABLE_FAST_INSTALL, [AC_BEFORE([$0],[AC_LIBTOOL_SETUP])dnl
AC_ENABLE_FAST_INSTALL(no)])

# AC_PROG_LD - find the path to the GNU or non-GNU linker
AC_DEFUN(AC_PROG_LD,
[AC_ARG_WITH(gnu-ld,
[  --with-gnu-ld           assume the C compiler uses GNU ld [default=no]],
test "$withval" = no || with_gnu_ld=yes, with_gnu_ld=no)
AC_REQUIRE([AC_PROG_CC])dnl
AC_REQUIRE([AC_CANONICAL_HOST])dnl
AC_REQUIRE([AC_CANONICAL_BUILD])dnl
ac_prog=ld
if test "$ac_cv_prog_gcc" = yes; then
  # Check if gcc -print-prog-name=ld gives a path.
  AC_MSG_CHECKING([for ld used by GCC])
  ac_prog=`($CC -print-prog-name=ld) 2>&5`
  case "$ac_prog" in
    # Accept absolute paths.
changequote(,)dnl
    [\\/]* | [A-Za-z]:[\\/]*)
      re_direlt='/[^/][^/]*/\.\./'
changequote([,])dnl
      # Canonicalize the path of ld
      ac_prog=`echo $ac_prog| sed 's%\\\\%/%g'`
      while echo $ac_prog | grep "$re_direlt" > /dev/null 2>&1; do
	ac_prog=`echo $ac_prog| sed "s%$re_direlt%/%"`
      done
      test -z "$LD" && LD="$ac_prog"
      ;;
  "")
    # If it fails, then pretend we aren't using GCC.
    ac_prog=ld
    ;;
  *)
    # If it is relative, then search for the first ld in PATH.
    with_gnu_ld=unknown
    ;;
  esac
elif test "$with_gnu_ld" = yes; then
  AC_MSG_CHECKING([for GNU ld])
else
  AC_MSG_CHECKING([for non-GNU ld])
fi
AC_CACHE_VAL(ac_cv_path_LD,
[if test -z "$LD"; then
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}${PATH_SEPARATOR-:}"
  for ac_dir in $PATH; do
    test -z "$ac_dir" && ac_dir=.
    if test -f "$ac_dir/$ac_prog" || test -f "$ac_dir/$ac_prog$ac_exeext"; then
      ac_cv_path_LD="$ac_dir/$ac_prog"
      # Check to see if the program is GNU ld.  I'd rather use --version,
      # but apparently some GNU ld's only accept -v.
      # Break only if it was the GNU/non-GNU ld that we prefer.
      if "$ac_cv_path_LD" -v 2>&1 < /dev/null | egrep '(GNU|with BFD)' > /dev/null; then
	test "$with_gnu_ld" != no && break
      else
	test "$with_gnu_ld" != yes && break
      fi
    fi
  done
  IFS="$ac_save_ifs"
else
  ac_cv_path_LD="$LD" # Let the user override the test with a path.
fi])
LD="$ac_cv_path_LD"
if test -n "$LD"; then
  AC_MSG_RESULT($LD)
else
  AC_MSG_RESULT(no)
fi
test -z "$LD" && AC_MSG_ERROR([no acceptable ld found in \$PATH])
AC_PROG_LD_GNU
])

AC_DEFUN(AC_PROG_LD_GNU,
[AC_CACHE_CHECK([if the linker ($LD) is GNU ld], ac_cv_prog_gnu_ld,
[# I'd rather use --version here, but apparently some GNU ld's only accept -v.
if $LD -v 2>&1 </dev/null | egrep '(GNU|with BFD)' 1>&5; then
  ac_cv_prog_gnu_ld=yes
else
  ac_cv_prog_gnu_ld=no
fi])
])

# AC_PROG_NM - find the path to a BSD-compatible name lister
AC_DEFUN(AC_PROG_NM,
[AC_MSG_CHECKING([for BSD-compatible nm])
AC_CACHE_VAL(ac_cv_path_NM,
[if test -n "$NM"; then
  # Let the user override the test.
  ac_cv_path_NM="$NM"
else
  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS="${IFS}${PATH_SEPARATOR-:}"
  for ac_dir in $PATH /usr/ccs/bin /usr/ucb /bin; do
    test -z "$ac_dir" && ac_dir=.
    if test -f $ac_dir/nm || test -f $ac_dir/nm$ac_exeext ; then
      # Check to see if the nm accepts a BSD-compat flag.
      # Adding the `sed 1q' prevents false positives on HP-UX, which says:
      #   nm: unknown option "B" ignored
      if ($ac_dir/nm -B /dev/null 2>&1 | sed '1q'; exit 0) | egrep /dev/null >/dev/null; then
	ac_cv_path_NM="$ac_dir/nm -B"
	break
      elif ($ac_dir/nm -p /dev/null 2>&1 | sed '1q'; exit 0) | egrep /dev/null >/dev/null; then
	ac_cv_path_NM="$ac_dir/nm -p"
	break
      else
	ac_cv_path_NM=${ac_cv_path_NM="$ac_dir/nm"} # keep the first match, but
	continue # so that we can try to find one that supports BSD flags
      fi
    fi
  done
  IFS="$ac_save_ifs"
  test -z "$ac_cv_path_NM" && ac_cv_path_NM=nm
fi])
NM="$ac_cv_path_NM"
AC_MSG_RESULT([$NM])
])

# AC_CHECK_LIBM - check for math library
AC_DEFUN(AC_CHECK_LIBM,
[AC_REQUIRE([AC_CANONICAL_HOST])dnl
LIBM=
case "$lt_target" in
*-*-beos* | *-*-cygwin*)
  # These system don't have libm
  ;;
*-ncr-sysv4.3*)
  AC_CHECK_LIB(mw, _mwvalidcheckl, LIBM="-lmw")
  AC_CHECK_LIB(m, main, LIBM="$LIBM -lm")
  ;;
*)
  AC_CHECK_LIB(m, main, LIBM="-lm")
  ;;
esac
])

# AC_LIBLTDL_CONVENIENCE[(dir)] - sets LIBLTDL to the link flags for
# the libltdl convenience library and INCLTDL to the include flags for
# the libltdl header and adds --enable-ltdl-convenience to the
# configure arguments.  Note that LIBLTDL and INCLTDL are not
# AC_SUBSTed, nor is AC_CONFIG_SUBDIRS called.  If DIR is not
# provided, it is assumed to be `libltdl'.  LIBLTDL will be prefixed
# with '${top_builddir}/' and INCLTDL will be prefixed with
# '${top_srcdir}/' (note the single quotes!).  If your package is not
# flat and you're not using automake, define top_builddir and
# top_srcdir appropriately in the Makefiles.
AC_DEFUN(AC_LIBLTDL_CONVENIENCE, [AC_BEFORE([$0],[AC_LIBTOOL_SETUP])dnl
  case "$enable_ltdl_convenience" in
  no) AC_MSG_ERROR([this package needs a convenience libltdl]) ;;
  "") enable_ltdl_convenience=yes
      ac_configure_args="$ac_configure_args --enable-ltdl-convenience" ;;
  esac
  LIBLTDL='${top_builddir}/'ifelse($#,1,[$1],['libltdl'])/libltdlc.la
  INCLTDL='-I${top_srcdir}/'ifelse($#,1,[$1],['libltdl'])
])

# AC_LIBLTDL_INSTALLABLE[(dir)] - sets LIBLTDL to the link flags for
# the libltdl installable library and INCLTDL to the include flags for
# the libltdl header and adds --enable-ltdl-install to the configure
# arguments.  Note that LIBLTDL and INCLTDL are not AC_SUBSTed, nor is
# AC_CONFIG_SUBDIRS called.  If DIR is not provided and an installed
# libltdl is not found, it is assumed to be `libltdl'.  LIBLTDL will
# be prefixed with '${top_builddir}/' and INCLTDL will be prefixed
# with '${top_srcdir}/' (note the single quotes!).  If your package is
# not flat and you're not using automake, define top_builddir and
# top_srcdir appropriately in the Makefiles.
# In the future, this macro may have to be called after AC_PROG_LIBTOOL.
AC_DEFUN(AC_LIBLTDL_INSTALLABLE, [AC_BEFORE([$0],[AC_LIBTOOL_SETUP])dnl
  AC_CHECK_LIB(ltdl, main,
  [test x"$enable_ltdl_install" != xyes && enable_ltdl_install=no],
  [if test x"$enable_ltdl_install" = xno; then
     AC_MSG_WARN([libltdl not installed, but installation disabled])
   else
     enable_ltdl_install=yes
   fi
  ])
  if test x"$enable_ltdl_install" = x"yes"; then
    ac_configure_args="$ac_configure_args --enable-ltdl-install"
    LIBLTDL='${top_builddir}/'ifelse($#,1,[$1],['libltdl'])/libltdl.la
    INCLTDL='-I${top_srcdir}/'ifelse($#,1,[$1],['libltdl'])
  else
    ac_configure_args="$ac_configure_args --enable-ltdl-install=no"
    LIBLTDL="-lltdl"
    INCLTDL=
  fi
])

dnl old names
AC_DEFUN(AM_PROG_LIBTOOL, [indir([AC_PROG_LIBTOOL])])dnl
AC_DEFUN(AM_ENABLE_SHARED, [indir([AC_ENABLE_SHARED], $@)])dnl
AC_DEFUN(AM_ENABLE_STATIC, [indir([AC_ENABLE_STATIC], $@)])dnl
AC_DEFUN(AM_DISABLE_SHARED, [indir([AC_DISABLE_SHARED], $@)])dnl
AC_DEFUN(AM_DISABLE_STATIC, [indir([AC_DISABLE_STATIC], $@)])dnl
AC_DEFUN(AM_PROG_LD, [indir([AC_PROG_LD])])dnl
AC_DEFUN(AM_PROG_NM, [indir([AC_PROG_NM])])dnl

dnl This is just to silence aclocal about the macro not being used
ifelse([AC_DISABLE_FAST_INSTALL])dnl

dnl This is my inclusion of HPPCEL-related macros here. According to
dnl Chap. 22 of the "Goat" book, 'Writing new macros for autoconf', 
dnl "If your package additionally uses Automake, these [your own macros] 
dnl macros should be placed in 'acinclude.m4'. The aclocal program from
dnl Automake reads in macro definitions from 'acinclude.m4' when 
dnl generating 'aclocal.m4'." (fabianb)

dnl
dnl ac_require_hppcel_package(package, include_file, library_file)
dnl   either include file or library_file may be left off if not needed
dnl   this macro searches for the files using find_hppcel_package().  If
dnl   found, it adds directory in which the found file resides to either 
dnl   CPPFLAGS (with a -I prefix)  or LDFLAGS (with a -L prefix)
dnl
AC_DEFUN(AC_REQUIRE_HPPCEL_PACKAGE,
[
AC_REQUIRE([AC_HPPCEL_SET_ARCHIVE])
AC_REQUIRE([AC_LD_SUPPORTS_LIBPATH])
AC_ARG_WITH(installed, [  --with-installed        Don't use local copies of HPPCEL packages],with_installed_specified=1)
AC_ARG_WITH(translit($1, `/',`_'), translit([  --with-$1=DIR	Where to find $1 package], `/',`_'))
define([with_translit], translit(with_$1, `/',`_'))
if test -n "$with_translit"; then
dnl
dnl if they did a with, kill the cache variables
dnl
translit(unset ac_cv_$1_include_arg,  `/',`_')
translit(unset ac_cv_$1_link_arg,  `/',`_')
if test `echo $with_translit | sed 's/\(.\).*/\1/g'` != "/"; then
with_translit=`pwd`/$with_translit
fi
fi
ifelse([$2], , ,
dnl
dnl  if arg2 (include_file) is specified
dnl
AC_MSG_CHECKING(needed include args for $1 package)
AC_CACHE_VAL(translit(ac_cv_$1_include_arg, `/',`_'), 
[AC_FIND_HPPCEL_PACKAGE($1, $2, hppcel_tmp, $with_translit)
if test -n "$hppcel_tmp"; then
translit(ac_cv_$1_include_arg, `/',`_')=-I`$PATHPROG $hppcel_tmp | sed 's#\\\\#/#g' | sed "s/.$2//g"`
fi
])
AC_MSG_RESULT(translit($ac_cv_$1_include_arg, `/',`_'))
dnl
dnl  add the result to CPPFLAGS if it is absent
dnl
translit(if test -n "$ac_cv_$1_include_arg"; then, `/',`_')
translit(arg="$ac_cv_$1_include_arg", `/',`_')
no_dash_arg=`echo $arg | sed 's/^-//g'`
[if test `echo $CPPFLAGS | grep -c "$no_dash_arg"` -eq 0; then
if test `echo $arg | grep -c "$1"` -eq 0; then
CPPFLAGS="$CPPFLAGS $arg";
else
CPPFLAGS="$arg $CPPFLAGS"
fi
fi]
fi
)
ifelse([$3], , ,
dnl
dnl  if arg3 (library_file) is specified
dnl
AC_MSG_CHECKING(needed link args for $1 package)
AC_CACHE_VAL(translit(ac_cv_$1_link_dir,  `/',`_'), 
[AC_FIND_HPPCEL_PACKAGE($1, $3, hppcel_tmp, $with_translit)
if test -n "$hppcel_tmp" -a "$hppcel_tmp" != "$3"; then
translit(ac_cv_$1_link_dir, `/',`_')=`$PATHPROG $hppcel_tmp | sed 's#\\\\#/#g' | sed "s/.$3//g"`
else
translit(ac_cv_$1_link_dir="",  `/',`_')
fi
])
AC_MSG_RESULT(translit($ac_cv_$1_link_dir, `/',`_'))
if test "$ac_cv_prog_cc_libpath" = "yes"; then
ld_arg="-LIBPATH:"
new_flags=$LIBPOSTARGS
else
ld_arg="-L"
new_flags=$LDFLAGS
fi
dnl
dnl  add the result to LDFLAGS if it is absent
dnl
translit(ac_cv_$1_link_arg=`echo $ac_cv_$1_link_dir, `/',`_') | sed "/./ s/^/$ld_arg/1"`
translit(if test -n "$ac_cv_$1_link_arg"; then, `/',`_')
translit(arg=$ac_cv_$1_link_arg, `/',`_')
no_dash_arg=`echo $arg | sed 's/^-//g'`
[if test `echo $new_flags | grep -c "$no_dash_arg"` -eq 0; then
if test `echo $arg | grep -c "$1"` -eq 0; then
dnl if arg does not includes a project spec add it at the end
new_flags="$new_flags $arg"
else
new_flags="$arg $new_flags"
fi
fi]
if test "$ac_cv_prog_cc_libpath" = "yes"; then
LIBPOSTARGS=$new_flags
LDPOSTFLAGS="/link $LIBPOSTARGS"
else
LDFLAGS=$new_flags
fi
fi
)
])dnl
dnl
dnl ac_find_hppcel_package(package, file_to_find, variable_to_set, suggestion)
dnl    search a set of standard directories to find file_to_find.  When found,
dnl    set $variable_to_set to the path of the file.  Use package and
dnl    suggestions to help search.  Mostly this searches ~chaos (if it exists)
dnl    ~parallel (if it exists) and the usual suspects like:
dnl    /usr/{include,lib} /usr/local/{include,lib} /opt/<package>/{include,lib}
dnl    /opt/misc/{include,lib}.
dnl
AC_DEFUN(AC_FIND_HPPCEL_PACKAGE,
[
AC_REQUIRE([AC_HAS_CSH])
AC_REQUIRE([AC_HAS_CYGPATH])
AC_REQUIRE([AC_HPPCEL_SET_ARCHIVE])
$3=""
search_list="$2"
CHAOS_HOMEDIR=""
PARALLEL_HOMEDIR=""
if test -n "$CSH"; then
CHAOS_HOMEDIR=`echo "echo ~chaos" | csh -sf  2>/dev/null` || CHAOS_HOMEDIR=""
PARALLEL_HOMEDIR=`echo "echo ~parallel" | csh -sf  2>/dev/null` || PARALLEL_HOMEDIR=""
fi
if test -n "$4"; then
if test `echo $4 | cut -c1` = "~"; then
EXPANDED=`echo "echo $4" | csh -sf 2>/dev/null` || EXPANDED=""
else
EXPANDED=$4
fi

search_list="$search_list $EXPANDED/$2 $EXPANDED/include/$2 $EXPANDED/share/$2 $EXPANDED/include/$hppcel_cv_archive/$2 $EXPANDED/lib/$hppcel_cv_archive/$2 $EXPANDED/lib/$2 $EXPANDED/$1/$2 $EXPANDED/$1/$hppcel_cv_archive/$2 $EXPANDED/$1/include/$2 $EXPANDED/$1/lib/$hppcel_cv_archive/$2"
fi
if test -z "$with_installed_specified"; then
search_list="$search_list `pwd`/../$1/$2 `pwd`/../lib/$2 `pwd`/../include/$2 `pwd`/../share/$2 $HOME/$1/$2 $HOME/$hppcel_cv_archive/lib/$2 $HOME/$hppcel_cv_archive/include/$2 $HOME/include/$2 $HOME/share/$2"
fi
if test "$libdir" != '${exec_prefix}/lib'; then
search_list="$search_list $libdir/$2"
fi
if test "$exec_prefix" != "NONE"; then
search_list="$search_list $exec_prefix/lib/$2"
fi
if test "$includedir" != '${prefix}/include'; then
search_list="$search_list $includedir/$2"
fi
if test "$prefix" != "NONE"; then
search_list="$search_list $prefix/lib/$2 $prefix/include/$2"
fi
if test -n "$CHAOS_HOMEDIR" -a -n "$hppcel_cv_archive"; then
search_list="$search_list $CHAOS_HOMEDIR/include/$2 $CHAOS_HOMEDIR/share/$2 $CHAOS_HOMEDIR/include/$hppcel_cv_archive/$2 $CHAOS_HOMEDIR/lib/$hppcel_cv_archive/$2 $CHAOS_HOMEDIR/lib/$2"
fi
if test -n "$PARALLEL_HOMEDIR" -a -n "$hppcel_cv_archive"; then
search_list="$search_list $PARALLEL_HOMEDIR/include/$2 $PARALLEL_HOMEDIR/share/$2 $PARALLEL_HOMEDIR/include/$hppcel_cv_archive/$2 $PARALLEL_HOMEDIR/lib/$hppcel_cv_archive/$2 $PARALLEL_HOMEDIR/lib/$2"
fi
search_list="$search_list /usr/lib/$2 /usr/local/lib/$2 /usr/include/$2 /usr/share/$2 /opt/$1/lib/$2 /opt/$1/include/$2 /opt/misc/lib/$2 /opt/misc/include/$2 /opt/misc/share/$2"
AC_SEARCH($search_list)
if test -n "$tmp_search_results"; then
$3=$tmp_search_results
fi
])dnl
dnl
dnl AC_HPPCEL_SET_ARCHIVE()
dnl   set the $hppcel_cv_machine_target variable to a standard archive name
dnl
AC_DEFUN(AC_HPPCEL_SET_ARCHIVE,[
AC_REQUIRE([AC_HAS_CSH])
AC_REQUIRE([AC_HAS_CYGPATH])
CHAOS_HOMEDIR=""
PARALLEL_HOMEDIR=""
if test -n "$CSH"; then
CHAOS_HOMEDIR=`echo "echo ~chaos" | csh -sf  2>/dev/null` || CHAOS_HOMEDIR=""
PARALLEL_HOMEDIR=`echo "echo ~parallel" | csh -sf  2>/dev/null` || PARALLEL_HOMEDIR=""
fi
if test "$cross_compiling" = yes ; then
  cpu=$host_cpu
  vendor=$host_vendot
  os=$host_os
else
  cpu=
  vendor=
  os=
fi
if test -x $CHAOS_HOMEDIR/bin/hppcel_arch; then
hppcel_cv_archive=`$CHAOS_HOMEDIR/bin/hppcel_arch "$cpu" "$vendor" "$os"`
elif test -x $PARALLEL_HOMEDIR/bin/hppcel_arch; then
hppcel_cv_archive=`$PARALLEL_HOMEDIR/bin/hppcel_arch "$cpu" "$vendor" "$os"`
else
hppcel_cv_archive=`hppcel_arch` || hppcel_cv_archive=""
fi
])dnl
dnl
dnl  AC_SEARCH(variable to define, options to try)
define(AC_SEARCH,
[tmp_search_results=""
for tmp_search_value in $1; do 
   if test -r $tmp_search_value; then 
	tmp_search_results=$tmp_search_value
	break
   fi 
done
])dnl
dnl
dnl
dnl AC_HPPCEL_LIB_PREFIX
dnl  this macro tries to set a reasonable default for the prefix value
dnl  call with two arguments, project name and library name
dnl
AC_DEFUN(AC_HPPCEL_LIB_PREFIX,
[if test "x$prefix" = xNONE; then
AC_REQUIRE([AC_HPPCEL_SET_ARCHIVE])
search_list=""
CHAOS_HOMEDIR=""
PARALLEL_HOMEDIR=""
if test -n "$CSH"; then
CHAOS_HOMEDIR=`echo "echo ~chaos" | csh -sf  2>/dev/null` || CHAOS_HOMEDIR=""
PARALLEL_HOMEDIR=`echo "echo ~parallel" | csh -sf  2>/dev/null` || PARALLEL_HOMEDIR=""
fi
if test -n "$CHAOS_HOMEDIR"; then
search_list="$search_list $CHAOS_HOMEDIR/$hppcel_cv_archive/lib/$2 $CHAOS_HOMEDIR/lib/$2"
fi
if test -n "$PARALLEL_HOMEDIR"; then
search_list="$search_list $PARALLEL_HOMEDIR/$hppcel_cv_archive/lib/$2 $PARALLEL_HOMEDIR/lib/$2"
fi
search_list="$search_list /usr/lib/$2 /usr/local/lib/$2 /opt/$1/lib/$2 /opt/misc/lib/$2"
AC_SEARCH($search_list)
if test -n "$tmp_search_results"; then
    prefix=`echo $tmp_search_results|sed "s%$hppcel_cv_archive/lib/$2%%g;s%lib/$2%%g;s%/[^/][^/]*//*[^/][^/]*$%%"`
    exec_prefix=`echo $tmp_search_results|sed 's%lib/$2%%g;s%/[^/][^/]*//*[^/][^/]*$%%'`
fi
fi
])
dnl

AC_DEFUN(AC_HAS_CSH, [AC_PATH_PROG(CSH,csh)])dnl
AC_DEFUN(AC_HAS_CYGPATH, [AC_CHECK_PROG(PATHPROG,cygpath,[cygpath -w],[echo])])dnl
AC_DEFUN(AC_PROG_CC_VCPP,
[AC_CACHE_CHECK([whether we are using MS Visual C++], ac_cv_prog_vcpp,
[
dnl The semicolon is to pacify NeXT's syntax-checking cpp.
cat > conftest.c <<EOF
#ifdef _MSC_VER
  yes;
#endif
EOF
if AC_TRY_COMMAND(${CC-cc} -E conftest.c) | egrep yes >/dev/null 2>&1; then
  ac_cv_prog_vcpp=yes
else
  ac_cv_prog_vcpp=no
fi])])
dnl
AC_DEFUN(AC_LD_SUPPORTS_LIBPATH, 
[AC_REQUIRE([AC_PROG_CC_VCPP])dnl
AC_CACHE_CHECK(whether ${CC-cc} accepts -LIBPATH:paths, ac_cv_prog_cc_libpath,
[
echo 'void f(){}' > conftest.c
if test "$ac_cv_prog_vcpp" = yes -a -z "`${CC-cc} -c conftest.c /link /LIBPATH:/tmp 2>&1 | sed 's/conftest.c//g'`"; then
  ac_cv_prog_cc_libpath=yes
else
  ac_cv_prog_cc_libpath=no
fi
rm -f conftest*
])])


AC_DEFUN(AC_FPRINTF_DEFINED,
[AC_MSG_CHECKING(whether stdio.h declares fprintf)
AC_CACHE_VAL(ac_cv_fprintf_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]fprintf[^a-zA-Z_]>>changequote([, ])dnl
, stdio.h, ac_cv_fprintf_found=yes, ac_cv_fprintf_found=no)
])
AC_MSG_RESULT($ac_cv_fprintf_found)
if test $ac_cv_fprintf_found = yes; then
   AC_DEFINE(FPRINTF_DEFINED,1, [define if stdio.h declares fprintf])
fi
])dnl
AC_DEFUN(AC_ALARM_DEFINED,
[AC_MSG_CHECKING(whether unistd.h declares alarm)
AC_CACHE_VAL(ac_cv_alarm_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]alarm[^a-zA-Z_]>>changequote([, ])dnl
, unistd.h, ac_cv_alarm_found=yes, ac_cv_alarm_found=no)
])
AC_MSG_RESULT($ac_cv_alarm_found)
if test $ac_cv_alarm_found = yes; then
   AC_DEFINE(ALARM_DEFINED,1,[define if unistd.h declares alarm])
fi
])dnl
AC_DEFUN(AC_PUTENV_DEFINED,
[AC_MSG_CHECKING(whether unistd.h or stdlib.h declares putenv)
AC_CACHE_VAL(ac_cv_putenv_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]putenv[^a-zA-Z_]>>changequote([, ])dnl
, stdlib.h, ac_cv_putenv_found=yes, ac_cv_putenv_found=no)
if test $ac_cv_putenv_found != yes; then
AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]putenv[^a-zA-Z_]>>changequote([, ])dnl
, unistd.h, ac_cv_putenv_found=yes, ac_cv_putenv_found=no)
fi
])
AC_MSG_RESULT($ac_cv_putenv_found)
if test $ac_cv_putenv_found = yes; then
   AC_DEFINE(PUTENV_DEFINED,1,[define if unistd.h or stdlib.h declares putenv])
fi
])dnl
dnl
AC_DEFUN(AC_FSCANF_DEFINED,
[AC_MSG_CHECKING(whether stdio.h declares fscanf)
AC_CACHE_VAL(ac_cv_fscanf_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]fscanf[^a-zA-Z_]>>changequote([, ])dnl
, stdio.h, ac_cv_fscanf_found=yes, ac_cv_fscanf_found=no)
])
AC_MSG_RESULT($ac_cv_fscanf_found)
if test $ac_cv_fscanf_found = yes; then
   AC_DEFINE(FSCANF_DEFINED,1, [define if stdio.h declares fprintf])
fi
])dnl
AC_DEFUN(AC_PRINTF_DEFINED,
[AC_MSG_CHECKING(whether stdio.h declares printf)
AC_CACHE_VAL(ac_cv_printf_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]printf[^a-zA-Z_]>>changequote([, ])dnl
, stdio.h, ac_cv_printf_found=yes, ac_cv_printf_found=no)
])
AC_MSG_RESULT($ac_cv_printf_found)
if test $ac_cv_printf_found = yes; then
   AC_DEFINE(PRINTF_DEFINED,1,[define if stdio.h declares printf])
fi
])dnl
AC_DEFUN(AC_WRITE_DEFINED,
[AC_MSG_CHECKING(whether unistd.h declares write)
AC_CACHE_VAL(ac_cv_write_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]write[^a-zA-Z_]>>changequote([, ])dnl
, unistd.h, ac_cv_write_found=yes, ac_cv_write_found=no)
])
AC_MSG_RESULT($ac_cv_write_found)
if test $ac_cv_write_found = yes; then
   AC_DEFINE(WRITE_DEFINED,1,[define if unistd.h declares write])
fi
])dnl
AC_DEFUN(AC_WRITEV_DEFINED,
[AC_MSG_CHECKING(whether unistd.h or sys/uio.h declares writev)
AC_CACHE_VAL(ac_cv_writev_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]writev[^a-zA-Z_]>>changequote([, ])dnl
, sys/uio.h, ac_cv_writev_found=yes, ac_cv_writev_found=no)
if test $ac_cv_writev_found != yes; then
AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]writev[^a-zA-Z_]>>changequote([, ])dnl
, unistd.h, ac_cv_writev_found=yes, ac_cv_writev_found=no)
fi
])
AC_MSG_RESULT($ac_cv_writev_found)
if test $ac_cv_writev_found = yes; then
   AC_DEFINE(WRITEV_DEFINED,1,[define if unistd.h or sys/uio.h declares writev])
fi
])dnl
AC_DEFUN(AC_READ_DEFINED,
[AC_MSG_CHECKING(whether unistd.h declares read)
AC_CACHE_VAL(ac_cv_read_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]read[^a-zA-Z_]>>changequote([, ])dnl
, unistd.h, ac_cv_read_found=yes, ac_cv_read_found=no)
])
AC_MSG_RESULT($ac_cv_read_found)
if test $ac_cv_read_found = yes; then
   AC_DEFINE(READ_DEFINED,1,[define if unistd.h declares read])
fi
])dnl
AC_DEFUN(AC_READV_DEFINED,
[AC_MSG_CHECKING(whether unistd.h or sys/uio.h declares readv)
AC_CACHE_VAL(ac_cv_readv_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]readv[^a-zA-Z_]>>changequote([, ])dnl
, sys/uio.h, ac_cv_readv_found=yes, ac_cv_readv_found=no)
if test $ac_cv_readv_found != yes; then
AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]readv[^a-zA-Z_]>>changequote([, ])dnl
, unistd.h, ac_cv_readv_found=yes, ac_cv_readv_found=no)
fi
])
AC_MSG_RESULT($ac_cv_readv_found)
if test $ac_cv_readv_found = yes; then
   AC_DEFINE(READV_DEFINED,1,[define if unistd.h or sys/uio.h declares readv])
fi
])dnl
dnl
])dnl
AC_DEFUN(AC_SSCANF_DEFINED,
[AC_MSG_CHECKING(whether stdio.h declares sscanf)
AC_CACHE_VAL(ac_cv_sscanf_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]sscanf[^a-zA-Z_]>>changequote([, ])dnl
, stdio.h, ac_cv_sscanf_found=yes, ac_cv_sscanf_found=no)
])
AC_MSG_RESULT($ac_cv_sscanf_found)
if test $ac_cv_sscanf_found = yes; then
   AC_DEFINE(SSCANF_DEFINED,1,[define if stdio.h declares sscanf])
fi
])dnl
AC_DEFUN(AC_SPRINTF_DEFINED,
[AC_MSG_CHECKING(whether stdio.h declares sprintf)
AC_CACHE_VAL(ac_cv_sprintf_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]sprintf[^a-zA-Z_]>>changequote([, ])dnl
, stdio.h, ac_cv_sprintf_found=yes, ac_cv_sprintf_found=no)
])
AC_MSG_RESULT($ac_cv_sprintf_found)
if test $ac_cv_sprintf_found = yes; then
   AC_DEFINE(SPRINTF_DEFINED,1,[define if sprintf is declared in stdio.h])
fi
])dnl
AC_DEFUN(AC_STRDUP_DEFINED,
[AC_MSG_CHECKING(whether string.h declares strdup)
AC_CACHE_VAL(ac_cv_strdup_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]strdup[^a-zA-Z_]>>changequote([, ])dnl
, string.h, ac_cv_strdup_found=yes, ac_cv_strdup_found=no)
])
AC_MSG_RESULT($ac_cv_strdup_found)
if test $ac_cv_strdup_found = yes; then
   AC_DEFINE(STRDUP_DEFINED,1,[define if string.h declares strdup])
fi
])dnl
AC_DEFUN(AC_BZERO_DEFINED,
[AC_MSG_CHECKING(whether string.h declares bzero)
AC_CACHE_VAL(ac_cv_bzero_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]bzero[^a-zA-Z_]>>changequote([, ])dnl
, string.h, ac_cv_bzero_found=yes, ac_cv_bzero_found=no)
])
AC_MSG_RESULT($ac_cv_bzero_found)
if test $ac_cv_bzero_found = yes; then
   AC_DEFINE(BZERO_DEFINED,1,[define if string.h declares bzero])
fi
])dnl
AC_DEFUN(AC_BCOPY_DEFINED,
[AC_MSG_CHECKING(whether string.h declares bcopy)
AC_CACHE_VAL(ac_cv_bcopy_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]bcopy[^a-zA-Z_]>>changequote([, ])dnl
, string.h, ac_cv_bcopy_found=yes, ac_cv_bcopy_found=no)
])
AC_MSG_RESULT($ac_cv_bcopy_found)
if test $ac_cv_bcopy_found = yes; then
   AC_DEFINE(BCOPY_DEFINED,1,[define if string.h declares bcopy])
fi
])dnl
dnl
AC_DEFUN(AC_GETDOMAINNAME_DEFINED,
[AC_MSG_CHECKING(whether unistd.h declares getdomainname)
AC_CACHE_VAL(ac_cv_getdomainname_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]getdomainname[^a-zA-Z_]>>changequote([, ])dnl
, unistd.h, ac_cv_getdomainname_found=yes, ac_cv_getdomainname_found=no)
])
AC_MSG_RESULT($ac_cv_getdomainname_found)
if test $ac_cv_getdomainname_found = yes; then
   AC_DEFINE(GETDOMAINNAME_DEFINED,1,[define if unistd.h declares getdomainname])
fi
])dnl
dnl
AC_DEFUN(AC_GETHOSTNAME_DEFINED,
[AC_MSG_CHECKING(whether unistd.h declares gethostname)
AC_CACHE_VAL(ac_cv_gethostname_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]gethostname[^a-zA-Z_]>>changequote([, ])dnl
, unistd.h, ac_cv_gethostname_found=yes, ac_cv_gethostname_found=no)
])
AC_MSG_RESULT($ac_cv_gethostname_found)
if test $ac_cv_gethostname_found = yes; then
   AC_DEFINE(GETHOSTNAME_DEFINED,1,[define if unistd.h declares gethostname])
fi
])dnl
dnl
AC_DEFUN(AC_GETPEERNAME_DEFINED,
[AC_MSG_CHECKING(whether sys/socket.h declares getpeername)
AC_CACHE_VAL(ac_cv_getpeername_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]getpeername[^a-zA-Z_]>>changequote([, ])dnl
, sys/socket.h, ac_cv_getpeername_found=yes, ac_cv_getpeername_found=no)
])
AC_MSG_RESULT($ac_cv_getpeername_found)
if test $ac_cv_getpeername_found = yes; then
   AC_DEFINE(GETPEERNAME_DEFINED,1,[define if sys/socket.h declares getpeername])
fi
])dnl
AC_DEFUN(AC_GETTIMEOFDAY_DEFINED,
[AC_MSG_CHECKING(whether sys/time.h declares gettimeofday)
AC_CACHE_VAL(ac_cv_gettimeofday_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]gettimeofday[^a-zA-Z_]>>changequote([, ])dnl
, sys/time.h, ac_cv_gettimeofday_found=yes, ac_cv_gettimeofday_found=no)
])
AC_MSG_RESULT($ac_cv_gettimeofday_found)
if test $ac_cv_gettimeofday_found = yes; then
   AC_DEFINE(GETTIMEOFDAY_DEFINED,1,[define if sys/time.h declares gettimeofday])
fi
])dnl
AC_DEFUN(AC_ON_EXIT_DEFINED,
[AC_MSG_CHECKING(whether stdlib.h declares on_exit)
AC_CACHE_VAL(ac_cv_on_exit_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]on_exit[^a-zA-Z_]>>changequote([, ])dnl
, stdlib.h, ac_cv_on_exit_found=yes, ac_cv_on_exit_found=no)
])
AC_MSG_RESULT($ac_cv_on_exit_found)
if test $ac_cv_on_exit_found = yes; then
   AC_DEFINE(ON_EXIT_DEFINED,1,[define if stdlib.h declares on_exit])
fi
])
dnl
dnl
AC_DEFUN(AC_RECV_DEFINED,
[AC_MSG_CHECKING(whether sys/socket.h declares recv)
AC_CACHE_VAL(ac_cv_recv_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]recv[^a-zA-Z_]>>changequote([, ])dnl
, sys/socket.h, ac_cv_recv_found=yes, ac_cv_recv_found=no)
])
AC_MSG_RESULT($ac_cv_recv_found)
if test $ac_cv_recv_found = yes; then
   AC_DEFINE(RECV_DEFINED,1,[define if sys/socket.h declares recv])
fi
])dnl
dnl
AC_DEFUN(AC_RECVFROM_DEFINED,
[AC_MSG_CHECKING(whether sys/socket.h declares recvfrom)
AC_CACHE_VAL(ac_cv_recvfrom_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]recvfrom[^a-zA-Z_]>>changequote([, ])dnl
, sys/socket.h, ac_cv_recvfrom_found=yes, ac_cv_recvfrom_found=no)
])
AC_MSG_RESULT($ac_cv_recvfrom_found)
if test $ac_cv_recvfrom_found = yes; then
   AC_DEFINE(RECVFROM_DEFINED,1,[define if sys/socket.h declares recvfrom])
fi
])dnl
dnl
AC_DEFUN(AC_SELECT_DEFINED,
[AC_MSG_CHECKING(whether unistd.h or sys/select.h declares select)
AC_CACHE_VAL(ac_cv_select_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]select[^a-zA-Z_]>>changequote([, ])dnl
, sys/select.h, ac_cv_select_found=yes, ac_cv_select_found=no)
if test $ac_cv_select_found != yes; then
AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]select[^a-zA-Z_]>>changequote([, ])dnl
, unistd.h, ac_cv_select_found=yes, ac_cv_select_found=no)
fi
])
AC_MSG_RESULT($ac_cv_select_found)
if test $ac_cv_select_found = yes; then
   AC_DEFINE(SELECT_DEFINED,1,[define if unistd.h or sys/select.h declares select])
fi
])dnl
dnl
dnl
AC_DEFUN(AC_SEND_DEFINED,
[AC_MSG_CHECKING(whether sys/socket.h declares send)
AC_CACHE_VAL(ac_cv_send_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]send[^a-zA-Z_]>>changequote([, ])dnl
, sys/socket.h, ac_cv_send_found=yes, ac_cv_send_found=no)
])
AC_MSG_RESULT($ac_cv_send_found)
if test $ac_cv_send_found = yes; then
   AC_DEFINE(SEND_DEFINED,1,[define if sys/socket.h declares send])
fi
])dnl
dnl
AC_DEFUN(AC_SENDTO_DEFINED,
[AC_MSG_CHECKING(whether sys/socket.h declares sendto)
AC_CACHE_VAL(ac_cv_sendto_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]sendto[^a-zA-Z_]>>changequote([, ])dnl
, sys/socket.h, ac_cv_sendto_found=yes, ac_cv_sendto_found=no)
])
AC_MSG_RESULT($ac_cv_sendto_found)
if test $ac_cv_sendto_found = yes; then
   AC_DEFINE(SENDTO_DEFINED,1,[define if sys/socket.h declares sendto])
fi
])dnl
dnl
AC_DEFUN(AC_ACCEPT_DEFINED,
[AC_MSG_CHECKING(whether sys/socket.h declares accept)
AC_CACHE_VAL(ac_cv_accept_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]accept[^a-zA-Z_]>>changequote([, ])dnl
, sys/socket.h, ac_cv_accept_found=yes, ac_cv_accept_found=no)
])
AC_MSG_RESULT($ac_cv_accept_found)
if test $ac_cv_accept_found = yes; then
   AC_DEFINE(ACCEPT_DEFINED,1,[define if sys/socket.h declares accept])
fi
])dnl
dnl
AC_DEFUN(AC_CONNECT_DEFINED,
[AC_MSG_CHECKING(whether sys/socket.h declares connect)
AC_CACHE_VAL(ac_cv_connect_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]connect[^a-zA-Z_]>>changequote([, ])dnl
, sys/socket.h, ac_cv_connect_found=yes, ac_cv_connect_found=no)
])
AC_MSG_RESULT($ac_cv_connect_found)
if test $ac_cv_connect_found = yes; then
   AC_DEFINE(CONNECT_DEFINED,1,[define if sys/socket.h declares connect])
fi
])dnl
dnl
AC_DEFUN(AC_SOCKET_DEFINED,
[AC_MSG_CHECKING(whether sys/socket.h declares socket)
AC_CACHE_VAL(ac_cv_socket_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]socket[^a-zA-Z_]>>changequote([, ])dnl
, sys/socket.h, ac_cv_socket_found=yes, ac_cv_socket_found=no)
])
AC_MSG_RESULT($ac_cv_socket_found)
if test $ac_cv_socket_found = yes; then
   AC_DEFINE(SOCKET_DEFINED,1,[define if sys/socket.h declares socket])
fi
])dnl
dnl
AC_DEFUN(AC_SETSOCKOPT_DEFINED,
[AC_MSG_CHECKING(whether sys/socket.h declares setsockopt)
AC_CACHE_VAL(ac_cv_setsockopt_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]setsockopt[^a-zA-Z_]>>changequote([, ])dnl
, sys/socket.h, ac_cv_setsockopt_found=yes, ac_cv_setsockopt_found=no)
])
AC_MSG_RESULT($ac_cv_setsockopt_found)
if test $ac_cv_setsockopt_found = yes; then
   AC_DEFINE(SETSOCKOPT_DEFINED,1,[define if sys/socket.h declares setsockopt])
fi
])dnl
dnl
AC_DEFUN(AC_GETSOCKNAME_DEFINED,
[AC_MSG_CHECKING(whether sys/socket.h declares getsockname)
AC_CACHE_VAL(ac_cv_getsockname_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]getsockname[^a-zA-Z_]>>changequote([, ])dnl
, sys/socket.h, ac_cv_getsockname_found=yes, ac_cv_getsockname_found=no)
])
AC_MSG_RESULT($ac_cv_getsockname_found)
if test $ac_cv_getsockname_found = yes; then
   AC_DEFINE(GETSOCKNAME_DEFINED,1,[define if sys/socket.h declares getsockname])
fi
])dnl
dnl
AC_DEFUN(AC_BIND_DEFINED,
[AC_MSG_CHECKING(whether sys/socket.h declares bind)
AC_CACHE_VAL(ac_cv_bind_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]bind[^a-zA-Z_]>>changequote([, ])dnl
, sys/socket.h, ac_cv_bind_found=yes, ac_cv_bind_found=no)
])
AC_MSG_RESULT($ac_cv_bind_found)
if test $ac_cv_bind_found = yes; then
   AC_DEFINE(BIND_DEFINED,1,[define if sys/socket.h declares bind])
fi
])dnl
dnl
AC_DEFUN(AC_FFLUSH_DEFINED,
[AC_MSG_CHECKING(whether stdio.h declares fflush)
AC_CACHE_VAL(ac_cv_fflush_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]fflush[^a-zA-Z_]>>changequote([, ])dnl
, stdio.h, ac_cv_fflush_found=yes, ac_cv_fflush_found=no)
])
AC_MSG_RESULT($ac_cv_fflush_found)
if test $ac_cv_fflush_found = yes; then
   AC_DEFINE(FFLUSH_DEFINED,1,[define if stdio.h declares fflush])
fi
])dnl
AC_DEFUN(AC_SCANF_DEFINED,
[AC_MSG_CHECKING(whether stdio.h declares scanf)
AC_CACHE_VAL(ac_cv_scanf_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]scanf[^a-zA-Z_]>>changequote([, ])dnl
, stdio.h, ac_cv_scanf_found=yes, ac_cv_scanf_found=no)
])
AC_MSG_RESULT($ac_cv_scanf_found)
if test $ac_cv_scanf_found = yes; then
   AC_DEFINE(SCANF_DEFINED,1,[define if stdio.h declares scanf])
fi
])dnl
AC_DEFUN(AC_FCLOSE_DEFINED,
[AC_MSG_CHECKING(whether stdio.h declares fclose)
AC_CACHE_VAL(ac_cv_fclose_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]fclose[^a-zA-Z_]>>changequote([, ])dnl
, stdio.h, ac_cv_fclose_found=yes, ac_cv_fclose_found=no)
])
AC_MSG_RESULT($ac_cv_fclose_found)
if test $ac_cv_fclose_found = yes; then
   AC_DEFINE(FCLOSE_DEFINED,1, [define if stdio.h declares fclose])
fi
])dnl
AC_DEFUN(AC_REWIND_DEFINED,
[AC_MSG_CHECKING(whether stdio.h declares rewind)
AC_CACHE_VAL(ac_cv_rewind_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]rewind[^a-zA-Z_]>>changequote([, ])dnl
, stdio.h, ac_cv_rewind_found=yes, ac_cv_rewind_found=no)
])
AC_MSG_RESULT($ac_cv_rewind_found)
if test $ac_cv_rewind_found = yes; then
   AC_DEFINE(REWIND_DEFINED,1, [define if stdio.h declares rewind])
fi
])dnl
AC_DEFUN(AC_PUTS_DEFINED,
[AC_MSG_CHECKING(whether stdio.h declares puts)
AC_CACHE_VAL(ac_cv_puts_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]puts[^a-zA-Z_]>>changequote([, ])dnl
, stdio.h, ac_cv_puts_found=yes, ac_cv_puts_found=no)
])
AC_MSG_RESULT($ac_cv_puts_found)
if test $ac_cv_puts_found = yes; then
   AC_DEFINE(PUTS_DEFINED,1,[define if stdio.h declares puts])
fi
])dnl
AC_DEFUN(AC_FPUTS_DEFINED,
[AC_MSG_CHECKING(whether stdio.h declares fputs)
AC_CACHE_VAL(ac_cv_fputs_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]fputs[^a-zA-Z_]>>changequote([, ])dnl
, stdio.h, ac_cv_fputs_found=yes, ac_cv_fputs_found=no)
])
AC_MSG_RESULT($ac_cv_fputs_found)
if test $ac_cv_fputs_found = yes; then
   AC_DEFINE(FPUTS_DEFINED,1,[define if stdio.h declares fputs])
fi
])dnl
AC_DEFUN(AC_TIME_DEFINED,
[AC_MSG_CHECKING(whether time.h declares time)
AC_CACHE_VAL(ac_cv_time_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]time[^a-zA-Z_]>>changequote([, ])dnl
, time.h, ac_cv_time_found=yes, ac_cv_time_found=no)
])
AC_MSG_RESULT($ac_cv_time_found)
if test $ac_cv_time_found = yes; then
   AC_DEFINE(TIME_DEFINED,1,[define if time.h declares time])
fi
])dnl
AC_DEFUN(AC_SETRLIMIT_DEFINED,
[AC_MSG_CHECKING(whether sys/resource.h declares setrlimit)
AC_CACHE_VAL(ac_cv_setrlimit_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]setrlimit[^a-zA-Z_]>>changequote([, ])dnl
, sys/resource.h, ac_cv_setrlimit_found=yes, ac_cv_setrlimit_found=no)
])
AC_MSG_RESULT($ac_cv_setrlimit_found)
if test $ac_cv_setrlimit_found = yes; then
   AC_DEFINE(SETRLIMIT_DEFINED,1, [define if setrlimit is declared in sys/resource.h])
fi
])dnl
AC_DEFUN(AC_LISTEN_DEFINED,
[AC_MSG_CHECKING(whether sys/socket.h declares listen)
AC_CACHE_VAL(ac_cv_listen_found,
[AC_EGREP_HEADER(
changequote(<<, >>)dnl
<<[^a-zA-Z_]listen[^a-zA-Z_]>>changequote([, ])dnl
, sys/socket.h, ac_cv_listen_found=yes, ac_cv_listen_found=no)
])
AC_MSG_RESULT($ac_cv_listen_found)
if test $ac_cv_listen_found = yes; then
   AC_DEFINE(LISTEN_DEFINED,1, [define if listen is declared in sys/socket.h])
fi
])dnl
dnl
AC_DEFUN(AC_HAS_STRUCT_HOSTENT,
[AC_CACHE_CHECK([whether struct hostent is in netdb.h or winsock.h],
  ac_cv_struct_hostent,
[AC_TRY_COMPILE([#include <netdb.h>],
[struct hostent vec;],
  ac_cv_struct_hostent=yes, 
[AC_TRY_COMPILE([#include <winsock.h>],
[struct hostent vec;],
  ac_cv_struct_hostent=yes, ac_cv_struct_hostent=no)])
])]
if test $ac_cv_struct_hostent = yes; then
  AC_DEFINE(HAS_STRUCT_HOSTENT, 1,[define if struct hostent is declared in netdb.h or winsock.h])
fi)
])
AC_DEFUN(AC_STRUCT_FDS_BITS,
[AC_CACHE_CHECK([for fds_bits in fd_set], ac_cv_struct_fds_bits,
[AC_TRY_COMPILE([#include <sys/select.h>], [fd_set s; s.fds_bits[0];],
ac_cv_struct_fds_bits=yes, ac_cv_struct_fds_bits=no)])
if test $ac_cv_struct_fds_bits = yes; then
  AC_DEFINE(HAVE_FDS_BITS,1,[Define if fd_set has element fds_bits])
fi
])
AC_DEFUN(AC_STRUCT_IOVEC,
[AC_CACHE_CHECK([whether struct iovec is in sys/uio.h],
  ac_cv_struct_iovec,
[AC_TRY_COMPILE([#include <sys/types.h>
#include <sys/uio.h>],
[struct iovec *vec;],
  ac_cv_struct_iovec=yes, ac_cv_struct_iovec=no)])
if test $ac_cv_struct_iovec = no; then
  AC_DEFINE(NEED_IOVEC_DEFINE)
fi
])
