/**
 * @ Wenchang
 * @time Apr, 2002
 */

import java.io.*;

public class Performance implements ExperimentConst
{
  public static void main (String[] args) {
    Performance cr = new Performance();
    cr.Calculate();
  }

  /** 
   * Test the performance difference of the original avs demo and 
   * the demo which uses isg-generated code.
   * Measurements: 1. The init procedure of raw ECho channel start up
   *               2. The # of frames transferred from the avs source
   *                  to the avs player in certain amount of time.
   * Note: The calculation reads in the data from `time_rec' file
   *       which records the performance data got from a shell script.
   */

  public void Calculate() {
    BufferedReader br = null;

    try {
	br = new BufferedReader(new InputStreamReader
	    (new FileInputStream
	    (PerformanceFile)));
      } catch (IOException e) {
      }	

    String line;
    String tmp;
	
    try {
	line = br.readLine();
	
	while (null!= line) {

	    line = line.trim();
	    
	    parseLine(line);
		
	    //System.out.println(initTime+", "+transferTime+", "+numberOfFrame);
	    init[numOfRec] = initTime;
	    trans[numOfRec] = transferTime/numberOfFrame;


	    initTotal += initTime;
	    transferTotal += transferTime;
	    numberOfFrameTotal += numberOfFrame;
	    
	    numOfRec ++;
	    line = br.readLine();
	}
    }
    catch (IOException e) {
    }

    //Calculate the statistics
    initAvg = initTotal/numOfRec;
    transAvg = transferTotal/numberOfFrameTotal;
    for (int i=0;i<numOfRec;i++) {
	initSxx += (init[i] - initAvg)*(init[i]-initAvg);
	transSxx += (trans[i] - transAvg)*(trans[i] - transAvg);
    }


    //output the result
    System.out.println(" ========================================");
    //System.out.println(initTotal+", "+transferTotal+", "+numberOfFrameTotal);
    System.out.println(" "+numOfRec+" records measured.");
    System.out.println(" Avg init time of ECho channel      : "+
		       initTotal/numOfRec/1000 + " milli-sec");
    System.out.println(" Total transfer time of video frames: "+
		       transferTotal + " sec");
    System.out.println(" Avg transfer time per video frame  : "+
		       transferTotal/numberOfFrameTotal+" sec");

    System.out.println(" ========================================");
    System.out.println("    initAvg :"+ initAvg +", initSxx : "+initSxx);
    System.out.println("    transAvg:"+ transAvg+", transSxx: "+transSxx);
  }

    public void parseLine(String line) {
	
	//try {
	    int idx1=line.indexOf("Init:");
	    idx1 += 5; //the length of "Init:"
	    int idx2=line.indexOf(',');
	    
	    initTime = Double.parseDouble(line.substring(idx1,idx2-1));
	    
	    idx1=line.indexOf("Streaming:");
	    idx1 += 10;
	    idx2 =line.indexOf(",", idx1);
	    transferTime = Double.parseDouble(line.substring(idx1,idx2-1));
		
	    idx1=line.indexOf("frames:");
	    idx1 += 7;
	    numberOfFrame=Double.parseDouble(line.substring(idx1));
	    //}
	    //catch (IOException e) {
	    //}
    }
	    
    double initTime, transferTime, numberOfFrame;
    double initTotal, transferTotal, numberOfFrameTotal;
    int numOfRec;
    int times = 100; //100 tests in total
    double init[] = new double[times];
    double trans[] = new double[times];
    double initAvg, initSxx, transAvg, transSxx;

}
