#! /bin/bash

if [ $# -lt 1 ];
then 
    echo "Testing program Usage: $0 <running time in sec>"
    exit 1
fi


AVS_ROOT=/usr/local/mware/UAV
Chan_id_file=$AVS_ROOT/../share/chanId


#start the src
cd $AVS_ROOT/src
./avs_source -c 1 -n 0 -o 6 &

sleep 2

#start the player

. $AVS_ROOT/scripts/player_env.sh


if [[ ! -a $Chan_id_file ]];
then 
    echo " File $Chan_id_file Not exists"
    exit 1
else 
    echo " Chan_id_file is $Chan_id_file"
fi

Chan_id=$(cat $Chan_id_file)

if [[ -z $Chan_id ]]
then 
    echo " Chan_id null"
    exit 1
fi
 
FORMAT_SERVER_HOST=localhost
export FORMAT_SERVER_HOST

cd $AVS_ROOT/player

#$3,4,5,6,7: host, port, mus, pixelsize, linesize
java avs.ViewClientWrapper "a" $Chan_id "2C" &

#Stop the demo after $1 sec
sleep $1

kill -9 `ps -ef|grep jdk|grep -v grep|awk '{print $2}'`
kill -SIGINT `ps -ef|grep avs_source|grep -v grep|awk '{print $2}'` 

echo "Bye..." 
