#! /bin/bash
###################################################
# $Id: test_receiver.sh,v 1.1.1.1 2003/06/11 18:49:00 wyan Exp $
# The modified version of `testloop.sh' + `test.sh'.
# The test will be run on 2 different laptops. The
# receiver run this script.
###################################################

ROOT=/usr/local/mware
#The time value to run the demo stored in this file: in sec's
SHARE_DIR=$ROOT/share
RT_VALUE_FILE=$SHARE_DIR/rt_value_file
RECEIVER_KILLED=$SHARE_DIR/rcvr_finished
SENDER_KILLED=$SHARE_DIR/sender_finished
NR_LOOP=$SHARE_DIR/nr_loop

function receiver() {
    AVS_ROOT=/usr/local/mware/UAV
    Chan_id_file=$AVS_ROOT/../share/chanId

    . $AVS_ROOT/scripts/player_env.sh

    if [[ ! -a $Chan_id_file ]];
    then 
	echo " File $Chan_id_file Not exists"
	exit 1
    else 
	echo " Chan_id_file is $Chan_id_file"
    fi

    Chan_id=$(cat $Chan_id_file)

    if [[ -z $Chan_id ]]
    then 
	echo " Chan_id null"
	exit 1
    fi
 
    FORMAT_SERVER_HOST=$FSH    #.168.1.12
    export FORMAT_SERVER_HOST

    cd $AVS_ROOT/player
    #$3,4,5,6,7: host, port, mus, pixelsize, linesize
    java avs.ViewClientWrapper "a" $Chan_id "2C" &
    
    #Stop the demo after $1 sec
    while [[ ! -a $SENDER_KILLED ]]
    do 
        echo "Wait for $SENDER_KILLED to be output"
	sleep 1
    done

    kill -9 `ps -ef|grep jdk|grep -v grep|awk '{print $2}'`
    
    if rm $SENDER_KILLED
    then 
      echo "$SENDER_KILLED removed "
    else 
      echo "No previous $SENDER_KILLED"
    fi

    touch $RECEIVER_KILLED
    
    echo "Bye..." 
}

##############################################

if [[ $# -lt 1 ]];
then 
  echo "Usage: test_receiver.sh <format_server_host>"
  exit 1
fi
 
TIME=101
FSH=$1
echo $TIME > $NR_LOOP
echo " $TIME output to $NR_LOOP ! "

LOOP=0

#Remove the previous log file
if rm $RT_VALUE_FILE && $SENDER_KILLED && RECEIVER_KILLED;
then
  echo "Previous time_rec  removed"
else
  echo "No previous time_rec  exists"
fi

echo "wait sender script to start ..."

while [[ $LOOP -lt $TIME ]]
do 

  while [[ ! -a $RT_VALUE_FILE ]]
  do 
    sleep 2
    echo "loop ... $RT_VALUE_FILE "
  done

  echo " $RT_VALUE_FILE found"

  sleep 2
  if rm $RT_VALUE_FILE;
    then 
      echo "$RT_VALUE_FILE removed "
    else 
      echo "No previous $RT_VALUE_FILE"
  fi

  receiver 

  let "LOOP = LOOP + 1"
  echo -n "   Receiver $LOOP run ends >>>>>>>>>>>>>>>>>>"

  sleep 2
done
