#! /bin/bash
###################################################
# $Id: test_sender.sh,v 1.1.1.1 2003/06/11 18:49:00 wyan Exp $
# The modified version of `testloop.sh' + `test.sh'.
# The test will be run on 2 different laptops. The
# sender run this script. 
# Start the receiver first !!!!!!!
###################################################

ROOT=/usr/local/mware
SHARE_DIR=$ROOT/share
#The time value to run the demo stored in this file: in sec's.
#But the value is NOT used. Just for indicating sender has started.
RT_VALUE_FILE=$SHARE_DIR/rt_value_file
RECEIVER_KILLED=$SHARE_DIR/rcvr_finished
SENDER_KILLED=$SHARE_DIR/sender_finished
NR_LOOP=$SHARE_DIR/nr_loop

LOW=10 # 10 sec
HIGH=50 # 50 sec
function rng() {
    a=$1
    X=$2
    b=$3
    M=$4
    let "rn = (a * X + b) % M"
    echo $rn # get around the limit of integer value of 256 in return value
}

function sender() {
    AVS_ROOT=/usr/local/mware/UAV
    Chan_id_file=$AVS_ROOT/../share/chanId

    #start the src
    cd $AVS_ROOT/src
    ./avs_source -c 1 -n 0 -o 6 &

    #output the time
    sleep 1
    echo "in sender(): 1st arg = $1"
    echo $1 > $RT_VALUE_FILE

    #Stop the demo after $1 sec
    sleep $1
    
    kill -SIGINT `ps -ef|grep avs_source|grep -v grep|awk '{print $2}'` 

    touch $SENDER_KILLED
    echo "Bye..." 
}



#Remove the previous log file
if rm $ROOT/UAV/src/time_rec 
then
  echo "Previous time_rec  removed"
else
  echo "No previous time_rec  exists"
fi

#TIME=10 # 10 times
LOOP=0
X0=1

#get the loop_nr of from the receiver
if [[ ! -a $NR_LOOP ]];
then 
  echo -n "File $NR_LOOP not exist"
  exit 1
else 
  TIME=$(cat $NR_LOOP)
  echo "$NR_LOOP==$TIME times will be run"
fi


while [[ $LOOP -lt $TIME ]]
do 
  X0=`rng 13821 $X0 0 32768`

  let "remainder = X0 % HIGH" 
  #until find a number s.t. $LOW<= ? <=$HIGH
  echo -n "      >>>>>> X0 is $X0 "
  echo
  
  while [[ $remainder -lt $LOW ]]
    do 
      X0=`rng 13821 $X0 0 32768`
      let "remainder = X0 % HIGH" # rn still too large
      #let "tmp = X0"
      #echo -n "X0 is $tmp"
      echo -n "      >>>>>>> X0 is $X0"
    done


  #Call test.sh with X0 as parameter
  #echo $remainder > $RT_VALUE_FILE
  touch $RT_VALUE_FILE 

  echo " $remainder output to $RT_VALUE_FILE"

  sender $remainder

  echo -n "   Sender $LOOP run $remainder sec's >>>>>>>>>>>>>>>>>>"
  let "LOOP = LOOP + 1"

  #wait for the player to end
  while [[ ! -a $RECEIVER_KILLED ]]
  do 
    echo "Wait for $RECEIVER_KILLED to be output"
    sleep 1
  done

  rm -f $RECEIVER_KILLED
done
