// @ Wenchang 
// @time Dec, 2001
//
// -*- mode: Java; c-basic-offset: 2; -*-

//
//
//  $Id: ViewClient.java,v 1.1.1.1 2003/06/11 18:48:51 wyan Exp $
//
//

package avs;

import java.io.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.color.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.geom.*;  // for 2D graphics stuff

import graph.*;//for plot chart

public class ViewClient
  extends JFrame
{
  boolean DEBUG=false;//false;
  String host,port,mus,pixelsize,pixelperline;
  
  JPanel drawPane = null;
  String chanId;
  JMenuItem filterItem, exitItem;
  JToggleButton pauseButton, edgeButton, halfButton, greyButton;
  JToggleButton shrinkButton, shrinkAvgButton;
  JToggleButton cropButton, zoomButton;
  JCheckBox ckboxCrop;
  JComboBox cropCombo, zoomCombo;
  JLabel lblStatus;
  Graphics g;
  BufferedImage image;
  WritableRaster color_raster, grey_raster, active_raster;
  DataBuffer db;
  ComponentColorModel color_ccm, grey_ccm, active_ccm;
  PixelInterleavedSampleModel active_csm;
  int frame_count = 0;
  Hashtable adaptation_table;
  LinkedList activeAdaptationList;
  StreamNode myStreamNode;
  /*vvv*/
  //String activeFormatTag;
  String activeFormatTag,newFormatTag;
  String shrinkFormatTag,shrinkAvgFormatTag;
  /*^^^*/
  boolean pauseOn;
  boolean drawCropRectangle;
  Rectangle cropRectangle;
  String cropFormatTag;
  avsCanvas canvas;
  FilterDialog filterFrame;
  echoPoller pollerThread;
  int activeHeight;
  int activeWidth;
  /*vvv*/
  final int DEFAULT_IMAGE_HEIGHT = 240;//480;
  final int DEFAULT_IMAGE_WIDTH = 320;//640;
  /*^^^*/
  boolean activeIsColor;
  int imageXOffset;
  int imageYOffset;

  /*vvv*/
    JTabbedPane tabPane;
    JPanel imagePane, plotPane;
    FpsPane fpsChart;
    BandwidthPane bwChart;
  /*^^^*/
  
  //  public native int startup();
  public native int startup(String host,int port,int musvalue,
			      int pixelsize,int pixelperline);

  public native int runNetwork (String chan, String formatId);
  public native void stopEcho();
  public native String goChannel (String chan, String formatId, Object param);
  public native String adapt (String streamletId, Object param);
  public native String adaptFrom (String chanId, String streamletId, Object param);

  public static void main (String s[])
  {
    System.loadLibrary ("avsjni");
    ViewClient theframe = new ViewClient ("avs client", new StreamNode (s[0], s[1], s[2]),"localhost","12345","15360","3","640");
  }

    //ViewClient (String caption, StreamNode sn)
    ViewClient(String caption,StreamNode sn, String host, String port,
	       String mus, String pixelsize, String pixelperline)
  {
    super (caption);

    //passing the options values
    this.host=host;
    this.port=port;
    this.mus=mus;
    this.pixelsize=pixelsize;
    this.pixelperline=pixelperline;

    adaptation_table = new Hashtable();
    adaptation_table.put ("", sn);
    activeAdaptationList = new LinkedList();
    
    buildInterface();
    filterFrame = new FilterDialog();
    status ("interface ready...\n");


    myStreamNode = sn;
    chanId = sn.chanId;
    activeFormatTag = sn.formatId;
    addWindowListener (new byebye());

    char tagChar = activeFormatTag.charAt (0);
    if (tagChar == '1')
      {
        activeHeight = 480;
        activeWidth = 640;
      }
    else if (tagChar == '2')
      {
        activeHeight = 240;
        activeWidth = 320;
      }
    else if (tagChar == '3')
      {
        activeHeight = 120;
        activeWidth = 160;
      }
    else if (tagChar == '4')
      {
        activeHeight = 60;
        activeWidth = 80;
      }

    tagChar = activeFormatTag.charAt (1);
    activeIsColor = (tagChar == 'C');

    status ("about to start ECho poller thread...");
    startup(host, Integer.parseInt(port), Integer.parseInt(mus),
	    Integer.parseInt(pixelsize), Integer.parseInt(pixelperline));
    pollerThread = new echoPoller();
    pollerThread.start();

    //Start the plot panes
    fpsChart.startdraw();
    bwChart.startdraw();

    status ("done");

    pack();
    setVisible (true);
  }
  
  public void 
  addNotify()
  {
    int[] numbits = { 8, 8, 8 };
    int[] grey_numbits = { 1 };

    super.addNotify();

    active_ccm = color_ccm = new ComponentColorModel (ColorSpace.getInstance (ColorSpace.CS_sRGB),
                                                      numbits, false, false,
                                                      Transparency.OPAQUE,
                                                      DataBuffer.TYPE_BYTE);

    grey_ccm = new ComponentColorModel (ColorSpace.getInstance (ColorSpace.CS_GRAY),
                                        grey_numbits, false, false,
                                        Transparency.OPAQUE,
                                        DataBuffer.TYPE_BYTE);

    db = new DataBufferByte (DEFAULT_IMAGE_HEIGHT * DEFAULT_IMAGE_WIDTH * 3);

    buildImage (activeWidth, activeHeight, activeIsColor);
  }


  private void
  buildImage (int width, int height, boolean isColor)
  {
    int[] bandoffsets = { 0, 1, 2 };
    int[] grey_bandoffsets = { 0 };

    active_csm = null;

    if (isColor)
      {
        active_csm = new PixelInterleavedSampleModel (DataBuffer.TYPE_BYTE,
                                                      width, height, 3,
                                                      width * 3,
                                                      bandoffsets);
        active_ccm = color_ccm;
      }
    else
      {
        active_csm = new PixelInterleavedSampleModel (DataBuffer.TYPE_BYTE,
                                                      width, height, 1,
                                                      width,
                                                      grey_bandoffsets);
        active_ccm = grey_ccm;
      }
    
    active_raster = null;
    active_raster = Raster.createWritableRaster (active_csm, db, new Point (0,0));
    
    image = null;
    image = new BufferedImage (active_ccm, active_raster, false, null);
    imageXOffset = (DEFAULT_IMAGE_WIDTH - width) / 2;
    imageYOffset = (DEFAULT_IMAGE_HEIGHT - height) / 2;
    
    //System.out.println(" [buildImage(): default_w: "+DEFAULT_IMAGE_WIDTH+", default_h: "+DEFAULT_IMAGE_HEIGHT+", w:"+width+", h:"+height+", xoffset:"+imageXOffset+", yoffset:"+imageYOffset);
	       
  }

    //The so-called `update_method_id' in avs_viewClient.cc
    //Every frame is updated to the screen from here.
  public void new_frame (int wd, int ht, int size, byte buff[])
  {
    if (!pauseOn)
    {
      status ("Got a frame (" + (++frame_count) + "): [" + wd + "x" + ht + "], " + size);
      
      active_raster.setDataElements (0, 0, wd, ht, buff);
      canvas.repaint();
      
      if (frame_count % 10 == 0) {
        //Debug.out (4, "Memory: " + Runtime.getRuntime().totalMemory () +
        //         "/" + Runtime.getRuntime ().freeMemory ());
        //        Runtime.getRuntime().gc ();
      }
    }

      //bookkeeping
      /**/
      fpsChart.setValue(frame_count, size);
      bwChart.setValue(frame_count,size);
      /**/
  }

  void 
    closeMe()
  {
    System.exit (0);
  }

  private void 
    buildInterface()
  {
    JMenuBar mb = new JMenuBar();
    JMenu viewerMenu = new JMenu ("viewer");
    filterItem = new JMenuItem ("filter...");
    exitItem = new JMenuItem ("close");
    viewerMenuListener vml = new viewerMenuListener();
    filterItem.addActionListener (vml);
    exitItem.addActionListener (vml);
    //viewerMenu.add (filterItem);
    viewerMenu.add (exitItem);
    KeyStroke ks = KeyStroke.getKeyStroke (KeyEvent.VK_C, Event.ALT_MASK);
    exitItem.setAccelerator (ks);
    viewerMenu.setMnemonic ('C');
    mb.add (viewerMenu);
    setJMenuBar (mb);

    // build the list pane
    getContentPane().add(Box.createVerticalStrut(20));
    getContentPane().setLayout (new BoxLayout (getContentPane(), BoxLayout.Y_AXIS));
    
    JPanel p1 = new JPanel();
    p1.setLayout (new BoxLayout (p1, BoxLayout.X_AXIS));
    tabPane = new JTabbedPane(SwingConstants.BOTTOM);
    
    imagePane = new JPanel();
    plotPane = new JPanel();
    
    tabPane.setPreferredSize(new Dimension(400,300));
        
    //drawPane = new JPanel();
    //drawPane.setLayout (new FlowLayout());
    /*vvv*/
    //drawPane.setPreferredSize (new Dimension (650,500));
    //drawPane.setPreferredSize (new Dimension (400,300));    


    canvas = new avsCanvas();
    //    canvas.setBorder (BorderFactory.createEtchedBorder());
    canvas.setPreferredSize (new Dimension (DEFAULT_IMAGE_WIDTH, DEFAULT_IMAGE_HEIGHT));
    canvas.setSize (new Dimension (DEFAULT_IMAGE_WIDTH, DEFAULT_IMAGE_HEIGHT));

    imagePane.add(canvas);

    //the plot pane
    plotPane.setLayout(new GridLayout(2,1));
    fpsChart = new FpsPane();
    bwChart = new BandwidthPane();
    plotPane.add(fpsChart);
    plotPane.add(bwChart);

    tabPane.add (plotPane,"Bandwidth");
    tabPane.add (imagePane,"Video");

    p1.add (tabPane);

    p1.add (Box.createHorizontalStrut (5));

    // set up button bar 
    JPanel controlPane = new JPanel();
    addControls (controlPane);
    p1.add (controlPane);
    getContentPane().add (p1);
    getContentPane().add (Box.createVerticalStrut (2));

    JPanel statusPane = new JPanel();
    statusPane.setBorder (BorderFactory.createEtchedBorder());
    lblStatus = new JLabel();
    lblStatus.setHorizontalAlignment (JLabel.LEFT);
    statusPane.add (lblStatus);
    getContentPane().add (statusPane);
  }

  private void 
  status (String s)
  {
    lblStatus.setText (s);
  }

  protected class viewerMenuListener implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      if (e.getSource() == exitItem)
        {
          closeMe();
        }
      else if (e.getSource() == filterItem)
        {
          filterFrame.setVisible (true);
        }
    }
  }

  protected class controlItemListener 
    implements ItemListener
  {
    public void 
      itemStateChanged (ItemEvent e)
    {
      doAdaptation (e);
    }
  }

  /*vvv*/
  void printLinkedList() 
  {
    if (null==activeAdaptationList ) {
      System.out.println(" [printLinkedList(): LinkedList NULL ");
    }
    else {
      System.out.println(" [printLiskedList(): List size:"+activeAdaptationList.size()+" List contents:");
      StreamNode sn;
      for (int i=0;i<activeAdaptationList.size();i++) {
	sn = (StreamNode)activeAdaptationList.get(i);
	if (sn !=null)
	  System.out.println("  ["+i+":"+sn.formatId+":"+sn.streamletId);
	  	         }
    }
    System.out.println(" \n");
  }

  void printHashTable()
  {
    if (null==adaptation_table) {
      System.out.println(" [printHashTable(): hashtable not exists");
    }
    else {
      System.out.println(" [printHashTable(): hashtable contents:");
      Enumeration e = adaptation_table.keys();
      for (; e.hasMoreElements();) {
	String key = (String)e.nextElement();

	StreamNode sn = (StreamNode)adaptation_table.get(key);
      	if (key.equals(""))
	  key = "EMPTY";
	  System.out.println("  key: "+key+" value:"+sn.formatId+":"+sn.streamletId);
      }
      System.out.println(" \n");
    }
  }

  protected void
    doAdaptation (ItemEvent e)
  {
    StreamNode ad;
    String streamletId = null;
    /*vvv*/
    //String newFormatTag = activeFormatTag;
    newFormatTag = activeFormatTag;
    /*^^^*/
    Object param = null;
    boolean rebuildImage = false;
    int deadListPos = 0;

    boolean on_off = (e.getStateChange() == ItemEvent.SELECTED);
    ItemSelectable which = e.getItemSelectable();
    if (which == edgeButton)
      {
	/*vvv*/
	/*
        streamletId = "edgeImage" + activeFormatTag;
        if (on_off)
          {
            greyButton.setEnabled (false);
          }
        else
          {
            greyButton.setEnabled (true);
          }
	  */
	/**/
        if (on_off)
          {
            greyButton.setEnabled (false);
	    //activeFormatTag = activeFormatTag.replace('G','C');
          }
        else
          {
            greyButton.setEnabled (true);
	    activeFormatTag = activeFormatTag.replace('C','G');
          }
	streamletId = "edgeImage"+activeFormatTag;
	/**/
	/*^^^*/
      }
    else if (which == greyButton)
      {
        streamletId = "greyImage" + activeFormatTag;
        activeIsColor = !on_off;
        rebuildImage = true;
        if (on_off)
          {
            edgeButton.setEnabled (true);
          }
	/*vvv*/
        //newFormatTag = newFormatTag.replace ('C', 'G');
	activeFormatTag = newFormatTag.replace ('C', 'G');
	/*^^^*/
	/*vvv*/
	/**/
	if (!on_off) {
	  activeFormatTag = activeFormatTag.replace('G','C');
	  streamletId = "greyImage" + activeFormatTag;
	}
	/**/
	/*^^^*/
      }
    else if (which == halfButton)
      {
        streamletId = "halfRate";
      }
    else if (which == cropButton)
      {
	/*vvv*/
        //streamletId = "cropImage1Cto" + cropFormatTag;
	streamletId = "cropImage2Cto" + cropFormatTag;
	/*^^^*/
        if (on_off)
          {
            param = cropRectangle;
            activeHeight = cropRectangle.height;
            activeWidth = cropRectangle.width;
	    /*vvv*/
            //newFormatTag = cropFormatTag;
	    activeFormatTag = cropFormatTag;
	    /*^^^*/
          }
        else
          {
            activeHeight = DEFAULT_IMAGE_HEIGHT;
            activeWidth = DEFAULT_IMAGE_WIDTH;
	    /*vvv*/
            //newFormatTag = "2C";//"1C";
	    activeFormatTag = "2C";//"2C";
	    /*^^^*/
          }
        ckboxCrop.setEnabled (!on_off);
        cropCombo.setEnabled (!on_off);
        drawCropRectangle = !on_off;
        rebuildImage = true;
      } 
    else if (which == shrinkButton)
      {
        if (on_off)
          {
	    int CIndx = newFormatTag.indexOf('C');
	    if (-1==CIndx || 0==CIndx) {
	      //Not allowed or Impossible
	    }
	    else {
	      char ch = newFormatTag.charAt(CIndx-1);
	      if (ch=='2') {
		streamletId = "shrinkImage"+"2Cto3C";
		activeHeight = 120;
		activeWidth = 160;
		activeFormatTag = "3C";
		shrinkFormatTag = "2Cto3C";
	      }
	      else if (ch=='3') {
		streamletId = "shrinkImage"+"3Cto4C";
		activeHeight = 60;
		activeWidth = 80;
		activeFormatTag = "4C";
		shrinkFormatTag = "3Cto4C";
	      }
	    }
          }
        else
          {
	    streamletId = "shrinkImage"+shrinkFormatTag;
	    if (newFormatTag.equals("3C")) {
		activeHeight = 240;
		activeWidth = 320;
	      activeFormatTag = "2C";
	    }
	    else if (newFormatTag.equals("4C")) {
		activeHeight = 120;
		activeWidth = 160;
	      activeFormatTag = "3C";
	    }
          }
	rebuildImage = true;
      }
    else if (which == shrinkAvgButton)
      {
        if (on_off)
          {
	    int CIndx = newFormatTag.indexOf('C');
	    if (-1==CIndx || 0==CIndx) {
	      //Not allowed or Impossible
	    }
	    else {
	      char ch = newFormatTag.charAt(CIndx-1);
	      if (ch=='2') {
		streamletId = "shrinkAvgImage"+"2Cto3C";
		activeHeight = 120;
		activeWidth = 160;
		activeFormatTag = "3C";
		shrinkAvgFormatTag = "2Cto3C";
	      }
	      else if (ch=='3') {
		streamletId = "shrinkAvgImage"+"3Cto4C";
		activeHeight = 60;
		activeWidth = 80;
		activeFormatTag = "4C";
		shrinkAvgFormatTag = "3Cto4C";
	      }
	    }
          }
        else
          {
	    streamletId = "shrinkAvgImage"+shrinkAvgFormatTag;
	    if (newFormatTag.equals("3C")) {
		activeHeight = 240;
		activeWidth = 320;
	      activeFormatTag = "2C";
	    }
	    else if (newFormatTag.equals("4C")) {
		activeHeight = 120;
		activeWidth = 160;
	      activeFormatTag = "3C";
	    }
          }
	rebuildImage = true;
      }
    if (DEBUG) {    
	System.out.println("\n");
	System.out.println(" [doAdaptation(): Please check info below:");
	System.out.println("    activeFormatTag="+activeFormatTag);
	printLinkedList();
	printHashTable();
    }
    
    if (!on_off)
      {
	  if (DEBUG) System.out.println(" [doAdaptation(): Button Not Selected");

        /*
         *  remove the adaptation name from the list
         */
        for (deadListPos = 0; deadListPos < activeAdaptationList.size(); deadListPos++)
          {
            StreamNode tsn = (StreamNode) activeAdaptationList.get (deadListPos);
	    if (DEBUG)
		System.out.println("     streamletId:"+streamletId+", tsn.streamletId:"+tsn.streamletId);

            if (tsn.streamletId.equals (streamletId))
              {
		  activeAdaptationList.remove (deadListPos);
		if (DEBUG)
		    System.out.println("  :"+streamletId+" removed");

                break;
              }
          }
      }
    else
      {
	  if (DEBUG) {
	      System.out.println(" [doAdaptation(): Button Selected");
	      System.out.println("   :"+streamletId+": added to the LinkedList");
	  }

        /*  adding the adaptation to the list  */
        StreamNode nsn = new StreamNode();
        nsn.streamletId = streamletId;
        nsn.param = param;
        activeAdaptationList.add (nsn);
      }

    /*
     *  now that the active list is properly set up, start looking into
     *  the hashtable.
     *  - first build the whole string of adaptations
     *  - look in the table for this string
     *    - if we find it, use the associated channel
     *  - if we don't find it:
     *  - build a new string with the last adaptation left off
     *  - look for this string in the hashtable
     *  - continue this until we find a string that is in the hashtable
     *  - once found:
     *    - work forward along the original adaptation string - for each adaptation
     *      that was removed during this search,
     *      - get the channel from the previous string that was found, or the base
     *        channel for the player if no previous string now exists
     *      - derive a new channel by using the last-discarded adaptation segment
     *      - build the appropriate adaptation string and insert it into the hashtable,
     *        associating the just-derived channel with it.  This becomes the 'previous
     *        channel' for the next iteration of the loop.
     *      - loop terminates when last adaptation is performed
     *
     */
    frame_count = 0;

    int s = activeAdaptationList.size();
    String partialString;
    String startChanId;
    if (DEBUG)
	System.out.println ("   Adaptation string (" + getAdaptationString (s) + ")");
    ad = (StreamNode) adaptation_table.get (getAdaptationString (s));
    if (ad != null)
      {
	  if (DEBUG)
	      System.out.println(" [doAdaptation(): ad != null");

        // yahoo, we found the sucker straightaway - no derivation necessary
        goChannel (ad.chanId, ad.formatId, ad.param);
	if (DEBUG)
	    System.out.println ("   Calling goChannel with format (" + ad.formatId + ")");
      }
    else
      {
	  if (DEBUG)
	      System.out.println(" [doAdaptation(): ad == null");

        // no joy
        int t = s - 1;
        startChanId = getBaseChanId();
        while (ad == null)
          {
	      if (DEBUG)
		  System.out.println(" [doAdaptation(): ad == null : while (ad==null)");

            partialString = getAdaptationString (t);
	    if (DEBUG)
		System.out.println ("     partialString (" + partialString + ")");
            ad = (StreamNode) adaptation_table.get (partialString);
            if (ad != null)
              {
		  if (DEBUG)
		      System.out.println("     ad!=null: "+ad.formatId+":"+ad.streamletId);
                startChanId = ad.chanId;
              }
            else
              {
		  if (DEBUG)
		      System.out.println("      ad==null: t--");

                t--;
              }
          }

        //        t++;

        while (t < s)
          {
	      if (DEBUG)
		  System.out.println(" [doAdaptation(): ad == null : while (t<s)");


            StreamNode new_ad;
            ad = (StreamNode) activeAdaptationList.get (t);
            String tstring = getAdaptationString (t+1);
            if (DEBUG) System.out.println (" <"+startChanId +">, tstring (" + tstring + ")");
            startChanId = adaptFrom (startChanId, ad.streamletId, ad.param);
	    if (DEBUG) System.out.println (" <"+startChanId +">");

            new_ad = new StreamNode (ad);
            new_ad.chanId = startChanId;
	    /*vvv*/
            //new_ad.formatId = newFormatTag;
	    new_ad.formatId = activeFormatTag;
	    /*^^^*/
            adaptation_table.put (tstring, new_ad);
	    if (DEBUG)
	    System.out.println(" :"+tstring+":"+new_ad.formatId+" has been put into the adaptation_table");

            t++;
          }
      }

    if (rebuildImage)
      buildImage (activeWidth, activeHeight, activeIsColor);
  }

  private String
    getBaseChanId()
  {
    return chanId;
  }

  private String
    getAdaptationString (int stopPos)
  {
    int i;
    int s;
    StringBuffer sb = new StringBuffer("");

    if (stopPos > activeAdaptationList.size()) return null;
    
    for (i = 0; i < stopPos; i++)
      {
        StreamNode sn = (StreamNode)activeAdaptationList.get(i);
        sb.append (sn.streamletId);
        if (i < stopPos - 1)
          {
            sb.append (':');
          }
      }

    return sb.toString();
  }
    
  

  private void 
    addControls (JPanel cp)
  {
    GridBagConstraints gbc = new GridBagConstraints();

    gbc.gridx = 0;
    gbc.gridy = GridBagConstraints.RELATIVE;
    gbc.gridwidth = gbc.gridheight = 1;
    gbc.fill = GridBagConstraints.NONE;
    gbc.ipadx = gbc.ipady = 0;
    gbc.insets = new Insets (0, 0, 0, 0);
    gbc.anchor = GridBagConstraints.CENTER;
    gbc.weightx = gbc.weighty = 0;

    cp.setLayout (new GridBagLayout());

    //  we need the following controls
    //
    //  enlarge/reduce - drop-down combo box
    //  crop - drag rectangle around image
    //  pause - in-out pushbutton
    //  edge-detection - in-out-pushbutton
    //  greyscale - in-out-pushbutton
    //  half-rate - in-out-pushbutton
    //
    //  on top need a listbox with all active displays
    //  then rect for focus box
    //  then control-set
    // 

    pauseButton = new JToggleButton ("pause");
    pauseButton.addItemListener (new ItemListener()
      {
        public void itemStateChanged (ItemEvent e)        {
          if (e.getStateChange() == ItemEvent.SELECTED)
            {
              pauseButton.setText ("play");
              pauseOn = true;
            }
          else
            {
              pauseButton.setText ("pause");
              pauseOn = false;
            }
        }
      });
    cp.add (pauseButton, gbc);
    pauseOn = false;

    cp.add (Box.createVerticalStrut (25), gbc);

    shrinkButton = new JToggleButton("shrink");    
    shrinkAvgButton = new JToggleButton("shrink detect");
    edgeButton = new JToggleButton ("edge detect");
    edgeButton.setEnabled (false);
    greyButton = new JToggleButton ("greyscale");
    halfButton = new JToggleButton ("half-rate");
    controlItemListener cil = new controlItemListener();
    shrinkButton.addItemListener(cil);
    shrinkAvgButton.addItemListener(cil);
    edgeButton.addItemListener (cil);
    greyButton.addItemListener (cil);
    halfButton.addItemListener (cil);
    
    cp.add(shrinkButton,gbc);
    cp.add(Box.createVerticalStrut (1), gbc);
    cp.add(shrinkAvgButton,gbc);
    cp.add(Box.createVerticalStrut (2), gbc);
    cp.add (edgeButton, gbc);
    cp.add (Box.createVerticalStrut (2), gbc);
    cp.add (greyButton, gbc);
    cp.add (Box.createVerticalStrut (2), gbc);
    cp.add (halfButton, gbc);
    cp.add (Box.createVerticalStrut (5), gbc);

    /*
    JPanel zoomPanel = new JPanel();
    zoomPanel.add (new JLabel ("enlarge / reduce"));
    zoomPanel.add (Box.createHorizontalStrut (2));
    zoomCombo = new JComboBox();
    zoomCombo.setEditable (false);
    zoomCombo.addItem ("0.125x");
    zoomCombo.addItem ("0.25x");
    zoomCombo.addItem ("0.5x");
    zoomCombo.addItem ("0.75x");
    zoomCombo.addItem ("1x");
    zoomCombo.addItem ("2x");
    zoomCombo.addItem ("4x");
    zoomCombo.addItem ("8x");
    zoomPanel.add (zoomCombo);
    zoomPanel.add (Box.createHorizontalStrut (2));
    zoomButton = new JToggleButton ("zoom it");
    zoomButton.addItemListener (cil);
    zoomButton.setEnabled (false);
    zoomCombo.setEnabled (false);
    zoomPanel.add (zoomButton);
    cp.add (zoomPanel, gbc);
    */

    JPanel cropPanel = new JPanel();
    cropCombo = new JComboBox();
    ckboxCrop = new JCheckBox ("crop");
    cropPanel.add (ckboxCrop);
    ckboxCrop.addItemListener (new ItemListener()
      {
        public void itemStateChanged (ItemEvent e)
        {
          boolean b = ckboxCrop.isSelected();
          drawCropRectangle = b;
          //          cropCombo.setEnabled (b);
          //cropButton.setEnabled (b);
        }
      });
    drawCropRectangle = false;
    cropPanel.add (Box.createHorizontalStrut (2));
    cropPanel.add (cropCombo);
    cropCombo.setEditable (false);
    /*vvv*/
    //cropCombo.addItem ("320 x 240");
    /*^^^*/
    cropCombo.addItem ("160 x 120");
    cropCombo.addItem ("80 x 60");
    cropCombo.addItemListener (new ItemListener()
      {
        public void itemStateChanged (ItemEvent e)
        {
          int idx = cropCombo.getSelectedIndex();
	  /*vvv*/
	  /*
          if (idx == 0)
            {
              cropRectangle.width = 320;
              cropRectangle.height = 240;
              cropFormatTag = "2C";
            }
	    else*/
	  if (idx == 0/*1*/)
            {
              cropRectangle.width = 160;
              cropRectangle.height = 120;
              cropFormatTag = "3C";
            }
          else if (idx == 1/*2*/)
            {
              cropRectangle.width = 80;
              cropRectangle.height = 60;
              cropFormatTag = "4C";
            }

          if (e.getStateChange() == ItemEvent.SELECTED)
            {
              status ("Crop rectangle set to " + cropRectangle.width + "x" + cropRectangle.height);
            }
          canvas.repaint();
        }
      });
    /*^^^*/

    cropPanel.add (Box.createHorizontalStrut (2));
    cropButton = new JToggleButton ("crop it");
    cropButton.addItemListener (cil);
    cropPanel.add (cropButton);

    cropRectangle = new Rectangle();
    cropRectangle.width = 160;//320;
    cropRectangle.height = 120;//240;
    cropRectangle.x = cropRectangle.y = 0;
    cropFormatTag = "3C";//"2C";
    /*^^^*/

    cp.add (cropPanel, gbc);

    imageXOffset = imageYOffset = 0;
  }    


  public class avsCanvas extends JPanel
  {
    avsCanvas()
    {
      AvsCanvasMouseListener ml = new AvsCanvasMouseListener();
      addMouseListener (ml);
      addMouseMotionListener (ml);
    }

    public void
      paintComponent (Graphics g)
    {
      Graphics2D g2 = (Graphics2D) g;
      if (image != null)
        {
          g.clearRect (0, 0, DEFAULT_IMAGE_WIDTH, DEFAULT_IMAGE_HEIGHT);
          g.drawImage (image, imageXOffset, imageYOffset, null);
	  //System.out.println(" [paintComponent(): xoffset:"+imageXOffset+", yoffset:"+imageYOffset);
          if (drawCropRectangle)
            {
		//System.out.println(" [paintComponent(): x:"+cropRectangle.x+", y:"+cropRectangle.y+", w:"+cropRectangle.width+", h:"+cropRectangle.height);

              g.drawRect (cropRectangle.x, 
                          cropRectangle.y,
                          cropRectangle.width,
                          cropRectangle.height);
            }
        }
    }

    class AvsCanvasMouseListener
      extends MouseInputAdapter
      implements MouseInputListener
    {
      private Point mouseDownPoint;
      private Point where;

      public void mousePressed (MouseEvent me)
      {
        System.out.println ("Rectangle (" + cropRectangle + ")");
        if (SwingUtilities.isLeftMouseButton (me))
          {
            mouseDownPoint = me.getPoint();
          }
      }

      public void mouseDragged (MouseEvent me)
      {
        where = me.getPoint();
        if (cropRectangle.contains (where)
            && (cropRectangle.x + cropRectangle.width) < getWidth()
            && (cropRectangle.y + cropRectangle.height) < getHeight()
            && drawCropRectangle)
          {
            where.translate (-mouseDownPoint.x, -mouseDownPoint.y);
            cropRectangle.setLocation (where);
            canvas.repaint();
          }

      }

      public void mouseReleased (MouseEvent me)
      {
        where = me.getPoint();
        if (cropRectangle.contains (where)
            && (cropRectangle.x + cropRectangle.width) < getWidth()
            && (cropRectangle.y + cropRectangle.height) < getHeight()
            && drawCropRectangle)
          {
            where.translate (-mouseDownPoint.x, -mouseDownPoint.y);
            cropRectangle.setLocation (where);
            canvas.repaint();
          }

      }        
    }
  }

  public class echoPoller extends Thread
  {
    public void run()
    {
      int rv = runNetwork (myStreamNode.chanId, myStreamNode.formatId);
    }
  }


}

  


class byebye 
  extends WindowAdapter
{
  public void windowClosing (WindowEvent e)
  {
    Window which = e.getWindow();
    which.setVisible (false);
    which.dispose();
    ((ViewClient)which).stopEcho();
  }
}


   

//
//
//  $Log: ViewClient.java,v $
//  Revision 1.1.1.1  2003/06/11 18:48:51  wyan
//  UAV1
//
//  Revision 1.7  2001/10/19 18:11:16  pmw
//  various happiness :)
//
//  Revision 1.6  2001/10/03 06:22:31  pmw
//  halfRate, crop, grey work.
//
//  Revision 1.5  2001/10/03 02:27:50  pmw
//  single handlers all work (except for enlarge/reduce)
//
//  Revision 1.4  2001/10/02 19:12:25  pmw
//  crop rectangle works, haven't tried to derive with it yet.  still can't get
//  anything but halfRate to install correctly.
//
//  Revision 1.3  2001/09/29 04:14:37  pmw
//  more interim checkins.  crop rectangle in place for GUI.
//
//  Revision 1.2  2001/09/26 21:13:37  pmw
//  interim checkin so I don't lose anything
//
//  Revision 1.1  2001/09/21 21:28:57  pmw
//  interim checkin...
//
//  Revision 1.3  2001/09/18 20:39:17  pmw
//  fixed several UI issues.  not quite working... ALMOST!
//
//  Revision 1.2  2001/07/24 17:45:25  pmw
//   updates for new version of avs checkin.  not configure-ized yet
//
//  Revision 1.7  2001/07/15 03:29:15  pmw
//  cosmetic stuff
//
//  Revision 1.6  2001/07/09 00:07:21  pmw
//  modified jni code to do RGB component-switching so we get the right
//  image
//
//  Revision 1.5  2001/07/08 12:38:48  pmw
//  finally fixed color problems and memory allocation problems.
//
//  Revision 1.4  2001/07/06 16:32:13  pmw
//  more changes
//
//  Revision 1.3  2001/06/21 23:17:36  pmw
//  finally does some streaming correctly. colors still fouled up.
//
//  Revision 1.2  2001/06/18 18:57:41  pmw
//  interim commit
//
//  Revision 1.1  2001/06/14 19:21:47  pmw
//  finally displays pictures semi-correctly
//
//
//
