/**
 * @author Wenchang
 * @time Feb, 2002
 * @file ViewClientWrapper.java
 */

package avs;

import avs.ViewClient;
//import avs.AdaptServer;
import java.io.*;

public class ViewClientWrapper
{
    public ViewClientWrapper(String[] args) {
	//start the GUI 
	System.loadLibrary ("avsjni");
	vc = new ViewClient ("avs client", 
		     new StreamNode (args[0], args[1], args[2]), host,
			     port, mus, pixelsize, pixelperline);
    }

    public static void main(String[] args) {
	//bootstrap
	int s = args.length;
	if ( s < 3) {
	    printCommand();
	    System.exit(-1);
	}
	
	if (s > 7) {
	    pixelperline = args[7];
	}
	else {
	    pixelperline = new String("640");
	}
	if (s > 6) {
	    pixelsize = args[6];
	}
	else {
	    pixelsize = new String("3");
	}	

	if (s > 5) {
	    mus = args[5];
	}
	else {
	    mus = new String("15360");
	}
	if (s > 4) {
	    port = args[4];
	}
	else {
	    port = new String("12345");
	}
	if (s > 3) {
	    host = args[3];
	}
	else {
	    host = new String("localhost");
	}
	
	
	printOptions();

	ViewClientWrapper vcw = new ViewClientWrapper(args);
	//AdaptServer as = new AdaptServer(vc);
	//start server
	//args[0] = "Naming";
	//as.runServer(args);
    }
    

    private static void printCommand() {
	System.out.println(" Usage: jaco avs.ViewClientWrapper \"Anything\" \"ECho_Channel_Id\" \"2C\" [HOST] [PORT] [MTU] [PIXEL_SIZE] [PIXEL_PER_LINE]");
	System.out.println("              2C:    starting from 320x240 Color");
	System.out.println("          [HOST]:    PPM receiver            [localhost]");
	System.out.println("          [PORT]:    receiving port number   [12345]");
	System.out.println("           [MTU]:    maximum UDP packet size [15360]");
	System.out.println("    [PIXEL_SIZE]:    PPM pixel in bytes      [3]");
	System.out.println("[PIXEL_PER_LINE]:    maximum pixels per line [640]");
	System.out.println(" Options must be given in PLACE!");
    }

    private static void printOptions() {
	System.out.println(" Relative information: ");
	System.out.println("          [HOST]: <"+host+">");
	System.out.println("          [PORT]: <"+port+">");
	System.out.println("           [MTU]: <"+mus+">");
	System.out.println("    [PIXEL_SIZE]: <"+pixelsize+">");
	System.out.println("[PIXEL_PER_LINE]: <"+pixelperline+">");
    }

    //CORBA obj
    //public AdaptAvsUav_Server aaus;
    public static ViewClient vc;
    //public FilterParam fp;
    
    //Command line option
    private static String host;
    private static String port;
    private static String mus;
    private static String pixelsize;
    private static String pixelperline;
}
