/* -*-C-*-
   @author: Yan, Wenchang
   @time: Dec, 2001
*/
 
#ifndef _IMAGESENDER_H
#define _IMAGESENDER_H

extern "C" {
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
 
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>
#include "connect.h" /*construct udp*/
 
/*for tprintf */
#include <sys/timeb.h>
#include <stdarg.h>
 
}
//typedef enum {FALSE, TRUE} boolean;

/* for debug */
extern int tprintf(const char* fmt, ...);
 
typedef unsigned long long uint64;
typedef   signed long long  int64;
typedef unsigned long      uint32;
typedef   signed long       int32;
typedef unsigned short     uint16;
typedef   signed short      int16;
typedef unsigned char      uint8;
typedef   signed char       int8;
 
inline uint16 ChangeEndian16(uint16 v) { return (v>>8) | (v<<8); }
inline uint32 ChangeEndian32(uint32 v) { return (v>>24) | ((v>>8)&0xFF00) | ((v&0xFF00)<<8) | (v<<
24); }
 
 
#ifdef WORDS_BIGENDIAN
inline uint16 ToLittleEndian16(uint16 v) { return ChangeEndian16(v); }
inline uint32 ToLittleEndian32(uint32 v) { return ChangeEndian32(v); }
inline uint16 ToBigEndian16(uint16 v)    { return v; }
inline uint32 ToBigEndian32(uint32 v)    { return v; }
#else
inline uint16 ToLittleEndian16(uint16 v) { return v; }
inline uint32 ToLittleEndian32(uint32 v) { return v; }
inline uint16 ToBigEndian16(uint16 v)    { return ChangeEndian16(v); }
inline uint32 ToBigEndian32(uint32 v)    { return ChangeEndian32(v); }
#endif

/*#define RECEIVER_HOST "localhost"*/
#define SENDER_HOST "localhost"
//Used as to distinguished from Mpeg headers in DVDview
#define PPMP_FRAME_HEADER 0x1ff
#define PPMP_PICT_HEADER 0x1f0

/*#define RECEIVER_PORT 12345*/

/*#define MUS 15360*/ /*51840*/ /*57600 */
/*#define MAXPIXELSIZE 3*/
/*#define MAXLINESIZE 640*/ /* Assume 640 is the largest width */

/* from avs_raw.h */
typedef struct {
  int tag;
  char ppm1;
  char ppm2;
  int size;
  int width;
  int height;
  char* buff;
} PPM_frame_info, *PPM_frame_info_ptr;

#define PPM_MAGIC1 'P'
#define PPM_MAGIC2 '3'
#define RPPM_MAGIC2 '6'
#define PPM_FORMAT (PPM_MAGIC1 * 256 + PPM_MAGIC2)
#define RPPM_FORMAT (PPM_MAGIC1 * 256 + RPPM_MAGIC2)
#define PPM_TYPE PPM_FORMAT


/*for debug*/
int tprintf(const char* fmt,...);
/*send the PPM header info*/
int send_preframe(u_char* PPMHeader, PPM_frame_info* pfi,
                  int socket, struct sockaddr* receiver);

int send_frame(int sd,u_char* frame,int frame_size,int frame_num,
	       PPM_frame_info_ptr pfip, struct sockaddr_in &rec,
	       int mus, int maxpixelsize, int maxpixelperline);


#endif
