/**
 * @author Wenchang
 * @time Feb, 2002
 * @file AdapterClient.java
 */

package avs;

import java.io.*;
import org.omg.CosNaming.*;
//import avs.AdaptAvsUav_Impl;
//import avs.ViewClient;

public class AdaptClient 
{
    public static void main(String[] args) {
        try
        {
	    AdaptAvsUav aau;
	    org.omg.CORBA.ShortHolder returnVal = 
		               new org.omg.CORBA.ShortHolder((short)1);

	    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, null);

            if( args.length == 1 )
            {
                // args[0] is an IOR-string 
                aau = AdaptAvsUavHelper.narrow(orb.string_to_object(args[0]));
            } 
            else
            {
                NamingContextExt nc = 
                    NamingContextExtHelper.narrow(
                        orb.resolve_initial_references( "NameService" ));

                org.omg.CORBA.Object o = 
                    nc.resolve(nc.to_name("AdaptAvsUav"));

                aau = AdaptAvsUavHelper.narrow(o);

            }

	    short trigger=1;

	    try {
		BufferedReader in = 
		    new BufferedReader(new InputStreamReader(System.in));
		java.lang.String str="";
		char ch;
		do {
		    printMenu();
		    System.out.print(" Your input ('q' exit): ");
		    str = in.readLine();
		    ch = str.charAt(0);
		    if (ch=='1') {
			//doAdapt
			aau.doAdapt(trigger,str.substring(1,str.length()),
				    returnVal);
		    }
		    else if (ch=='0') {
			aau.undoAdapt(trigger,str.substring(1,str.length()),
				      returnVal);
		    }
		} while (!(str.equals("q") || str.equals("Q")));
		
	    } catch (IOException e) {
	    }
	    
            orb.shutdown(true);
            System.out.println("done. ");
       
        }
        catch (Exception e) 
        {
            e.printStackTrace();
        }
    }

    public static void printMenu() {
	System.out.println(" Example filter string:");
	System.out.println("      shrinkImage2Cto3C, shrinkImage3Cto4C");
	System.out.println("      shrinkAvgImage2Cto3C, shrinkAvgImage3Cto4C");
	System.out.println("      cropImage2Cto3C, cropImage2Cto4C");
	System.out.println("      greyImage2C, greyImage3C, greyImage4C");
	System.out.println("      edgeImage2G, edgeImage3G, edgeImage4G");
	System.out.println(" ===============================================");
	System.out.println(" Note: 1) input string must be exact one from list");
	System.out.println("       2) the order of placing filter matters, to");
	System.out.println("          be safe, undo the corresponding filter");
	System.out.println("          after each adaptation.");
	System.out.println("       3) e.g. input 1shrinkImage2Cto3C");
	System.out.println("                     ^===========^^^^^^");
	System.out.println("          meaning: 1 - doAdapt, 0 - undoAdapt");
	System.out.println("                   shrinkImage - name");
	System.out.println("                   2C - 320x240 Color");
	System.out.println("                   3C - 160x120 Color");
	System.out.println("");
    }
}
