/**
 * @author Wenchang
 * @date Feb, 2002
 * @file AdapterServer.java
 */

package avs;

import java.io.*;
import org.omg.CosNaming.*;
import avs.AdaptAvsUav_Impl;
import avs.ViewClient;

public class AdaptServer 
{
    public AdaptServer(ViewClient vc) {
	System.out.println(" [AdaptServer::cstr()");
	this.vc=vc;
    }

    public static void runServer(String[] args) {
        org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, null);
        try
        {
            org.omg.PortableServer.POA poa = 
                org.omg.PortableServer.POAHelper.narrow(orb.resolve_initial_references("RootPOA"));

            poa.the_POAManager().activate();
    
	    org.omg.CORBA.Object o = 
		poa.servant_to_reference(new AdaptAvsUav_Impl(vc));

	    if (args[0].equals("Naming")) {
		//Use the Naming Service
		System.out.println(" using naming service");

		NamingContextExt nc = NamingContextExtHelper.narrow 
		    (orb.resolve_initial_references("NameService"));
		nc.bind( nc.to_name("AdaptAvsUav"), o);
		System.out.println(" [AdaptServer::runServer(): \"AdaptAvsUav\" bound to the Naming Service");
	    }
	    else {
		// write the object reference to args[0]
		PrintWriter ps = 
		    new PrintWriter(new FileOutputStream(new File(refFile)));
		ps.println( orb.object_to_string( o ) );
		ps.close();
		System.out.println(" [AdaptServer::runServer(): ref written to file: "+refFile);
	    } 
	}
	catch ( Exception e )
	    {
		e.printStackTrace();
	    }        
	//start orb
	orb.run();
	System.out.println(" [AdapterServer::runServer(): orb running ...");
    }
    
    public static final String refFile = "refIOR";
    public FilterParam fp;
    public static ViewClient vc;
}
