/*
 *  @ Wenchang Yan
 *  @date Dec, 2001
 *
 *  $Id: avs_viewClient.cc,v 1.1.1.1 2003/06/11 18:48:58 wyan Exp $
 *
 */

/*vvv*/
#undef DEBUG_WHERE 
#define DEBUG_WHERE 1
#include <imagesender.h>
/*^^^*/

#include <avs_viewClient.h>

extern "C" 
{
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include "io.h"
#include "cm.h"
#include "echo.h"
#include "gen_thread.h"

#include "avs_util.h"
#include "avs_raw.h"
#include "strlt.h"
}

static char *DEFAULT_STRLT_PATH = "/home/pmw/sandbox/avs/strlt";
static char *NEW_FORMAT_NAME_BASE = "Raw_data";
static const int NEW_FORMAT_NAME_LEN = 15;
static char NEW_FORMAT_NAME[NEW_FORMAT_NAME_LEN];

/*For integration with BBN UAV*/
static char hostname[40]; /*localhost*/
static int portno; /* 12345, The receiving port at BBN's side */
static int mus; /* 15360;  15 K, ACE/TAO allows 15kB UDP at max*/
static int maxpixelsize; /*3bytes*/
static int maxpixelperline;/* =640; max pixels per line*/

typedef struct
{
  jobject jo;
  JNIEnv* env;
  char *channel_output_type;
} handler_env_items;

static handler_env_items my_handler_items;

/*vvv*/
//extern CManager cm;
CManager cm;
int active_cm_condition;
//extern EControlContext ecc;
EControlContext ecc;
/*^^^*/

IOContext ioc;
static EChannel chan = NULL;
static EChannel adaptedChan = NULL;
static ECSinkHandle sink_handle = NULL;
static jmethodID update_method_id;
static jbyteArray j_component_array;
static jbyte *native_component_array;

static jclass rectangle_class_id;
static jfieldID height_field_id;
static jfieldID width_field_id;
static jfieldID x_field_id;
static jfieldID y_field_id;
static jclass integer_class_id;
static jmethodID intValue_method_id;

const size_t MAX_ARRAY_SIZE = (640*480*3);

/*vvv*/

static int socket_init=0;//socket constructed or not
int frameNum;//total # of frames sent
struct hostent* h;
struct sockaddr_in receiver;
//int portno;
int sd;


/*^^^*/

void exception_check (JNIEnv* e)
{
  if (e->ExceptionOccurred())
    {
      e->ExceptionDescribe();
      e->ExceptionClear();
    }
}
static unsigned long ct = 0;
void
update_handler (void* event, void* client_data, attr_list alist)
{
  Raw_data_ptr rawrecP;
  Raw_data1C_ptr rawrec1CP; Raw_data1G_ptr rawrec1GP;   
  Raw_data1DC_ptr rawrec1DCP; Raw_data1DG_ptr rawrec1DGP;
  Raw_data2C_ptr rawrec2CP; Raw_data2G_ptr rawrec2GP;
  Raw_data2DC_ptr rawrec2DCP; Raw_data2DG_ptr rawrec2DGP;
  Raw_data3C_ptr rawrec3CP; Raw_data3G_ptr rawrec3GP;
  Raw_data3DC_ptr rawrec3DCP; Raw_data3DG_ptr rawrec3DGP;
  Raw_data4C_ptr rawrec4CP; Raw_data4G_ptr rawrec4GP;
  Raw_data4DC_ptr rawrec4DCP; Raw_data4DG_ptr rawrec4DGP;
  //  struct tm *now;
  //time_t nowt;
  //int sfd;
  char *format;
  char ppm1 = '-', ppm2 = '-';
  int width = 0, height = 0, size = 0, tag = 0;
  char *tmpBuff = NULL;
  jvalue update_method_args[4];

  //  fprintf (stdout, "\r%d",ct++); fflush(stdout);return;
  handler_env_items* handler_items = &my_handler_items;

  /* Untyped stream */
  if (!handler_items->channel_output_type) {
     rawrecP = (Raw_data_ptr) event;
     
     ppm1 = rawrecP->ppm1; ppm2 = rawrecP->ppm2;
     width = rawrecP->width; height = rawrecP->height;
     tmpBuff = rawrecP->buff; 
     size = rawrecP->size;
     tag = rawrecP->tag;

  } else {			/* Typed stream - which then? */
    format = handler_items->channel_output_type;
    if (strstr(format, "1C")) {
      rawrec1CP = (Raw_data1C_ptr) event;
      ppm1 = rawrec1CP->ppm1; ppm2 = rawrec1CP->ppm2;
      width = rawrec1CP->width; height = rawrec1CP->height;
      tmpBuff = rawrec1CP->buff; 
      size = rawrec1CP->size;
      tag = rawrec1CP->tag;
      
    } else if (strstr(format, "2C\0")) {
      rawrec2CP = (Raw_data2C_ptr) event;
      
      ppm1 = rawrec2CP->ppm1; ppm2 = rawrec2CP->ppm2;
      width = rawrec2CP->width; height = rawrec2CP->height;
      tmpBuff = rawrec2CP->buff; 
      size = rawrec2CP->size;
      tag = rawrec2CP->tag;
      
    } else if (strstr(format, "3C\0")) {
      rawrec3CP = (Raw_data3C_ptr) event;
      
      ppm1 = rawrec3CP->ppm1; ppm2 = rawrec3CP->ppm2;
      width = rawrec3CP->width; height = rawrec3CP->height;
      tmpBuff = rawrec3CP->buff; 
      size = rawrec3CP->size;
      tag = rawrec3CP->tag;
      
    } else if (strstr(format, "4C\0")) {
      rawrec4CP = (Raw_data4C_ptr) event;
      ppm1 = rawrec4CP->ppm1; ppm2 = rawrec4CP->ppm2;
      width = rawrec4CP->width; height = rawrec4CP->height;
      tmpBuff = rawrec4CP->buff; 
      size = rawrec4CP->size;
      tag = rawrec4CP->tag;
    } else if (strstr(format, "1G\0")) {
      rawrec1GP = (Raw_data1G_ptr) event;
      ppm1 = rawrec1GP->ppm1; ppm2 = rawrec1GP->ppm2;
      width = rawrec1GP->width; height = rawrec1GP->height;
      tmpBuff = rawrec1GP->buff; 
      size = rawrec1GP->size;
      tag = rawrec1GP->tag;
    } else if (strstr(format, "2G\0")) {
      rawrec2GP = (Raw_data2G_ptr) event;
      ppm1 = rawrec2GP->ppm1; ppm2 = rawrec2GP->ppm2;
      width = rawrec2GP->width; height = rawrec2GP->height;
      tmpBuff = rawrec2GP->buff; 
      size = rawrec2GP->size;
      tag = rawrec2GP->tag;
    } else if (strstr(format, "3G\0")) {
      rawrec3GP = (Raw_data3G_ptr) event;
      ppm1 = rawrec3GP->ppm1; ppm2 = rawrec3GP->ppm2;
      width = rawrec3GP->width; height = rawrec3GP->height;
      tmpBuff = rawrec3GP->buff; 
      size = rawrec3GP->size;
      tag = rawrec3GP->tag;
    } else if (strstr(format, "4G\0")) {
      rawrec4GP = (Raw_data4G_ptr) event;
      ppm1 = rawrec4GP->ppm1; ppm2 = rawrec4GP->ppm2;
      width = rawrec4GP->width; height = rawrec4GP->height;
      tmpBuff = rawrec4GP->buff; 
      size = rawrec4GP->size;
      tag = rawrec4GP->tag;
    } else if (strstr(format, "1DC\0")) {
      rawrec1DCP = (Raw_data1DC_ptr) event;
      ppm1 = rawrec1DCP->ppm1; ppm2 = rawrec1DCP->ppm2;
      width = rawrec1DCP->width; height = rawrec1DCP->height;
      tmpBuff = rawrec1DCP->buff; 
      size = rawrec1DCP->size;
      tag = rawrec1DCP->tag;
    } else if (strstr(format, "2DC\0")) {
      rawrec2DCP = (Raw_data2DC_ptr) event;
      ppm1 = rawrec2DCP->ppm1; ppm2 = rawrec2DCP->ppm2;
      width = rawrec2DCP->width; height = rawrec2DCP->height;
      tmpBuff = rawrec2DCP->buff; 
      size = rawrec2DCP->size;
      tag = rawrec2DCP->tag;
    } else if (strstr(format, "3DC\0")) {
      rawrec3DCP = (Raw_data3DC_ptr) event;
      ppm1 = rawrec3DCP->ppm1; ppm2 = rawrec3DCP->ppm2;
      width = rawrec3DCP->width; height = rawrec3DCP->height;
      tmpBuff = rawrec3DCP->buff; 
      size = rawrec3DCP->size;
      tag = rawrec3DCP->tag;
    } else if (strstr(format, "4DC\0")) {
      rawrec4DCP = (Raw_data4DC_ptr) event;
      ppm1 = rawrec4DCP->ppm1; ppm2 = rawrec4DCP->ppm2;
      width = rawrec4DCP->width; height = rawrec4DCP->height;
      tmpBuff = rawrec4DCP->buff; 
      size = rawrec4DCP->size;
      tag = rawrec4DCP->tag;
    } else if (strstr(format, "1DG\0")) {
      rawrec1DGP = (Raw_data1DG_ptr) event;
      ppm1 = rawrec1DGP->ppm1; ppm2 = rawrec1DGP->ppm2;
      width = rawrec1DGP->width; height = rawrec1DGP->height;
      tmpBuff = rawrec1DGP->buff; 
      size = rawrec1DGP->size;
      tag = rawrec1DGP->tag;
    } else if (strstr(format, "2DG\0")) {
      rawrec2DGP = (Raw_data2DG_ptr) event;
      ppm1 = rawrec2DGP->ppm1; ppm2 = rawrec2DGP->ppm2;
      width = rawrec2DGP->width; height = rawrec2DGP->height;
      tmpBuff = rawrec2DGP->buff; 
      size = rawrec2DGP->size;
      tag = rawrec2DGP->tag;
    } else if (strstr(format, "3DG\0")) {
      rawrec3DGP = (Raw_data3DG_ptr) event;
      ppm1 = rawrec3DGP->ppm1; ppm2 = rawrec3DGP->ppm2;
      width = rawrec3DGP->width; height = rawrec3DGP->height;
      tmpBuff = rawrec3DGP->buff; 
      size = rawrec3DGP->size;
      tag = rawrec3DGP->tag;
    } else if (strstr(format, "4DG\0")) {
      rawrec4DGP = (Raw_data4DG_ptr) event;
      ppm1 = rawrec4DGP->ppm1; ppm2 = rawrec4DGP->ppm2;
      width = rawrec4DGP->width; height = rawrec4DGP->height;
      tmpBuff = rawrec4DGP->buff; 
      size = rawrec4DGP->size;
      tag = rawrec4DGP->tag;
    }
  }

  handler_items->env->SetByteArrayRegion (j_component_array, 0, size, (jbyte*) tmpBuff);
  exception_check (handler_items->env);

  /*vvv*/
  /**/
  PPM_frame_info ppmfi;
  ppmfi.tag = tag;
  ppmfi.ppm1 = ppm1; ppmfi.ppm2 = ppm2;
  ppmfi.size = size;
  ppmfi.width = width;
  ppmfi.height = height;
  ppmfi.buff = 0;//Not used for now

  int rtvalue = send_frame(sd,(u_char*)tmpBuff,size,frameNum,&ppmfi,
  		   receiver,mus,maxpixelsize,maxpixelperline);

  frameNum ++;
  /*^^^*/

  update_method_args[0].i = width;
  update_method_args[1].i = height;
  update_method_args[2].i = size;
  update_method_args[3].l = j_component_array;
  
  /**/
  handler_items->env->CallVoidMethodA (handler_items->jo, update_method_id, update_method_args);
  /**/
  exception_check (handler_items->env);
}

extern "C" {

static jstring
do_adaptation (JNIEnv *env, jobject jo, char* c_chanId, jstring streamletId, jobject param);


JNIEXPORT jint JNICALL 
/*Java_avs_ViewClient_startup (JNIEnv *env, jobject jo)*/
Java_avs_ViewClient_startup (JNIEnv *env, jobject jo, jstring host, 
			     jint port, jint musvalue, jint pixelsize,
			     jint pixelperline)
{
  const char* tmpStr;
  /*vvv*/
  gen_pthread_init();
  cm = CManager_create();
  if (cm == NULL) {
    fprintf(stderr, "[Java_avs_ViewClient_startup(): CManager_create failed\n");
    exit(1);
  }

  ecc = ECho_CM_init(cm);

  tmpStr = env->GetStringUTFChars(host,0);

  tprintf( "host: %s, port: %d, mus: %d, pixelsize: %d, pixelperline: %d, strlen: %d\n",
	   tmpStr, port, musvalue, pixelsize, pixelperline,strlen(tmpStr));

  /*book keeping*/
  if (NULL==host)
    strcpy(hostname,"localhost");
  else 
    strcpy(hostname,const_cast<char*>(tmpStr));
  
  env->ReleaseStringUTFChars(host,tmpStr);

  portno = port; mus=musvalue; maxpixelsize = pixelsize; 
  maxpixelperline = pixelperline;

  /*  store all our formats in an iocontext for easy(?) handling  */
  ioc = create_IOcontext();
  avs_registerFormats (ioc);
  my_handler_items.channel_output_type = NULL;

  rectangle_class_id = env->FindClass ("java/awt/Rectangle");
  height_field_id = env->GetFieldID (rectangle_class_id, "height", "I");
  width_field_id = env->GetFieldID (rectangle_class_id, "width", "I");
  x_field_id = env->GetFieldID (rectangle_class_id, "x", "I");
  y_field_id = env->GetFieldID (rectangle_class_id, "y", "I");

  integer_class_id = env->FindClass ("java/lang/Integer");
  intValue_method_id = env->GetMethodID (integer_class_id, "intValue", "()I");

  if (0==socket_init) {

    h = gethostbyname(hostname);
    if  (h==NULL) {
      printf(" [avs_viewClient::startup(): unknown host '%s' \n", hostname);
      exit(-1);
    }    
    receiver.sin_family = h->h_addrtype;
    memcpy((char *) &receiver.sin_addr.s_addr,
	   h->h_addr_list[0], h->h_length);
    receiver.sin_port = htons(portno);

    sd = connect_udp(SENDER_HOST,0);
    if (sd<0) {
      fprintf(stderr, "[avs_viewClient::startup(): can't create socket\n");
      exit(-1);
    }

    socket_init = 1;//Socket init successed
    frameNum = 0;
  }
  
  if (DEBUG_WHERE)
    tprintf(" [avs_viewClient::startup(): Socket has been constructed!\n");

  return 0;
}


JNIEXPORT jstring JNICALL
Java_avs_ViewClient_goChannel (JNIEnv *env, jobject jo, jstring chanId, jstring formatId, jobject param)
{
  const char *c_chanId;
  const char *c_formatId;

  c_chanId = env->GetStringUTFChars (chanId, (jboolean*)0);
  c_formatId = env->GetStringUTFChars (formatId, (jboolean*)0);

  chan = EChannel_open (ecc, const_cast<char*> (c_chanId));
  if (chan == NULL)
    {
      fprintf (stderr, "couldn't open event channel ID %s, stopping.\n", c_chanId);
      return NULL;
    }
  
  memset (NEW_FORMAT_NAME, 0, NEW_FORMAT_NAME_LEN);
  strcpy (NEW_FORMAT_NAME, NEW_FORMAT_NAME_BASE);
  strcat (NEW_FORMAT_NAME, c_formatId);

  if (sink_handle != NULL)
    ECcancel_sink_subscribe (sink_handle);

  free (my_handler_items.channel_output_type);
  my_handler_items.channel_output_type = strdup (c_formatId);  

  fprintf (stderr, "goChannel new format (%s)\n", NEW_FORMAT_NAME);

  sink_handle = ECsink_typed_subscribe (chan,
                                        avs_getFormatFieldList (ioc, NEW_FORMAT_NAME),
                                        NULL, update_handler, NULL); 

  env->ReleaseStringUTFChars (chanId, c_chanId);
  env->ReleaseStringUTFChars (formatId, c_formatId);

  return env->NewStringUTF (ECglobal_id (chan));
}  


JNIEXPORT int JNICALL
Java_avs_ViewClient_runNetwork (JNIEnv *env, jobject jo, jstring chanId, jstring formatId)
{
  update_method_id = env->GetMethodID (env->GetObjectClass (jo), "new_frame", "(III[B)V");
  exception_check (env);

  j_component_array = env->NewByteArray (MAX_ARRAY_SIZE);

  exception_check (env);

  sink_handle = NULL;

  if (Java_avs_ViewClient_goChannel (env, jo, chanId, formatId, (jobject)NULL) == NULL)
    return -1;

  my_handler_items.env = env;
  my_handler_items.jo = jo;

  CMrun_network (cm);
  return 0;
}
      
/*
 * Class:     avs_viewClient
 * Method:    stopEcho
 * Signature: ()V
 */
JNIEXPORT void JNICALL 
Java_avs_ViewClient_stopEcho (JNIEnv *env, jobject jo)
{
  CManager_close (cm);
}



JNIEXPORT jstring JNICALL
Java_avs_ViewClient_adaptFrom (JNIEnv *env, jobject jo, jstring chanId, jstring streamletId, jobject param)
{
  const char* c_chanId;
  jstring rv;
  c_chanId = env->GetStringUTFChars (chanId, (jboolean*)0);  
  rv = do_adaptation (env, jo, const_cast<char*> (c_chanId), streamletId, param);
  env->ReleaseStringUTFChars (chanId, c_chanId);
  return rv;
}


JNIEXPORT jstring JNICALL
Java_avs_ViewClient_adapt (JNIEnv *env, jobject jo, jstring streamletId, jobject param)
{
  return do_adaptation (env, jo, ECglobal_id (chan), streamletId, param);
}


static jstring
do_adaptation (JNIEnv *env, jobject jo, char* c_chanId, jstring streamletId, jobject param)
{
  Streamlet_T strlt;
  const char* c_streamletId;
  const char* strlt_path = NULL;
  ECdata_struct imgRectangle_spec;
  Params_rectangle imgRectangle;
  ECdata_struct imgFactor_spec;
  Params_factor imgFactor;

  c_streamletId = env->GetStringUTFChars (streamletId, (jboolean*)0);

  strlt = Strlt_new();
  
  strlt_path = getenv ("AVS_STRLT_PATH");
  if (strlt_path == NULL)
    strlt_path = DEFAULT_STRLT_PATH;

  if (Strlt_init (strlt, const_cast<char*> (strlt_path), const_cast<char*> (c_streamletId)) != 0)
    {
      fprintf (stderr, "Couldn't load streamlet %s\n", c_streamletId);
      env->ReleaseStringUTFChars (streamletId, c_streamletId);
      return NULL;
    }

  if (1) 
    {
      fprintf(stdout, "Streamlet name          %s\n", 
	      Strlt_getName(strlt));
      fprintf(stdout, "Streamlet input         %s\n", 
	      Strlt_getInputChan(strlt)); 
      fprintf(stdout, "Streamlet output        %s\n", 
	      Strlt_getOutputChan(strlt)); 
      fprintf (stderr, "par=%d\n", Strlt_takesParams(strlt));
      fprintf(stdout, "Streamlet takes params? %c\n", 
	      Strlt_takesParams(strlt)? 'Y':'N');
      if (Strlt_takesParams(strlt))
	fprintf(stdout, "Streamlet params        %s\n", 
		Strlt_getParams(strlt));  
      //      fprintf(stdout, "Streamlet code\n%s\n", Strlt_getCode(strlt)); 
    }

  
  fprintf (stderr, "[1]");fflush(0);

  char *strlt_name = Strlt_getName (strlt);
  if (strcmp (strlt_name, "cropImage.ecl") == 0)
    {
      if (env->IsInstanceOf (param, env->FindClass ("java/awt/Rectangle")))
        {
          imgRectangle.x = env->GetIntField (param, x_field_id);
          imgRectangle.y = env->GetIntField (param, y_field_id);
          imgRectangle.height = env->GetIntField (param, height_field_id);
          imgRectangle.width = env->GetIntField (param, width_field_id);

          imgRectangle_spec.data_field_list = avs_getFormatFieldList (ioc, "Params_rectangle");
          imgRectangle_spec.data_subformat_list = NULL;
          imgRectangle_spec.initial_value = &imgRectangle;
        }

      adaptedChan = EChannel_typed_derive_data (ecc, c_chanId, Strlt_getCode (strlt),
                                                avs_getFormatFieldList (ioc, Strlt_getOutputChan (strlt)),
                                                NULL, &imgRectangle_spec);
    }
  else if (strcmp (strlt_name, "halfRate.ecl") == 0)
    {
      /*vvv*/
      adaptedChan = EChannel_derive (ecc, c_chanId, Strlt_getCode (strlt));
      //adaptedChan = EChannel_typed_derive_data (ecc, c_chanId, Strlt_getCode (strlt),avs_getFormatFieldList(ioc,Strlt_getOutputChan(strlt)),NULL,NULL);
      if (adaptedChan==NULL) fprintf(stderr," [do_adaptation(): halfRate channel failed\n");
      /*^^^*/
    }
  else if (strcmp (strlt_name, "reduceImage.ecl") == 0)
    {
      if (env->IsInstanceOf (param, integer_class_id))
        {
          imgFactor.factor = env->CallIntMethod (param, intValue_method_id);
          
          imgFactor_spec.data_field_list = avs_getFormatFieldList (ioc, "Params_factor");
          imgFactor_spec.data_subformat_list = NULL;
          imgFactor_spec.initial_value = &imgFactor;
        }

      adaptedChan = EChannel_typed_derive_data (ecc, c_chanId, Strlt_getCode(strlt),
                                                avs_getFormatFieldList (ioc, Strlt_getOutputChan (strlt)),
                                                NULL, &imgFactor_spec);
    }
  else if (strcmp (strlt_name, "greyImage.ecl") == 0 || strcmp (strlt_name, "edgeImage.ecl") == 0)
    {
      adaptedChan = EChannel_typed_derive_data (ecc, c_chanId, Strlt_getCode(strlt),
                                                avs_getFormatFieldList (ioc, Strlt_getOutputChan (strlt)),
                                                NULL, NULL);
    }
  else if (strcmp (strlt_name, "shrinkImage.ecl") == 0)
    {
      adaptedChan = EChannel_typed_derive_data (ecc, c_chanId, Strlt_getCode (strlt),
                                                avs_getFormatFieldList (ioc, Strlt_getOutputChan (strlt)),
                                                NULL, NULL);
    }
  else if (strcmp (strlt_name, "shrinkAvgImage.ecl") == 0)
    {
      adaptedChan = EChannel_typed_derive_data (ecc, c_chanId, Strlt_getCode (strlt),
                                                avs_getFormatFieldList (ioc, Strlt_getOutputChan (strlt)),
                                                NULL, NULL);
    }

  fprintf (stderr, "[2]");fflush(0);

  free (my_handler_items.channel_output_type);
  my_handler_items.channel_output_type = strdup (Strlt_getOutputChan (strlt));

  ECcancel_sink_subscribe (sink_handle);
  if (adaptedChan == NULL)
    {
      fprintf(stderr, "BAAAAAAAA!!\n");
    }
  sink_handle = ECsink_typed_subscribe (adaptedChan, 
                                        avs_getFormatFieldList (ioc, Strlt_getOutputChan (strlt)),
                                        NULL, update_handler, NULL); 

  fprintf (stderr, "[3]");

  env->ReleaseStringUTFChars (streamletId, c_streamletId);
  Strlt_free (strlt);
  return env->NewStringUTF (ECglobal_id (adaptedChan));

}


}

/*
 *
 *  $Log: avs_viewClient.cc,v $
 *  Revision 1.1.1.1  2003/06/11 18:48:58  wyan
 *  UAV1
 *
 *  Revision 1.14  2001/11/04 19:29:11  pmw
 *   improvements for frame rate
 *
 *  Revision 1.13  2001/10/19 18:11:16  pmw
 *  various happiness :)
 *
 *  Revision 1.12  2001/10/10 17:41:59  pmw
 *  now uses configure to do things.  also modified ViewMaster to update list
 *  correctly from JNI thread.
 *
 *  Revision 1.11  2001/10/03 06:22:31  pmw
 *  halfRate, crop, grey work.
 *
 *  Revision 1.10  2001/10/03 02:27:50  pmw
 *  single handlers all work (except for enlarge/reduce)
 *
 *  Revision 1.9  2001/10/02 19:12:27  pmw
 *  crop rectangle works, haven't tried to derive with it yet.  still can't get
 *  anything but halfRate to install correctly.
 *
 *  Revision 1.8  2001/09/29 04:14:37  pmw
 *  more interim checkins.  crop rectangle in place for GUI.
 *
 *  Revision 1.7  2001/09/26 21:13:37  pmw
 *  interim checkin so I don't lose anything
 *
 *  Revision 1.6  2001/09/21 21:28:58  pmw
 *  interim checkin...
 *
 *  Revision 1.5  2001/09/18 20:54:55  pmw
 *  now works for 1C images, no specializations yet
 *
 *  Revision 1.4  2001/09/18 20:39:16  pmw
 *  fixed several UI issues.  not quite working... ALMOST!
 *
 *  Revision 1.3  2001/08/22 22:05:23  pmw
 *  changes for directory service - not yet complete
 *
 *  Revision 1.2  2001/07/24 17:45:25  pmw
 *   updates for new version of avs checkin.  not configure-ized yet
 *
 *  Revision 1.8  2001/07/15 03:29:15  pmw
 *  cosmetic stuff
 *
 *  Revision 1.7  2001/07/09 00:07:21  pmw
 *  modified jni code to do RGB component-switching so we get the right
 *  image
 *
 *  Revision 1.6  2001/07/08 12:38:48  pmw
 *  finally fixed color problems and memory allocation problems.
 *
 *  Revision 1.5  2001/07/06 16:32:13  pmw
 *  more changes
 *
 *  Revision 1.4  2001/06/21 23:17:36  pmw
 *  finally does some streaming correctly. colors still fouled up.
 *
 *  Revision 1.3  2001/06/18 18:57:41  pmw
 *  interim commit
 *
 *  Revision 1.2  2001/06/15 19:21:28  pmw
 *  interim commit
 *
 *  Revision 1.1  2001/06/14 19:21:47  pmw
 *  finally displays pictures semi-correctly
 *
 *  Revision 1.1.1.1  2001/05/24 20:38:14  pmw
 *  initial checkin
 *
 *
 */

#ifdef MUST_SWITCH_COLOR
  if (format[strlen (format) - 1] == 'C')
    {
      /*
       *  color image, have to do shifting.
       */

      /*
       *  can't do the memcpy here because for some reason we need to switch 
       *  pixel component ordering.  We are supposed to receive pixels in RGB
       *  component order but for some reason Java will not display them correctly
       *  unless they arrive in BGR (it can't be that all byte-based images have to be
       *  BGR, can it???)  Until I find out more information about this
       *  I'll just have to do this switcheroo.
       */
      
      //  memcpy (native_component_array, rd->buff, rd->size);
      for (int i = 0; i < size; i += 3)
        {
          native_component_array[i+2] = tmpBuff[i];
          native_component_array[i+1] = tmpBuff[i+1];
          native_component_array[i] = tmpBuff[i+2];
        }
    }
  else

    {
      /*
       *  greyscale, supposedly we can do memcpy
       */
      //      memcpy (native_component_array, tmpBuff, size);
    }
#endif
