/* -*-C-*-
*******************************************************************************
*
* File:         arglTest.c
* RCS:          $Header: /net/hp47/infosphere/CVSinfopipe/demos/UAV/src/arglTest.c,v 1.1.1.1 2003/06/11 18:48:52 wyan Exp $
* Description:  Test long arg
* Author:       Fabian Ernesto Bustamante
*               Systems Research Group
*               College of Computing
*               Georgia Institute of Technology
* Created:      Mon Feb 26, 2001 at 22:59:00
* Modified:     Thu Jul 19, 2001 at 21:51:15 fabianb@cc.gatech.edu
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
* (C) Copyright 2001, Georgia Institute of Technology, all rights reserved.
*
*******************************************************************************
*/

#include <stdio.h>
#include <stdlib.h>
#include "argl.h"

int
main (int argc, char *argv[])
{
  FILE* configFile;
  int num_shared_procs, num_distr_procs, no_output;
  char *logname;

  if (argc != 2) {
    fprintf(stderr, "Usage: %s <config-file>\n", argv[0]);
    exit(1);
  }

  configFile = fopen(argv[1], "r");
  ARGL_REGISTER_INT("CFG_numSharedProcs", num_shared_procs);
  ARGL_REGISTER_INT("CFG_numDistrProcs", num_distr_procs);
  ARGL_REGISTER_STRING("CFG_login", logname);
  ARGL_REGISTER_BOOL("CFG_noOuput", no_output);
  Argl_parse_file (configFile);    

  printf("num_shared_procs: %d\n", num_shared_procs);
  printf("num_distr_procs: %d\n", num_distr_procs);
  printf("Login: %s\n", logname);
  printf("no_output: %d\n", no_output);

  exit(0);
} /* end main */
