/* -*-C-*-
*******************************************************************************
*
* File:         ebw_common.h
* RCS:          $Id: ebw_common.h,v 1.1.1.1 2003/06/11 18:48:52 wyan Exp $
* Description:  Common definition to sink and source for bandwidth experiment
* Author:       Fabian E. Bustamante
*               Systems Research Group
*               College of Computing
*               Georgia Institute of Technology
* Created:      Wed Sep 19, 2001 at 21:03:52
* Modified:     Mon Oct 01, 2001 at 08:09:12 fabianb@cc.gatech.edu
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
* (C) Copyright 2001, Georgia Institute of Technology, all rights reserved.
*
*******************************************************************************
*/

#ifndef EBW_COMMON_H
#define EBW_COMMON_H 1

#include <common.h>

#include <io.h>

typedef struct {
  int tag;
  int size;
  char *buff;
} Datarec, *Datarec_ptr;

IOField Datarec_fld[] = {
  {"tag","integer",sizeof(int),IOOffset(Datarec_ptr,tag)},
  {"size","integer",sizeof(int),IOOffset(Datarec_ptr,size)},
  {"buff", "char[size]", sizeof(char), IOOffset(Datarec_ptr,buff)},
  {NULL,NULL},
};

#endif /* !EBW_COMMON_H */
