/* -*-C-*-
*******************************************************************************
*
* File:         styx.h
* RCS:          $Id: styx.h,v 1.1.1.1 2003/06/11 18:48:53 wyan Exp $
* Description:  Error and debuging functions
* Author:       Fabian Ernesto Bustamante
*               Systems Research Group
*               College of Computing
*               Georgia Institute of Technology
* Created:      Wed May 30, 2001 at 17:02:09
* Modified:     Mon Jul 09, 2001 at 15:07:27 fabianb@cc.gatech.edu
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
* (C) Copyright 2001, Georgia Institute of Technology, all rights reserved.
*
*******************************************************************************
*/

#ifndef STYX_H
#define STYX_H 1

#include <common.h>

#define MAXFILENAME 255
#define MAXLINE     128

extern void Styx_asDaemon PARAMS((int onOff));
extern int  Styx_setLogFile PARAMS((char *name));
extern void Styx_setDebugLevel PARAMS((int level));
extern void Styx_privateLog PARAMS((int onOff));
extern void Styx_setProgname PARAMS((char *str));
extern char *Styx_progname PARAMS((void));
extern void Styx_errRet PARAMS((const char *fmt, ...));
extern void Styx_errSys PARAMS((const char *fmt, ...));
extern void Styx_errDump PARAMS((const char *fmt, ...));
extern void Styx_errMsg PARAMS((const char *fmt, ...));
extern void Styx_errQuit PARAMS((const char *fmt, ...));
extern void Styx_debugMsg PARAMS((int debugLevel, const char *fmt, ...));

#endif /* !STYX_H */
