/* -*-C-*-
*******************************************************************************
*
* File:         tv.h
* RCS:          $Id: tv.h,v 1.1.1.1 2003/06/11 18:48:53 wyan Exp $
* Description:  Timeval associated functions
* Author:       Fabian Ernesto Bustamante
*               Systems Research Group
*               College of Computing
*               Georgia Institute of Technology
* Created:      Wed Feb 28, 2001 at 17:27:58
* Modified:     Mon Jul 09, 2001 at 14:45:41 fabianb@cc.gatech.edu
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
* (C) Copyright 2001, Georgia Institute of Technology, all rights reserved.
*
*******************************************************************************
*/


#ifndef TV_H
#define TV_H 1

#include <common.h>

extern int tv_zero PARAMS((struct timeval* t0));
extern int tv_assign PARAMS((struct timeval* t0, struct timeval* t1));
extern u_long tv_toSecs PARAMS((struct timeval* t0));
extern u_long tv_toMsecs PARAMS((struct timeval* t0));
extern u_long tv_toUsecs PARAMS((struct timeval* t0));
extern int tv_msecsTo PARAMS((u_long ms, struct timeval* t0));
extern int tv_minus2 PARAMS((struct timeval* t0, struct timeval* t1, 
			     struct timeval* t2));
extern int tv_minus PARAMS((struct timeval* t0, struct timeval* t1));
extern int tv_add2 PARAMS((struct timeval* t0, struct timeval* t1, 
			   struct timeval* t2));
extern int tv_add PARAMS((struct timeval* t0, struct timeval* t1));

#endif /* !TV_H */
