/* -*-C-*-
*******************************************************************************
*
* File:         xmalloc.c
* RCS:          $Id: xmalloc.c,v 1.1.1.1 2003/06/11 18:48:53 wyan Exp $
* Description:  memory management with out of memory reporting
* Author:       Fabian Ernesto Bustamante
*               Systems Research Group
*               College of Computing
*               Georgia Institute of Technology
* Created:      Wed Jun 27, 2001 at 12:19:15
* Modified:     Thu Jul 19, 2001 at 12:53:15 fabianb@cc.gatech.edu
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
* (C) Copyright 2001, Georgia Institute of Technology, all rights reserved.
*
*******************************************************************************
*/

#if HAVE_CONFIG_H
#  include <config.h>
#endif

#include <common.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>

/*----------------------------------------------------------------------------*/

/*
 * xmalloc:
 *
 * Parameters:
 *
 * Returns:
 *
 */

void *
avs_xmalloc (num)
     size_t num;
{
  void *new = malloc (num);
  if (!new)
    perror ("Memory exhausted");
  return new;
} /* end xmalloc */


/*----------------------------------------------------------------------------*/

/*
 * xrealloc:
 *
 * Parameters:
 *
 * Returns:
 *
 */

void *
avs_xrealloc (p, num)
     void *p; size_t num;
{
  void *new;

  if (!p)
    return avs_xmalloc (num);

  new = realloc (p, num);
  if (!new)
    perror ("Memory exhausted");

  return new;
} /* end xrealloc */


/*----------------------------------------------------------------------------*/

/*
 * xcalloc:
 *
 * Parameters:
 *
 * Returns:
 *
 */

void *
xcalloc (num, size)
     size_t num;
     size_t size;
{
#if HAVE_CALLOC
  void *new = calloc (num, size);
#else 
  void *new = avs_xmalloc (num * size);
  bzero (new, num * size);
#endif
  return new;
} /* end xcalloc */
     
