/* -*-C-*-
*******************************************************************************
*
* File:         sensNet.h
* RCS:          $Id: sensNet.h,v 1.1.1.1 2003/06/11 18:49:01 wyan Exp $
* Description:  Sensor for network effective throughput
* Author:       Fabian E. Bustamante
*               Systems Research Group
*               College of Computing
*               Georgia Institute of Technology
* Created:      Tue Sep 18, 2001 at 21:31:27
* Modified:     Thu Oct 11, 2001 at 23:32:56 fabianb@cc.gatech.edu
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
* (C) Copyright 2001, Georgia Institute of Technology, all rights reserved.
*
*******************************************************************************
*/

#ifndef SENSNET_H
#define SENSNET_H 1

#include <common.h>

#define SENSNET_CM_HEADER_READS 2
#define SENSNET_READ  0
#define SENSNET_WRITE 1

extern int    sensNet_Init PARAMS((int frequency));
extern int    sensNet_Continue PARAMS((int op));
extern int    sensNet_Stop PARAMS((int op));
extern int    sensNet_Finish PARAMS((void));
extern int    sensNet_SetHistLen PARAMS((int histLen, int op));
extern int    sensNet_GetHistory PARAMS((double history[], int len, int op));
extern double sensNet_GetLast PARAMS((int op));
extern int    sensNet_FreeHistory PARAMS((void));

#endif /* !SENSNET_H */
