/* -*-C-*-
*******************************************************************************
*
* File:         stats.h
* RCS:          $Id: stats.h,v 1.1.1.1 2003/06/11 18:49:01 wyan Exp $
* Description:  Basic statistic set
* Author:       Fabian E. Bustamante
*               Systems Research Group
*               College of Computing
*               Georgia Institute of Technology
* Created:      Sat Sep 29, 2001 at 18:01:27
* Modified:     Mon Oct 01, 2001 at 08:01:40 fabianb@cc.gatech.edu
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
* (C) Copyright 2001, Georgia Institute of Technology, all rights reserved.
*
*******************************************************************************
*/

#ifndef STATS_H 
#define STATS_H 1

#include <common.h>

#ifndef MAX
#define MAX(x,y) ((x)>(y) ? (x) : (y))
#endif

#ifndef MIN
#define MIN(x,y) ((x)<(y) ? (x) : (y))
#endif

#ifndef ABS
#define ABS(x) ((x) > 0 ? (x) : (-(x)))
#endif

#ifndef SQUARE
#define SQUARE(x) ((x)*(x))
#endif

#ifndef DIVROUNDDOWN
#define DIVROUNDDOWN(n,s) ((n) / (s))
#endif

#ifndef DIVROUNDUP
#define DIVROUNDUP(n,s)   (((n) + (s)) + ((((n) % (s)) > 0) ? 1:0))
#endif

extern double Stats_mean PARAMS((double *array, int len));
extern double Stats_var PARAMS((double *array, int len));
extern double Stats_sdev PARAMS((double *array, int len));

#endif /* !STATS_H */
