/*------------------------------------------------------------------------------*/

/*
 * enlargeImage:
 *
 * Parameters: inImage and enlarge factor
 *
 * Returns: outImage
 *
 */

int 
enlargeImage (Raw_data* inImage, Raw_data* outImage, int n)
{
  int col, subcol, row, subrow;
  int rowIndx, outIndx, colIndx, outColIndx, outRowIndx;

  outImage->ppm1 = inImage->ppm1;
  outImage->ppm2 = inImage->ppm2;
  outImage->width = inImage->width * n;
  outImage->height = inImage->height * n;
  outImage->maxval = 255;

  outRowIndx = 0;
  for (row = 0; row < inImage->height; ++row) {
    rowIndx = row * inImage->width * 3;
    for (subrow = 0; subrow < n; ++subrow) {
      for (col = 0, colIndx = 0; col < inImage->width; ++col, colIndx += 3) {
	outIndx = outRowIndx * outImage->width * 3;
	for (subcol = 0, outColIndx = (col * n * 3); subcol < n; 
	     ++subcol, outColIndx += 3) {
	  outImage->buff[outIndx+outColIndx+0] = inImage->buff[rowIndx+colIndx+0];
	  outImage->buff[outIndx+outColIndx+1] = inImage->buff[rowIndx+colIndx+1];
	  outImage->buff[outIndx+outColIndx+2] = inImage->buff[rowIndx+colIndx+2];
	}
      }
      ++outRowIndx;
    }
  }

  return 0;
} /* end enlargeImage */
