
#include "ControlCenterServer.h"

//Defined in Monitor.cpp
extern unsigned int FILTER;
extern unsigned int user_fps;

extern float last_shm_buf_4_bw;
extern int last_shm_buf_8_jitter;
extern int last_shm_buf_12_pkt_rate;
extern float last_shm_buf_16_miss_pkt_rate;
extern int last_shm_buf_20_last_seq;
extern float last_shm_buf_24_fps;

ControlCenterImpl :: ControlCenterImpl() 
{}

void ControlCenterImpl :: assignFilter(CORBA::ULong filter
				       ACE_ENV_ARG_DECL_WITH_DEFAULTS
				       /*,
					 CORBA::Environment &ACE_TRY_ENV*/
				       ) ACE_THROW_SPEC (( CORBA::SystemException))
{
  //ACE_UNUSED_ARG (ACE_TRY_ENV);

  user_fps = (filter & 0x00FF0000) >> 16;
  filter &= 0xFF00FFFF;
  FILTER = filter;
  //cout<<" [ControlCenterImpl::assignFitler(): FILTER got new value: 0x"<<hex<<FILTER<<", new user_fps: "<<user_fps<<endl;
}


void ControlCenterImpl::getMeasurements(CORBA::Float_out bw, CORBA::Long_out jitter,
			       CORBA::Long_out pkt_rate, CORBA::Float_out miss_rate,
			       CORBA::ULong_out last_seq_nr, CORBA::Float_out fps
					ACE_ENV_ARG_DECL_WITH_DEFAULTS
					/*,
					  CORBA::Environment &ACE_TRY_ENV*/
			        )
    ACE_THROW_SPEC (( CORBA::SystemException))
{
  //ACE_UNUSED_ARG (ACE_TRY_ENV);

  bw = last_shm_buf_4_bw;
  jitter =  last_shm_buf_8_jitter;
  pkt_rate = last_shm_buf_12_pkt_rate;
  miss_rate = last_shm_buf_16_miss_pkt_rate;
  last_seq_nr = last_shm_buf_20_last_seq;
  fps = last_shm_buf_24_fps;
  //cout<<" [ControlCenterImpl::getMeasurements(): bw: "<<bw<<", jitter: "<<jitter <<", pkt_rate: "<<pkt_rate<<", miss_rate: "<<miss_rate<<", last_seq: " <<last_seq_nr<<", fps:"<<fps<<endl;

}




