
  /* 
   * This file is generated by the Infopipe Stub Generator (ISG).
   * @ GaTech. 
   * Modify where necessarily.
   */

  //////////////////////////////////////
  // CtrlManager.cpp
#include "CtrlManager.h"


 CtrlManager::CtrlManager(void)
{
}
    

 CtrlManager::~CtrlManager(void)
{
}
    

int CtrlManager::init(CORBA::ORB_ptr orb)
{
  if (0 != this->namingClient.init(orb))
    ACE_ERROR_RETURN ((LM_ERROR, " (%P|%t) Unable to init " "TAO_Naming_client\n."), -1);

  this->_orb = CORBA::ORB::_duplicate(orb);
  return 0;
}
    

void CtrlManager::bindToReceivers(const ACE_CString &senderName, const
    ACE_CString & receiverName, AVStreams::MMDevice_ptr sender, CORBA::Environment &ACE_TRY_ENV)
{
  this->senderName = senderName;

  CosNaming::Name name (1);
  name.length (1);

  ACE_TRY
    {
      name[0].id =
        CORBA::string_dup (senderName.c_str());

      this->senderContext =
        this->namingClient->bind_new_context (name
	                                      ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;

      ACE_DEBUG((LM_DEBUG,
                 "(%P|%t) CtrlManager::bindToReceiver(): after senderContext: senderName: %s, receiverName: %s\n",senderName.c_str(), receiverName.c_str()));

      name [0].id =
        CORBA::string_dup (receiverName.c_str()/*"Receivers"*/);

      this->receiverContext =
        this->senderContext->bind_new_context (name
	                                       ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;

      ACE_DEBUG((LM_DEBUG,
                 "(%P|%t) CtrlManager::bindToReceiver(): after receiverContext:senderName: %s, receiverName: %s\n",senderName.c_str(), receiverName.c_str()));

    }
  ACE_CATCH (CosNaming::NamingContext::AlreadyBound, al_ex)
    {
      name[0].id = CORBA::string_dup (this->senderName.c_str ());

      ACE_DEBUG((LM_DEBUG,
                 "(%P|%t) CtrlManager::bindToReceiver(): ACE_CATCH\n                 senderName: %s, receiverName: %s\n",senderName.c_str(), receiverName.c_str()));

      CORBA::Object_var object =
        this->namingClient->resolve (name
	                             ACE_ENV_ARG_PARAMETER);
      ACE_CHECK;

      this->senderContext =
        CosNaming::NamingContext::_narrow (object.in ());

      name[0].id = CORBA::string_dup (receiverName.c_str()/*"Receivers"*/);

      object =
        this->senderContext->resolve (name
                                      ACE_ENV_ARG_PARAMETER);
      ACE_CHECK;

      this->receiverContext =
        CosNaming::NamingContext::_narrow (object.in ());

      this->resolveReceivers (ACE_TRY_ENV);
      ACE_CHECK;

      ACE_DEBUG((LM_DEBUG,
                 "(%P|%t) CtrlManager::bindToReceiver(): ACE_CATCH\nreceivers resolved\n"));

    }
  ACE_ENDTRY;
  ACE_CHECK;

  name [0].id =
    CORBA::string_dup (this->senderName.c_str ());

  this->senderContext->rebind (name, sender
                               ACE_ENV_ARG_PARAMETER);
  ACE_CHECK;
}
    

void CtrlManager::connectToReceivers(AVStreams::MMDevice_ptr
    sender, AVStreams::streamQoS& theQos, int useQos, CORBA::Environment &ACE_TRY_ENV)
{
  ACE_CString protocol = "UDP";

  CORBA::Any_var property;
  CORBA::Any newProperty;

  AVStreams::flowSpec *ext_sender_flows, *ext_receiver_flows;
  AVStreams::flowSpec sender_flows, receiver_flows;
  AVStreams::flowSpec flow_spec(1);
  flow_spec.length(1);


  TAO_StreamCtrl* streamCtrl;
  AVStreams::StreamCtrl_var streamCtrl_object;

  ACE_TRY
    {
      property = sender->get_property_value("Flows");
      ACE_TRY_CHECK;
      *property >>= ext_sender_flows;
      sender_flows = AVStreams::flowSpec(*ext_sender_flows);
      ACE_DEBUG((LM_DEBUG,
                 " (%P|%t) CtrlManager::connectToReceivers(): sender has Flows\n"));
    }
  ACE_CATCH (CosPropertyService::PropertyNotFound, prop_ex)
    {
      ACE_DEBUG((LM_DEBUG,
                 " (%P|%t) CtrlManager::connectToReceivers(): sender has NO Flows\n"));
      sender_flows.length(0);
    }
  ACE_ENDTRY;
  ACE_CHECK;


  for (Receivers::iterator iterator = this->receivers.begin();
       iterator != this->receivers.end();
       ++iterator)
    {
      ACE_CString flowname =
        this->senderName +
        "_"+
        (*iterator).ext_id_;

      TAO_Forward_FlowSpec_Entry sender_entry (flowname.c_str(),
                                               "IN",
                                               "USER_DEFINED",
                                               "",
                                               protocol.c_str(),
                                               0);

      ACE_DEBUG((LM_DEBUG,
                 "(%P|%t)CtrlManager::connectToReceivers(): loop flowname: %s\n",flowname.c_str()));

      flow_spec[0] = CORBA::string_dup (sender_entry.entry_to_string());

      ACE_NEW (streamCtrl, TAO_StreamCtrl);

      PortableServer::ServantBase_var safe_streamCtrl = streamCtrl;

      streamCtrl_object = streamCtrl->_this (ACE_ENV_SINGLE_ARG_PARAMETER);
      ACE_CHECK;

      newProperty <<= streamCtrl_object.in();

      sender->define_property("Related_StreamCtrl", newProperty);

      //Register into the streamCtrls map
      this->streamCtrls.bind (flowname, streamCtrl_object);

      ACE_TRY_EX (label1)
        {
          property = (*iterator).int_id_ -> get_property_value("Flows");
          ACE_TRY_CHECK_EX(label);
          *property >>= ext_sender_flows;
          receiver_flows = AVStreams::flowSpec(*ext_receiver_flows);
          ACE_DEBUG((LM_DEBUG,
                     " (%P|%t) CtrlManager::connectToReceivers(): *iterator has Flows\n"));

        }
      ACE_CATCH (CosPropertyService::PropertyNotFound, prop_ex)
        {
          ACE_DEBUG((LM_DEBUG,
                     " (%P|%t) CtrlManager::connectToReceivers(): *iterator has NO Flows\n"));

          receiver_flows.length(0);
        }
      ACE_ENDTRY;
      ACE_CHECK;

      if (theQos.length() > 0)
        theQos[0].QoSType = CORBA::string_dup (flowname.c_str());

      int result = streamCtrl->bind_devs (sender,
                                          (*iterator).int_id_.in(),
                                          theQos,
                                          flow_spec
                                          ACE_ENV_ARG_PARAMETER);
      ACE_CHECK;
      ACE_DEBUG((LM_DEBUG, "(%P|%t)CtrlManager::bind_devs() here %s %d %d\n",__FILE__,__LINE__, result));

      for (unsigned int i=0; i<flow_spec.length(); i++) {
        ACE_DEBUG((LM_DEBUG,
                   "(%P|%t)Adding flow spec: %s\n",
                   flow_spec[i].in()
                   ));

        sender_flows.length(sender_flows.length()+1);
        sender_flows [sender_flows.length()-1] =
          CORBA::string_dup (flow_spec[i]);

        receiver_flows.length(receiver_flows.length()+1);
        receiver_flows [receiver_flows.length()-1] =
          CORBA::string_dup (flow_spec[i]);
      }

      newProperty <<= receiver_flows;
      (*iterator).int_id_ -> define_property("Flows", newProperty);
    }//End of loop


  newProperty <<= sender_flows;
  sender->define_property("Flows", newProperty);
}
    

void CtrlManager::bindToSender(const ACE_CString &senderName, const ACE_CString &receiverName, AVStreams::MMDevice_ptr receiver, CORBA::Environment &ACE_TRY_ENV)
{
  this->senderName = senderName;
  this->receiverName = receiverName;

  this->receiver = AVStreams::MMDevice::_duplicate (receiver);

  int senderContextExt = 0;
  CosNaming::Name name (1);
  name.length (1);

  ACE_TRY
    {
      name[0].id =
        CORBA::string_dup (senderName.c_str());

      CORBA::Object_var object = this->namingClient->resolve(name
                                                             ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;

      //if no exception, then...
      senderContextExt = 1;

      ACE_DEBUG((LM_DEBUG,
                 "(%P|%t)CtrlManager::bindToSender(): senderContextExt =1\n"));

      this->senderContext =
        CosNaming::NamingContext::_narrow(object.in());

      name [0].id =
        CORBA::string_dup (receiverName.c_str()/*"Receivers"*/);

      object = this->senderContext->resolve (name
                                             ACE_ENV_ARG_PARAMETER);

      ACE_CHECK;

      this->receiverContext =
        CosNaming::NamingContext::_narrow (object.in());

      ACE_DEBUG((LM_DEBUG,
                 "(%P|%t)CtrlManager::bindToSender(): senderContextExt =1\n
                  receiverContext (0x%d) resolved.\n", &receiverContext));

    }
  ACE_CATCH (CosNaming::NamingContext::NotFound, al_ex)
    {
      ACE_DEBUG((LM_DEBUG,
                 "(%P|%t)CtrlManager::bindToSender(): ACE_CATCH\n"));

      name[0].id = CORBA::string_dup (this->senderName.c_str ());

      this->senderContext =
        this->namingClient->bind_new_context (name
                                              ACE_ENV_ARG_PARAMETER);
      ACE_CHECK;

      name[0].id = CORBA::string_dup (receiverName.c_str()/*"Receivers"*/);

      this->receiverContext =
        this->senderContext->bind_new_context(name
                                              ACE_ENV_ARG_PARAMETER);

      ACE_CHECK;
    }
  ACE_ENDTRY;
  ACE_CHECK;

  name[0].id = CORBA::string_dup (this->receiverName.c_str());

  this->receiverContext->rebind (name, receiver
	                         ACE_ENV_ARG_PARAMETER);
  ACE_CHECK;

  if (senderContextExt) {
    ACE_TRY
      {
        name[0].id = CORBA::string_dup(this->senderName.c_str());
        CORBA::Object_var object =
          this->senderContext->resolve(name
                                       ACE_ENV_ARG_PARAMETER);

        ACE_TRY_CHECK;

        this->sender = AVStreams::MMDevice::_narrow (object.in());

        ACE_DEBUG((LM_DEBUG,
                   "(%P|%t)CtrlManager::bindToSender(): if (senderContextExt), sender
found at (0x%d)\n", &sender));

      }
    ACE_CATCH (CosNaming::NamingContext::NotFound, al_ex)
      {
        ACE_DEBUG((LM_DEBUG,
                   "(%P|%t)CtrlManager::bindToSender(): if (senderContextExt), ACE_CATCH, naming not found exception"));

      }
    ACE_ENDTRY;
    ACE_CHECK;
  }
}
    

void CtrlManager::connectToSender(AVStreams::streamQoS& theQos, int useQos, CORBA::Environment &ACE_TRY_ENV)
{
  if (CORBA::is_nil(this->sender.in())) {
    ACE_DEBUG((LM_DEBUG, " (%P|%t) ConnectToSender(): sender is_nil, exit\n"));
    return;
  }

  ACE_DEBUG((LM_DEBUG, " (%P|%t) ConnectToSender(): sender is_not_nil\n"));

  ACE_CString protocol = "UDP";

  ACE_CString flowname =
    this->senderName +
    "_" +
    this->receiverName;

  TAO_Forward_FlowSpec_Entry sender_entry(flowname.c_str(),
                                          "IN",
                                          "USER_DEFINED",
                                          "",
                                          protocol.c_str(),
                                          0);

  ACE_DEBUG((LM_DEBUG, " (%P|%t)CtrlManager::connectToSender(): flowname: %s\n",flowname.c_str()));


  AVStreams::flowSpec flow_spec(1);
  flow_spec.length(1);
  flow_spec[0] = CORBA::string_dup(sender_entry.entry_to_string());

  CORBA::Any_var property;
  CORBA::Any newProperty;

  AVStreams::flowSpec *ext_sender_flows, sender_flows;
  AVStreams::flowSpec *ext_receiver_flows, receiver_flows;

  TAO_StreamCtrl* streamCtrl;
  AVStreams::StreamCtrl_var streamCtrl_object;

  ACE_DEBUG((LM_DEBUG, " (%P|%t)CtrlManager::connectToSender(): before streamCtrl NeW\n"));

  ACE_NEW (streamCtrl, TAO_StreamCtrl);

  ACE_DEBUG((LM_DEBUG, " (%P|%t)CtrlManager::connectToSender(): after streamCtrl NeW\n"));

  streamCtrl_object = streamCtrl->_this(ACE_ENV_SINGLE_ARG_PARAMETER);
  ACE_CHECK;

  //this->streamCtrls.bind (flowname, streamCtrl_object);
  ACE_DEBUG((LM_DEBUG, " (%P|%t)CtrlManager::connectToSender(): streamCtrl_object\n"));

  ACE_TRY
    {
      ACE_DEBUG((LM_DEBUG, " (%P|%t)CtrlManager::connectToSender(): enter TRY\n"));
      property = sender->get_property_value("Flows");
      ACE_TRY_CHECK;

      ACE_DEBUG((LM_DEBUG, " (%P|%t)CtrlManager::connectToSender(): enter TRY2\n"));

      *property >>= ext_sender_flows;
      sender_flows = AVStreams::flowSpec (*ext_sender_flows);
      ACE_DEBUG((LM_DEBUG, " (%P|%t)CtrlManager::connectToSender(): sender has Flow\n"));
    }
  ACE_CATCH (CosPropertyService::PropertyNotFound, prop_ex)
    {
      ACE_DEBUG((LM_DEBUG, " (%P|%t)CtrlManager::connectToSender(): sender has NO Flow\n"));
      sender_flows.length(0);
    }
  ACE_ENDTRY;
  ACE_CHECK;


  ACE_TRY
    {
      property = receiver->get_property_value("Flows");
      ACE_TRY_CHECK;
      *property >>= ext_receiver_flows;
      sender_flows = AVStreams::flowSpec(*ext_receiver_flows);
      ACE_DEBUG((LM_DEBUG, " (%P|%t)CtrlManager::connectToSender(): receiverer has Flow\n"));
    }
  ACE_CATCH (CosPropertyService::PropertyNotFound, prop_ex)
    {
      ACE_DEBUG((LM_DEBUG, " (%P|%t)CtrlManager::connectToSender(): receiver has NO Flow\n"));
      receiver_flows.length(0);
    }
  ACE_ENDTRY;
  ACE_CHECK;

  for (unsigned int i = 0; i < flow_spec.length(); i++) {
    ACE_DEBUG((LM_DEBUG, "(%P|%t)Flow spec: %s\n", flow_spec[i].in()));
    sender_flows.length( sender_flows.length()+1);
    sender_flows [sender_flows.length()-1] = CORBA::string_dup(flow_spec[i]);

    receiver_flows.length( receiver_flows.length()+1);
    receiver_flows [receiver_flows.length()-1] =
      CORBA::string_dup(flow_spec[i]);
  }

  CORBA::Boolean result =
    streamCtrl->bind_devs (this->sender.in(),
                           this->receiver.in(),
                           theQos,
                           flow_spec
                           ACE_ENV_ARG_PARAMETER);
  ACE_CHECK;
  ACE_DEBUG((LM_DEBUG, "(%P|%t)bind_devs here %s %d\n",__FILE__,__LINE__));

  if (0==result)
    ACE_ERROR ((LM_ERROR,
                "bind_devs failed!\n"
                ));

  AVStreams::flowSpec start_spec;
  streamCtrl->start (start_spec
                     ACE_ENV_ARG_PARAMETER);
  ACE_CHECK;

  newProperty <<= sender_flows;
  this->sender->define_property("Flows", newProperty);

  newProperty <<= streamCtrl_object.in();
  this->sender->define_property("Related_StreamCtrl", newProperty);

  newProperty <<= receiver_flows;
  this->receiver->define_property("Flows", newProperty);
}
    

void CtrlManager::destroy(CORBA::Environment &ACE_TRY_ENV)
{
  AVStreams::flowSpec stop_spec;

  for (StreamCtrls::iterator iterator = this->streamCtrls.begin ();
       iterator != this->streamCtrls.end ();
       ++iterator)
    {
      (*iterator).int_id_->destroy (stop_spec
                                    ACE_ENV_ARG_PARAMETER);
      ACE_CHECK;
    }
}
    

void CtrlManager::destroy(const ACE_CString &flowname, CORBA::Environment &ACE_TRY_ENV)
{
  this->protocolObjects.unbind (flowname);
  this->receivers.unbind (flowname);

  AVStreams::StreamCtrl_var streamCtrl;
  this->streamCtrls.unbind (flowname,
                            streamCtrl);

  AVStreams::flowSpec stop_spec;
  streamCtrl->destroy (stop_spec
                       ACE_ENV_ARG_PARAMETER);
  ACE_CHECK;
}
    

CtrlManager::Receivers & CtrlManager::getReceivers(void)
{
  return this->receivers;
}
    

CtrlManager::ProtocolObjects & CtrlManager::getProtocolObjects(void)
{
  return this->protocolObjects;
}
    

CtrlManager::StreamCtrls & CtrlManager::getStreamctrls(void)
{
  return this->streamCtrls;
}
    

void CtrlManager::addToStreamCtrlsMap(const ACE_CString &flowname, TAO_StreamEndPoint *endpoint, CORBA::Environment &ACE_TRY_ENV)
{
  CORBA::Any_ptr streamCtrl_ptr =
    endpoint->get_property_value ("Related_StreamCtrl"
                                  ACE_ENV_ARG_PARAMETER);
  ACE_CHECK;

  AVStreams::StreamCtrl_ptr streamCtrl;

  *streamCtrl_ptr >>= streamCtrl;

  this->streamCtrls.bind (flowname,
                          streamCtrl);
}
    

void CtrlManager::addToReceiversMap(CosNaming::BindingList& bindingList, CORBA::Environment &ACE_TRY_ENV)
{
  for (unsigned int i = 0; i<bindingList.length(); i++) {
    ACE_CString rName = bindingList[i].binding_name[0].id.in();

    CosNaming::Name name(1);
    name.length(1);
    name[0].id = CORBA::string_dup (rName.c_str());

    CORBA::Object_var obj = this->receiverContext->resolve(name
                                                           ACE_ENV_ARG_PARAMETER);

    AVStreams::MMDevice_var rDevice = AVStreams::MMDevice::_narrow(obj.in());

    this->receivers.bind (rName, rDevice);

    ACE_DEBUG((LM_DEBUG, " (%P|%t) addToReceiversMap(): binding <%s> and device <0x%x>\n", rName.c_str(), &rDevice));
  }
}
    

void CtrlManager::resolveReceivers(CORBA::Environment &ACE_TRY_ENV)
{
  CosNaming::BindingIterator_var iterator;
  CosNaming::BindingList_var binding_list;
  const CORBA::ULong chunk = 100;

  //Turn context into a list
  this->receiverContext->list (chunk,
                               binding_list,
                               iterator
                               ACE_ENV_ARG_PARAMETER);
  ACE_CHECK;

  this->addToReceiversMap (binding_list, ACE_TRY_ENV);
  ACE_CHECK;

  if (!CORBA::is_nil (iterator.in ()))
    {
      CORBA::Boolean more = 1;

      while (more)
        {
          more = iterator->next_n (chunk, binding_list
                                   ACE_ENV_ARG_PARAMETER);
          ACE_CHECK;

          this->addToReceiversMap (binding_list, ACE_TRY_ENV);
          ACE_CHECK;
        }
    }
}
    

#if defined (ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION)

template class ACE_Hash_Map_Entry<ACE_CString, AVStreams::MMDevice_var>;
template class ACE_Hash_Map_Manager<ACE_CString, AVStreams::MMDevice_var, ACE_Null_Mutex>;
template class ACE_Hash_Map_Manager_Ex<ACE_CString, AVStreams::MMDevice_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>;
template class ACE_Hash_Map_Iterator_Base_Ex<ACE_CString, AVStreams::MMDevice_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>;
template class ACE_Hash_Map_Iterator_Ex<ACE_CString, AVStreams::MMDevice_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>;
template class ACE_Hash_Map_Reverse_Iterator_Ex<ACE_CString, AVStreams::MMDevice_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>;

template class ACE_Hash_Map_Entry<ACE_CString, TAO_AV_Protocol_Object *>;
template class ACE_Hash_Map_Manager<ACE_CString, TAO_AV_Protocol_Object *, ACE_Null_Mutex>;
template class ACE_Hash_Map_Manager_Ex<ACE_CString, TAO_AV_Protocol_Object *, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>;
template class ACE_Hash_Map_Iterator_Base_Ex<ACE_CString, TAO_AV_Protocol_Object *, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>;
template class ACE_Hash_Map_Iterator_Ex<ACE_CString, TAO_AV_Protocol_Object *, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>;
template class ACE_Hash_Map_Reverse_Iterator_Ex<ACE_CString, TAO_AV_Protocol_Object *, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>;

template class ACE_Hash_Map_Entry<ACE_CString, AVStreams::StreamCtrl_var>;
template class ACE_Hash_Map_Manager<ACE_CString, AVStreams::StreamCtrl_var, ACE_Null_Mutex>;
template class ACE_Hash_Map_Manager_Ex<ACE_CString, AVStreams::StreamCtrl_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>;
template class ACE_Hash_Map_Iterator_Base_Ex<ACE_CString, AVStreams::StreamCtrl_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>;
template class ACE_Hash_Map_Iterator_Ex<ACE_CString, AVStreams::StreamCtrl_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>;
template class ACE_Hash_Map_Reverse_Iterator_Ex<ACE_CString, AVStreams::StreamCtrl_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>;


#elif defined (ACE_HAS_TEMPLATE_INSTANTIATION_PRAGMA)

#pragma instantiate ACE_Hash_Map_Entry<ACE_CString, AVStreams::MMDevice_var>
#pragma instantiate ACE_Hash_Map_Manager<ACE_CString, AVStreams::MMDevice_var, ACE_Null_Mutex>
#pragma instantiate ACE_Hash_Map_Manager_Ex<ACE_CString, AVStreams::MMDevice_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>
#pragma instantiate ACE_Hash_Map_Iterator_Base_Ex<ACE_CString, AVStreams::MMDevice_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>
#pragma instantiate ACE_Hash_Map_Iterator_Ex<ACE_CString, AVStreams::MMDevice_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>
#pragma instantiate ACE_Hash_Map_Reverse_Iterator_Ex<ACE_CString, AVStreams::MMDevice_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>

#pragma instantiate ACE_Hash_Map_Entry<ACE_CString, TAO_AV_Protocol_Object *>
#pragma instantiate ACE_Hash_Map_Manager<ACE_CString, TAO_AV_Protocol_Object *, ACE_Null_Mutex>
#pragma instantiate ACE_Hash_Map_Manager_Ex<ACE_CString, TAO_AV_Protocol_Object *, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>
#pragma instantiate ACE_Hash_Map_Iterator_Base_Ex<ACE_CString, TAO_AV_Protocol_Object *, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>
#pragma instantiate ACE_Hash_Map_Iterator_Ex<ACE_CString, TAO_AV_Protocol_Object *, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>
#pragma instantiate ACE_Hash_Map_Reverse_Iterator_Ex<ACE_CString, TAO_AV_Protocol_Object *, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>

#pragma instantiate ACE_Hash_Map_Entry<ACE_CString, AVStreams::StreamCtrl_var>
#pragma instantiate ACE_Hash_Map_Manager<ACE_CString, AVStreams::StreamCtrl_var, ACE_Null_Mutex>
#pragma instantiate ACE_Hash_Map_Manager_Ex<ACE_CString, AVStreams::StreamCtrl_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>
#pragma instantiate ACE_Hash_Map_Iterator_Base_Ex<ACE_CString, AVStreams::StreamCtrl_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>
#pragma instantiate ACE_Hash_Map_Iterator_Ex<ACE_CString, AVStreams::StreamCtrl_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>
#pragma instantiate ACE_Hash_Map_Reverse_Iterator_Ex<ACE_CString, AVStreams::StreamCtrl_var, ACE_Hash<ACE_CString>, ACE_Equal_To<ACE_CString>, ACE_Null_Mutex>


#endif /* ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION */
