//
//$Id: Monitor.cpp,v 1.3 2003/06/25 15:16:21 wyan Exp $
//
//File: Monitor.cpp
//      The Monitor pipe
//

#include "Monitor.h"
//#include "ace/Get_Opt.h"
#include "ace/OS.h"  


#define DEBUG 0

//////////////////////////////////////
// For measurement
#include "Share_Syn.h"
char* shm, *shm_buf;
int semid;
union semun sunion;
int DeleteSemid=0;
ACE_Shared_Memory_SV* shm_reader;

//
//////////////////////////////////////



////////////////////////////////////////////////////////////
//Customized def
int PACKET_SIZE;
int PAYLOAD_SIZE;
int NR_PACKETS;
int DATA_TYPE;//char=1, int=2, float=3, double=4
int INTERVAL; //in milli-sec
char OUT_FILE[50];
//
////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////
//Custermized code.
//This makes the received frame be
//accessible to ReceiverMonitorServer class. So that
//ReceiverMonitorServer class can further process the 
//received data. 
Type* global_buf;
int global_buf_length;
//
///////////////////////////////////////////////////////////



int SenderMonitorClientStreamEndPoint::get_callback (const char *flowname,
					       TAO_AV_Callback*& callback)
{
  ACE_DECLARE_NEW_CORBA_ENV;
  
  callback = &this->callback;

  return 0;
}


int SenderMonitorClientStreamEndPoint::set_protocol_object
                                       (const char* flowname,
					TAO_AV_Protocol_Object* object)
{
  CtrlManager& ctrlManager = SENDER_MONITOR_CLIENT::instance()->getCtrlManager();

  ctrlManager.getProtocolObjects().bind (flowname, object);

  ctrlManager.addToStreamCtrlsMap (flowname, this);
  
  return 0;
}


CORBA::Boolean SenderMonitorClientStreamEndPoint::handle_preconnect 
                                            (AVStreams::flowSpec& 
					     flow_spec)  
{
  for (unsigned int i = 0; i<flow_spec.length(); i++) {
    TAO_Forward_FlowSpec_Entry entry;
    entry.parse (flow_spec[i].in());

    ACE_CString flowname (entry.flowname());

    CtrlManager& ctrlManager = SENDER_MONITOR_CLIENT::instance()->getCtrlManager();

    int result = ctrlManager.getProtocolObjects().find(flowname);

    if (0==result) {
      ACE_DEBUG ((LM_DEBUG, " MonitorClient changes receivers\n"));
      ctrlManager.destroy(flowname);
    }
  }
  
  return 0;
}



SenderMonitorClient::SenderMonitorClient(void) : clientMMDevice(0), 
  /*clientName("MonitorClient"),*/
		                     Pipe()
{
  //Add additional code below
}



SenderMonitorClient::~SenderMonitorClient(void)
{
}

//Virtual method from Pipe class
int SenderMonitorClient::initPipe()
{
  return 0;
}


CtrlManager& SenderMonitorClient::getCtrlManager(void)
{
  return ctrlManager;
}

const char* SenderMonitorClient::getName(void) const
{
  return clientName.c_str();
}


int SenderMonitorClient::init(int argc, 
			char** argv, 
			const char* clientName,
			const char* serverName,
			CORBA::Environment& ACE_TRY_ENV)
{
  //Originally was in Cstr
  this->clientName = CORBA::string_dup (clientName);

  int result;

  /////////////////////////////////////////////////
  //Customerized init
  result = initPipe();

  result = monitorClientEndpointStrategy.init(TAO_AV_CORE::instance()->orb(),
				       TAO_AV_CORE::instance()->poa());
  if (0!=result) return result;

  result = ctrlManager.init(TAO_AV_CORE::instance()->orb());
  if (0!=result) return result;

  ACE_NEW_RETURN (clientMMDevice,
		  TAO_MMDevice (&monitorClientEndpointStrategy),
		  -1);

  PortableServer::ServantBase_var safeMMDevice = clientMMDevice;

  AVStreams::MMDevice_var mmdevice = clientMMDevice->_this();
  ACE_CHECK_RETURN (-1);

  ctrlManager.bindToReceivers(clientName,
			      serverName/*"MonitorServer"*/,
			      mmdevice.in(),
			      ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  AVStreams::streamQoS theQos;
  theQos.length(0);

  ctrlManager.connectToReceivers (mmdevice.in(),
				  theQos,
				  0,
				  ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  //Add additional code below

  return 0;
}
				  

int SenderMonitorClient::sendData(void)
{
  char buf[BUFSIZ];
  int times = 0;

  INFOP infop;
  Data data;

  int sem_flag = 0;

  cout<<" PACKET_SIZE:"<<PACKET_SIZE<<", PAYLOAD_SIZE:"<<PAYLOAD_SIZE
      <<", NR_PACKETS:"<<NR_PACKETS<<", DATA_TYPE:"<<DATA_TYPE
      <<", INTERVAL: "<<INTERVAL<<", BUFSIZ:"<<BUFSIZ<<endl;

  switch (DATA_TYPE) {
  case 1:
    data.SIZE = PAYLOAD_SIZE/sizeof(char);
    data.buff = new Type[data.SIZE];
    for (int i=0;i<data.SIZE;i++) data.buff[i]='x';  
    break;
  case 2:
    data.SIZE = PAYLOAD_SIZE/sizeof(int);
    data.buff = new Type[data.SIZE];
    for (int i=0;i<data.SIZE;i++) data.buff[i]=1;  
    break;
  case 3:
    data.SIZE = PAYLOAD_SIZE/sizeof(float);
    data.buff = new Type[data.SIZE];
    for (int i=0;i<data.SIZE;i++) data.buff[i]=1.1;  
    break;
  case 4:
    data.SIZE = PAYLOAD_SIZE/sizeof(double);
    data.buff = new Type[data.SIZE];
    for (int i=0;i<data.SIZE;i++) data.buff[i]=1.1;  
    break;
  default:
    ACE_ERROR_RETURN((LM_DEBUG, " SenderMonitorClient::sendData(): invalid data type\n"), -1);
  }
  
  
  //ACE_Time_Value sleep_time(0, 500000);//.5 sec
  ACE_Time_Value current;
  ACE_TRY
    {
      while (times < NR_PACKETS) {
	//if (times > 1) 
	// break;
	//ACE_OS::sleep(sleep_time);

	times++;

        if (1<times) {
        {
          //Read the data from shared mem
          if (DEBUG)
            printf("Waiting until written... "),
              fflush(stdout);
          locksem(semid, SN_READ);
          //printf("done; ");
          if (DEBUG)
            printf("Waiting for lock... "),
              fflush(stdout);
          locksem(semid, SN_LOCK);
          sem_flag = *(int*)shm_buf;
          //printf("done.\n");
          if (DEBUG)
            printf("Read flag(%d)\n",sem_flag),
              fflush(stdout);
          unlocksem(semid, SN_LOCK);
          unlocksem(semid, SN_WRITE);
        }
        if (sem_flag != 1) {
          ACE_DEBUG((LM_DEBUG," SenderMonitorClient::sendData(): flag in sem forbids processing\n"));
          times--;
          continue;
        }
        }

	//Init infop
	SET_INFOP(ver, infop, 1);
	SET_INFOP(pad, infop, 0);
	SET_INFOP(extension, infop, 1);
	SET_INFOP(marker, infop, 0);
        SET_INFOP(type, infop, 1);
	SET_INFOP(seq, infop, times);
	SET_INFOP(length, infop, sizeof(infop)+PAYLOAD_SIZE);
	//Use src_id to pass the value of NR_PACKET to the receiver side
	SET_INFOP(src_id, infop, NR_PACKETS);
	current = ACE_OS::gettimeofday();
	SET_INFOP(time, infop, current.sec()*1000000+current.usec());

	if (DEBUG) {
	cout<<" infop: size = "<<sizeof(infop)<<endl;
	cout<<" infop: ver("<<infop.ver<<"), pad("<<infop.pad
	    <<"), extension("<<infop.extension<<"), marker("<<infop.marker
	    <<"), type("<<infop.type<<"), seq("<<infop.seq
	    <<"), time("<<infop.time<<"), length("<<infop.length
	    <<"), src_id("<<infop.src_id<<")"<<endl;
	}

	setInDataFlow(infop, data);
	inDataToOutData(0);
	int size = exportOutDataFlow (buf, BUFSIZ);
	/*
	cout<<" sendData(): main while loop, times="<<times<<", BUFSIZ="
	    <<BUFSIZ<<", buf_length="<<size<<"\n";

	cout<<"             buf: >"<<buf[0+INFOP_HEADER_SIZE]<<buf[1+INFOP_HEADER_SIZE]<<buf[2+INFOP_HEADER_SIZE]<<buf[3+INFOP_HEADER_SIZE]<<"<\n";
	*/

	CtrlManager::ProtocolObjects& pObjects = 
	  SENDER_MONITOR_CLIENT::instance()->getCtrlManager().getProtocolObjects();

	int j=0;
	for (CtrlManager::ProtocolObjects::iterator iterator =
	       pObjects.begin();
	     iterator != pObjects.end();
	     ++iterator)
	  {
	    if (DEBUG)
	      ACE_DEBUG((LM_DEBUG,
			 "(%P|%t) sendData(): loop, j=%d\n",j));
	    j++;

	    int result = (*iterator).int_id_->send_frame(buf, size/*BUFSIZ*/);
	
	    if (0>result)
	      ACE_ERROR_RETURN ((LM_ERROR, "(%P|%t)sendData() failed!\n"), -1);
	    else 
	      ACE_DEBUG((LM_DEBUG, "(%P|%t)SenderMonitorClient::sendData(): %d bytes data sent\n", size));

	  }
	ACE_DEBUG((LM_DEBUG, "===================================Packet(%d)\n",times-1));

      }
    }
  ACE_CATCHANY 
    {
      ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,
			   " (%P|%t)sendData(): exception\n");
      return -1;
    }
  ACE_ENDTRY;
  
  return 0;
}





//====================================================================

//The filter from the ControlCenter is passed to this variable.
unsigned int applied_filter = 0;
extern unsigned int FILTER;
unsigned int user_fps;
float last_shm_buf_4_bw;
int last_shm_buf_8_jitter;
int last_shm_buf_12_pkt_rate;
float last_shm_buf_16_miss_pkt_rate;
int last_shm_buf_20_last_seq;
float last_shm_buf_24_fps;

int ReceiverMonitorClientStreamEndPoint::get_callback (const char *flowname,
					       TAO_AV_Callback*& callback)
{
  ACE_DECLARE_NEW_CORBA_ENV;
  
  callback = &this->callback;

  return 0;
}


int ReceiverMonitorClientStreamEndPoint::set_protocol_object
                                       (const char* flowname,
					TAO_AV_Protocol_Object* object)
{
  CtrlManager& ctrlManager = RECEIVER_MONITOR_CLIENT::instance()->getCtrlManager();

  ctrlManager.getProtocolObjects().bind (flowname, object);

  ctrlManager.addToStreamCtrlsMap (flowname, this);
  
  return 0;
}


CORBA::Boolean ReceiverMonitorClientStreamEndPoint::handle_preconnect 
                                            (AVStreams::flowSpec& 
					     flow_spec)  
{
  for (unsigned int i = 0; i<flow_spec.length(); i++) {
    TAO_Forward_FlowSpec_Entry entry;
    entry.parse (flow_spec[i].in());

    ACE_CString flowname (entry.flowname());

    CtrlManager& ctrlManager = RECEIVER_MONITOR_CLIENT::instance()->getCtrlManager();

    int result = ctrlManager.getProtocolObjects().find(flowname);

    if (0==result) {
      ACE_DEBUG ((LM_DEBUG, " MonitorClient changes receivers\n"));
      ctrlManager.destroy(flowname);
    }
  }
  
  return 0;
}



ReceiverMonitorClient::ReceiverMonitorClient(void) : clientMMDevice(0), 
  /*clientName("MonitorClient"),*/
						     Pipe()
{
  //Add additional code below
}


ReceiverMonitorClient::~ReceiverMonitorClient(void)
{
}

//Virtual method from Pipe class
int ReceiverMonitorClient::initPipe()
{
  return 0;
}


CtrlManager& ReceiverMonitorClient::getCtrlManager(void)
{
  return ctrlManager;
}

const char* ReceiverMonitorClient::getName(void) const
{
  return clientName.c_str();
}


int ReceiverMonitorClient::init(int argc, 
			char** argv, 
			const char* clientName,
			const char* serverName,
			CORBA::Environment& ACE_TRY_ENV)
{
  //Originally was in Cstr
  this->clientName = CORBA::string_dup (clientName);

  int result;

  /////////////////////////////////////////////////
  //Customerized init
  result = initPipe();

  result = monitorClientEndpointStrategy.init(TAO_AV_CORE::instance()->orb(),
				       TAO_AV_CORE::instance()->poa());
  if (0!=result) return result;

  result = ctrlManager.init(TAO_AV_CORE::instance()->orb());
  if (0!=result) return result;

  ACE_NEW_RETURN (clientMMDevice,
		  TAO_MMDevice (&monitorClientEndpointStrategy),
		  -1);

  PortableServer::ServantBase_var safeMMDevice = clientMMDevice;

  AVStreams::MMDevice_var mmdevice = clientMMDevice->_this();
  ACE_CHECK_RETURN (-1);

  ctrlManager.bindToReceivers(clientName,
			      serverName/*"MonitorServer"*/,
			      mmdevice.in(),
			      ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  AVStreams::streamQoS theQos;
  theQos.length(0);

  ctrlManager.connectToReceivers (mmdevice.in(),
				  theQos,
				  0,
				  ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);


  return 0;
}
				  

int ReceiverMonitorClient::sendData(void)
{
  char buf[BUFSIZ];
  int times = 0;
  
  int sem_flag =0 ;

  int size = 0;
  INFOCP infocp;
  int accum_time = 0;
  int accum_pkt_size = 0;
  int accum_jitter = 0;
  int nr_pkts = 0;
  
  CtrlFlow cf;
  Data data; 
  data.SIZE = SHMSZ_R;// - 4;
  data.buff = new char[data.SIZE];

  bool shmUpdated = false;

  float shm_buf_4_bw;// ,last_shm_buf_4_bw;
  int shm_buf_8_jitter;//, last_shm_buf_8_jitter;
  int shm_buf_12_pkt_rate;//, last_shm_buf_12_pkt_rate;
  float shm_buf_16_miss_pkt_rate = 0;//, last_shm_buf_16_miss_pkt_rate;
  int shm_buf_20_last_seq = 0;//, last_shm_buf_20_last_seq;
  float shm_buf_24_fps = 0;
  
  shm_buf_4_bw = last_shm_buf_4_bw = 0;
  shm_buf_8_jitter = last_shm_buf_8_jitter = 0;
  shm_buf_12_pkt_rate = last_shm_buf_12_pkt_rate = 0;
  last_shm_buf_16_miss_pkt_rate = last_shm_buf_20_last_seq = 0;

  ACE_TRY
    {
      while (1) {
	times++;

	sem_flag = *(int*)shm_buf;

        if (sem_flag == 2) {
	  shm_buf_4_bw = *(float*)(shm_buf+4);
	  shm_buf_8_jitter = *(int*)(shm_buf+8);
	  shm_buf_12_pkt_rate = *(int*)(shm_buf+12);
	  shm_buf_16_miss_pkt_rate = *(float*)(shm_buf+16);
	  shm_buf_20_last_seq = *(int*)(shm_buf+20);

	  shm_buf_24_fps = *(float*)(shm_buf+24);

	  if ( (shm_buf_4_bw != last_shm_buf_4_bw) ||
	       (shm_buf_8_jitter != last_shm_buf_8_jitter) ||
	       (shm_buf_12_pkt_rate != last_shm_buf_12_pkt_rate))
	    {
	      shmUpdated = true;
	      last_shm_buf_4_bw = shm_buf_4_bw;
	      last_shm_buf_8_jitter = shm_buf_8_jitter;
	      last_shm_buf_12_pkt_rate = shm_buf_12_pkt_rate;

	      last_shm_buf_16_miss_pkt_rate = shm_buf_16_miss_pkt_rate;
	      last_shm_buf_20_last_seq = shm_buf_20_last_seq;

	      last_shm_buf_24_fps = shm_buf_24_fps;

	      *(unsigned int*)data.buff = FILTER;//0x80000000 | FILTER;//filterType
	      *(float*)(data.buff + 4) = shm_buf_4_bw;
	      *(int*)(data.buff + 8) = shm_buf_8_jitter;
	      *(int*)(data.buff + 12) = shm_buf_12_pkt_rate;
	      *(float*)(data.buff + 16) = shm_buf_16_miss_pkt_rate;
	      *(int*)(data.buff + 20) = shm_buf_20_last_seq;
	      *(int*)(data.buff + 24) = user_fps;
	      if (DEBUG) {
		ACE_DEBUG((LM_DEBUG,
			   "(%P|%t) main(): wwwwwwwwwwwwwwwwwww %dth packet last!\n\n",
			   shm_buf_20_last_seq));
	      }
	    }
	  else 
	    {
	      shmUpdated = false;
	    }
        }
	else if (sem_flag == 4) {
	  shm_buf_4_bw = *(float*)(shm_buf+4);
	  shm_buf_12_pkt_rate = *(int*)(shm_buf+8);
	  shm_buf_16_miss_pkt_rate = *(float*)(shm_buf+12);

	  *(unsigned int*)data.buff = 99 ;//filterType
	  *(float*)(data.buff + 4) = shm_buf_4_bw;
	  *(int*)(data.buff + 8) = shm_buf_12_pkt_rate;
	  *(int*)(data.buff + 12) = shm_buf_16_miss_pkt_rate;

	  data.SIZE = 16;
	  shmUpdated = true;

	  if (DEBUG) {
	    ACE_DEBUG((LM_DEBUG,"(%P|%t) main(): FFFFFFFFFFFFFFFFFFFFF packet returned!\n\n"
		       ));
	  }
	}
	  
	if (shmUpdated) 
	  {
	    SET_INFOP(ver, infocp, 1);
	    SET_INFOP(pad, infocp, 0);
	    SET_INFOP(rec_ct, infocp, 1);
	    SET_INFOP(type, infocp, sem_flag);
	    SET_INFOP(length, infocp, sizeof(infocp));
	    
	    setOutCtrlFlow(infocp, data);
	
	    size = exportOutCtrlFlow(buf, BUFSIZ);

	    cf = RECEIVER_MONITOR_CLIENT::instance() -> getOutCtrlFlow();

	    if (DEBUG) {
	      cout<<" infocp: size = "<<sizeof(infocp)<<endl;
	      cout<<" infop: ver("<<infocp.ver<<"), pad("<<infocp.pad
		  <<"), type("<<infocp.type
		  <<"), length("<<infocp.length
		  <<endl;
	      cout<<" data.SIZE: "<<cf.data.SIZE<<endl;
	    }
	
	    CtrlManager::ProtocolObjects& pObjects = 
	      RECEIVER_MONITOR_CLIENT::instance()->getCtrlManager().getProtocolObjects();
	    
	    int j=0;
	    for (CtrlManager::ProtocolObjects::iterator iterator =
		   pObjects.begin();
		 iterator != pObjects.end();
		 ++iterator)
	      {
		if (DEBUG)
		  ACE_DEBUG((LM_DEBUG,
			     "(%P|%t) sendData(): loop, j=%d\n",j));
		j++;
		
		int result = (*iterator).int_id_->send_frame(buf, size);
		
		if (0>result)
		  ACE_ERROR_RETURN ((LM_ERROR, "(%P|%t)sendData() failed!\n"), -1);
		else {
		  if (DEBUG) 
		    ACE_DEBUG((LM_DEBUG,
			       "(%P|%t)ReceiverMonitorClient::sendData(): %d bytes data sent\n", 
			       size));
		}
	      }
	  } //if (shmUpdated) 

      }/*while (1)*/
    }
  ACE_CATCHANY 
    {
      ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,
			   " (%P|%t)sendData(): exception\n");
      return -1;
    }
  ACE_ENDTRY;

  if (data.buff) delete [] data.buff;
  
  return 0;
}



//=====================================================================



SenderMonitorServerCallback::SenderMonitorServerCallback (void)
  // : decoder(PPMDecoder(MUS, MAXPIXELSIZE, MAXLINESIZE))
{
  //ACE_INET_Addr inet_addr( 8800, "localhost");
}



int SenderMonitorServerCallback::receive_frame (ACE_Message_Block *frame,
                                     TAO_AV_frame_info *frame_info,
                                     const ACE_Addr &peer_address)
{
  int i=0;

  if (DEBUG)
    ACE_DEBUG((LM_DEBUG,"(%P|%t) SenderMonitorServerCallback::receive_frame()\n"));

  while (0 != frame) {
    //char* buf = frame->rd_ptr();
    global_buf = (Type*)(frame->rd_ptr());
    global_buf_length = frame->length();

    frame = frame->cont();
  }
  
  return 0;
}

int SenderMonitorServerStreamEndPoint::get_callback (const char* flowname, 
                                          TAO_AV_Callback*& callback)
{
  ACE_DECLARE_NEW_CORBA_ENV;

  callback = &this->callback;

  return 0;
}




SenderMonitorServer::SenderMonitorServer(void) : //clientName("MonitorClient"),
  //serverName("MonitorServer"),
                           serverMMDevice(0)
{
}


//Virtual method from Pipe class
int SenderMonitorServer::initPipe()
{
  return 0;
}


int SenderMonitorServer::init (int argc, char** argv, 
			 const char* clientName,
			 const char* serverName,
			 CORBA::Environment& ACE_TRY_ENV)
{
  //Originally was in Cstr
  this->clientName = CORBA::string_dup (clientName);
  this->serverName = CORBA::string_dup (serverName);


  int result;

  result = monitorServerEndpointStrategy.init(TAO_AV_CORE::instance()->orb(),
                                         TAO_AV_CORE::instance()->poa());
  if (0!=result) return result;

  result = ctrlManager.init(TAO_AV_CORE::instance()->orb());
  if (0!=result) return result;

  ACE_NEW_RETURN (serverMMDevice,
                  TAO_MMDevice (&monitorServerEndpointStrategy),
                  -1);

  AVStreams::MMDevice_var mmdevice = serverMMDevice->_this();
  ACE_CHECK_RETURN (-1);

  ctrlManager.bindToSender (clientName,
                            serverName,
                            mmdevice.in(),
                            ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  AVStreams::streamQoS theQos;
  theQos.length(0);


  ctrlManager.connectToSender (theQos,
                               0,
                               ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  //Add additional code below

  return 0;
}


CtrlManager& SenderMonitorServer::getCtrlManager(void)
{
  return ctrlManager;
}

const char* SenderMonitorServer::getName(void) const
{
  return serverName.c_str();
}

//====================================================================

ReceiverMonitorServerCallback::ReceiverMonitorServerCallback (void)
  // : decoder(PPMDecoder(MUS, MAXPIXELSIZE, MAXLINESIZE))
{
  //ACE_INET_Addr inet_addr( 8800, "localhost");
}



int ReceiverMonitorServerCallback::receive_frame (ACE_Message_Block *frame,
                                     TAO_AV_frame_info *frame_info,
                                     const ACE_Addr &peer_address)
{
  while (0 != frame) {
    //char* buf = frame->rd_ptr();
    global_buf = (Type*)(frame->rd_ptr());
    global_buf_length = frame->length();

    if (DEBUG)
      ACE_DEBUG((LM_DEBUG,"(%P|%t) ReceiverMonitorServerCallback::receive_frame(): %d bytes received\n", global_buf_length));
    frame = frame->cont();
  }
  
  return 0;
}

int ReceiverMonitorServerStreamEndPoint::get_callback (const char* flowname, 
                                          TAO_AV_Callback*& callback)
{
  ACE_DECLARE_NEW_CORBA_ENV;

  callback = &this->callback;

  return 0;
}


ReceiverMonitorServer::ReceiverMonitorServer(void) : //clientName("MonitorClient"),
  //serverName("MonitorServer"),
                           serverMMDevice(0)
{
}


//Virtual method from Pipe class
int ReceiverMonitorServer::initPipe()
{
  return 0;
}


int ReceiverMonitorServer::init (int argc, char** argv, 
			 const char* clientName,
			 const char* serverName,
			 CORBA::Environment& ACE_TRY_ENV)
{
  //Originally was in Cstr
  this->clientName = CORBA::string_dup (clientName);
  this->serverName = CORBA::string_dup (serverName);


  int result;

  result = monitorServerEndpointStrategy.init(TAO_AV_CORE::instance()->orb(),
                                         TAO_AV_CORE::instance()->poa());
  if (0!=result) return result;

  result = ctrlManager.init(TAO_AV_CORE::instance()->orb());
  if (0!=result) return result;

  ACE_NEW_RETURN (serverMMDevice,
                  TAO_MMDevice (&monitorServerEndpointStrategy),
                  -1);

  AVStreams::MMDevice_var mmdevice = serverMMDevice->_this();
  ACE_CHECK_RETURN (-1);

  ctrlManager.bindToSender (clientName,
                            serverName,
                            mmdevice.in(),
                            ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  AVStreams::streamQoS theQos;
  theQos.length(0);


  ctrlManager.connectToSender (theQos,
                               0,
                               ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  //Add additional code below

  return 0;
}


CtrlManager& ReceiverMonitorServer::getCtrlManager(void)
{
  return ctrlManager;
}

const char* ReceiverMonitorServer::getName(void) const
{
  return serverName.c_str();
}





#if defined (ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION)
template class ACE_Singleton <SenderMonitorClient, ACE_Null_Mutex>;
template class ACE_Singleton <ReceiverMonitorClient, ACE_Null_Mutex>;
template class TAO_AV_Endpoint_Reactive_Strategy_A<SenderMonitorClientStreamEndPoint, TAO_VDev, AV_Null_MediaCtrl>;
template class TAO_AV_Endpoint_Reactive_Strategy_A<ReceiverMonitorClientStreamEndPoint, TAO_VDev, AV_Null_MediaCtrl>;
template class TAO_AV_Endpoint_Reactive_Strategy<SenderMonitorClientStreamEndPoint, TAO_VDev, AV_Null_MediaCtrl>;
template class TAO_AV_Endpoint_Reactive_Strategy<ReceiverMonitorClientStreamEndPoint, TAO_VDev, AV_Null_MediaCtrl>;

template class ACE_Singleton <SenderMonitorServer, ACE_Null_Mutex>;
template class ACE_Singleton <ReceiverMonitorServer, ACE_Null_Mutex>;
template class TAO_AV_Endpoint_Reactive_Strategy_B<SenderMonitorServerStreamEndPoint, TAO_VDev, AV_Null_MediaCtrl>;
template class TAO_AV_Endpoint_Reactive_Strategy_B<ReceiverMonitorServerStreamEndPoint, TAO_VDev, AV_Null_MediaCtrl>;
template class TAO_AV_Endpoint_Reactive_Strategy<SenderMonitorServerStreamEndPoint, TAO_VDev, AV_Null_MediaCtrl>;
template class TAO_AV_Endpoint_Reactive_Strategy<ReceiverMonitorServerStreamEndPoint, TAO_VDev, AV_Null_MediaCtrl>;


#elif defined (ACE_HAS_TEMPLATE_INSTANTIATION_PRAGMA)
#pragma instantiate ACE_Singleton <SenderMonitorClient, ACE_Null_Mutex>
#pragma instantiate ACE_Singleton <ReceiverMonitorClient, ACE_Null_Mutex>
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy_A
                     <SenderMonitorClientStreamEndPoint,
                      TAO_VDev,
                      AV_Null_MediaCtrl>
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy_A
                     <ReceiverMonitorClientStreamEndPoint,
                      TAO_VDev,
                      AV_Null_MediaCtrl>
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy
                     <SenderMonitorClientStreamEndPoint,
                      TAO_VDev,
                      AV_Null_MediaCtrl>
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy
                     <ReceiverMonitorClientStreamEndPoint,
                      TAO_VDev,
                      AV_Null_MediaCtrl>

#pragma instantiate ACE_Singleton <SenderMonitorServer, ACE_Null_Mutex>
#pragma instantiate ACE_Singleton <ReceiverMonitorServer, ACE_Null_Mutex>
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy_B
                     <SenderMonitorServerStreamEndPoint,
                      TAO_VDev,
                      AV_Null_MediaCtrl>
		     
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy_B
                     <ReceiverMonitorServerStreamEndPoint,
                      TAO_VDev,
                      AV_Null_MediaCtrl>
		     
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy
                     <SenderMonitorServerStreamEndPoint,
                      TAO_VDev,
                      AV_Null_MediaCtrl>
		     
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy
                     <ReceiverMonitorServerStreamEndPoint,
                      TAO_VDev,
                      AV_Null_MediaCtrl>
		     
#endif /* ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION */
