
  /* 
   * This file is generated by the Infopipe Stub Generator (ISG).
   * @ GaTech. 
   * Modify where necessarily.
   */

  //////////////////////////////////////
  // PPMP.h


  

#ifndef _PPMP_H_
#define _PPMP_H_

  
#include <string.h>
#include <netinet/in.h>
#include <iostream>



typedef unsigned long long uint64;
typedef   signed long long  int64;
typedef unsigned long      uint32;
typedef   signed long       int32;
typedef unsigned short     uint16;
typedef   signed short      int16;
typedef unsigned char      uint8;
typedef   signed char       int8;
 
inline uint16 ChangeEndian16(uint16 v) { return (v>>8) | (v<<8); }
inline uint32 ChangeEndian32(uint32 v) { return (v>>24) | ((v>>8)&0xFF00) | ((v&0xFF00)<<8) | (v<<
24); }

#ifdef WORDS_BIGENDIAN
inline uint16 ToLittleEndian16(uint16 v) { return ChangeEndian16(v); }
inline uint32 ToLittleEndian32(uint32 v) { return ChangeEndian32(v); }
inline uint16 ToBigEndian16(uint16 v)    { return v; }
inline uint32 ToBigEndian32(uint32 v)    { return v; }
#else
inline uint16 ToLittleEndian16(uint16 v) { return v; }
inline uint32 ToLittleEndian32(uint32 v) { return v; }
inline uint16 ToBigEndian16(uint16 v)    { return ChangeEndian16(v); }
inline uint32 ToBigEndian32(uint32 v)    { return ChangeEndian32(v); }
#endif



#if defined (STRUCT_PPM_frame_info)

#else

typedef struct {
  int tag;          //Reserved
  char ppm1;        //'P'
  char ppm2;        //'1'-'6'
  int size;         //width*height*pixel_size_in_bytes
  int width;
  int height;
  char* buff;       //Reserved
} PPM_frame_info, *PPM_frame_info_ptr;

#define STRUCT_PPM_frame_info

#endif

//Only used in sending PPM_frame_info before sending
//each fragment of the whole PPM frame
#define PPMP_FRAME_HEADER_OFFSET 0
#define PPMP_FRAME_INFO_OFFSET 8
//Used in sending each fragment of the whole PPM frame
#define PPMP_PICT_HEADER_OFFSET 0
#define PPMP_FRAME_NO_OFFSET 4

//Used as to distinguished from Mpeg headers in DVDview
#define PPMP_FRAME_HEADER 0x1ff
#define PPMP_PICT_HEADER 0x1f0


  
  
  

  
  //////////////////////////////////////
  // classPPMP

class PPMP_Fragment
{
public:
  PPMP_Fragment(char* frag_buf, size_t frag_len);

public:
  PPMP_Fragment(unsigned long ppmp_header, unsigned long frame_no, const char* msg_buf, size_t len, char* frag_buf);



  size_t get_frag_length()
    {
      return frag_length;
    }

  size_t get_payload_length()
    {//No matter it's a frame or pict header, data starts from 
      //PPMP_FRAME_INFO_OFFSET
      return frag_length - PPMP_FRAME_INFO_OFFSET;
    }

  void copy_payload(char *target_buffer)
    {
      memcpy(target_buffer, frag_buffer + PPMP_FRAME_INFO_OFFSET, 
	     frag_length - PPMP_FRAME_INFO_OFFSET);
    }

  unsigned long get_ppmp_frame_header()
    {
      return ntohl(*((unsigned long *) (frag_buffer + PPMP_FRAME_HEADER_OFFSET)));
    }

  unsigned long get_ppmp_pict_header()
    {
      return ntohl(*((unsigned long *) (frag_buffer + PPMP_PICT_HEADER_OFFSET)));
    }

  unsigned long get_ppmp_frame_no()
    {
      return ntohl(*((unsigned long*) (frag_buffer+ PPMP_FRAME_NO_OFFSET)));
    }

  
  
protected:
 char* frag_buffer;

protected:
 size_t frag_length;

};// class: 



/////////////////////////////////////////////////////////////////////////////

  class PPMP_Sender
{
public:
  PPMP_Sender(int mus, int pixelsize, int maxpixelperline);

public:
 int send_preframe(const char* PPMHeader, const int src_id, const int seq, const unsigned int filter_flag);

public:
 int send_whole_frame(const char *msg_buf, const size_t len, const unsigned long PPMFrame_num, const int src_id, const unsigned int filter_flag);

public:
 virtual int send_fragment(const char *msg_buf, const size_t
    len, const int src_id, const int seq, const unsigned int
    filter_flag, const unsigned short mark) = 0;

public:
 virtual void setPPMFrameInfo(int mus, PPM_frame_info& ppmfi) = 0;

public:
 int lines_send_curr;

public:
 PPM_frame_info pfi;

public:
 int bpp;

public:
 int max_buf_size;

public:
 int lines_send_per_time;

public:
 int num_times;

public:
 int mus;

private:
 unsigned long curr_frame_num;

};// class: 



///////////////////////////////////////////////////////////////////////////////

  class Flag_Array
{
public:
  Flag_Array();

public:
  Flag_Array(int first, int last);


  int get_current_idx() {return current;}
  int get_start_idx() {return start;}
  int get_end_idx() {return end;}
  void increase_idx(int i) {current+=i;}
  void set_available(int idx) 
    {
    available[idx] = true;}

  bool all_available() {
    bool b = false;
    for (int i=start; i<=end; i++) {
      if (available[i]==false) 

	return b;
    }
    return true;
  }

  
public:
 void init_available();

public:
 void free_available();

private:
 int start;

private:
 int end;

private:
 int current;

private:
 bool* available;

};// class: 



///////////////////////////////////////////////////////////////////////////////

  class PPMP_Receiver
{
public:
  PPMP_Receiver(int mus);

public:
 int process_ppm(const char* msg, size_t len, unsigned long PPMFrameNum, PPM_frame_info& pfi);

public:
 void start_defragment(const char* img, int first,int last, int d_start_line, int d_end_line, int i_start_line);

public:
 char* accumulate_fragment(const char *frag_buf, size_t frag_len, PPM_frame_info& pfi, bool flushOrNot);

public:
 virtual int process_whole_frame(const char *frame, size_t len) = 0;

public:
 void free_img_buffer();

public:
 char* img_buffer;

protected:
 int MUS;

protected:
 int line_accumulated;

protected:
 bool first;

protected:
 int data_start_line;

protected:
 int data_end_line;

protected:
 int img_start_line;

protected:
 Flag_Array line;

protected:
 int frame_height;

protected:
 int frame_width;

protected:
 unsigned long frame_no;

protected:
 unsigned long curr_PPM_frame_num;

protected:
 int rpos;

protected:
 int gpos;

protected:
 int bpos;

protected:
 int bytes_per_line;

protected:
 int bits_per_pixel;

protected:
 bool little_endian;

protected:
 int BytesReceived;

protected:
 int fileidx;

};// class: 




#endif // 



  