
  /* 
   * This file is generated by the Infopipe Stub Generator (ISG).
   * @ GaTech. 
   * Modify where necessarily.
   */

  //////////////////////////////////////
  // Pipe.cpp
#include <stdio.h>
#include <iostream>
#include <ace/OS.h>
#include "Pipe.h"


ACE_Time_Value qos_last, qos_now;
extern int accum_qos_time;

#define DEBUG 0

  

extern "C" {
  
    //<block name="filter_ENCRYPT">
#include "encrypt.h"
extern EncryptParam encryptParam;
extern int KEYSIZE;
    //</block>
  
    //<block name="filter_JPEG">
#include "jpgcodec.h"
    //</block>
  
    //<block name="filter_GZIP">
#include "gzip.h"
    //</block>
  
    //<block name="filter_SHRINK">
#include "imgFilters/filters.h"
    //</block>
  
    //<block name="filter_GREY">
#include "imgFilters/filters.h"
    //</block>
  
}    


extern unsigned int FILTER;
typedef enum filter_type_ {GZIP=0, LZO, SHRINK, GREY, JPEG1, JPEG2, JPEG3, ENCRYPT} filter_type;
#define SET_FILTER(i) (FILTER &= 1<<(i))
#define FILTER_GET(flag, i) ((flag) & 1<<(i))


EncryptParam encryptParam;
int KEYSIZE = 192;//bits = 24 bytes

  

 Pipe::Pipe()
 : in (DataFlow()), out (DataFlow()), inC (CtrlFlow()), outC (CtrlFlow())
{
}
    

 Pipe::~Pipe()
{
}
    

DataFlow& Pipe::getInDataFlow(void)
{
  return in;
}
    

DataFlow& Pipe::getOutDataFlow(void)
{
  return out;
}
    

void Pipe::setInDataFlow(const INFOP& infop, const Data& data)
{
  in.setINFOP(infop);
  in.setPayload(data);
}
    

void Pipe::setOutDataFlow(const INFOP& infop, const Data& data)
{
  out.setINFOP(infop);
  out.setPayload(data);
}
    

void Pipe::inDataToOutData(unsigned int filterFlag)
{
  Data outData, inData;
  outData.buff = inData.buff = NULL;
  int out_len=0;

  in.getPayload(&inData);

  if ((filterFlag & 0x80000000) == 0 && (filterFlag != 0) ) {
    if (FILTER_GET(filterFlag, GZIP)) {

    //<block name="filter_GZIP">
      outData.SIZE=inData.SIZE + 50;
      outData.buff = new Type[outData.SIZE];

      qos_last = ACE_OS::gettimeofday();
      int status = gzip_compress(1, inData.buff, inData.SIZE, outData.buff, &out_len);
      qos_now = ACE_OS::gettimeofday();
      accum_qos_time += (qos_now.sec() - qos_last.sec())*1000000 + (qos_now.usec() - qos_last.usec());

      if (0>status) 
	printf(" [Pipe::inDataToOutData(): GZIP encoding error\n");

      outData.SIZE = out_len;

      SET_INFOP(type, in.infop, filterFlag);
      SET_INFOP(length, in.infop, out_len + sizeof(out.infop));
      SET_INFOP(src_id, in.infop, accum_qos_time);
      setOutDataFlow(in.infop, outData);
    //</block>
  
    }
    else if (FILTER_GET(filterFlag, LZO)) {

     }
     else if (FILTER_GET(filterFlag, ENCRYPT)) {

    //<block name="filter_ENCRYPT">
      if (DEBUG) printf(" [Pipe::inDataToOutData(): No compression but encryption  ...\n");
      outData.SIZE = inData.SIZE;
      outData.buff = new Type[outData.SIZE];
      memcpy(outData.buff, inData.buff, outData.SIZE);
    //</block>
  
    }
    else if ( FILTER_GET(filterFlag, JPEG1) || FILTER_GET(filterFlag, JPEG2)
	      || FILTER_GET(filterFlag, JPEG3) ) {

    //<block name="filter_JPEG">
      if (DEBUG) printf(" [Pipe::inDataToOutData(): Img filters  ...\n");
      out = in;
    //</block>
  
    }
    else if ( FILTER_GET(filterFlag, SHRINK) ) {

    //<block name="filter_SHRINK">
      if (DEBUG) printf(" [Pipe::inDataToOutData(): Img filters  ...\n");
      out = in;
    //</block>

    }
    else if ( FILTER_GET(filterFlag, GREY) ) {

    //<block name="filter_GREY">
      if (DEBUG) printf(" [Pipe::inDataToOutData(): Img filters  ...\n");
      out = in;
    //</block>

    }
  
    if ( FILTER_GET(filterFlag, ENCRYPT)) {

    //<block name="filter_ENCRYPT">
      if (DEBUG) printf(" [Pipe::inDataToOutData(): encryption, outData.SIZE: %d\n",outData.SIZE);
      int padding = 0; int cpy_size = 0;
      padding = outData.SIZE % encryptParam.keySize;
      
      if (padding != 0) {
	outData.SIZE = outData.SIZE + encryptParam.keySize - padding;
	cpy_size = outData.SIZE + padding -encryptParam.keySize;
      }
      else 
	cpy_size = outData.SIZE;

      Data another;
      another.SIZE = outData.SIZE;
      another.buff = new Type[another.SIZE];
      memcpy(another.buff, outData.buff, cpy_size);
      if (outData.buff) delete [] outData.buff, outData.buff = NULL;

      qos_last = ACE_OS::gettimeofday();
      int status = Encrypt((void *) &(encryptParam.cryptContext), another.buff, another.SIZE, &out_len);
      qos_now = ACE_OS::gettimeofday();
      accum_qos_time += (qos_now.sec() - qos_last.sec())*1000000 + (qos_now.usec() - qos_last.usec());
      
      if (0 != status) 
	printf(" [Pipe::inDataToOutData(): Encryption error\n");

      outData.SIZE = out_len + 2 ;//Add two bytes to store the length of the padding. if 0 means no padding.
      outData.buff = new Type[outData.SIZE];
      memcpy(outData.buff, another.buff, outData.SIZE -2);
      *(unsigned short*)(outData.buff + outData.SIZE-2) = padding;
      
      SET_INFOP(type, in.infop, filterFlag);
      SET_INFOP(length, in.infop, out_len + 2 + sizeof(out.infop));
      SET_INFOP(src_id, in.infop, accum_qos_time);
      setOutDataFlow(in.infop, outData);

      if (another.buff) delete [] another.buff, another.buff = NULL;
    //</block>

     }
    }
  else if ((filterFlag & 0x80000000) == 0x80000000 && (filterFlag != 0)) {
    //This is decryption, decompression or both
    //This is decryption
    if (FILTER_GET(filterFlag, ENCRYPT)) {

    //<block name="filter_ENCRYPT">
      int padding = *(unsigned short*)(inData.buff + inData.SIZE - 2);

      Data another;
      another.SIZE = inData.SIZE - 2;
      another.buff = new Type[another.SIZE];
      memcpy(another.buff, inData.buff, another.SIZE);
      
      if (inData.buff) delete [] inData.buff, inData.buff = NULL;
      
      qos_last = ACE_OS::gettimeofday();
      int status = Decrypt((void *) &(encryptParam.cryptContext), another.buff, another.SIZE, &out_len);
      if(0 != status)
	printf(" [Pipe::inDataToOutData(): Decryption error\n");	
      qos_now = ACE_OS::gettimeofday();
      accum_qos_time += (qos_now.sec() - qos_last.sec())*1000000 + (qos_now.usec() - qos_last.usec());
     
      if(padding > 0)
	out_len = out_len + padding - encryptParam.keySize;

      inData.SIZE = out_len;
      inData.buff = new Type[inData.SIZE];
      memcpy(inData.buff, another.buff, out_len);

      if (another.buff) delete [] another.buff, another.buff = NULL;
    //</block>

    }
    if (FILTER_GET(filterFlag, GZIP)) {

    //<block name="filter_GZIP">

      outData.SIZE=inData.SIZE*10;
      outData.buff = new Type[outData.SIZE];

      qos_last = ACE_OS::gettimeofday();
      int status = gzip_decompress(inData.buff, inData.SIZE, outData.buff, &out_len);
      
      if (0>status) 
	printf(" [Pipe::inDataToOutData(): GZIP decoding error\n");
      qos_now = ACE_OS::gettimeofday();
      accum_qos_time += (qos_now.sec() - qos_last.sec())*1000000 + (qos_now.usec() - qos_last.usec());

      outData.SIZE = out_len;

      SET_INFOP(length, in.infop, out_len);

      setOutDataFlow(in.infop, outData);
    //</block>

    }
    else if (FILTER_GET(filterFlag, LZO)) {

    }
    else if (FILTER_GET(filterFlag, ENCRYPT) )
      {

    //<block name="filter_ENCRYPT">
	setOutDataFlow(in.infop, inData);
    //</block>

      }
    else if ( FILTER_GET(filterFlag, JPEG1) || FILTER_GET(filterFlag, JPEG2)
	     || FILTER_GET(filterFlag, JPEG3) )
      {

    //<block name="filter_JPEG">
	setOutDataFlow(in.infop, inData);
    //</block>

      }
    else if ( FILTER_GET(filterFlag, SHRINK) )
      {

    //<block name="filter_SHRINK">
	setOutDataFlow(in.infop, inData);
    //</block>

      }
    else if ( FILTER_GET(filterFlag, GREY) ) 
      {

    //<block name="filter_GREY">
	setOutDataFlow(in.infop, inData);
    //</block>

      }
  }
  else if (filterFlag == 0 )
    {
    if (DEBUG) printf(" [Pipe::inDataToOutData(): NO filters  ...\n");
    out = in;
    }

  if (outData.buff) delete [] outData.buff, outData.buff = NULL;
  if (inData.buff) delete [] inData.buff, inData.buff = NULL;
}
    

int Pipe::importInDataFlow(char* inbuf, int inbuf_len)
{
  Data d; d.buff = NULL;
  INFOP infop;

  memcpy(&infop, inbuf, INFOP_HEADER_SIZE);
  d.SIZE = (inbuf_len - INFOP_HEADER_SIZE)/sizeof(Type);

  d.buff = new Type[d.SIZE];
  memcpy(d.buff, inbuf + INFOP_HEADER_SIZE, inbuf_len - INFOP_HEADER_SIZE);

  setInDataFlow(infop, d);

  if (d.buff) delete [] d.buff;
  d.buff = NULL;

  return 0;
}
    

int Pipe::exportOutDataFlow(char* outbuf, int outbuf_len)
{
  Data d; d.buff=NULL;

  out.getPayload(&d);
  INFOP infop = out.getHeader();

  if (outbuf_len < INFOP_HEADER_SIZE + d.SIZE) {
    printf(" Warning: Pipe::exportOutDataFlow(): buffer size not large engouth\n");    return -1;
  }

  int size =0 ;
  memcpy(outbuf, &infop, INFOP_HEADER_SIZE);
  size += INFOP_HEADER_SIZE;
  memcpy(outbuf + INFOP_HEADER_SIZE, d.buff, d.SIZE);
  size += d.SIZE;

  if (d.buff) delete [] d.buff;
  d.buff = NULL;

  return size;
}
    

  


//======================================================================================

  
  
CtrlFlow& Pipe::getInCtrlFlow(void)
{
  return inC;
}
    

CtrlFlow& Pipe::getOutCtrlFlow(void)
{
  return outC;
}
    

void Pipe::setInCtrlFlow(const INFOCP& infocp, const Data& data)
{
  inC.setINFOCP(infocp);
  inC.setPayload(data);
}
    

void Pipe::setOutCtrlFlow(const INFOCP& infocp, const Data& data)
{
  outC.setINFOCP(infocp);
  outC.setPayload(data);
}
    

void Pipe::inCtrlToOutCtrl(unsigned int filterFlag)
{
  outC = inC;
}
    

int Pipe::importInCtrlFlow(char* inbuf, int inbuf_len)
{
  Data d; d.buff = NULL;
  INFOCP infocp;

  memcpy(&infocp, inbuf, INFOCP_HEADER_SIZE);
  d.SIZE = (inbuf_len - INFOCP_HEADER_SIZE)/sizeof(Type);

  d.buff = new Type[d.SIZE];
  memcpy(d.buff, inbuf + INFOCP_HEADER_SIZE, inbuf_len - INFOCP_HEADER_SIZE);

  setInCtrlFlow(infocp, d);

  if (d.buff) delete [] d.buff;
  d.buff = NULL;

  return 0;
}
    

int Pipe::exportOutCtrlFlow(char* outbuf, int outbuf_len)
{
  Data d; d.buff=NULL;

  outC.getPayload(&d);
  INFOCP infocp = outC.getHeader();

  if (outbuf_len < INFOCP_HEADER_SIZE + d.SIZE) {
    printf(" Warning: Pipe::exportOutCtrlFlow(): buffer size not large engouth\n");    return -1;
  }

  int size =0 ;
  memcpy(outbuf, &infocp, INFOCP_HEADER_SIZE);
  size += INFOCP_HEADER_SIZE;
  memcpy(outbuf + INFOCP_HEADER_SIZE, d.buff, d.SIZE);
  size += d.SIZE;

  if (d.buff) delete [] d.buff;
  d.buff = NULL;

  return size;
}
    
