
  /* 
   * This file is generated by the Infopipe Stub Generator (ISG).
   * @ GaTech. 
   * Modify where necessarily.
   */

  //////////////////////////////////////
  // Receiver.cpp


#define NEW_DISPLAYER
  
  #include <ace/Get_Opt.h>
#include <math.h>
#include "Receiver.h"



#define DEBUG 0

#include "PPMP.h"
#include "ppmdecoder.h"
class PPMDecoder;

typedef unsigned char pixval;
#define IMAGE_SIZE  921600 /* 3*640*480 */
int MUS = 15360;
int MAXPIXELSIZE = 3;
int MAXLINESIZE = 640;
int PORTNO = 0;

PPM_frame_info pfi;
int curr_frame_nr = 0;

#include "Share_Syn.h"
char* shm, *shm_buf;
int semid;
union semun sunion;
int DeleteSemid = 0;
ACE_Shared_Memory_SV* shm_writer;

int WINDOW_SIZE = 64;
DataFlow df;
INFOP infop;
Data data;
ACE_Time_Value last, now;
int* window_delta_t;
int nr_pkt_received = 0;
int window_nr_pkt_received = 0;
int accum_pkt_size = 0;//in bytes
int window_accum_pkt_size = 0;
int accum_time = 0;//in micro sec
int window_accum_time =0;
int window_proc_time = 0;//recv side playback time accumulated
int accum_qos_time = 0;//qos processing time at the receiver side
int accum_qos_time_sender = 0;//this is the src_id field in the header of the sender msg
int accum_jitter = 0;//in micro sec
int window_accum_jitter = 0;
int accum_missing_pkt = 0;
int window_accum_missing_pkt = 0;
int pktnr_seqnr_diff = 0;//used to find missing packet

unsigned long last_sender;

extern "C" char* dejpgImage = NULL;
Type* global_buf;
int global_buf_length;

unsigned int  FILTER=0;//the filter flag
typedef enum filter_type_ {GZIP=0, LZO, SHRINK, GREY, JPEG1, JPEG2, JPEG3, ENCRYPT} filter_type;
#define SET_FILTER(i) (FILTER |= 1<<(i))
#define FILTER_GET(flag, i) ((flag) & 1<<(i))


  

extern "C" {
  
    //<block name="filter_ENCRYPT">
#include "encrypt.h"
extern EncryptParam encryptParam;
extern int KEYSIZE;
    //</block>
  
    //<block name="filter_JPEG">
#include "jpgcodec.h"
    //</block>
  
    //<block name="filter_GZIP">
#include "gzip.h"
    //</block>
  
    //<block name="filter_SHRINK">
#include "imgFilters/filters.h"
    //</block>
  
    //<block name="filter_GREY">
#include "imgFilters/filters.h"
    //</block>
  
}    


  
//Helper class
class Signal_Handler : public ACE_Event_Handler
{
public:
  Signal_Handler() : exit_requested(0) { }

  int handle_signal(int signum, siginfo_t*,ucontext_t*) {
    exit_requested = 1;

    if (shm_writer->remove () < 0)
      ACE_ERROR ((LM_ERROR,
                  "%p\n",
                  "remove"));
    return 0;
  }

  int exit_requested;
};

  


  
  
  
int ReceiverStreamEndPoint::get_callback(const char *flowname, TAO_AV_Callback *&callback)
{
  ACE_DECLARE_NEW_CORBA_ENV;

  callback = &this->callback;

  return 0;

}
    

 ReceiverCallback::ReceiverCallback(void)
{
}
    

int ReceiverCallback::receive_frame(ACE_Message_Block* frame, TAO_AV_frame_info* frame_info, const ACE_Addr &peer_address)
{
  while (0 != frame) {
    global_buf = (Type*)(frame->rd_ptr());
    global_buf_length = frame->length();

    frame = frame->cont();
  }

  return 0;
}
    



  //<block name="pipe_Receiver">

  
  
 Receiver::Receiver(void)
 : senderName("Sender"), receiverName("Receiver"), receiverMMDevice(0), Pipe()
{
}
    

 Receiver::~Receiver(void)
{
}
    

int Receiver::parseArgs(int argc, char** argv)
{
  if(argc < 1){
    ACE_DEBUG((LM_DEBUG, "Usage:\n\n"));
    ACE_DEBUG((LM_DEBUG, "   Receiver [-M MTU] [-P maxpixel] [-L maxlinesize] [-p portno]\n"));

    return -1;
  }

  ACE_Get_Opt opts (argc, argv, "M:P:L:p:");

  int c;
  while ((c= opts ()) != -1)
    {
      switch (c)
        {
        case 'M':
          MUS = ACE_OS::atoi (opts.optarg);
          break;
        case 'P':
          MAXPIXELSIZE = ACE_OS::atoi (opts.optarg);
          break;
        case 'L':
          MAXLINESIZE = ACE_OS::atoi (opts.optarg);
          break;
        case 'p':
          PORTNO = ACE_OS::atoi (opts.optarg);
          break;
        default:
          ACE_DEBUG ((LM_DEBUG, "Unknown Option\n"));
        }
    }
  return 0;
}
  

int Receiver::initPipe()
{
  return 0;
}
  

int Receiver::init(int argc, char** argv, CORBA::Environment& ACE_TRY_ENV)
{
  int result;

  result = receiverEndpointStrategy.init(TAO_AV_CORE::instance()->orb(),
                                         TAO_AV_CORE::instance()->poa());
  if (0!=result) return result;

  result = parseArgs (argc, argv);
  if (0!= result) return result;

  if (NULL== (window_delta_t = (int*)malloc(sizeof(int)*WINDOW_SIZE-1)))
    ACE_ERROR_RETURN((LM_ERROR,
                      " Cannot create array\n"),-1);

  for (int i=0;i<WINDOW_SIZE-1;i++)
    window_delta_t[i]=0;

  
    //<block name="filter_ENCRYPT">
  if (1) {
    encryptParam.keySize = KEYSIZE/8;
    encryptParam.ivSize = encryptParam.keySize;
    if (NULL == (encryptParam.key = (char *) malloc(encryptParam.keySize * sizeof(char))) ||
        NULL == (encryptParam.iv = (char *) malloc(encryptParam.ivSize * sizeof(char))))
      cout<<" Encryption key no mem\n", exit(-1);

    char algo[30];
    sprintf(algo, "%s-%d", "rijndael", encryptParam.keySize*8); //KEYSIZE in bytes.
    strncpy(encryptParam.key, "abcdefghijklmnopqrstuvwxyz123456", encryptParam.keySize);
    strncpy(encryptParam.iv, "abcdefghijklmnopqrstuvwxyz123456", encryptParam.keySize);

    if ( MCRYPT_FAILED == (encryptParam.cryptContext = CreateContext(algo, "cbc")))
      cout<<" Encryption error 1\n", exit(-1);
    if (0 > SetParams((void *) &(encryptParam.cryptContext), encryptParam.key,
encryptParam.iv))
      cout<<" Encryption error 2\n", exit(-1);
  }
    //</block>
  
    //<block name="filter_JPEG">
  if (1) {
    int ret = init_jpeg_compress();
    ret = init_jpeg_decompress();
    if (ret < 0)
      cout<<" Jpeg init error\n", exit(-1);
  }
    //</block>
  
  if (1) {
    if (NULL==(dejpgImage = (char*)malloc(sizeof(char)*260000)))
      cout<<" mem alloc error\n";
  }
  

  result = ctrlManager.init(TAO_AV_CORE::instance()->orb());
  if (0!=result) return result;

  ACE_NEW_RETURN (receiverMMDevice,
                  TAO_MMDevice (&receiverEndpointStrategy),
                  -1);

  AVStreams::MMDevice_var mmdevice = receiverMMDevice->_this(ACE_ENV_SINGLE_ARG_PARAMETER);
  ACE_CHECK_RETURN (-1);

  ctrlManager.bindToSender (senderName,
                            receiverName,
                            mmdevice.in(),
                            ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  AVStreams::streamQoS theQos;
  theQos.length(0);

  ctrlManager.connectToSender (theQos,
                               0,
                               ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  //Add additional code below

  return 0;
}
    

CtrlManager & Receiver::getCtrlManager(void)
{ 
  return ctrlManager;
}
    

const char* Receiver::getName(void)
{ 
  return receiverName.c_str();
}
    



    //</block>

  
  
int main(int argc, char **argv)
{
  ACE_DECLARE_NEW_CORBA_ENV;

  ACE_TRY
    {
      CORBA::ORB_var orb = CORBA::ORB_init (argc,
                                            argv,
                                            0,
                                            ACE_TRY_ENV);
      ACE_TRY_CHECK;

      CORBA::Object_var obj
        = orb->resolve_initial_references ("RootPOA"
                                           ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;

      PortableServer::POA_var root_poa
        = PortableServer::POA::_narrow (obj.in ()
                                        ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;

      PortableServer::POAManager_var mgr
        = root_poa->the_POAManager (ACE_ENV_SINGLE_ARG_PARAMETER);
      ACE_TRY_CHECK;

      mgr->activate (ACE_ENV_SINGLE_ARG_PARAMETER);
      ACE_TRY_CHECK;

      TAO_AV_CORE::instance ()->init (orb.in (),
                                      root_poa.in ()
                                      ACE_ENV_ARG_PARAMETER);
      ACE_TRY_CHECK;

      // Initialize the Client.
      int result = 0;

      Receiver* receiver = RECEIVER::instance();

      shm_writer = new ACE_Shared_Memory_SV (SHM_KEY_R, SHMSZ_R,
                  ACE_Shared_Memory_SV::ACE_CREATE);

      shm = (char *) shm_writer->malloc ();
      if (shm == 0)
        ACE_ERROR_RETURN ((LM_ERROR,
                       "%p\n\t(%P|%t) Cannot create shared memory segment.\n"
                           ,argv[0]), -1);
      ACE_DEBUG ((LM_INFO,
                  "(%P|%t) Shared Memory is at 0x%x\n",
                  shm ));

      //Create semaphore
      if (-1==(semid = semget(IPC_PRIVATE, 3, SHM_R|SHM_W))) {
        perror("  semaphore error:\n");
        ACE_ERROR_RETURN((LM_ERROR,
                          "(%P|%t) Cannot create semaphore\n"),-1);

      }
      else
        ACE_DEBUG((LM_DEBUG,
                   "(%P|%t) Create semaphore with id: %d\n", semid));

      DeleteSemid = semid;
      atexit(&mydelete);
      signal(SIGINT, &sigdelete);
      sunion.val = 1;
      safesemctl(semid, SN_WRITE, SETVAL, sunion);
      safesemctl(semid, SN_LOCK, SETVAL, sunion);
      sunion.val = 0;
      safesemctl(semid, SN_READ, SETVAL, sunion);
      //store the semid to shm
      *(int*)shm = semid;
      shm_buf = shm+sizeof(int);

      result = receiver->init (argc,
                               argv,
                               ACE_TRY_ENV);
      ACE_TRY_CHECK;

      if (result < 0)
        ACE_ERROR_RETURN ((LM_ERROR,
                           "Receiver::main(): init failed\n"), -1);

      Signal_Handler signal_handler;

      data.SIZE=0; data.buff=NULL;
      global_buf = NULL;

      int pkt_seq_nr = 0; int infop_seq_nr = 0; int infop_seq_base = 0;
      bool start_bookkeeping = false;

      bool jpgFrame = false;

      PPMDecoder decoder(MUS, MAXPIXELSIZE, MAXLINESIZE);

      unsigned int last_PPM_frame_num = 0;

      while (!signal_handler.exit_requested) {
        orb->perform_work(ACE_ENV_SINGLE_ARG_PARAMETER);

        if (!global_buf)
          continue;

        now = ACE_OS::gettimeofday();
        nr_pkt_received ++, window_nr_pkt_received++;

        jpgFrame = false;

        RECEIVER::instance() ->
          importInDataFlow((char*)global_buf, global_buf_length);

        df = RECEIVER::instance() -> getInDataFlow();

        infop = df.getHeader();
/*
        cout<<" infop: size = "<<sizeof(infop)<<endl;
        cout<<" infop: ver("<<infop.ver<<"), pad("<<infop.pad
            <<"), extension("<<infop.extension<<"), marker("<<infop.marker
            <<"), type("<<infop.type<<"), seq("<<infop.seq
            <<"), time("<<infop.time<<"), length("<<infop.length
            <<"), src_id("<<infop.src_id<<")"<<endl;
*/
        {///////////////////////////////////////////////////////////////////
          /////
          if (infop_seq_nr - infop.seq > 32768) infop_seq_base += 65536;
          pkt_seq_nr = infop_seq_base + infop.seq;
          infop_seq_nr = infop.seq;

          if (pkt_seq_nr - nr_pkt_received != pktnr_seqnr_diff) {
            if (pkt_seq_nr - nr_pkt_received < pktnr_seqnr_diff) {
             cout<<" packet seq # out of order panic !!!!!!!!!!!"<<endl;
            }
            else {
              accum_missing_pkt += pkt_seq_nr - nr_pkt_received -
        	    pktnr_seqnr_diff;     
	      window_accum_missing_pkt += pkt_seq_nr - nr_pkt_received - pktnr_seqnr_diff;
              pktnr_seqnr_diff = pkt_seq_nr - nr_pkt_received;
            }
          }
          if (1 >= nr_pkt_received ) {
            //no-op
          }
          else {
            int tmp_time = (now.sec() - last.sec())* 1000000 + (now.usec() - last.usec());
            if (tmp_time<0) tmp_time = -tmp_time;
            accum_time += tmp_time;

            if (1 < window_nr_pkt_received) {
              window_accum_time += tmp_time;
              window_delta_t[window_nr_pkt_received -2] = tmp_time;
            }
          }

          last = now;

          if (!start_bookkeeping) {
            pktnr_seqnr_diff = infop.seq - nr_pkt_received;
            start_bookkeeping = true;
            cout<<" init pktnr_seqnr_diff: "<<pktnr_seqnr_diff<<endl;
          }

          accum_pkt_size += infop.length, window_accum_pkt_size += infop.length;

          if (window_nr_pkt_received >= WINDOW_SIZE )
            {
              //Calculating the Recv Side jitter first.
              double sum = 0; double mean = 0;
              for (int i=0;i<window_nr_pkt_received-1;i++)
                sum += window_delta_t[i];

              mean = (double)sum / (window_nr_pkt_received-1);
              sum = 0;
              for (int i=0;i<window_nr_pkt_received-1;i++)
                sum += (window_delta_t[i] - mean)*(window_delta_t[i] - mean);

              window_accum_jitter = sqrt(sum/(window_nr_pkt_received-2));
            }

          last_sender = infop.time;
          ////
        }/////////////////////////////////////////////////////////////////


        unsigned int filterFlag = 0;
        filterFlag |= infop.type;
        if (filterFlag != 0)
          filterFlag |= 0x80000000; //Means it's decoding instead of encoding or ...

        RECEIVER::instance() -> inDataToOutData (filterFlag);

        df = RECEIVER::instance() -> getOutDataFlow();
        df.getPayload(&data);

  
        //if jpeg.
        //Assume the whole frame has been compressed into the come-in jpeg.
        if (FILTER_GET(filterFlag, JPEG1)) {
          int ret0 = init_jpeg_decompress();
          if (ret0 < 0)
            cout<<" Jpeg init error\n", exit(-1);

          if (infop.marker == 0xF) {
            //it's a PPM_info struct, doesn't need to be dejpeg'ed.
            //skip the first 4 bytes
            char* buf = data.buff + PPMP_FRAME_NO_OFFSET;
            //retrieve the new frame #
            memcpy(&curr_frame_nr, buf, sizeof(unsigned long));
            //Now the struct PPM_frame_info
            buf += sizeof(unsigned long);
            memcpy(&pfi, buf, sizeof(PPM_frame_info));

            if (DEBUG) printf(" [Receiver::main() 1: curr_frame_nr=%d, pfi: tag=%d,ppm1=%c,ppm2=%c,size=%d,width=%d,height=%d,*buff=%x\n",curr_frame_nr,pfi.tag,pfi.ppm1,pfi.ppm2,pfi.size,pfi.width,pfi.height,pfi.buff);

            decoder.decode_jpg (data.buff, data.SIZE);
          }
          else if (infop.marker == 0) {
            //Be careful there're 8 bytes header in front of each jpg'ed frame.
            //char header[PPMP_FRAME_INFO_OFFSET];
            char* tmp_buf = NULL;
            if (!(tmp_buf = (char*)malloc((pfi.size + PPMP_FRAME_INFO_OFFSET)
                                          * sizeof(char)))) {
              printf(" [Receiver::main(): 0ut of mem\n");
              exit(-1);
            }
            int ret = jpeg_to_ppm (data.buff + PPMP_FRAME_INFO_OFFSET,
                                   data.SIZE - PPMP_FRAME_INFO_OFFSET,
                                   pfi.height,//infop.src_id,
                                   pfi.width,
                                   255,
                                   dejpgImage);

            if (0>ret) cout<<" Jpeg decompression error"<<endl;

            memcpy (tmp_buf, data.buff, PPMP_FRAME_INFO_OFFSET);
            memcpy (tmp_buf+PPMP_FRAME_INFO_OFFSET, dejpgImage, pfi.size);
            decoder.decode_jpg (tmp_buf, pfi.size + PPMP_FRAME_INFO_OFFSET);
            if (tmp_buf) free(tmp_buf);

          }/* if (infop.marker) */

          jpgFrame = true;
          int r1 = end_jpeg_decompress();
          if (r1 < 0) cout<<" end_jpeg_decompress() error\n";

        } /* IF JPEG1 */
  

        if (!jpgFrame) {

          decoder.decode_ppm (data.buff, data.SIZE);

        }

        if (DEBUG)
          ACE_DEBUG((LM_DEBUG," [Receiver::main(): nr_packet_rec: %d\n", nr_pkt_received));


        if (window_nr_pkt_received >= WINDOW_SIZE ) {
          *(unsigned int*)shm_buf = 0x2;
          *(float*)(shm_buf + 4) = (float)((double)window_accum_pkt_size*8/window_accum_time
                                             *1.0485);
          *(int*)(shm_buf + 8) = (int)window_accum_jitter;
          *(int*)(shm_buf + 12) = (int)((double)window_nr_pkt_received*1000000/window_accum_time);
          *(float*)(shm_buf + 16) = (float)
                                   ((double)window_accum_missing_pkt/window_nr_pkt_received);
          *(int*)(shm_buf + 20) = pkt_seq_nr;
	  *(float*)(shm_buf + 24) = (decoder.getCurrPPMFrameNum() - last_PPM_frame_num)
	                            *1e6/window_accum_time;	

	  last_PPM_frame_num = decoder.getCurrPPMFrameNum();

          if (DEBUG) {
            ACE_DEBUG((LM_DEBUG,
                       "(%P|%t) main(): wwwwwwwwwwwwwwwwwww %dth packet last!\n\n",                       nr_pkt_received));
          }
        }

        //Prepare for the next window if necessary
        if (window_nr_pkt_received >= WINDOW_SIZE) {
          window_accum_pkt_size = 0, window_nr_pkt_received = 0,
            window_accum_time = 0, window_accum_jitter = 0;
          window_accum_missing_pkt = 0;
          window_proc_time = 0;
          for (int i=0;i<WINDOW_SIZE-1;i++)
            window_delta_t[i]=0;
        }

        if (DEBUG) {
        cout<<" infop: size = "<<sizeof(infop)<<endl;
        cout<<" infop: ver("<<infop.ver<<"), pad("<<infop.pad
            <<"), extension("<<infop.extension<<"), marker("<<infop.marker
            <<"), type("<<infop.type<<"), seq("<<infop.seq
            <<"), time("<<infop.time<<"), length("<<infop.length
            <<"), src_id("<<infop.src_id<<")"<<endl;
        cout<<" data: ["<<data.buff[0]<<":"<<data.buff[1]<<":"
            <<data.buff[2]<<":"<<data.buff[3]<<
          "]"<<", size: "<<data.SIZE<<endl;
        cout<<"=============================================="<<endl;
        }

      }

      //////////////////////////////////////////////////////////////////////
      // If the ctrl-C is pressed, then update the shm for the last ctrl msg
      {
        *(unsigned int*)shm_buf = 0x4;
        *(float*)(shm_buf + 4) = (float)((double)accum_pkt_size*8/accum_time*1.0485);
        *(int*)(shm_buf + 8) = (int)((double)nr_pkt_received*1000000/accum_time);
        *(float*)(shm_buf + 12) = (float)((double)accum_missing_pkt/nr_pkt_received);
        if (DEBUG) {
          ACE_DEBUG((LM_DEBUG,"(%P|%t) main(): FFFFFFFFFFFFFFFFFFFFF %dth packet returned!\n\n",
                     nr_pkt_received));
        }
      }

      if (window_delta_t) free(window_delta_t);
      //
      //////////////////////////////////////////////////////////////////////

      ACE_OS::sleep(3);
      RECEIVER::instance ()->getCtrlManager().destroy (ACE_TRY_ENV);
      ACE_TRY_CHECK;

      ACE_OS::sleep (1);

      if (shm_writer->remove () < 0)
        ACE_ERROR ((LM_ERROR,
                    "%p\n",
                    "remove"));

      orb->destroy (ACE_ENV_SINGLE_ARG_PARAMETER);
      ACE_TRY_CHECK;
    }
  ACE_CATCHANY
    {
      ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,"Receiver::main(): Exception !\n");
      if (shm_writer->remove () < 0)
        ACE_ERROR ((LM_ERROR,
                    "%p\n",
                    "remove"));
      return -1;
    }
  ACE_ENDTRY;
  ACE_CHECK_RETURN (-1);

  return 0;
}
    

  

  
#if defined (ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION)
template class ACE_Singleton <Receiver,ACE_Null_Mutex>;
template class TAO_AV_Endpoint_Reactive_Strategy  <ReceiverStreamEndPoint,   TAO_VDev, AV_Null_MediaCtrl>;
template class TAO_AV_Endpoint_Reactive_Strategy_B<ReceiverStreamEndPoint, TAO_VDev, AV_Null_MediaCtrl>;
#elif defined (ACE_HAS_TEMPLATE_INSTANTIATION_PRAGMA)
#pragma instantiate ACE_Singleton <Receiver,ACE_Null_Mutex>
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy  <ReceiverStreamEndPoint,   TAO_VDev, AV_Null_MediaCtrl>
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy_B<ReceiverStreamEndPoint, TAO_VDev, AV_Null_MediaCtrl>
#endif /* ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION */


    