
#include "Share_Syn.h"


int safesemctl(int semid, int semnum, int cmd, union semun arg) {
  int retval;
  retval = semctl(semid, semnum, cmd, arg);
  if (retval == -1) 
    printf("Error in semctl()\n"), mydelete();

  return retval;
}

void locksem(int semid, int semnum) {
  struct sembuf sb;

  sb.sem_num = semnum;
  sb.sem_op = -1;
  sb.sem_flg = SEM_UNDO;

  safesemop(semid, &sb, 1);
}

void unlocksem(int semid, int semnum) {
  struct sembuf sb;

  sb.sem_num = semnum;
  sb.sem_op = 1;
  sb.sem_flg = SEM_UNDO;

  safesemop(semid, &sb, 1);
}


void waitzero(int semid, int semnum) {
  struct sembuf sb;

  sb.sem_num = semnum;
  sb.sem_op = 0;
  sb.sem_flg = 0;        
 
  safesemop(semid, &sb, 1);
}

int safesemop(int semid, struct sembuf *sops, unsigned nsops) {
  int retval;

  retval = semop(semid, sops, nsops);
  if (retval == -1) {
    //printf( "semid %d (%d operations) failed",
    //          semid, nsops);
  }
  return retval;
}

void mydelete(void) {
  printf("\nExiting; deleting semaphore %d.\n", DeleteSemid);
  if (semctl(DeleteSemid, 0, IPC_RMID, 0) == -1) {
    printf("Error releasing semaphore.\n");
  }
}

void sigdelete(int signum) {
  /* Calling exit will conveniently trigger the normal
     delete item. */
  exit(0);
}

