/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <unistd.h>

#include "interface.h"
#include "support.h"
#include "cfg_info_parse.h"

typedef enum filter_type_ {GZIP=0, LZO, SHRINK, GREY, JPEG1, JPEG2, JPEG3, ENCRYPT}
filter_type;
#define SET_FILTER(i) (FILTER |= 1<<(i))

extern unsigned int FILTER;

//CORBA object and other stuff...
extern int init_ControlCenterC(int argc, char* argv[]);

void init_rc();
gint open_file_fd (char* path, int flags);
void dump_ALL_PROFILE();

struct profile {
  char* name;
  GList* filters;
};

GList* ALL_PROFILE = NULL;

int
main (int argc, char *argv[])
{
  GtkWidget *window_main;

  //TAO stuff....
  init_ControlCenterC(argc, argv);

  init_rc();

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  window_main = create_window_main ();
  gtk_widget_show (window_main);

  gtk_main ();
  
  return 0;
}




void init_rc() {
  int i;
  gint file;
  GScanner* gs;
  gchar curr_profile[30];
  struct profile* pf;
  
  if ((file = open_file_fd("./profile.conf", O_RDONLY)) < 0 ) {
    printf(" [init_rc(): file %s open error!\n", "./profile.conf");
    exit(-1);
  }

  gs = g_scanner_new(&gsconfig);
  g_scanner_input_file (gs, file);
  parse_conf_file (gs);
  g_scanner_destroy (gs);

  close(file);
  dump_ALL_PROFILE();

  if ((file = open_file_fd("./PROFILE", O_RDONLY)) < 0 ) {
    printf(" [init_rc(): file %s open error!\n", "./profile.conf");
    exit(-1);
  }
  
  i = read(file, curr_profile, 29);
  curr_profile[i]='\0';
  printf(" [init_rc(): curr_profile: >%s<\n",curr_profile);

  for (i=0; i< g_list_length(ALL_PROFILE); i++) {
    pf = (struct profile*)g_list_nth_data(ALL_PROFILE, i);
    if (NULL != pf) {
      if ( 0 == g_ascii_strcasecmp(pf->name, curr_profile) )
	  break;
    }
  }

  for (i=0; i< g_list_length(pf->filters); i++) {
    gchar* f = (gchar*)g_list_nth_data(pf->filters, i);
    if (0 == g_ascii_strcasecmp(f, "SHRINK"))
      SET_FILTER(SHRINK);
    if (0 == g_ascii_strcasecmp(f, "GZIP"))
      SET_FILTER(GZIP);
    if (0 == g_ascii_strcasecmp(f, "GREY"))
      SET_FILTER(GREY);
    if (0 == g_ascii_strcasecmp(f, "JPEG"))
      SET_FILTER(JPEG1);
    if (0 == g_ascii_strcasecmp(f, "ENCRYPT"))
      SET_FILTER(ENCRYPT);
  }
  
  printf (" [init_rc(): FILTER(%x)\n", FILTER);
}


gint open_file_fd (char* path, int flags)
{
  guint file;
  if ( (file=open(path, flags )) == -1) {
    printf(" [open_file_fd(): Error reading file %s\n",path);
    return -1;
  }

  return file;
}

void dump_ALL_PROFILE()
{
  int i,j;
  struct profile* di;

  //assign the first demo name to the default demo name
  if ( NULL != ALL_PROFILE ) {
    for (i=0; i<g_list_length(ALL_PROFILE); i++) {
      di = (struct profile*)g_list_nth_data(ALL_PROFILE, i);
      if (NULL != di) {
	printf(" \n\n[dump_ALL_PROFILE(): ");
	
	if (NULL != di->name) {
	  printf(" \nprofile name: %s", di->name);
	}
	if (NULL != di->filters) {
	  for (j = 0; j<g_list_length(di->filters); j++) {
	    printf("\n              ");
	    printf("%s",(char*)g_list_nth_data(di->filters,j));
	  }
	}
      else
        printf(" filters list has no element!\n");
      }
    }
  }
  else {
    printf(" [init_rc(): GList ALL_PROFILE empty or default not found!");
    exit(-1);
  }
  printf("\n");
}
