//
//$Id: filters.h,v 1.1.1.1 2003/06/11 19:05:36 wyan Exp $
//
//File: filters.h
//      The filters include shrink, grey, and others 
//      The input images should be in raw pixel format.
//      @see ecl filters in the Gatech-UAV demo

#ifndef _FILTERS_H
#define _FILTERS_H

//The characteristics of each PPM frame.
//This infomation is needed both at the PPM frame

//      The caller responsible for allocating/deallocating
//        the mem for output image. (field char* buff).

#if defined ( STRUCT_PPM_frame_info )

#else

typedef struct {
  int tag;          //Reserved
  char ppm1;        //'P'
  char ppm2;        //'1'-'6'
  int size;         //width*height*pixel_size_in_bytes
  int width;
  int height;
  char* buff;       
} PPM_frame_info, *PPM_frame_info_ptr;

#define STRUCT_PPM_frame_info

#endif

int shrinkFilter(const PPM_frame_info_ptr inImage, 
		 PPM_frame_info_ptr outImage);

int greyFilter(const PPM_frame_info_ptr inImage,
	       PPM_frame_info_ptr outImage);


#endif



