
#include "PPMP.h"
#include "ppmudpreader.h"


//For callbacks on TAO AVStreams' Sender class
#include "Sender.h"
extern int AV_MAX_BUFSIZ;

//base time value. Assume the sender and receiver clock diffs at most 1000 sec.
static unsigned int base = 0;


extern "C" {
#include "jpgcodec.h"
}
FILE* outfile = NULL;
static int rcvr_bytes = 0;


#define DEBUG 0


PPM_UDP_Reader::PPM_UDP_Reader(int mus, int pixelsize, int maxpixelperline
			       /*,
				 PPM_frame_info& ppmfi*/)
  :PPMP_Sender(mus,pixelsize,maxpixelperline/*,ppmfi*/)
{
  //sprintf(hostname,"%s",host);
  //sprintf(receiver_hostname,"%s",receiver_host);

  //portno = receiver_port;

  //h = gethostbyname(receiver_hostname);
  //if(h==NULL) {
  //printf(" [PPM_UDP_Reader::Cstr(): unknown host '%s' \n", receiver_host);
  //exit(1);
  //}

  //receiver.sin_family = h->h_addrtype;
  //memcpy((char *) &receiver.sin_addr.s_addr, 
  //       h->h_addr_list[0], h->h_length);
  //receiver.sin_port = htons(portno);

  //sd = connect_udp(hostname,0);
  //if (sd<0) {
  //  fprintf(stderr, "[PPM_UDP_Reader::Cstr(): can't create socket\n");
  //  exit(-1);
  //}
}

PPM_UDP_Reader::~PPM_UDP_Reader() {
  //close(sd);
}


void PPM_UDP_Reader::setPPMFrameInfo (int mus, PPM_frame_info& ppmfi)
{
  pfi = ppmfi;

  bpp = 8*pfi.size/pfi.height/pfi.width;

  max_buf_size = (mus + PPMP_FRAME_INFO_OFFSET + sizeof(unsigned long)
		  + sizeof(PPM_frame_info));

  //lines_send_per_time = (int)(((double)mus)/((double)pfi.width*pixelsize) 
  //		      + .9999); //.01% = impossible
  lines_send_per_time = (int)(((double)mus)/((double)pfi.size/pfi.height)
			      + .9999);


  //Be careful if size/height modulo mus is not zero
  max_buf_size = max_buf_size < lines_send_per_time*pfi.width*3 ?
                 lines_send_per_time*pfi.width*3 + PPMP_FRAME_INFO_OFFSET +
                 sizeof(unsigned long) + sizeof(PPM_frame_info) 
                 :
                 max_buf_size;

  num_times =(int)(((double)pfi.height/(double)lines_send_per_time)+.9999);
}


static unsigned int pkt_seq_nr = 0;

int PPM_UDP_Reader::send_fragment(const char *frag_buf,
				  const size_t len, 
				  const int src_id,
				  const int seq,
				  const unsigned int filter_flag,
				  const unsigned short mark) 
{
  char buf[AV_MAX_BUFSIZ];

  //int sum = 0;
  int result =0;

  DataFlow df;
  INFOP infop;
  Data data;  data.SIZE=0; data.buff=NULL;

  ACE_Time_Value now = ACE_OS::gettimeofday();

  if (0 == base) {
    //Get called only once.
    ACE_Time_Value t = ACE_OS::gettimeofday();
    unsigned int tmp = t.sec();
    base = tmp - tmp%1000;
  }


  ACE_TRY
    {
      //The first pkt # is 1.
      pkt_seq_nr ++;

      //Init infop
      SET_INFOP(ver, infop, 1);
      SET_INFOP(pad, infop, 0);
      SET_INFOP(extension, infop, 1);
      SET_INFOP(marker, infop, mark);
      SET_INFOP(type, infop, filter_flag);
      SET_INFOP(seq, infop, pkt_seq_nr/*seq*/);
      SET_INFOP(time, infop, (now.sec() - base)*1000000 + now.usec());
      SET_INFOP(length, infop, sizeof(infop)+len );
      SET_INFOP(src_id, infop, src_id);
      //SET_INFOP(src_id, infop, lines_send_curr);//Borrow this field currently.

      data.SIZE = len;
      data.buff = new char[data.SIZE];
	
      memcpy(data.buff, frag_buf, data.SIZE); 

      if (DEBUG)
	printf("  data.buff(%p), frag_buf(%p), data.SIZE: %d, AV_MAX_BUFSIZ: %d\n",data.buff, frag_buf,data.SIZE,
	     AV_MAX_BUFSIZ);
      /*
      printf("[2] %x:%x:%x:%x - %x\n", data.buff[PPMP_FRAME_INFO_OFFSET],
	     data.buff[PPMP_FRAME_INFO_OFFSET +1], data.buff[PPMP_FRAME_INFO_OFFSET+2],
	     data.buff[PPMP_FRAME_INFO_OFFSET +3], data.buff[data.SIZE-1]);
      */

      /*
      if (0xF == mark) {
	if (outfile!=NULL) fclose(outfile);
	
	if (NULL==(outfile = fopen("img.ppm", "w"))) 
	  cout<<" File open error\n";
	
	char header[15];
	sprintf(header, "%c%c\n%d %d\n%d\n", 'P', '6', 320, 240 ,255);
	fwrite(header, sizeof(header),1, outfile);
      }
      else if (0 == mark) {
	char* dejpgImage_1 = (char*)malloc(sizeof(char)*260000);

	printf("              lines_send_curr: %d, ret_size: %d\n",infop.src_id,
	       data.SIZE-PPMP_FRAME_INFO_OFFSET);
	       

	int ret = jpeg_to_ppm (data.buff + PPMP_FRAME_INFO_OFFSET,
			       len - PPMP_FRAME_INFO_OFFSET,
			       infop.src_id,
			       320,
			       255,
			       dejpgImage_1);
	cout<<" after jpeg_to_ppm()\n";
	
	fwrite(dejpgImage_1, infop.src_id*320*3, 1, outfile);
	rcvr_bytes += infop.src_id*320*3;
	
	if (rcvr_bytes % (320*240*3) == 0) {
	  cout<<" One PPM accumulated !!!!!!!!!!!!!!!"<<endl;
	  rcvr_bytes = 0;
	  fclose(outfile);
	  outfile = NULL;
	}

	if (dejpgImage_1) free(dejpgImage_1);
      }
      */

      SENDER::instance()->setInDataFlow(infop, data);
      SENDER::instance()->inDataToOutData (filter_flag);
      int size = SENDER::instance()->exportOutDataFlow(buf, AV_MAX_BUFSIZ);

      if (DEBUG) {
	cout<<" [PPM_UDP_Reader::send_fragment(): Frame #"<<seq<<"\n";
	cout<<" infop: size = "<<sizeof(infop)<<", filter="<<filter_flag<<endl;
        cout<<" infop: ver("<<infop.ver<<"), pad("<<infop.pad
            <<"), extension("<<infop.extension<<"), marker("<<infop.marker
            <<"), type("<<infop.type<<"), seq("<<infop.seq
            <<"), time("<<infop.time<<"), length("<<infop.length
            <<"), src_id("<<infop.src_id<<")"<<endl;
	cout<<"   frag_size:"<<len<<", buf_size:"<<size<<", data.SIZE:"<<data.SIZE<<endl;
	cout<<endl;
      }

      /*      
      if (0xF == mark) {
	if (outfile!=NULL) fclose(outfile);
	
	if (NULL==(outfile = fopen("img.ppm", "w"))) 
	  cout<<" File open error\n";
	
	char header[15];
	sprintf(header, "%c%c\n%d %d\n%d\n", 'P', '6', 320, 240 ,255);
	fwrite(header, sizeof(header),1, outfile);
      }
      else if (0 == mark) {
	char* dejpgImage = (char*)malloc(sizeof(char)*260000);
	
	int ret = jpeg_to_ppm (buf + PPMP_FRAME_INFO_OFFSET + INFOP_HEADER_SIZE,
			       size - PPMP_FRAME_INFO_OFFSET - INFOP_HEADER_SIZE,
			       240,//infop.src_id,
			       320,
			       255,
			       dejpgImage);
	fwrite(dejpgImage, 240*320*3, 1, outfile);
	rcvr_bytes += 240*320*3;
	
	if (rcvr_bytes % (320*240*3) == 0) {
	  cout<<" One PPM accumulated !!!!!!!!!!!!!!!"<<endl;
	  rcvr_bytes = 0;
	  fclose(outfile);
	  outfile = NULL;
	}

	if (dejpgImage) free(dejpgImage);
      }
      */


      CtrlManager::ProtocolObjects& pObjects = 
          SENDER::instance()->getCtrlManager().getProtocolObjects();

      int j=0;
      for (CtrlManager::ProtocolObjects::iterator iterator =
	     pObjects.begin();
	   iterator != pObjects.end();
	   ++iterator)
	{
	  j++;
	  
	  result = (*iterator).int_id_->send_frame(buf, size);
	  
	  if (0>result)
	    ACE_ERROR_RETURN ((LM_ERROR, "send_fragment() failed!\n"), -1);
	  else 
	    if (DEBUG)
	      ACE_DEBUG((LM_DEBUG, "         send_fragment(): %d bytes sent =====>>>>>\n\n\n", size));
	}

      if (data.buff) delete [] data.buff, data.buff = NULL;
    }
  ACE_CATCHANY 
    {
      ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,
                           " send_fragment(): exception\n");
      return -1;
    }
  ACE_ENDTRY;
  
  return len;
}
