<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="xml"/>

<!-- ================================================================= -->
<!-- $Id: SUAV.xsl,v 1.1.1.1 2003/06/11 19:05:41 wyan Exp $                                                              -->
<!-- Wenchang                                                          -->
<!-- ================================================================= -->
<!-- This stylesheet is specifically designed for ISG as the TAO       -->
<!-- AVStream abstract machine (binding). In addition the BBN QuO may  -->
<!-- also be created as needed.                                        -->
<!-- ================================================================= -->



<!-- The general templates and defs -->
<!-- The TAO/AVStream -->


<xsl:include href="sender.xsl"/>
<xsl:include href="senderMakefile.xsl"/>
<xsl:include href="senderNode000.xsl"/>
<xsl:include href="senderdatatypes.xsl"/>
<xsl:include href="senderimgfilters.xsl"/>
<xsl:include href="senderlocalvars.xsl"/>

<!-- Identify the components in an application which use TAO AVStream -->
<!-- The true values will be known later -->


<xsl:template match="/">
<files>

<!-- The sender.c file -->
  <xsl:call-template name="Sender">
    <xsl:with-param name="filters">
        <xsl:for-each select="/xip/composedPipe/connections/connection/filters/filter">
           <xsl:variable name="found_filter">      
              <xsl:value-of select="attribute::name"/>
              </xsl:variable>
           <xsl:value-of select="concat('{', $found_filter, '}')"/>
        </xsl:for-each>
    </xsl:with-param>
  </xsl:call-template>

<!-- Makefile, requires Filters -->
	<xsl:call-template name="Sender_Makefile">
    <xsl:with-param name="filters">
        <xsl:for-each select="/xip/composedPipe/connections/connection/filters/filter">
           <xsl:variable name="found_filter">      
              <xsl:value-of select="attribute::name"/>
              </xsl:variable>
           <xsl:value-of select="concat('{', $found_filter, '}')"/>
        </xsl:for-each>
    </xsl:with-param>
  </xsl:call-template>


<!-- Node000 Header File, requires Filters -->
	<xsl:call-template name="Sender_Node_Header">
    <xsl:with-param name="filters">
        <xsl:for-each select="/xip/composedPipe/connections/connection/filters/filter">
           <xsl:variable name="found_filter">      
              <xsl:value-of select="attribute::name"/>
              </xsl:variable>
           <xsl:value-of select="concat('{', $found_filter, '}')"/>
        </xsl:for-each>
    </xsl:with-param>
  </xsl:call-template>


<!-- Node000Sender file, requires Filters -->
	<xsl:call-template name="Sender_Node">
    <xsl:with-param name="filters">
        <xsl:for-each select="/xip/composedPipe/connections/connection/filters/filter">
           <xsl:variable name="found_filter">      
              <xsl:value-of select="attribute::name"/>
              </xsl:variable>
           <xsl:value-of select="concat('{', $found_filter, '}')"/>
        </xsl:for-each>
    </xsl:with-param>
  </xsl:call-template>

<!-- Datatypes.h file -->
	<xsl:call-template name="Sender_Datatype_Header">
    <xsl:with-param name="filters">
        <xsl:for-each select="/xip/composedPipe/connections/connection/filters/filter">
           <xsl:variable name="found_filter">      
              <xsl:value-of select="attribute::name"/>
              </xsl:variable>
           <xsl:value-of select="concat('{', $found_filter, '}')"/>
        </xsl:for-each>
    </xsl:with-param>
  </xsl:call-template>


<!-- Image Filters file -->
	<xsl:call-template name="Sender_Image_Filters">
    <xsl:with-param name="filters">
        <xsl:for-each select="/xip/composedPipe/connections/connection/filters/filter">
           <xsl:variable name="found_filter">      
              <xsl:value-of select="attribute::name"/>
              </xsl:variable>
           <xsl:value-of select="concat('{', $found_filter, '}')"/>
        </xsl:for-each>
    </xsl:with-param>
  </xsl:call-template>


<!-- senderlocalvars.h file -->
	<xsl:call-template name="Sender_Local_Variables_Header">
    <xsl:with-param name="filters">
        <xsl:for-each select="/xip/composedPipe/connections/connection/filters/filter">
           <xsl:variable name="found_filter">      
              <xsl:value-of select="attribute::name"/>
              </xsl:variable>
           <xsl:value-of select="concat('{', $found_filter, '}')"/>
        </xsl:for-each>
    </xsl:with-param>
  </xsl:call-template>



</files>
</xsl:template>


                                            
</xsl:stylesheet>
