

/******************************
 * Supposed to be generated
 * Node000.c -- the implementation file for this node
 *
 *
 ******************************/

extern "C" {
#include "Node000.h"
#include "localvars.h"
  int showPPM_wrapper(char* ppmFrame, int width, int height, int bytesPerPixel,
	      unsigned long PPMFrameNum,
	      char magic1, char magic2);
}

//////////////////////////////////////////////////////////
//Global Variables from Node000.h
// IPADDRESS
char *SERVERHOST;
int ARRAYSIZE;
int PKTCOUNT;
double bytesRcvd;
int outgoingDataLength;
long latency;
int ID;

PPMDataHdr Node000IncomingData;
//ArrayData Node000IncomingData;
// END GLOBAL VARIABLES
///////////////////////////////////////////////allNodes.h

int ppmDataHdrLength;
int qosHdrLength;
int dPktHdrLength;
int arrayDataLength;
int ctrlHdrLength;
int authHdrLength;
int sessionHdrLength;

/////////////////////////////////////////////////////////

// Public and Private Keys
R_RSA_PUBLIC_KEY mypubKey, senderpubKey;
R_RSA_PRIVATE_KEY myprivKey;
char *keys_path="./keys/";

// Receiver Sockets
int receiver_node_Node000ReceiveSocket;
int ctrlSock;

// Thread end indicator for the control thread
// Receiving Thread - main thread
// Control Thread
// and GUI Thread, to get user input.
int control_thread;


// Security 
EncryptParam encryptParam;


// Local Data Structures 
unsigned short port;              // SERVER PORT - TODO:FIX
struct timeval baseTime;          // Start of TIME
CtrlHdr latHdr;                   // CONTROL PACKET
struct timeval last_pkt_time;     // Time 

// Holding Buffers- To minimize malloc time
char *in_buf, *proc_buf;
int conn_done = 0;

//FEEDBACK
int pkt_count=0;
int window_count=0;
int pkt_rate_hist;

// stats
double jitter;
double qos_time;
char compress_type;

inline long getTS()
{
	struct timeval now;
	
	gettimeofday(&now, NULL);

	return(long)((now.tv_sec-baseTime.tv_sec)*1e6 + now.tv_usec);
}

/****************
 * 
 * Receive the whole data packet
 *
 * Inputs: user header (containing ptr to data init NULL)
 * 				socket id
 * 
 * DO: AUTO
 * 		1. Recv header. see if its a data PKT
 * 		2. If data Packet - recv QOS Hdr
 * 		3. Recv userHdr and user data ptr
 * 		4. pass userData and QoS Header to QoS function
 * 		4. Step 4 returns PPM Data. becomes useHdr->data
 * 		5. return
 * 		
 * Hidden O/P's
 * 		1. DataPacket Header
 * 		2. QoS Header
 ****************/
int receiveDataPacket(int receiveSocket, void *uHdr)
{
	// Temporary Buffers
	char *in, *out;

	// Timing, stats
	int start, end;
	int bytes_rcvd = 0, buf_size, status=1;
	int out_len;
	static int w_startTS; // START OF WINDOW
	
	// JITTER CALC
	static int lastTransit = 0;
	int transit;
	
	// Headers
	dataPacketHdr dpktHdr;
	UserDataHdrPtr aPtr;
	QoSHdr qosHdrR;
	//PPMDataHdrPtr ppmPtr;

	//Init Headers
	memset((void*)&dpktHdr, 0, dPktHdrLength);
	memset((void*)&qosHdrR, 0, qosHdrLength);

	// Receive Main Header
	if(receiveData(receiveSocket, &dpktHdr, 
	    dPktHdrLength, MSG_WAITALL)
	    != dPktHdrLength)
	{
		perror("Error: receiving Main Header\n");
		return -1;
	}
	if(dpktHdr.flags == FIN_REQ)
	{
		conn_done = 1;
		return -1;
	}
	// Receive QoS Header
	if(receiveData(receiveSocket, &qosHdrR, 
	    qosHdrLength, MSG_WAITALL)
	    != qosHdrLength )
	{
		perror("Error: receiving QoS Header\n");
		return -1;
	}
	
	
	///////////// USER PORTION /////////////////
	
	aPtr = (UserDataHdrPtr) uHdr;
	
	// Calc amount of Data to receive
	bytes_rcvd = dpktHdr.length - dPktHdrLength - qosHdrLength - 
					(userHdrLength - 4);
	
	// RECEIVE prev calc amount of user data
	
	// if ARRAYSIZE == ZERO comment this section
	
	// Header Has some information in it. Receive it first
	if(userHdrLength != 4)
	{
		if(receiveData(receiveSocket, aPtr, userHdrLength - 4, MSG_WAITALL)
										!= (userHdrLength - 4))
		{
			printf("Error: receiving User Header\n");
			return -1;
		}
	}

	in = in_buf; 
	if((receiveData(receiveSocket, in, bytes_rcvd, MSG_WAITALL))
	    != bytes_rcvd )
	{
		perror("Error: receiving user Header\n");
		return -1;
	}
	aPtr->buffer = in_buf;
//QOS PORTION

	out_len = bytes_rcvd;	
	start = getTS();
	if(qosHdrR.type != 0)
	{	
		out = proc_buf;
		status = processQoSReceiver(&qosHdrR, in, bytes_rcvd, out, &out_len, uHdr);
		//aPtr->buffer = out;
		//printf("Processed Array:%d:%s\n", status, out);
	}else{
		aPtr->buffer = in;
	}
	end = getTS();
	qos_time += end - start;

//END of QOS PORTION
	
	// Always init status to 1
	if(status >= 0)
	{
		// Amount of Acutal bytes Received
		// Amount of info Rcvd = ARRAYSIZE or o/p of QOS
		int t_count = pkt_count +1;
		bytesRcvd += bytes_rcvd + dPktHdrLength + qosHdrLength;
		
		if((t_count % WINDOWSIZE) == 1)
		{
			w_startTS = getTS();
			//lastVal = bytesRcvd;
		}
		
		latHdr.time = dpktHdr.time;
		
		// SEND FEEDBACK ABOUT PROCESSING RATE
		if((t_count%WINDOWSIZE) == 0)
		{
			int time_taken = getTS() - w_startTS;
			int inst_pkt_rate;
			latHdr.flags = FEEDBACK;

			pkt_rate_hist = (int)((WINDOWSIZE * 1e6)/time_taken);
			//pkt_rate_hist = (inst_pkt_rate + 9*pkt_rate_hist)/10;
			latHdr.pkt_rate = pkt_rate_hist;
			printf("Inst pkt Rate:%d\n", pkt_rate_hist);
			sendData(ctrlSock, &latHdr, ctrlHdrLength, 0);
		}
		
		if(t_count==1)
		{
			lastTransit = getTS() - dpktHdr.time;	
		}else{
			// DO the jitter calcs
			int transit = getTS() - dpktHdr.time;
			int deltaTransit = transit - lastTransit;
		
			if(deltaTransit < 0)
				deltaTransit *= -1;
			jitter  += (1.0/16.0) * (deltaTransit - jitter);
			
			lastTransit = transit;
		}	
		
		pkt_count++;
		return out_len;
	}
	return -1;
}

int processQoSReceiver ( QoSHdrPtr qosHdrR, char *in, int in_len, 
								char *out, int *out_len, void *hdr)
{
	int status = 1;
	UserDataHdrPtr uptr = (UserDataHdrPtr) hdr;
	char enc_type = (qosHdrR->type) & 0xF0;
	compress_type = (qosHdrR->type) & 0xF;

	//printf("Ency type:%d Compress type:%d\n", enc_type, compress_type);		

//<block name="filter_ENCRYPT">
	if(enc_type == ENCRYPT)
	{


		status = Decrypt((void *) &(encryptParam.cryptContext), in, in_len, out_len);

		if(status < 0){
			printf("Error Decrypting\n");
			return -1;
		}
		if(qosHdrR->pad != 0)
			*out_len = *out_len + qosHdrR->pad - encryptParam.keySize;

	}
//</block>
	
	switch(compress_type)
	{
//<block name="filter_LZO">
		case LZO:

			break;
//</block>

//<block name="filter_GZIP">
		case GZIP:

	    status = gzip_decompress(in, in_len, out, out_len);
			uptr->buffer = out;
	
			break;
//</block>

//<block name="filter_JPEG">
		case JPG:

		//	init_jpeg_decompress();
			jpeg_to_ppm(in, in_len, uptr->height, uptr->width, uptr->maxval, out);
			uptr->buffer = out;
		//	end_jpeg_decompress();

			break;
//</block>
		
		default:
		/*	out = in;
			in = NULL;*/
			break;
	}

	return status;
}
/***********************
 * CLOSE SOCKET 
 *
 **********************/
void closeSocket(int sock)
{
	close(sock);
	printf("Close connection \n");
}

/***********************
 * 
 * SEND function.
 * Can be used by the user while writing his send fn.
 * Provides Transparency from underlying protocols
 * 
 * RETURN: number of bytes sent
 ***********************/

// Currently only TCP. so easily just a send
// FLAGS: MSG_OOB - outofband data
int sendData(int sockfd, void *dstruct, int size, int flags)
{
	return send(sockfd, dstruct, size, 0);
}


/***********************
 * 
 * RECEIVE function.
 * Can be used by the user while writing his recv fn.
 * Provides Transparency from underlying protocols
 * 
 * RETURN: number of bytes received
 ***********************/

// Currently only TCP.
// FLAGS : 
// MSG_OOB - for out of band Data
// MSG_PEEK - to check w.o exactly recving
// MSG_WAITALL - fill the struct b4 returning

int receiveData(int sockfd, void *dstruct, int size, int flags)
{
	return recv(sockfd, dstruct, size, flags);
}

/***********
 * Receiver Node Processing
 * 
 ***********/
void receiver_node_Node000Receive()
{
	//raiseEvent("beginProcessing");
	raiseEvent("receive");
}

/***********
 * Event Handling
 * 
 **********/
void raiseEvent(char *event)
{
	//printf("start event : %s \n", event);


	if (event == "receive") {
		receiveDataPacket(receiver_node_Node000ReceiveSocket,
		    &Node000IncomingData);
		
		//Write the PPM Image to a file
		
		processPPMImage(Node000IncomingData);
		//printf(" event : %s \n", event);
	}

}
/**********
 * Init Receiver Node Socket
 * 
 **********/
int receiver_node_Node000initReceiveSocket()
{
	int sock;
	struct sockaddr_in sin;
	int data_port = port;
	
	// Create a new socket
	sock = socket(PF_INET, SOCK_STREAM, 0);
	
	// Init connection parameters
	sin.sin_family = AF_INET;
	sin.sin_port = htons(data_port);
	
	sin.sin_addr.s_addr = inet_addr(SERVERHOST);
	
	// Loop to have a different port number for each pipe
	while ((connect(sock, (struct sockaddr *) &sin, sizeof(sin))) == -1) {
		data_port = data_port + 1;
		sin.sin_port = htons(data_port);
	}
	data_port = data_port + 1;

	printf("Connection to server %s ... \n", SERVERHOST);
	
	return sock;
}

/*********
 * Receiver Pipe Startup
 *
 * 
 *********/

pthread_t cThread, guiThread;
extern void *gui_thread(void*);

int authenticated = 0;

void infopipeStartup()
{
	init_local_vars();

	// Init Control Socket
	control_thread = 0;
	if( pthread_create(&cThread, NULL, receiverNodeControl, NULL) != 0)
	{
		printf("Error Creating Control Thread\n");
		return;
	}

	while(!authenticated);

	// Now initialize the gui thread
	if( pthread_create(&guiThread, NULL, gui_thread, NULL) != 0)
	{
		printf("Error Creating GUI Thread\n");
		return;
	}
	// Init Data Socket
	bytesRcvd = 0;
	receiver_node_Node000ReceiveSocket =
		receiver_node_Node000initReceiveSocket();
	strcpy(latHdr.srcID, "client");
	latHdr.flags = LATENCYREP;
	printf("Receive socket initialized \n");
}

int init_local_vars()
{
	char algo[30];
	int keySize = 24;
	//port = 10000;
	
	// Init Header Lengths
	dPktHdrLength = sizeof(dataPacketHdr);
	qosHdrLength = sizeof(QoSHdr);
	ppmDataHdrLength = sizeof(PPMDataHdr);	
	arrayDataLength = sizeof(ArrayData);
	ctrlHdrLength = sizeof(CtrlHdr);
	authHdrLength = sizeof(AuthHdr);
	sessionHdrLength = sizeof (SessionHdr);

	// Init Buffer
	ARRAYSIZE = 260000;
	in_buf = (char*)malloc(ARRAYSIZE + 1024);
	proc_buf = (char*)malloc(270000);
	//Node000IncomingData.buffer = (char*)malloc(sizeof(char) *ARRAYSIZE);

	conn_done = 0;
	pkt_rate_hist = 2;

	// INitialize available filter configurations

	// Code for LZO Filter Initialization
//<block name="filter_LZO">

	haveLZO = 0;

//</block>

//<block name="filter_JPEG">

	haveLossy = 1;
	init_jpeg_decompress();

//</block>


//<block name="filter_GZIP">

	haveGZIP = 1;

//</block>

//<block name="filter_ENCRYPT">

	haveEncode = 1;
	encryptParam.keySize = keySize;
	encryptParam.ivSize = keySize;

	encryptParam.key = (char *) calloc(1, encryptParam.keySize * sizeof(char));
	encryptParam.iv = (char *) calloc(1, encryptParam.ivSize * sizeof(char));

 	strncpy(encryptParam.key, "abcdefghijklmnopqrstuvwxyz123456", keySize);	
 	strncpy(encryptParam.iv, "abcdefghijklmnopqrstuvwxyz123456", keySize);	

	printf("Initialized Encryption mod with keysize:%d\n", keySize);

	if(encryptParam.keySize != 0)
	{
		
		sprintf(algo,"%s-%d","rijndael", (encryptParam.keySize*8));
	
		printf("Setting algo:%s\n", algo);
		encryptParam.cryptContext = CreateContext(algo, "ecb");
		SetParams((void *) &(encryptParam.cryptContext), encryptParam.key, encryptParam.iv);

	}

//</block>

//<block name="filter_GREY">

	haveGrayscale = 1;

//</block>

//<block name="filter_SHRINK">

	haveScale = 1;

//</block>

	gettimeofday(&baseTime, NULL);

	setKeysPath(keys_path);
	readPubKey("client.pub", &mypubKey);
	readPubKey("server.pub", &senderpubKey);
	readPrivKey("client.prv", &myprivKey);


}
/************
 * Receiver Pipe Shutdown
 ************/
void infopipeShutdown()
{
	// Close socket 
	closeSocket(receiver_node_Node000ReceiveSocket);
	closeSocket(ctrlSock);
}

/******************
 * Control Thread For the receiver
 *
 * 1. Connect to control sock of sender
 * 2. authenticate
 * 	2.1 maybe ask for session key
 * 3. agree on init params/qos requirements
 * 4. send back control info 
 * 5. repeat 3,4 in a while(1) loop
 *
 ******************/

void *receiverNodeControl(void *args)
{
	int s_port, addr_len, tcpnodelay_flag = 1;
	char hostname[50];	
	struct hostent *server_host, *cli_host;
	struct sockaddr_in server_addr;
	int c_port = 10002;
	CtrlHdr chdr;
	
	s_port = (ushort)(port+5);

	// Socket Creation
	addr_len = sizeof (struct sockaddr);
	
	bzero((void*)&server_addr, addr_len);
	
	server_addr.sin_family = AF_INET;
	server_addr.sin_port = htons (s_port);

	server_addr.sin_addr.s_addr = inet_addr(SERVERHOST);
	
	// CLIENT 
	if (gethostname(hostname, 50) != 0)
	{
		fprintf(stderr, "Unable to get Hostname\n");
		exit(0);
	}
					
	if ((cli_host = gethostbyname(hostname)) == NULL)
	{
		fprintf(stderr,"%s host not found by client. Exiting....\n", hostname);
		return 0;
	}
	// printf("Client name:%s\n",cli_host->h_name);	
	
	
	// SOCKET CREATION
	
	ctrlSock = socket (AF_INET, SOCK_STREAM, 0);
	if (ctrlSock < 0)
	{
		fprintf (stderr, "Unable to create socket. Exiting Client........\n");
		return 0;
	}
	
	if ( connect(ctrlSock, (struct sockaddr*)&server_addr, addr_len) < 0)
	{
		perror("Unable to connect to server\n");
		exit(0);
	}
	
	printf("Control Socket Connection Established\n");
	
	//receiveData(ctrlSock, hostname, 50, 0);

	//printf("MSg from server:%s\n", hostname);

	authenticated = authenticate(ctrlSock);
	while(1){
		if(receiveData(ctrlSock, &chdr, sizeof(chdr), MSG_WAITALL)!= ctrlHdrLength)
		{
			perror("Error Rcving control msg\n");
		}
		
		if(chdr.flags == FIN_REQ)
		{
			// Check if all packets have been received.
			// If so break connection
			while(pkt_count != chdr.pkt_rate) sleep(1);
		
			chdr.flags = FIN_REP;
			sendData(ctrlSock, &chdr, sizeof(chdr), 0);
			printf("Received End of stream msg: Sending back FIN\n");
			control_thread = 1;
			break;
		}
	}

	return 0;

}

// ONLY TCP...
int authenticate (int sock_fd)
{
	CtrlHdr cHdr;
	AuthHdr aHdr;
	SessionHdr sHdr;
	
	char msg[2048];
	char dec_msg[2048];
	unsigned int t1, t2; // temp

	cHdr.enc_type = DBLPKENC;
	strcpy(cHdr.srcID, "client");

	aHdr.flags = '0';
	strcpy(aHdr.magic, MAGIC);
	aHdr.random[15] = '1';
	switch((int)cHdr.enc_type)
	{
		case PLAINTXT:
			break;
		case PKENC:
			break;
		case DBLPKENC:
			
			memcpy(msg, (void*)&aHdr, authHdrLength);
			
			// Encrypt with own Private Key 
			RSAPrivateEncryptBlock((uchar *)dec_msg, 
															&t1, 
															(uchar*)msg, 
															authHdrLength, 
															&myprivKey);
			//printf("L1:%d\n", t1);
			
			// Encrypt with rcvr's Private Key
			RSAPublicEncryptBlock((uchar*)msg,  
															&t2,
															(uchar*)dec_msg, 
															t1, 
															&senderpubKey);
			cHdr.length = t2;
			//printf("Encrypted Msg Length:%d\n", t2);
			
			
			if(aHdr.flags == (char)SESSKEYREP)
			{
				// SEND SESSION KEY WITH REPLY
				// MODIFY FLAGS + LENGTH
				// ALSO ADD IT TO MSG
			}

			
			send(sock_fd, &cHdr, ctrlHdrLength, 0);
			send(sock_fd, msg, t2, 0);

			// NOW WAIT FOR REPLY
			recv(sock_fd, &cHdr, ctrlHdrLength, MSG_WAITALL);
			printf("Waiting to recv encrypted pkt of size %d\n", cHdr.length);
			recv(sock_fd, msg, cHdr.length, MSG_WAITALL);
			
			// Decrypt with my private Key 
			RSAPrivateDecryptBlock((uchar*)dec_msg, 
															&t1, 
															(uchar*)msg, 
															cHdr.length, 
															&myprivKey);
			
			RSAPublicDecryptBlock((uchar*)msg, 
														&t2, 
														(uchar*)dec_msg, 
														t1,
														&senderpubKey);
			
			if(t2 != authHdrLength)
			{
				printf("Wrong Msg decrypted\n");
			}
			memcpy((void*)&aHdr, msg, t2);
			
			if((strncmp(aHdr.magic, MAGIC, 16) == 0) && aHdr.random[15] == '2')
			{
				printf("Server %s authenticated\n", cHdr.srcID);
				return 1;
			}else {
				printf("Wrong Reply from Server\n");
			}
			break;
		default:
			return -1;
	}
}

int processPPMImage(PPMDataHdr p)
{
	static int fcount = 0;
	printf("Width:%d Ht: %d Magic:%c Size:%d\n", p.width, p.height, p.magic[1], p.size);
	showPPM_wrapper(p.buffer, p.width, p.height, (p.magic[1] == '6')?3:1,
	      1,
	      'P', p.magic[1]); 
	fcount++;

	return 1;
}


int gui_set_params()
/*
 * Get the Values in the Control Message
 * Send them to the server
 */
{
	CtrlHdr ctrl_params;

	ctrl_params.flags = SETPARAMS;
	ctrl_params.enc_type = PLAINTXT;
	ctrl_params.length = ctrlHdrLength;
	
	ctrl_params.pkt_rate = target_fps;
	ctrl_params.srcID[0] = ifCompress;
	ctrl_params.srcID[1] = ifScale;
	ctrl_params.srcID[2] = ifLossy;
	ctrl_params.srcID[3] = ifEncode;
	//printf("New params:ifEncode:.....................................%c\n", ifEncode+'0');
	ctrl_params.srcID[4] = ifGrayscale;

	sendData(ctrlSock, &ctrl_params, ctrlHdrLength, 0);
	
	// Do you wait for a reply?
	return -1;
}

