


/*
 * GUI Thread
 *
 * Get user input to change parameters and 
 * send back the updated values to the sender.
 *
 */
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <unistd.h>

#include "interface.h"
#include "support.h"


// Get the parameters from the GUI/ file
int gui_get_params();

// Send params to the server using the control Socket.
// In Node000.c
int gui_set_params();

// Send an error message to STDOUT/GUI
int error_msg();

// The thread routine
void *gui_thread(void *);
// Values denoting presence/absence of filters
extern char haveLZO, haveGZIP, haveLossy, haveEncode, haveGrayscale, haveScale;
#define haveCompress (((haveLZO | haveGZIP)==0)?0:1)

// Values that encompass user preferences
extern char ifCompress, ifLossy, ifScale, ifGrayscale, ifEncode;
extern int target_fps;

void *gui_thread(void *args)
{
	int i;
  GtkWidget *window_main;
	int argc=1;
	char **argv;
	
	argv = (char**)malloc(2*sizeof(char*));
	*argv = (char*) malloc(20);
	strcpy(*argv,"./receiver");
  //TAO stuff....
  //init_ControlCenterC(argc, argv);

  //init_rc();

 // gtk_set_locale ();
  gtk_init (&argc, &argv);

  //add_pixmap_directory ("./");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  window_main = create_window_main ();
  gtk_widget_show (window_main);

  gtk_main ();
  
 
	return 0;
}

int gui_get_params()
{
	// Simulate a GUI using a file
	// File Format
	// 
	// 
	FILE *fp;
	int tmp[5];

	fp = fopen("params.txt", "r");
	if(fp == NULL)
		return -1;

	fscanf(fp, "%d\n%d\n%d\n%d\n%d\n%d", &target_fps, &tmp[0], 
									&tmp[1], &tmp[2], &tmp[3], &tmp[4]);
	fclose(fp);

	ifCompress = (char)tmp[0] & haveCompress;
	ifLossy = (char)tmp[1] & haveLossy;
	ifScale = (char)tmp[2] & haveScale;
	ifGrayscale = (char)tmp[3] & haveGrayscale;
	ifEncode = (char)tmp[4] & haveEncode;

	//printf("New params:ifEncode:.....................................%d\n",ifLossy );

	return 1;	
}
extern int gui_set_params();

int cback()
{
	gui_set_params();
}
