<xsl:stylesheet version="1.0"                                                
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template name="Receiver_Makefile">
<xsl:param name="filters"/>

<file><name>receiver/Makefile</name>

<content>


#
#  Makefile for receiver
#
CFLAGS=#-pg#-ggdb
CC = g++ 
MYLIBS=../../lib/
INC=../../include
INCRSA=$(INC)/rsaref2
#INCGTK=-I /usr/include/gtk-2.0/ -I/usr/include/glib-2.0/ -I /usr/include/pango-1.0/ -I /usr/include/atk-1.0/ -I /usr/include/gtk-2.0/gdk -I /usr/lib/gtk-2.0/include/ -I/usr/lib/glib-2.0/include/

INCGTK=`pkg-config --cflags gtk+-2.0`
LFLAGS=-lpthread -lm

all: receiver

receiver: receiver.o Node000.o gui_thread.o 
	$(CC) $(LFLAGS) -oreceiver receiver.o Node000.o\
	callbacks.o gui_thread.o interface.o support.o\
	-L$(MYLIBS) -lmyutils -ldisplay -lrsaref\
	-lvideogfx\
	-L /usr/X11R6/lib/ -lXext -L/usr/lib/\
	`pkg-config --libs gtk+-2.0`\
<xsl:if test="contains($filters, 'ENCRYPT')">	-lencrypt\
</xsl:if>
<xsl:if test="contains($filters, 'LZO')">	-llzo\
</xsl:if>
<xsl:if test="contains($filters, 'GZIP')">	-lgzip\
</xsl:if>
<xsl:if test="contains($filters, 'JPEG')">	-ljpeg
</xsl:if>
	
receiver.o: receiver.c Node000.h 
	$(CC) -c receiver.c -I$(INC) -I$(INCRSA) 

Node000.o: Node000.c datatypes.h Node000.h localvars.h
	$(CC) $(CFLAGS) -c Node000.c -I$(INC) -I$(INCRSA) 

gui_thread.o: gui_thread.c interface.o callbacks.o support.o
	g++ $(CFLAGS) -c gui_thread.c -I$(INC) -I$(INCRSA) $(INCGTK)

interface.o:interface.c interface.h
	g++ $(CFLAGS) -c interface.c $(INCGTK)

support.o:support.c support.h
	g++ $(CFLAGS) -c support.c $(INCGTK)
	
callbacks.o:callbacks.c callbacks.h
	g++ $(CFLAGS) -c callbacks.c $(INCGTK)

clean:
	rm -f *.o receiver core*

</content>
</file>
</xsl:template>
</xsl:stylesheet>
