<xsl:stylesheet version="1.0"                                                
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template name="Sender">
<xsl:param name="filters"/>
<file><name>sender/sender.c</name>

<content>

//&lt;block name="pipe_Sender">
#include "Node000.h"
#include "vdev.h"
#include &lt;pthread.h>

#define PPMSIZE 230400

VDev_T vdev = NULL;
struct VDev_imageSize size;

extern int control_thread;
extern PPMDataHdr Node000OutgoingData;
extern short port;
int transfer()
{

	struct timeval end, s1, e1;
	int pixOrder = 6;
	// Read Image from the camera
	// In this case- fill in all the other fields
	// magic, height, width, maxval and size
	
	strcpy(Node000OutgoingData.magic, "P6");
	Node000OutgoingData.width = 320;
	Node000OutgoingData.height = 240;
	Node000OutgoingData.maxval = 255;
	Node000OutgoingData.size = PPMSIZE;
	
	Node000OutgoingData.buffer = (char *) VDev_getPPMImage(vdev, pixOrder);
	//readPPMFile(&amp;Node000OutgoingData);

	sender_node_Node000Submit();

	//free(Node000OutgoingData.buffer);
}

int main(int argc, char **argv)
{
	int i,j,k,l;
	int keySize;
	int usecs;	
	int st, end;
	struct VDev_imageSize vdev_size;

	if(argc != 3)
	{
		printf("Usage: ./sender runtime(in seconds) &lt;port no>)\n");
		exit(0);
	}
	usecs = atoi(argv[1]) * 1e6;
	port = atoi(argv[2]);
		
	///////////// BEGIN STARTUP CAM
	VDev_init(320,240);
	
  if (VDev_numVDevices() &lt; 1) 
    printf("No camera connected.\n");
	
  vdev = VDev_getVDevice(0);
	
  if (vdev == NULL || !VDev_isValid(vdev)) 
    printf("Something is wrong, what camera are you asking for ?\n");
	
  printf("V4L name: %s\n", VDev_getIntfName(vdev));
	
  VDev_open(vdev, 2);
	
  if (VDev_getDescriptor(vdev) &lt; 0) 
    printf("Something is wrong, what camera are you asking for?\n");
	
  VDev_getSize(vdev, &amp;vdev_size);
    printf("Size (width, heigth): (%d, %d)\n", vdev_size.width, vdev_size.height);

	////////////// END STARTUP CAM
	infopipeStartup();
	// controlStartup();

	/* --------------- */
	/* - init camera - */
	/* --------------- */
	 

	/* ---------------------------- */
	/* - video stream transfering - */
	/* ---------------------------- */
	strcpy(Node000OutgoingData.magic, "P6");
	Node000OutgoingData.width = 320;
	Node000OutgoingData.height = 240;
	Node000OutgoingData.maxval = 255;
	Node000OutgoingData.size = PPMSIZE;
	
	i=0;
	st = getTS();
	while (1) {
		
		transfer();
		i++;
		end = getTS();

		if((end - st) > usecs)
			break;
	}
	
	end_conn();
	while(!control_thread) 
		sleep(1);
	infopipeShutdown();
}
//&lt;/block>
</content>
</file>
</xsl:template>
</xsl:stylesheet>
