<xsl:stylesheet version="1.0"                                                
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template name="Sender_Datatype_Header">
<xsl:param name="filters"/>

<file><name>sender/datatypes.h</name>

<content>

#ifndef __DATATYPES_H	
#define __DATATYPES_H

#include &lt;stdio.h>
#include &lt;stdlib.h>
#include &lt;string.h>
#include &lt;unistd.h>
#include &lt;signal.h>
#include &lt;fcntl.h>

#ifndef FALSE
	#define FALSE 0
	#define TRUE (!FALSE)
#endif

#ifndef NULL
	#define NULL 0
#endif

#define userHdrLength (ppmDataHdrLength)
#define UserDataHdr PPMDataHdr
#define UserDataHdrPtr PPMDataHdrPtr
//#define userHdrLength (arrayDataLength)
//#define UserDataHdr ArrayData
//#define UserDataHdrPtr ArrayDataPtr

#define USEGZIP
#define USELZO
#define USECRYPT

#define GZIP 5 
#define LZO 6
#define JPG 7
#define ENCRYPT	0x10
#define SHRINK 0x21
#define GRAYSCALE 0x22
#define SHRINKGRAYSCALE 0x23 // aka SHRINK | GRAYSCALE

#define STATFNAME "stats.txt"
//#define STATSvsTIME 1
//#define TIMING_STATS 0


typedef struct dataPacketHeader_t{
	char flags;
	char type;
	short seqNumber;
	unsigned long time;
	long length;
	long sourceID;
	

	// QoS Options
}dataPacketHdr, *dataPacketHdrPtr;

typedef struct QoSHeader_t{
	char type;
	char options;
	char region;
	char tag;
	int pad;
}QoSHdr, *QoSHdrPtr;

typedef struct PPMDataHdr_t 
{
	char magic[2];
	int width;
	int height;
	int maxval;
	
	int size;
	char * buffer;
} PPMDataHdr, *PPMDataHdrPtr;


typedef struct ArrayData_t
{
	char *buffer;
}ArrayData, *ArrayDataPtr;

#define PLAINTXT 1  // Plaintxt
#define PKENC 2			// PK Enc
#define DBLPKENC 3	// Dual Pub key enc
#define SYMENC 4		// Symmetric Key enc

#define SENDER 1
#define DUAL 2
#define RECEIVER 3

#define LATENCYREP 64 
#define FEEDBACK 63
#define FIN_REQ 0x10 
#define FIN_REP 0x11
#define SETPARAMS 0x21

typedef struct INFOCP_t {                                                            
  char flags; // int ver: 2;        The version                                          
							// int pad: 1;        The padding                                          
  						// int rec_ct: 5;     The report count                                     

	char enc_type;		// PK encrypted
										// PK Double Encrypted
										// PK Encryption + (request/reply)session key
										// (request/reply)Session Key
	unsigned short length; //The length of the packet- not inc the header
	unsigned long time;
	unsigned long total_latency;

	int pkt_rate;
	int bw;
	char srcID[16];
	char *data;     //The start of the meta data                           
}CtrlHdr, *CtrlHdrPtr;

// The authentication Header
#define SESSKEYREQ (char)0x1
#define SESSKEYREP (char)0x3
#define MAGIC "IAMSENDING"

typedef struct AUTH_t {
	char flags;
	char magic[16];
	char random[16];
}AuthHdr, *AuthHdrPtr;

// The session keys header
typedef struct SESS_t {
	char flags;
	int algorithm_type;
	char keysize; // In bytes
	char key[32]; // Not transmitted in the 
								// case of a request
}SessionHdr, *SessionHdrPtr;

#endif 

</content>
</file>
</xsl:template>
</xsl:stylesheet>
