<xsl:stylesheet version="1.0"                                                
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template name="Sender_Image_Filters">
<xsl:param name="filters"/>
<file><name>sender/imgfilters.c</name>

<content>


//
//$Id: senderimgfilters.xsl,v 1.1.1.1 2003/06/11 19:05:41 wyan Exp $
//
//File: filters.c
//      The filters include shrink, grey, and others
//      The input images should be in raw pixel format.
//      @see ecl filters in the Gatech-UAV demo

#include "datatypes.h"

int shrinkFilter(int options, PPMDataHdr *inImage,
                 char *out_buf)
{
  int col;
  int row;
  int indx;
  int outIndx;
  int currIndx;
  int currOutIndx;
  int inOffset;

  inOffset = inImage->width * 3;
  for (row = 0; row &lt; (inImage->height - 1); row = row + 2) {
    indx = row * inOffset;
    outIndx = row  * inImage->width/4 * 3;

    for ( col = 0; col &lt; (inImage->width - 1); col = col + 2 ) {
        currIndx = indx + col * 3;
        currOutIndx = outIndx + col / 2 * 3;
        out_buf[currOutIndx] = (inImage->buffer[currIndx]);
        out_buf[currOutIndx+1] = (inImage->buffer[currIndx+1]);
				out_buf[currOutIndx+2] = (inImage->buffer[currIndx+2]);
    }
  }

	// Now change the parameters appropriately
	// size/=4, {width,height}/=2
  inImage->size = inImage->size/4;
	inImage->width /=2;
	inImage->height /=2;
	
  return 1;
}


int greyFilter(int options, PPMDataHdr *inImage,
               char *out_buf)
{
  int col;
  int row;
  int indx;
  int outIndx;
  int tmp;

  indx = 0;
  outIndx = 0;
  for (row = 0; row &lt; inImage->height; row = row + 1) {
    for ( col = 0; col &lt; inImage->width; col = col + 1) {
      tmp = (0.299 * inImage->buffer[indx]  + 0.587 * inImage->buffer[indx+1] +
             0.114 * inImage->buffer[indx+2]) + 0.5;
      out_buf[outIndx] = tmp;
      indx = indx + 3;
      outIndx = outIndx + 1;
    }
  }

  inImage->size /= 3;  
 
  inImage->magic[1] = '5';

  return 1;
}

</content>
</file>
</xsl:template>
</xsl:stylesheet>
