/****************************
 *
 * authentication function
 *
 * uses rsaref2 - ref rsalicense.txt TODO
 * 
 ****************************/

#ifndef __AUTH_H
#define __AUTH_H 1

#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <unistd.h>
#include "global.h"
#include "rsaref.h"


void initRandomStruct (R_RANDOM_STRUCT *randomStruct);
#ifndef uint
typedef unsigned int uint;
#endif
#ifndef uchar
typedef unsigned char uchar;
#endif

int readPubKey(char *filename, R_RSA_PUBLIC_KEY *pubKey);

int readPrivKey(char *filename, R_RSA_PRIVATE_KEY *privKey);

int RSAPublicEncryptBlock(uchar *out, uint *outlen, 
								uchar *in, uint inlen, R_RSA_PUBLIC_KEY *pubKey);

int RSAPublicDecryptBlock(uchar *out, uint *outlen, 
								uchar *in, uint inlen, 
								R_RSA_PUBLIC_KEY *pubKey);

int RSAPrivateDecryptBlock(uchar *out, uint *outlen, 
								uchar *in, uint inlen, 
								R_RSA_PRIVATE_KEY *privKey);

int RSAPrivateEncryptBlock(uchar *out, uint *outlen, 
								uchar *in, uint inlen, R_RSA_PRIVATE_KEY *privKey);

int setKeysPath(char *path);
#endif
