#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>

#include "sipParser.h"

char *exec_child(char *filename, char *arg);

char *getBlockXip(char *filename)
{
	return exec_child("getBlockXip.py", filename);
}

char *getXip(char *filename)
{
	return exec_child("getXip.py", filename);
}

char *getBlockSip(char *filename)
{
	return exec_child("getBlockSip.py", filename);
}

char *exec_child(char *filename, char *arg)
{
	int pfd[2];
	int pid;

	char *buf = NULL;
	int rb;
	
	struct stat st;
	int status;


	pipe(pfd);
	pid = fork();
	switch(pid) {
	case 0:
		close(pfd[0]);
		dup2(pfd[1], fileno(stdout));
		execl(filename, arg, arg, NULL);
		perror("error on exec()\n");
		exit(-1);
	case -1:
		printf("error on fork()\n");
		exit(-2);
	default:
		close(pfd[1]);

		wait(&status);
		fstat(pfd[0], &st);
		buf = (char *)malloc(st.st_size + 1);
		rb = read(pfd[0], buf, st.st_size);
		buf[rb] = 0;

		close(pfd[0]);
	}

	return buf;
}

int main(int argc, char **argv) 
{
	printf("%s", getBlockXip(argv[1]));
	printf("%s", getXip(argv[1]));
	printf("%s", getBlockSip(argv[1]));
}
