// Prototypes for out.cpp
//
#ifndef OUTCPPDEFINED
#define OUTCPPDEFINED

// Headers for dealing with XML
#include <util/PlatformUtils.hpp>
#include <sax/ErrorHandler.hpp>
#include <sax/SAXParseException.hpp>
#include <parsers/DOMParser.hpp>
// apparently must follow at least the util/PlatformUtils.hpp #include
#include <sax/SAXException.hpp>
#include <dom/DOM_DOMException.hpp>
#include <dom/DOM_NamedNodeMap.hpp>


int generateCode( DOM_Document, DOM_Document );
int writeFiles( DOM_Element );

int updateMarks(DOM_Element e);
int makeTextAndMarkNode(DOM_Node futureParent, DOMString textToAdd);
int makeText( DOM_Node futureParent, DOMString textToAdd );
int markElement(DOM_Element e);
int isElementMarked( DOM_Element n );

int fillTagWithText(DOM_Element root, char *tagName, DOMString text);
DOMString mapType(DOMString fromType, DOMString toDomain);

ostream &operator<<( ostream &out, DOMString );
ostream &operator<<( ostream &out, DOM_Element r );

// make path string like param1/param2/param3/.../param_last/
char *makePathString(char *str, ...);
// make sub-directories along the given path
int makePathDir(char *path, mode_t mode = 0755);

#endif //OUTCPPDEFINED
