<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<!--xsl:output method="text"/-->

<!-- ================================================================= -->
<!-- $Id: CppClass.xsl,v 1.1.1.1 2003/06/11 19:11:43 wyan Exp $                                                              -->
<!-- Wenchang                                                          -->
<!-- ================================================================= -->
                                                                         
<!--xsl:include href="common.xsl"/-->
<xsl:include href="CppMethod.xsl"/>
<!-- xsl:include href="CppProperty.xsl"/ -->


<!-- ======================== -->
<!--   The comment template   -->
<!-- ======================== -->
<xsl:template name="comment">
<xsl:text>
</xsl:text>
<xsl:value-of select="$type_idt"/><xsl:text>//////////////////////////////////////</xsl:text>
  <xsl:text>
</xsl:text>
<xsl:value-of select="$type_idt"/><xsl:text>// </xsl:text>
  <xsl:param name="value">
     <xsl:text>General comment</xsl:text>
  </xsl:param>
  <xsl:value-of select="$value"/><xsl:text>
</xsl:text>
</xsl:template>


                                                                         
<!-- ========================================= -->		    
<!-- Template: C++ class declaration        == -->
<!-- ========================================= -->
<xsl:template name="class">
<xsl:param name="name"/>
<xsl:param name="parents"/>
<!-- class declaration -->
<xsl:text>class </xsl:text><xsl:value-of select="$name"/>
<!-- inheritance -->
  <xsl:if test="starts-with($parents, '{')">
    <xsl:text> : </xsl:text>
    <xsl:call-template name="class_inheritance">
      <xsl:with-param name="parent_classes">
        <xsl:value-of select="$parents"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:if>

  <!-- class body -->
  <xsl:text>
{</xsl:text>
</xsl:template>



<!-- ============================== -->
<!-- Template: class_inheritance == -->
<!-- ============================== -->
<xsl:template name="class_inheritance">
  <xsl:param name="parent_classes"/>
  <xsl:if test="starts-with($parent_classes, '{')">
    <xsl:text> </xsl:text>
    <xsl:value-of select="substring-before(substring-after($parent_classes,'{'), '}')"/>
    <!-- recursive -->
    <xsl:if test="contains(substring-after($parent_classes,'}'), '{')">
      <xsl:text>, </xsl:text>
      <xsl:call-template name="class_inheritance">
        <xsl:with-param name="parent_classes" select="substring-after($parent_classes,'}')" />
      </xsl:call-template>
    </xsl:if>
  </xsl:if>
</xsl:template>


<!-- ========================================= -->
<!-- Template: C++ dependency               == -->
<!-- ========================================= -->
<xsl:template name="dependency">
  <xsl:param name="files"/>
  <xsl:if test="starts-with($files, '{')">
    <xsl:text>#include &quot;</xsl:text>
    <xsl:value-of select="substring-before(substring-after($files,'{'), '}')"/><xsl:text>&quot;
</xsl:text>
  <!-- recursive -->
    <xsl:call-template name="dependency">
      <xsl:with-param name="files" select="substring-after($files,'}')" />
    </xsl:call-template>
  </xsl:if>
</xsl:template>
                                                          		    
                                                          		    
<!-- ========================================= -->
<!-- Template: C++ use                      == -->
<!-- param: files are the included files.   == -->
<!-- `{' and `}' are just the delimeter of  == -->
<!-- each head include                      == -->
<!-- ========================================= -->

<xsl:template name="use">
  <xsl:param name="files"/>
  <xsl:if test="starts-with($files, '{')">
    <xsl:text>#include &lt;</xsl:text>
    <xsl:value-of select="substring-before(substring-after($files,'{'), '}')"/><xsl:text>&gt;
</xsl:text>
  <!-- recursive -->
    <xsl:call-template name="use">
      <xsl:with-param name="files" select="substring-after($files,'}')" />
    </xsl:call-template>
  </xsl:if>
</xsl:template>




                                                          		    
                                                          		    
</xsl:stylesheet>
