<xsl:stylesheet version="1.0"                                                
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- ================================================================= -->
<!-- $Id: Distributor.xsl,v 1.1.1.1 2003/06/11 19:11:43 wyan Exp $                                                              -->
<!-- Wenchang                                                          -->
<!-- ================================================================= -->

<!-- ================================= -->
<!--      The Distributor_H template   -->
<!-- ================================= -->

<xsl:template name="Distributor_H">
  <xsl:param name="name"/>

  <!-- Capitalized name -->
  <xsl:variable name="name_all_capital">
    <xsl:value-of select="translate($name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
  </xsl:variable>
  <xsl:variable name="name_all_small">
    <xsl:value-of
    select="translate($name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
  </xsl:variable>

  <xsl:value-of select="$empty_line"/>
  <xsl:value-of select="$empty_line"/>

  <!-- opening tag for isg post-processing -->
  <file><name>
     <xsl:value-of select="$dir_avstreams"/><xsl:value-of select="$name"/>.h</name><content>

  <xsl:value-of select="$file_header"/>

  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'.h')"/>
    </xsl:with-param>
  </xsl:call-template>

  <!-- include ifdef-endif -->
<xsl:text>
#ifndef _</xsl:text><xsl:value-of select="$name_all_capital"/><xsl:text>_H_
#define _</xsl:text><xsl:value-of select="$name_all_capital"/><xsl:text>_H_
</xsl:text>

  <xsl:value-of select="$empty_line"/>

  <!-- The system include -->
  <xsl:call-template name="use">
    <xsl:with-param name="files">{orbsvcs/AV/AVStreams_i.h}{orbsvcs/AV/Endpoint_Strategy.h}{orbsvcs/AV/Policy.h}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="dependency">
    <xsl:with-param name="files">{Connection_Manager.h}</xsl:with-param>
  </xsl:call-template>

  <xsl:value-of select="$empty_line"/>
  <!-- ======================================= -->
  <!-- The Distributor_Receiver_Callback class -->
  <!--                                         -->
  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'_Receiver_Callback class: AVStreams calls this class when data shows up from a sender.')"/>
    </xsl:with-param>
  </xsl:call-template>

  <xsl:value-of select="$empty_line"/>
  <!-- The class declaration -->
  <xsl:call-template name="class">
    <xsl:with-param name="name"><xsl:value-of select="concat($name,'_Receiver_Callback')"/></xsl:with-param>
    <xsl:with-param name="parents">{public TAO_AV_Callback}</xsl:with-param>
  </xsl:call-template>

  <!-- The class method -->
  <xsl:call-template name="method">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '_Receiver_Callback')"/></xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">
      <xsl:value-of select="concat('~', $name, '_Receiver_Callback')"/></xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">handle_destroy</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <!-- The closing of class -->
  <xsl:text>
};// class: </xsl:text>

  

  <!-- ======================================= -->
  <!-- The Distributor_Receiver_StreamEndPoint class -->
  <!--                                         -->
  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'_Receiver_StreamEndPoint class: AVStreams calls this class during connection setup')"/>
    </xsl:with-param>
  </xsl:call-template>

  <!-- The class declaration -->
  <xsl:call-template name="class">
    <xsl:with-param name="name"><xsl:value-of select="concat($name,'_Receiver_StreamEndPoint')"/></xsl:with-param>
    <xsl:with-param name="parents">{public TAO_Server_StreamEndPoint}</xsl:with-param>
  </xsl:call-template>

  <!-- The class method -->
  <xsl:call-template name="method">
    <xsl:with-param name="name">get_callback</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{const char *flowname}{TAO_AV_Callback *&amp;callback}</xsl:with-param>
  </xsl:call-template>

  <!-- The class member field -->
  <xsl:call-template name="data_member">
    <xsl:with-param name="name">callback_</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">
      <xsl:value-of select="concat($name, '_Receiver_Callback')"/>
    </xsl:with-param>
  </xsl:call-template>

  <!-- The closing of class -->
  <xsl:text>
};// class: </xsl:text>
<xsl:value-of select="concat($name, '_Receiver_StreamEndPoint')"/>
<xsl:text>

</xsl:text>



  <!-- ======================================= -->
  <!-- The Distributor_Sender_Callback class -->
  <!--                                         -->
  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'_Sender_StreamEndPoint class: Defines a sender stream endpoint.')"/>
    </xsl:with-param>
  </xsl:call-template>

  <!-- The class declaration -->
  <xsl:call-template name="class">
    <xsl:with-param name="name"><xsl:value-of select="concat($name,'_Sender_StreamEndPoint')"/></xsl:with-param>
    <xsl:with-param name="parents">{public TAO_Client_StreamEndPoint}</xsl:with-param>
  </xsl:call-template>

  <!-- The class method -->
  <xsl:call-template name="method">
    <xsl:with-param name="name">get_callback</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{const char *flowname}{TAO_AV_Callback *&amp;callback}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">set_protocol_object</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{const char *flowname}{TAO_AV_Protocol_Object *object}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">modify_QoS</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">CORBA::Boolean</xsl:with-param>
    <xsl:with-param name="params">{AVStreams::streamQoS &amp;new_qos}{const
    AVStreams::flowSpec &amp;the_flows}{CORBA::Environment &amp;ACE_TRY_ENV) ACE_THROW_SPEC(( CORBA::SystemException, AVStreams::noSuchFlow, AVStreams::QoSRequestFailed )}</xsl:with-param>
  </xsl:call-template>

  <!-- The class member field -->
  <xsl:call-template name="data_member">
    <xsl:with-param name="name">callback_</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">TAO_AV_Callback</xsl:with-param>
  </xsl:call-template>

  <!-- The closing of class -->
  <xsl:text>
};// class: </xsl:text>
<xsl:value-of select="concat($name, '_Sender_StreamEndPoint')"/>
<xsl:text>

</xsl:text>

  <!-- =============================== -->
  <!--  The other global staff: just   -->
  <!--  treat it as plain text         -->
  <!-- =============================== -->
  <xsl:text>typedef TAO_AV_Endpoint_Reactive_Strategy_A
          &lt;</xsl:text><xsl:value-of select="concat($name, '_Sender_StreamEndPoint')"/><xsl:text>,
           TAO_VDev,
           AV_Null_MediaCtrl&gt;
        SENDER_ENDPOINT_STRATEGY;
  </xsl:text>

  <xsl:text>typedef TAO_AV_Endpoint_Reactive_Strategy_B
          &lt;</xsl:text><xsl:value-of select="concat($name, '_Receiver_StreamEndPoint')"/><xsl:text>,
           TAO_VDev,
           AV_Null_MediaCtrl&gt;
        RECEIVER_ENDPOINT_STRATEGY;
  </xsl:text>


  <!-- =============================== -->
  <!-- The Distributor           class -->
  <!--                                 -->
  <xsl:value-of select="$empty_line"/>

  <!-- The comment -->
  <xsl:call-template name="comment">
    <xsl:with-param name="value">
       <xsl:value-of select="concat($name,' class')"/>
    </xsl:with-param>
  </xsl:call-template>

  <xsl:value-of select="$empty_line"/>
  <!-- The local include -->
  
  <xsl:value-of select="$empty_line"/>
  <!-- The class declaration -->
  <xsl:call-template name="class">
    <xsl:with-param name="name"><xsl:value-of select="$name"/></xsl:with-param>
  </xsl:call-template>

  <!-- The class method -->
  <xsl:call-template name="method">
    <xsl:with-param name="name"><xsl:value-of select="$name"/></xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name"><xsl:value-of select="concat('~', $name)"/></xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">init</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{int argc}{char** argv}{CORBA::Environment&amp;}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">done</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{void}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">done</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
    <xsl:with-param name="params">{int}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">connection_manager</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">Connection_Manager &amp;</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="method">
    <xsl:with-param name="name">fill_qos</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
    <xsl:with-param name="params">{AVStreams::streamQoS&amp; the_qos}</xsl:with-param>
  </xsl:call-template>

  <!-- The class member field -->
  <xsl:call-template name="data_member">
    <xsl:with-param name="name">connection_manager_</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">Connection_Manager</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">debug_level_</xsl:with-param>
    <xsl:with-param name="visibility">public</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">sender_endpoint_strategy_</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">SENDER_ENDPOINT_STRATEGY</xsl:with-param>
  </xsl:call-template>
  <xsl:call-template name="data_member">
    <xsl:with-param name="name">receiver_endpoint_strategy_</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">RECEIVER_ENDPOINT_STRATEGY</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name"><xsl:value-of select="concat($name_all_small, '_receiver_mmdevice_')"/></xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">TAO_MMDevice*</xsl:with-param>
  </xsl:call-template>
  <xsl:call-template name="data_member">
    <xsl:with-param name="name"><xsl:value-of select="concat($name_all_small, '_sender_mmdevice_')"/></xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">TAO_MMDevice*</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">sender_name_</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">ACE_CString</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name_all_small, '_name_')"/>
    </xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">ACE_CString</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">done_</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="data_member">
    <xsl:with-param name="name">use_qos_stream_</xsl:with-param>
    <xsl:with-param name="visibility">protected</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
  </xsl:call-template>

  <!-- The closing of class -->
  <xsl:text>
};// class: </xsl:text><xsl:value-of select="$name"/><xsl:text>

</xsl:text>

  <!-- ===================================== -->
  <!-- The Singleton typedef for Distributor -->
  <!-- ===================================== -->

  <xsl:text>typedef ACE_Singleton&lt;</xsl:text><xsl:value-of
  select="$name"/><xsl:text>, ACE_Null_Mutex&gt; </xsl:text><xsl:value-of select="$name_all_capital"/><xsl:text>;
</xsl:text>
#define DEBUG_LEVEL (DISTRIBUTOR::instance()->debug_level_)

  <xsl:value-of select="$empty_line"/>
<xsl:text>
#endif // _</xsl:text><xsl:value-of select="$name_all_capital"/><xsl:text>_H_
</xsl:text>



  </content></file>

</xsl:template>

<!-- ================================== -->
<!--  End of The Distributor_H template -->
<!-- ================================== -->


<!-- ================================= -->
<!--      The Distributor_CPP template -->
<!-- ================================= -->

<xsl:template name="Distributor_CPP">
  <xsl:param name="name"/>

  <!-- Capitalized name -->
  <xsl:variable name="name_all_capital">
    <xsl:value-of select="translate($name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/>
  </xsl:variable>
  <xsl:variable name="name_all_small">
    <xsl:value-of
    select="translate($name,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
  </xsl:variable>

  <xsl:value-of select="$empty_line"/>
  <xsl:value-of select="$empty_line"/>

  <file><name>
     <xsl:value-of select="$dir_avstreams"/><xsl:value-of select="$name"/>.cpp</name><content>

  <xsl:value-of select="$file_header"/>

  <xsl:call-template name="comment">
    <xsl:with-param name="value">
      <xsl:value-of select="concat($name,'.cpp')"/>
    </xsl:with-param>
  </xsl:call-template>


  <!-- The system include -->
  <xsl:call-template name="use">
    <xsl:with-param name="files">{ace/Get_Opt.h}{orbsvcs/AV/Protocol_Factory.h}</xsl:with-param>
  </xsl:call-template>

  <xsl:call-template name="dependency">
    <xsl:with-param name="files">
      <xsl:value-of select="concat('{',$name,'.h}')"/></xsl:with-param>
  </xsl:call-template>

  <xsl:value-of select="$empty_line"/>
  <!-- The implementation of related class method -->
  <!-- get_callback() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '_Sender_StreamEndPoint::get_callback')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{const char *flowname}{TAO_AV_Callback *&amp;callback}</xsl:with-param>
    <xsl:with-param name="content">
{
  ACE_DECLARE_NEW_CORBA_ENV;
  // Create and return the sender application callback to AVStreams
  // for further upcalls.

  int retval = 0;

  if (DEBUG_LEVEL > 0)
    ACE_DEBUG((LM_DEBUG,
               "<xsl:value-of select="$name"/>_Sender_StreamEndPoint::get_callback(%s,*)\n"
               "<xsl:value-of select="$name"/> callback created\n",
               flowname));

  callback = &amp;this->callback_;

  //<xsl:value-of select="$name_all_capital"/>::instance ()->connection_manager ().connect_negotiator(this, flowname);

  return retval;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of get_callback() -->


  <!-- set_protocol_object() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '_Sender_StreamEndPoint::set_protocol_object')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{const char *flowname}{TAO_AV_Protocol_Object *object}</xsl:with-param>
    <xsl:with-param name="content">
{
  if (DEBUG_LEVEL > 0)
    ACE_DEBUG((LM_DEBUG,
               "<xsl:value-of select="$name"/>_Sender_StreamEndPoint::"
               "set_protocol_object(%s,*)\n",
               flowname));

  // Hint (based on application function as of 15 May 2001):
  // The flowname is composed of the distributor and receiver components,
  // i.e. if the distributor's name is X and the receiver Y then the
  // flowname is X_Y.

  // Insert a Frame_Filter object on top of the passed in
  // TAO_AV_Protocol_Object, and put the Frame_Filter into the
  // list of protocol objects to send to.

  // Frame_Filter *object_wrapper = new Frame_Filter(flowname, object);
  // JPL - Inserting the delegate wrapper in the way
  //FrameFilterWrapper *object_wrapper = new FrameFilterWrapper(flowname,
  //                                                            object,
  //                                                            DEBUG_LEVEL);
  //object_wrapper->_quo_initialize(TAO_AV_CORE::instance()->orb());

  Connection_Manager &amp;connection_manager =
    <xsl:value-of select="$name_all_capital"/>::instance ()->connection_manager ();

  // Add to the map of protocol objects.
  //connection_manager.protocol_objects ().bind (flowname,
  //                                             object_wrapper);

  // Store the related streamctrl.
  connection_manager.add_streamctrl (flowname,
                                     this);

  AVStreams::StreamCtrl_var streamctrl;

  //if(connection_manager.streamctrls().find(flowname, streamctrl) == 0) {
  //  object_wrapper->set_streamctrl(streamctrl.in());
  //}

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of set_protocol_0bject -->  

  <!-- modify_Qos -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '_Sender_StreamEndPoint::modify_QoS')"/></xsl:with-param>
    <xsl:with-param name="type">CORBA::Boolean</xsl:with-param>
    <xsl:with-param name="params">{AVStreams::streamQoS &amp;new_qos}{const
    AVStreams::flowSpec &amp;the_flows}{CORBA::Environment &amp;ACE_TRY_ENV) ACE_THROW_SPEC(( CORBA::SystemException, AVStreams::noSuchFlow, AVStreams::QoSRequestFailed )}</xsl:with-param>
    <xsl:with-param name="content">
{
  ACE_DEBUG ((LM_DEBUG,
              "Sender_StreamEndPoint::modify_QoS\n"));
     
  int result =  this->change_qos (new_qos, the_flows, ACE_TRY_ENV);
  ACE_CHECK_RETURN (0);
         
  if (result != 0)
    return 0;
     
  return 1;
}    
    </xsl:with-param>
  </xsl:call-template>

  <!-- get_callback() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '_Receiver_StreamEndPoint::get_callback')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{const char *flowname}{TAO_AV_Callback *&amp;callback}</xsl:with-param>
    <xsl:with-param name="content">
{
  ACE_DECLARE_NEW_CORBA_ENV;

  // Create and return the receiver application callback to AVStreams
  // for further upcalls.
  if (DEBUG_LEVEL > 0)
    ACE_DEBUG((LM_DEBUG,
               "<xsl:value-of select="$name"/>_Receiver_StreamEndPoint::get_callback(%s,*)"
               "<xsl:value-of select="$name"/> callback created\n",
               flowname));
  //  callback = &amp;this->callback_;  // return value via out-parameter

  //  return 0;

  int retval = 0;

  callback = &amp;this->callback_;

  //<xsl:value-of select="$name_all_capital"/>::instance ()->connection_manager ().connect_negotiator(this, flowname);

  return retval;

}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of get_callback() -->  

  <!-- Distributor_Receiver_Callback() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '_Receiver_Callback::', $name,'_Receiver_Callback')"/></xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of Distributor_Receiver_Callback() -->

  <!-- ~Distributor_Receiver_Callback() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '_Receiver_Callback::~', $name,'_Receiver_Callback')"/></xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="content">
{
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of ~Distributor_Receiver_Callback() -->



  <!-- handle_destroy() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '_Receiver_Callback::handle_destroy')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
  // Called when the sender requests the stream to be shutdown.
  ACE_TRY_NEW_ENV
    {
      ACE_DEBUG ((LM_DEBUG,
                  "<xsl:value-of select="$name"/>_Receiver_Callback::end_stream\n"));
      
      <xsl:value-of select="$name_all_capital"/>::instance ()->connection_manager ().destroy (ACE_TRY_ENV);
      ACE_TRY_CHECK;
      
      // We can close down now.
      <xsl:value-of select="$name_all_capital"/>::instance ()->done (1);
    }
  ACE_CATCHANY
    {
      ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,
                           "<xsl:value-of select="$name"/>_Receiver_Callback::handle_destroy Failed\n");
      return -1;
    }
  ACE_CATCHALL
    {
      ACE_DEBUG((LM_ERROR, "%N, %l Unknown Exception caught\n"));
    } 
  ACE_ENDTRY;

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of handle_destroy() -->

  <!-- Distributor() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::', $name)"/></xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="init">
      <xsl:value-of select="concat('{', 'sender_name_(', '&quot;', 'sender',
      '&quot;', ')', '}{', $name_all_small, '_name_(', '&quot;')"/><xsl:value-of
      select="$name_all_small"/><xsl:value-of select="concat('&quot;', ')}', '{use_qos_stream_(0)}')"/>    </xsl:with-param>
    <xsl:with-param name="content">
{
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of Distributor() -->

  <!-- ~Distributor() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::~', $name)"/></xsl:with-param>
    <xsl:with-param name="type">none</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of ~Distributor() -->

  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::connection_manager')"/></xsl:with-param>
    <xsl:with-param name="type">Connection_Manager &amp;</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
  return this->connection_manager_;
}
    </xsl:with-param>
  </xsl:call-template>


  <!-- init() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">
      <xsl:value-of select="concat($name, '::init')"/></xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{int argc}{char**
    argv}{CORBA::Environment&amp; ACE_TRY_ENV}</xsl:with-param>
    <xsl:with-param name="content">
{
  // Initialize the connection class.
  int result =
    this->connection_manager_.init (TAO_AV_CORE::instance ()->orb ());
  if (result != 0)
    return result;

  // Initialize the endpoint strategy with the orb and poa.
  result =
    this->sender_endpoint_strategy_.init (TAO_AV_CORE::instance ()->orb (),
                                          TAO_AV_CORE::instance ()->poa ());
  if (result != 0)
    return result;

  result =
    this->receiver_endpoint_strategy_.init (TAO_AV_CORE::instance ()->orb (),
                                            TAO_AV_CORE::instance ()->poa ());
  if (result != 0)
    return result;

  // Parse the command line arguments
  //result =
  //  this->parse_args (argc,
  //                    argv);
  //if (result != 0)
  //  return result;

  u_long priority_mask = 0;

  if(DEBUG_LEVEL > 0) {
    ACE_SET_BITS(priority_mask,  LM_ERROR | LM_WARNING | LM_INFO | LM_DEBUG);
  }
  else {
    ACE_SET_BITS(priority_mask,  LM_ERROR | LM_WARNING );
  }

  ACE_LOG_MSG->priority_mask (priority_mask, ACE_Log_Msg::PROCESS);

  ACE_NEW_RETURN (this-><xsl:value-of select="$name_all_small"/>_sender_mmdevice_,
                  TAO_MMDevice (&amp;this->sender_endpoint_strategy_),
                  -1);

  // Servant Reference Counting to manage lifetime
  PortableServer::ServantBase_var safe_sender_mmdevice =
    this-><xsl:value-of select="$name_all_small"/>_sender_mmdevice_;

  AVStreams::MMDevice_var <xsl:value-of select="$name_all_small"/>_sender_mmdevice =
    this-><xsl:value-of select="$name_all_small"/>_sender_mmdevice_->_this (ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  ACE_NEW_RETURN (this-><xsl:value-of select="$name_all_small"/>_receiver_mmdevice_,
                  TAO_MMDevice (&amp;this->receiver_endpoint_strategy_),
                  -1);

  // Servant Reference Counting to manage lifetime
  PortableServer::ServantBase_var safe_receiver_mmdevice =
    this-><xsl:value-of select="$name_all_small"/>_receiver_mmdevice_;

  AVStreams::MMDevice_var <xsl:value-of select="$name_all_small"/>_receiver_mmdevice =
    this-><xsl:value-of select="$name_all_small"/>_receiver_mmdevice_->_this (ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);


  // Bind to receivers.
  this->connection_manager_.bind_to_receivers (this-><xsl:value-of select="$name_all_small"/>_name_, <xsl:value-of select="$name_all_small"/>_sender_mmdevice.in (), ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  AVStreams::streamQoS the_qos;
  this->fill_qos( the_qos );
  // Connect to receivers
  this->connection_manager_.connect_to_receivers (<xsl:value-of select="$name_all_small"/>_sender_mmdevice.in(), the_qos, use_qos_stream_, ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  // Bind to sender.
  this->connection_manager_.bind_to_sender (this->sender_name_,
                                            this-><xsl:value-of select="$name_all_small"/>_name_,
                                            <xsl:value-of select="$name_all_small"/>_receiver_mmdevice.in (), ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  // Connect to sender.
  this->connection_manager_.connect_to_sender (the_qos, use_qos_stream_, ACE_TRY_ENV);
  ACE_CHECK_RETURN (-1);

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of init() -->

  <!-- fill_qos() -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name"><xsl:value-of select="concat($name,'::fill_qos')"/></xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
    <xsl:with-param name="params">{AVStreams::streamQoS&amp; qos}</xsl:with-param>
    <xsl:with-param name="content">
{
#if defined(RESERVATION_CONTROL)

  // When Reservation Control is in place, the QoS should be
  // controlled externally, so don't set it here.

  qos.length(0);

#else

  CORBA::ULong bandwidth =      1000000/8;
  CORBA::ULong peak_bandwidth = 1100000/8;

  qos.length (1);
  qos [0].QoSType =  CORBA::string_dup ("Data_Receiver");
  
  qos [0].QoSParams.length (10);
  
  qos [0].QoSParams [0].property_name = CORBA::string_dup ("Service_Type");
  qos [0].QoSParams [0].property_value &lt;&lt;= (CORBA::Short) ACE_SERVICETYPE_CONTROLLEDLOAD;
  
  qos [0].QoSParams [1].property_name = CORBA::string_dup ("Token_Rate");
  qos [0].QoSParams [1].property_value &lt;&lt;= (CORBA::ULong) bandwidth ;
  
  qos [0].QoSParams [2].property_name = CORBA::string_dup ("Token_Bucket_Size");  qos [0].QoSParams [2].property_value &lt;&lt;= (CORBA::ULong) 5000;
  
  qos [0].QoSParams [3].property_name = CORBA::string_dup ("Peak_Bandwidth");
  qos [0].QoSParams [3].property_value &lt;&lt;= (CORBA::ULong) peak_bandwidth;
  
  qos [0].QoSParams [4].property_name = CORBA::string_dup ("Latency");
  qos [0].QoSParams [4].property_value &lt;&lt;= (CORBA::ULong) 0;
  
  qos [0].QoSParams [5].property_name = CORBA::string_dup ("Delay_Variation");
  qos [0].QoSParams [5].property_value &lt;&lt;= (CORBA::ULong) 0;
  
  qos [0].QoSParams [6].property_name = CORBA::string_dup ("Max_SDU_Size");
  qos [0].QoSParams [6].property_value &lt;&lt;= (CORBA::ULong) 65535;
  
  qos [0].QoSParams [7].property_name = CORBA::string_dup ("Minimum_Policed_Size");
  qos [0].QoSParams [7].property_value &lt;&lt;= (CORBA::ULong) 368;
  
  qos [0].QoSParams [8].property_name = CORBA::string_dup ("TTL");
  qos [0].QoSParams [8].property_value &lt;&lt;= (CORBA::ULong) 25;
  
  qos [0].QoSParams [9].property_name = CORBA::string_dup ("Priority");
  qos [0].QoSParams [9].property_value &lt;&lt;= (CORBA::ULong) 1;

#endif  
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of fill_qos() -->

  <xsl:call-template name="method_imp">
    <xsl:with-param name="name"><xsl:value-of select="$name"/>::done</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{none}</xsl:with-param>
    <xsl:with-param name="content">
{
  return this->done_;
}
    </xsl:with-param>
  </xsl:call-template>


  <xsl:call-template name="method_imp">
    <xsl:with-param name="name"><xsl:value-of select="$name"/>::done</xsl:with-param>
    <xsl:with-param name="type">void</xsl:with-param>
    <xsl:with-param name="params">{int done}</xsl:with-param>
    <xsl:with-param name="content">
{
  this->done_ = done;
}
    </xsl:with-param>
  </xsl:call-template>


  <!-- The main -->
  <xsl:call-template name="method_imp">
    <xsl:with-param name="name">main</xsl:with-param>
    <xsl:with-param name="type">int</xsl:with-param>
    <xsl:with-param name="params">{int argc, char **argv}</xsl:with-param>
    <xsl:with-param name="content">
{
  //distributor_pid_ = (CORBA::Long)ACE_OS::getpid();
  //process_name_ = ACE::basename(argv[0]);

  ACE_DECLARE_NEW_CORBA_ENV;
  ACE_TRY
    {
      // Initialize the ORB first.
      CORBA::ORB_var orb =
        CORBA::ORB_init (argc,
                         argv,
                         0,
                         ACE_TRY_ENV);
      ACE_TRY_CHECK;

      CORBA::Object_var obj
        = orb->resolve_initial_references ("RootPOA",
                                           ACE_TRY_ENV);
      ACE_TRY_CHECK;

      // Get the POA_var object from Object_var.
      PortableServer::POA_var root_poa =
        PortableServer::POA::_narrow (obj.in (),
                                      ACE_TRY_ENV);
      ACE_TRY_CHECK;

      PortableServer::POAManager_var mgr
        = root_poa->the_POAManager (ACE_TRY_ENV);
      ACE_TRY_CHECK;

      mgr->activate (ACE_TRY_ENV);
      ACE_TRY_CHECK;

      // Initialize the AVStreams components.
      TAO_AV_CORE::instance ()->init (orb.in (),
                                      root_poa.in (),
                                      ACE_TRY_ENV);
      ACE_TRY_CHECK;

      // Initialize the Distributor
      int result =
        <xsl:value-of select="$name_all_capital"/>::instance ()->init (argc,
                                        argv,
                                        ACE_TRY_ENV);
      ACE_TRY_CHECK;

      if (result != 0)
        return result;

      while (!<xsl:value-of select="$name_all_capital"/>::instance ()->done ())
        {
          orb->perform_work (ACE_TRY_ENV);
          ACE_TRY_CHECK;
        }

      // Hack for now....
      ACE_OS::sleep (1);
    }
  ACE_CATCHANY
    {
      ACE_PRINT_EXCEPTION (ACE_ANY_EXCEPTION,"main");
      return -1;
    }
  ACE_ENDTRY;
  ACE_CHECK_RETURN (-1);

  return 0;
}
    </xsl:with-param>
  </xsl:call-template>
  <!-- End of main() -->


  <!-- The ending declaration -->
#if defined (ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION)
template class ACE_Singleton &lt;<xsl:value-of select="$name"/>,ACE_Null_Mutex&gt;;
template class TAO_AV_Endpoint_Reactive_Strategy_A&lt;<xsl:value-of select="$name"/>_Sender_StreamEndPoint,   TAO_VDev, AV_Null_MediaCtrl&gt;;
template class TAO_AV_Endpoint_Reactive_Strategy  &lt;<xsl:value-of select="$name"/>_Sender_StreamEndPoint,   TAO_VDev, AV_Null_MediaCtrl&gt;;
template class TAO_AV_Endpoint_Reactive_Strategy_B&lt;<xsl:value-of select="$name"/>_Receiver_StreamEndPoint, TAO_VDev, AV_Null_MediaCtrl&gt;;
template class TAO_AV_Endpoint_Reactive_Strategy  &lt;<xsl:value-of select="$name"/>_Receiver_StreamEndPoint, TAO_VDev, AV_Null_MediaCtrl&gt;;
//template class NamingHelper&lt;UAVCallbacks::Sender_Control_Callback&gt;;
#elif defined (ACE_HAS_TEMPLATE_INSTANTIATION_PRAGMA)
#pragma instantiate ACE_Singleton &lt;<xsl:value-of select="$name"/>,ACE_Null_Mutex&gt;
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy_A&lt;<xsl:value-of select="$name"/>_Sender_StreamEndPoint,   TAO_VDev, AV_Null_MediaCtrl&gt;
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy  &lt;<xsl:value-of select="$name"/>_Sender_StreamEndPoint,   TAO_VDev, AV_Null_MediaCtrl&gt;
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy_B&lt;<xsl:value-of select="$name"/>_Receiver_StreamEndPoint, TAO_VDev, AV_Null_MediaCtrl&gt;
#pragma instantiate TAO_AV_Endpoint_Reactive_Strategy  &lt;<xsl:value-of select="$name"/>_Receiver_StreamEndPoint, TAO_VDev, AV_Null_MediaCtrl&gt;
#pragma instantiate NamingHelper&lt;UAVCallbacks::Sender_Control_Callback&gt;;
#endif /* ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION */



    </content></file> 
  <!--
  <xsl:call-template name="output_file_close_tag"/>
  -->

</xsl:template>
<!-- ================================= -->
<!--  End of The Distributor_CPP template   -->
<!-- ================================= -->


  



</xsl:stylesheet>
