<?xml version="1.0" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="xml"/>

<!-- this is a mapping of the infopipe types -->
<!-- <xsl:variable name="maptables" select="document('file:///net/hp47/infosphere/isg/zorn/isg/templates/ECho2/ECho2mapTables.xml')/mapTables"/> -->
<xsl:variable name="maptables" select="document('ECho2mapTables.xml')/mapTables"/> 

<xsl:template name="allHeader">
<xsl:for-each select="/xip/composedPipe">
<file>
<name><thisPipeName><xsl:value-of select="@name"/></thisPipeName>/allNodes.h</name>
<content>
// &lt;block name="composedPipe_<xsl:value-of select="@name"/>"&gt;
#ifndef	INFOPIPEALLNODESSHARE
#define	INFOPIPEALLNODESSHARE
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;string.h&gt;
#include &lt;unistd.h&gt;
#include &lt;cm.h&gt;
#include &lt;io.h&gt;
#include &lt;echo.h&gt;
#include &lt;gen_thread.h&gt;


<xsl:for-each select="//datatypes/datatype">
// &lt;block name="datatype_<xsl:value-of select="@name"/>"&gt;
typedef struct <xsl:value-of select="@name"/>StructDef
{
  <!-- here is where we describe for a normal arg -->
  <xsl:for-each select="arg"> <xsl:variable name="this" select="."/> <xsl:value-of select="$maptables/mapTable[@to='C']/mapping[@from=$this/@type]/@to"/><xsl:text> </xsl:text> <!--<xsl:call-template name="doMapping"><xsl:with-param name="mapTo" select="'C'"/><xsl:with-param name="from" select="@type"/></xsl:call-template>--> <xsl:value-of select="@name"/>;
  </xsl:for-each>
  <!-- here is where we describe for an array arg -->
  <xsl:for-each select="arrayArg"> <xsl:variable name="this" select="."/> <xsl:value-of select="$maptables/mapTable[@to='C']/mapping[@from=$this/@type]/@to"/><xsl:text> </xsl:text> <xsl:choose><xsl:when test="number(@size)"><xsl:value-of select="@name"/>[<xsl:value-of select="@size"/>]</xsl:when><xsl:otherwise> *<xsl:value-of select="@name"/></xsl:otherwise></xsl:choose>;
  int <xsl:value-of select="@name"/>Size; // = <xsl:value-of select="@size"/>;
  </xsl:for-each>
  <!-- here is where we describe for an array arg -->
<!--  <xsl:for-each select="arrayArg"> <xsl:variable name="this" select="."/> <xsl:value-of select="$maptables/mapTable[@to='C']/mapping[@from=$this/@type]/@to"/><xsl:text> </xsl:text> <xsl:value-of select="@name"/>[<xsl:value-of select="@size"/>];
  int <xsl:value-of select="@name"/>Size;// = <xsl:value-of select="@size"/>;
  </xsl:for-each> -->
  } <xsl:value-of select="@name"/>Struct, * <xsl:value-of select="@name"/>Struct_ptr;
// &lt;/block&gt;
</xsl:for-each>

#endif //	INFOPIPEALLNODESSHARE
// &lt;/block&gt;
</content> <xsl:text>
</xsl:text>
</file> <xsl:text>
</xsl:text>
</xsl:for-each>
</xsl:template>
</xsl:stylesheet>
