<?xml version="1.0" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"> 

<xsl:output method="xml"/>

<xsl:include href="javaDatatype.xsl"/>
<xsl:include href="javaSocket.xsl"/>

<xsl:template match="/">
<files>
  <xsl:call-template name="java_datatype">
    <xsl:with-param name="datatype" select="xip/datatypes/datatype"/>
  </xsl:call-template>
  <xsl:call-template name="java_pipe">
    <xsl:with-param name="pipe" select="xip/composedPipe/declarations/pipe"/>
  </xsl:call-template>
  <xsl:call-template name="javaSocketClasses"/>
</files>
</xsl:template>

<xsl:template name="java_pipe">
  <xsl:param name="pipe"/>
  <xsl:for-each select="$pipe">
<xsl:variable name="pipe_name" select="@name"/>
<xsl:variable name="class_name" select="@class"/>
<xsl:variable name="class_pipe" select="/xip/pipes/pipe[@name=$class_name]"/>
<xsl:variable name="connection" select="../../connections/connection"/>
<file>
<name><xsl:value-of select="@name"/>Exception.java</name>
<content>
public class <xsl:value-of select="@name"/>Exception extends Exception {

    <xsl:value-of select="@name"/>Exception(String msg) {
        super("<xsl:value-of select="@name"/>Exception: " + msg);
    }
}
</content>
</file>
<file>
<name><xsl:value-of select="@name"/>.java</name>
<content>
/* &lt;block name="pipe_<xsl:value-of select="@name"/>"&gt; */
/* 
   This file is generated by Infopipe Stub Generater 
   using java socket template ver. 0.2 created by Younggyun Koh 
*/

import java.net.*;
import java.util.*;
import java.io.*;

public class <xsl:value-of select="@name"/> {

	private <xsl:value-of select="@name"/>Middle middle = null;

	/* Input arguments */
	<xsl:for-each select="$class_pipe/inport">private InfopipeDataType_<xsl:value-of select="@type"/> in_<xsl:value-of select="@name"/> = new InfopipeDataType_<xsl:value-of select="@type"/>();
	</xsl:for-each>
	/* Output arguments */
	<xsl:for-each select="$class_pipe/outport">private InfopipeDataType_<xsl:value-of select="@type"/> out_<xsl:value-of select="@name"/> = new InfopipeDataType_<xsl:value-of select="@type"/>();
	</xsl:for-each>

	public static void main(String[] args) throws <xsl:value-of select="@name"/>Exception {

		/* create new instance of <xsl:value-of select="@name"/> */
		<xsl:value-of select="@name"/> thisPipe = new <xsl:value-of select="@name"/>();

		thisPipe.run();
	}

	public void run() throws <xsl:value-of select="@name"/>Exception {

		/* input stubs */
		InfopipeSocketServerStub <xsl:value-of select="@name"/>InputStub = new InfopipeSocketServerStub(5353, "<xsl:value-of select="@name"/>InputStub");
		
		/* output stubs */
		<xsl:for-each select="$class_pipe/outport"><xsl:variable name="port_name" select="@name"/><xsl:variable name="this_connection" select="$connection[from/@pipe=$pipe_name and from/@port=$port_name]"/>
		InfopipeSocketClientStub out_<xsl:value-of select="@name"/>_stub = new InfopipeSocketClientStub("<xsl:value-of select="concat($this_connection/to/@pipe, '/', $this_connection/to/@port)"/>", "out_<xsl:value-of select="@name"/>_stub");
		</xsl:for-each>

		while(true) {
			try {
				<xsl:for-each select="$class_pipe/inport">in_<xsl:value-of select="@name"/>.parseXML(<xsl:value-of select="../@name"/>InputStub.getIn());
				</xsl:for-each>
			} catch (Exception e) {
				e.printStackTrace();
				System.out.println(e.getMessage());
				System.exit(-1);
			}

			//System.out.println("<xsl:value-of select="@name"/>: got data");
			<xsl:for-each select="$class_pipe/inport">//System.out.println(in_<xsl:value-of select="@name"/>.formatToXML());
			</xsl:for-each>

			middle.call(
				/* Input arguments */
				<xsl:for-each select="$class_pipe/inport">in_<xsl:value-of select="@name"/>,
				</xsl:for-each>
				/* Output arguments */
				<xsl:for-each select="$class_pipe/outport">out_<xsl:value-of select="@name"/>,
				</xsl:for-each>
				"<xsl:value-of select="@name"/>");

			try {
				<xsl:for-each select="$class_pipe/outport">out_<xsl:value-of select="@name"/>.formatToXML(<xsl:value-of select="../@name"/>OutputStub.getOut());
				</xsl:for-each>
			} catch (Exception e) {
				System.out.println(e.getMessage());
				System.exit(-1);
			}
		}

	}

	public <xsl:value-of select="@name"/>() {

		/* JAVA TEMPLATE! should change to node later */ 
		middle = new <xsl:value-of select="@name"/>Middle();
	}
}
/* &lt;/block&gt; */
</content>
</file>
<file>
<name><xsl:value-of select="@name"/>Middle.java</name>
<content>
/* &lt;block name="pipe_<xsl:value-of select="@name"/>"&gt; */
/* 
   This file is generated by Infopipe Stub Generater 
   using java socket template ver. 0.2 created by Younggyun Koh 
*/

import java.net.*;
import java.util.*;
import java.io.*;

/* Add user importings here */


/* End of user importings */

public class <xsl:value-of select="@name"/>Middle {
	
	public <xsl:value-of select="@name"/>Middle() {
		/* Add user constructor code here */

		/* End of user constructor code */
	}

	public void call(

		/* input arguments */
		<xsl:for-each select="$class_pipe/inport">InfopipeDataType_<xsl:value-of select="@type"/> in_<xsl:value-of select="@name"/>,
		</xsl:for-each>
		/* output arguments */
		<xsl:for-each select="$class_pipe/outport">InfopipeDataType_<xsl:value-of select="@type"/> out_<xsl:value-of select="@name"/>,
		</xsl:for-each>
		String dummy
	) throws <xsl:value-of select="@name"/>Exception {
		/* Add user code here */


		/* End of user code */
	}
}
/* &lt;/block&gt; */
</content>
</file>
  </xsl:for-each>
</xsl:template>

</xsl:stylesheet>

