/*
 * @author Wenchang
 * @time 02/26/2002
 */
#ifndef _VIDEO_FMT_HH
#define _VIDEO_FMT_HH


#define VID_NONE           0
#define VID_GREY           1
#define VID_RGB15_LE       2  /* 15 bpp little endian */
#define VID_RGB16_LE       3  /* 16 bpp little endian */
#define VID_RGB15_BE       4  /* 15 bpp big endian */
#define VID_RGB16_BE       5  /* 16 bpp big endian */
#define VID_BGR24          6  /* bgrbgrbgrbgr (LE) */
#define VID_BGR32          7  /* bgr-bgr-bgr- (LE) */
#define VID_RGB24          8  /* rgbrgbrgbrgb (BE) */
#define VID_RGB32          9  /* -rgb-rgb-rgb (BE) */
#define VID_LUT2          10  /* lookup-table 2 byte depth */
#define VID_LUT4          11  /* lookup-table 4 byte depth */
#define VID_YUV422        12  /* YUV 4:2:2 */
#define VID_YUV422P       13  /* YUV 4:2:2 (planar) */
#define VID_YUV420P       14  /* YUV 4:2:0 (planar) */
#define VID_MJPEG         15  /* MJPEG (AVI) */
#define VID_JPEG          16  /* JPEG (JFIF) */
#define NUM_VID_FMT       17


#endif
