/* -*-C-*-
*******************************************************************************
*
* File:         list.h
* RCS:          $Id: list.h,v 1.1.1.1 2001/07/03 20:30:44 fabianb Exp $
* Description:  Basic list lib
* Author:       Fabian Ernesto Bustamante
*               Systems Research Group
*               College of Computing
*               Georgia Institute of Technology
* Created:      Wed May 09, 2001 at 15:55:32
* Modified:     Wed May 09, 2001 at 15:55:40 fabianb@cc.gatech.edu
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
* (C) Copyright 2001, Georgia Institute of Technology, all rights reserved.
*
*******************************************************************************
*/


#ifndef LIST_INCLUDED
#define LIST_INCLUDED 1

typedef struct List_T *List_T;

extern List_T List_new           (void);
extern List_T List_list          (void *x, ...);
extern void*  List_delete        (List_T list);
extern void*  List_head          (List_T list);
extern void*  List_tail          (List_T list);
extern void*  List_next          (List_T list);
extern void*  List_previous      (List_T list);
extern void*  List_current       (List_T list);
extern int    List_length        (List_T list);
extern void*  List_search        (List_T list, void *x, 
				   int (*)(void *, void *));
extern void   List_free          (List_T list);
extern void   List_append        (List_T list, void *x);
extern void   List_beforeInsert  (List_T list, void* el);
extern void   List_orderedInsert (List_T list, void* el, 
				  int (*comp)(void *, void *));
extern List_T List_sort          (List_T list, int (*)(void*, void *));
extern void   List_map           (List_T list, void apply(void **x, void *cl), 
				  void *cl);
extern void **List_toArray       (List_T list, void *end);

#endif /* !LIST_INCLUDED */
