/* -*-C-*-
*******************************************************************************
*
* File:         pwc-ioctl.h
* RCS:          $Id: pwc-ioctl.h,v 1.1.1.1 2001/07/03 20:30:44 fabianb Exp $
* Description:  These are private ioctl() commands, specific for the Philips 
*               webcams. They contain functions not found in other webcams, 
*               and settings not specified in the Video4Linux API. 
* Author:       Fabian E. Bustamante
*               Systems Research Group
*               College of Computing
*               Georgia Institute of Technology
* Created:      Sun May 13, 2001 at 10:30:26
* Modified:     Sun May 13, 2001 at 10:31:59 fabianb@cc.gatech.edu
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
* (C) Copyright 2001, Georgia Institute of Technology, all rights reserved.
*
*******************************************************************************
*/


#ifndef PWC_IOCTL_INCLUDED
#define PWC_IOCTL_INCLUDED

/* 
 * The frame rate is encoded in the video_window.flags parameter,
 *  in the high 16 bits, since some flags are defined nowadays. The following
 *  defines provide a mask and shift to filter out this value.
 *
 */

#define PWC_FPS_SHIFT		16
#define PWC_FPS_MASK		0xFF0000
#define PWC_FPS_FRMASK		0x3F0000
#define PWC_FPS_SNAPSHOT	0x400000

 /* Restore user settings */
#define VIDIOCPWCRUSER		_IO('v', 192)
 /* Save user settings */
#define VIDIOCPWCSUSER		_IO('v', 193)
 /* Restore factory settings */
#define VIDIOCPWCFACTORY	_IO('v', 194)

 /* Set AGC (Automatic Gain Control); int < 0 = auto, 0..65535 = fixed */
#define VIDIOCPWCSETAGC		_IOW('v', 200, int)
 /* Get AGC; int < 0 = auto, >= 0 = fixed. range 0..65535 */
#define VIDIOCPWCGETAGC		_IOR('v', 200, int)


#endif /* PWC_IOCTL_INCLUDED */
