/*
 * $Id: callbacks.c,v 1.1.1.1 2003/06/11 21:16:00 wyan Exp $
 * $Revision: 1.1.1.1 $
 * $Log: callbacks.c,v $
 * Revision 1.1.1.1  2003/06/11 21:16:00  wyan
 * demoHarness
 *
 * Revision 1.9  2002/11/22 16:12:56  wyan
 *
 *  This demo puts a front end to show how GaTech Infopipe Stub Generator
 *  (ISG) works. ISG has been used in several places including the GaTech
 *  Multi-UAV demo, the Mapquest (Java socket) demo and BBN's OEP demo.
 *  More demos using ISG to expediate programming are expected in the
 *  future.
 *  The demo is fully implemented in GLib, GDK and GTK+. This latest
 *  version uses GTK+2.0.5. Since there have been significant changes
 *  from GTK+1.2 (from which the previous version was implemented), lots
 *  of modifications has been made in this update. It's not suprised you
 *  may find different function API which serves the same job or 2 different
 *  data structure of the similar data.
 *
 *  Wenchang 12/21/02
 *
 * Revision 1.5  2002/11/06 21:51:20  wyan
 * *** empty log message ***
 *
 * Revision 1.4  2002/07/12 16:56:23  wyan
 *
 * autoconf targeting for python package
 *
 * Revision 1.3  2002/07/05 20:37:38  wyan
 * *** empty log message ***
 *
 * Revision 1.2  2002/07/03 03:54:05  wyan
 * *** empty log message ***
 *
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

//#define GTK_ENABLE_BROKEN

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "const.h"
#include "dialog_show_file.h"
#include "cfg_window.h"
#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <string.h>
#include <unistd.h>
#include <stdarg.h>
#include <sys/types.h>
#include <time.h>
#include <sys/timeb.h>
#include <sys/wait.h>

#include "sipParser.h"

extern FILE* OUT;

#ifndef USE_STDOUT
extern long OS_file_pos;
#endif

#define FREE_PTR_ARRAY(array,size) \
  do {\
    int i;\
    if (NULL!=array) {\
      for (i=0;i<size;i++) \
        if (NULL!=array[i]) free(array[i]);\
      free(array);\
    }\
  } while (0)


 
void
on_isg_demo_destroy                    (GtkObject       *object,
                                        gpointer         user_data)
{
  gtk_exit(0);
}

void
on_window_main_destroy                 (GtkObject       *object,
                                        gpointer         user_data)
{
  int i,j;
  free(DEMO_SRC_FILE);
  free(XIP_FILE);
  free(GENCODE_FILE);
  free(DEMO_ISG_FILE);

#ifndef USE_STDOUT
  if (OUT!=stdout&&OUT!=stderr&&OUT!=stdin) {
    fclose(OUT);
    remove(OS_FILE_NAME);
  }
#endif

  FREE_PTR_ARRAY(SIP_dialog_window, NR_SIP_FILE);
  FREE_PTR_ARRAY(SIP_dialog_window_text, NR_SIP_FILE);
  FREE_PTR_ARRAY(XIP_dialog_window, NR_XIP_FILE);
  FREE_PTR_ARRAY(XIP_dialog_window_text, NR_XIP_FILE);

  /* Free file_text_list*/
  
  for (i=0;i<g_list_length(file_text_list);i++) {
    if (NULL != g_list_nth_data(file_text_list,i)) {
      GList* tmp = ((file_text*)g_list_nth_data(file_text_list,i))->blk_list;
      if (NULL != tmp) {
	for (j=0; j < g_list_length (tmp); j++) {
	  if (NULL != g_list_nth_data(tmp,j)) 
	    free(g_list_nth_data(tmp,j));
	}
	g_list_free(tmp);
      }
       
      free(g_list_nth_data(file_text_list,i));
    }
  }

  //for the char array in clist_cfg_path_value
  for (i = 0;i<3;i++) {
    for (j=0;j<2;j++) {
      if (NULL!=clist_cfg_path_value[i][j]) 
	free(clist_cfg_path_value[i][j]);
    }
  }

  //close the stats_input
  if (stats_input) fclose(stats_input);

  printf(" bye, bye\n");
  gtk_exit(0);
}

/*
 * Used to be used to display the relative statistics in the stats window.
 * Now only display facts -- but keep the old name.
 */
FILE* stats_input = NULL;

guint on_stat_update(gpointer data)
{
  char line[2] ;
  static int wc=0;
  int nr;
  GtkTextIter    iter1, iter2;

  if (!stats_input) {
    return TRUE;
  }

  //Get the current iterator offset
  gtk_text_buffer_get_iter_at_offset(text_stats_buf, &iter1, wc);

  if ((nr = fread(line,1,1,stats_input)) != 0 ){
    //gtk_text_insert(GTK_TEXT(text_stats),small_font,NULL,NULL,line,
    //	    nr);
    gtk_text_buffer_insert (text_stats_buf, &iter1, line, 1);
    gtk_text_buffer_get_end_iter(text_stats_buf, &iter1);
    gtk_text_view_scroll_to_iter(GTK_TEXT_VIEW(text_stats), &iter1,
  		       0,TRUE,0,0);

     wc+=nr;
     if (wc>= 3000) {
       gtk_text_buffer_get_start_iter(text_stats_buf, &iter1);
       gtk_text_buffer_get_end_iter(text_stats_buf, &iter2);
       gtk_text_buffer_delete(text_stats_buf, &iter1, &iter2);
       wc = 0;
     }
     return TRUE;
   }
   else 
     rewind(stats_input);

  return TRUE;
}

/*
void
on_clist_menu_select_row               (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_notebook_set_page(GTK_NOTEBOOK(notebook_main), row);

  //Insert the msg into the Dump page
  //Have no way trace the file pos in stdin/stdout/stderr.
#ifndef USE_STDOUT
  if ( gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook_main)) == 7 
       && OUT != stdout && OUT!= stderr && OUT!=stdin) 
    {
      int tmp;
      GdkFont* fixed_font; 
      fprintf(OUT, " Dump page clicked\n");
      if ((fixed_font = gdk_font_load (C_SRC_FONT)) == NULL) {
	fprintf(stdout, "font NOT found\n");
      }
      
      tmp = ftell(OUT)-OS_file_pos;//actually I mean step
      fseek(OUT, -tmp, SEEK_CUR);
      gtk_text_freeze(GTK_TEXT(text_dump));      
      insert_file(text_dump, fixed_font, OUT);
      gtk_text_thaw(GTK_TEXT(text_dump));
      OS_file_pos += tmp;
    }
	
#endif
}
*/


/* Flags. 
 * If the `=>XIP' button or the `gen code' button is clicked
 */
gboolean SIP_XIP_windows_popped = FALSE;
gboolean GENCODE_windows_popped = FALSE;

/* The popup windows for SIP code*/
GtkWidget** SIP_dialog_window;
GtkWidget** SIP_dialog_window_text;//text area
GtkTextBuffer** SIP_dialog_window_text_buf;

/* The popup windows for XIP code*/
GtkWidget** XIP_dialog_window;
GtkWidget** XIP_dialog_window_text;
GtkTextBuffer** XIP_dialog_window_text_buf;

/* The popup windows for GenCode */
GtkWidget** gencode_dialog_window;
GtkWidget** gencode_dialog_window_text;
GtkTextBuffer** gencode_dialog_window_text_buf;



/* Changeable buttons in the main SIP window */
void
on_button_SIP_to_XIP_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  int i;
  char* tmp_str = NULL;
  FILE* xip_file_in;

  if (!SIP_XIP_windows_popped) {
    char str[3];
    int i;
    int x = 20; int y = 20; int step = 5; int offset =0;

    if (!SIP_file_created) {
      MSG(" [on_button_SIP_to_XIP_clicked(): windows NOT popped because XIP file has NOT created\n");
      return;
    }

    //Generate block XIP first ......and write to XIP_file
    for (i=0;i<NR_XIP_FILE;i++) {
      //Gen'd from SIP file
      if (REAL_SIP_FILE[i]) {
	tmp_str = getBlockXip(REAL_SIP_FILE[i]);
	usleep(100);
      }
      else 
	ERR(" [on_button_SIP_to_XIP_clicked(): # of SIP and XIP files unmatched !");

      if ((xip_file_in = open_file(XIP_FILE[i],"w"))==NULL) {
	ERR1(" [on_button_SIP_to_XIP_clicked(): cannot open file %s for write\n",XIP_FILE[i]);
	gtk_exit(-1);
      }
      fwrite(tmp_str, 1, strlen(tmp_str), xip_file_in);
      MSG1(" [on_button_SIP_to_XIP_clicked(): file %s is writen",XIP_FILE[i]);
      fclose(xip_file_in);
    }
    if (tmp_str) g_free(tmp_str);
    
    usleep(100);

    //Generate REAL_XIP and write to XIP_file
    //if (!strcmp(curr_demo->name, "UAV")) {
    for (i=0;i<NR_XIP_FILE;i++) {
      //Gen'd from SIP file
      if (REAL_SIP_FILE[i]) {
	tmp_str = getXip(REAL_SIP_FILE[i]);
	usleep(100);
      }
      else 
	ERR(" [on_button_SIP_to_XIP_clicked(): # of SIP and XIP files unmatched !");

      if ((xip_file_in = open_file(REAL_XIP_FILE[i],"w"))==NULL) {
	ERR1(" [on_button_SIP_to_XIP_clicked(): cannot open file %s for write\n",XIP_FILE[i]);
	gtk_exit(-1);
      }
      fwrite(tmp_str, 1, strlen(tmp_str), xip_file_in);
      MSG1(" [on_button_SIP_to_XIP_clicked(): file %s is writen",REAL_XIP_FILE[i]);
      fclose(xip_file_in);
    }
    if (tmp_str) g_free(tmp_str);
    
    usleep(100);
    //}

    XIP_file_created = TRUE;
    for (i=0;i<NR_XIP_FILE;i++) {
      if (load_one_file((text_XIP_file_buf[i]), XIP_FILE[i], "r", font_size))
	{
	update_file_text_list_file(XIP, XIP_FILE[i],
		       gtk_widget_get_name(GTK_WIDGET(text_XIP_file[i])));    
	update_file_text_list_text(text_XIP_file[i], (text_XIP_file_buf[i]),
                       gtk_widget_get_name(GTK_WIDGET(text_XIP_file[i])));
	update_file_text_list_blk_list((text_XIP_file_buf[i]),
                       gtk_widget_get_name(GTK_WIDGET(text_XIP_file[i])));
	XIP_file_created &= TRUE;
	}
      else 
	XIP_file_created &= FALSE;
    }


    SIP_dialog_window = malloc(NR_SIP_FILE * sizeof(GtkWidget*));
    SIP_dialog_window_text = malloc(NR_SIP_FILE*sizeof(GtkWidget*));
    SIP_dialog_window_text_buf = malloc(NR_SIP_FILE*sizeof(GtkTextBuffer*));
    XIP_dialog_window = malloc(NR_XIP_FILE * sizeof(GtkWidget*));
    XIP_dialog_window_text = malloc(NR_XIP_FILE*sizeof(GtkWidget*));
    XIP_dialog_window_text_buf = malloc(NR_XIP_FILE*sizeof(GtkTextBuffer*));

    for (i=0;i<NR_SIP_FILE;i++) {
      int_to_str(str,i);
      SIP_dialog_window[i] = create_dialog_show_file (SIP_FILE[i], x+offset,
				y+offset, &(SIP_dialog_window_text[i]), 
					  &(SIP_dialog_window_text_buf[i]),
		concat(concat("SIP_dialog_window_text[",str),"]")	);
      MSG2(" [on_button_SIP_to_XIP_clicked(): %s file_dialog created, text name: %s",SIP_FILE[i],gtk_widget_get_name(GTK_WIDGET(SIP_dialog_window_text[i])));
      offset += step;

      //register
      if (SIP_dialog_window[i]) {
	update_file_text_list_file(SIP,SIP_FILE[i],
	  gtk_widget_get_name(GTK_WIDGET(SIP_dialog_window_text[i])));
	  update_file_text_list_text(SIP_dialog_window_text[i],
				    (SIP_dialog_window_text_buf[i]),
		   gtk_widget_get_name(GTK_WIDGET(SIP_dialog_window_text[i])));
	  update_file_text_list_blk_list((SIP_dialog_window_text_buf[i]),
		   gtk_widget_get_name(GTK_WIDGET(SIP_dialog_window_text[i])));
      }
    }

    x = 500; y=20; offset = 0;
    for (i=0;i<NR_XIP_FILE;i++) {
      int_to_str(str,i);
      XIP_dialog_window[i] = create_dialog_show_file (XIP_FILE[i], x-offset,
				y+offset,&(XIP_dialog_window_text[i]),
					&(XIP_dialog_window_text_buf[i]),
		concat(concat("XIP_dialog_window_text[",str),"]")	);
      MSG2(" [on_button_SIP_to_XIP_clicked(): %s file_dialog created, &%p\n",XIP_FILE[i],XIP_dialog_window[i]);
      offset += step;
	
      if (XIP_dialog_window[i]) {
	  update_file_text_list_file(XIP,XIP_FILE[i],
		   gtk_widget_get_name(GTK_WIDGET(XIP_dialog_window_text[i])));
	  update_file_text_list_text(XIP_dialog_window_text[i],
				   (XIP_dialog_window_text_buf[i]),
		   gtk_widget_get_name(GTK_WIDGET(XIP_dialog_window_text[i])));
	  update_file_text_list_blk_list((XIP_dialog_window_text_buf[i]),
		   gtk_widget_get_name(GTK_WIDGET(XIP_dialog_window_text[i])));
      }
    }
    SIP_XIP_windows_popped = TRUE;
  }/*  if (SIP_XIP_windows_popped == 0) */

  //Pop up the windows
  for (i=0;i<NR_SIP_FILE;i++) {
    if (NULL != SIP_dialog_window[i]) {
      MSG1(" [on_button_SIP_to_XIP_clicked(): &%p SIP window showed",SIP_dialog_window[i]);

      gtk_widget_show(SIP_dialog_window[i]);
    }
  }
  for (i=0;i<NR_XIP_FILE;i++) {
    if (NULL != XIP_dialog_window[i]) {
      MSG1(" [on_button_SIP_to_XIP_clicked(): &%p XIP window showed\n",XIP_dialog_window[i]);

      gtk_widget_show(XIP_dialog_window[i]);
    }
  }

  //Just a click to get rid of block infomation in the spec displays
  if (SIP_dialog_window_text[0])
    on_dialog_show_file_text_button_press(SIP_dialog_window_text[0],
					NULL,NULL);
}


void
on_checkbutton_SIP_editable_toggled    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  int i;
  if (gtk_toggle_button_get_active(togglebutton)) {
    gtk_widget_set_sensitive (GTK_WIDGET(button_SIP_save2file),
			      TRUE);
    gtk_widget_set_sensitive (GTK_WIDGET(button_SIP_restore),
			      TRUE);
    MSG(" [on_checkbutton_SIP_editable_toggled(): togglebutton active.");
    for (i=0;i<NR_SIP_FILE;i++) {
      gtk_text_view_set_editable(GTK_TEXT_VIEW(text_SIP_file[i]),TRUE);
      g_signal_handlers_block_by_func(GTK_TEXT_VIEW(text_SIP_file[i]),
				      G_CALLBACK(on_dialog_show_file_text_button_press),
				      NULL);
      MSG1(" [on_checkbutton_SIP_editable_toggled(): text_SIP_file[%d] signal blocked.",i);
    }
  }
  else {
    gtk_widget_set_sensitive (GTK_WIDGET(button_SIP_save2file),
			      FALSE);
    gtk_widget_set_sensitive (GTK_WIDGET(button_SIP_restore),
			      FALSE);
    MSG(" [on_checkbutton_SIP_editable_toggled(): togglebutton inactive.");
    for (i=0;i<NR_SIP_FILE;i++) {
      gtk_text_view_set_editable(GTK_TEXT_VIEW(text_SIP_file[i]),FALSE);
      g_signal_handlers_unblock_by_func(GTK_TEXT_VIEW(text_SIP_file[i]),
				      G_CALLBACK(on_dialog_show_file_text_button_press),
				      NULL);
      MSG1(" [on_checkbutton_SIP_editable_toggled(): text_SIP_file[%d] signal unblocked.",i);
    }
  }
}


/* Changeable buttons in the main XIP window */
void
on_checkbutton_XIP_editable_toggled    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  int i;
  if (gtk_toggle_button_get_active(togglebutton)) {
    gtk_widget_set_sensitive (GTK_WIDGET(button_XIP_save2file),
			      TRUE);
    MSG(" [on_checkbutton_XIP_editable_toggled(): togglebutton active.");
    for (i=0;i<NR_XIP_FILE;i++) {
      gtk_text_view_set_editable(GTK_TEXT_VIEW(text_XIP_file[i]),TRUE);
    }
  }
  else {
    gtk_widget_set_sensitive (GTK_WIDGET(button_XIP_save2file),
			      FALSE);
    MSG(" [on_checkbutton_XIP_editable_toggled(): togglebutton inactive.");
    for (i=0;i<NR_XIP_FILE;i++) {
      gtk_text_view_set_editable(GTK_TEXT_VIEW(text_XIP_file[i]),FALSE);
    }
  }
}

/*
 * This will save the block_sip file into sip file (w/o block info). But the actual
 * original SIP file won't be replaced because all the changes of sip
 * will take place in mem instead of overwriting the original sip file. But the 
 * block_sip/xip/block_xip will be regenerated and the original files will be overwritten
 * by the new contents.
 */
void on_button_SIP_save2file_clicked (GtkButton* button,
				      gpointer user_data)
{
  GtkTextBuffer* text_buf;
  GtkTextIter iter_s, iter_e;
  gint size;
  gchar* file = NULL;
  int i;
  MSG(" [on_button_SIP_save2file_clicked(): SIP_save2file button clicked.");

  //Now only support one SIP / one XIP text view window
  if (!text_SIP_file[0]) return;

  text_buf = gtk_text_view_get_buffer (GTK_TEXT_VIEW(text_SIP_file[0]));
  gtk_text_buffer_get_start_iter (GTK_TEXT_BUFFER(text_buf),
				  &iter_s);
  gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER(text_buf),
				  &iter_e);
  size = gtk_text_buffer_get_char_count (GTK_TEXT_BUFFER(text_buf));
  
  file = gtk_text_buffer_get_text (GTK_TEXT_BUFFER(text_buf),
				   &iter_s, &iter_e,
				   TRUE);
  if (last_blk_SIP) g_free(last_blk_SIP);
  last_blk_SIP = g_strdup(file);
  last_blk_SIP_size = size;
  
  save_blk_SIP_2_SIP_file(file, REAL_SIP_FILE[0], "w");

  if (file) g_free(file);

  // Update the related info as if the demo is switched to another one.
  // See on_radio_button_demo_selection_clicked().

  /*Remove the blockXip.xml if exists (generated by previous run)*/
  for (i=0;i<NR_XIP_FILE;i++) {
    if (remove(XIP_FILE[i])==0) {
      MSG1(" [on_button_SIP_save2file_clicked(): %s removed\n",XIP_FILE[i]);
    }
    if (!strcmp(curr_demo->name, "UAV")) {
      if (remove(REAL_XIP_FILE[i])==0) {
	MSG1(" [on_button_SIP_save2file_clicked(): %s removed\n",REAL_XIP_FILE[i]);
      }
    }
  }
  
  /*Remove the previously generated code if exists*/
  for (i=0;i<NR_GENCODE_FILE; i++) {
    if (remove(GENCODE_FILE[i]) == 0)
      MSG1( " [on_button_SIP_save2file_clicked(): %s removed\n",GENCODE_FILE[i]);
    else
      MSG1(" [on_button_SIP_save2file_clicked(): %s not be removed\n",
	   GENCODE_FILE[i]);
  }

  //Must be called before set_curr_demo();
  destroy_notebooks_widgets();
  clear_text_stats();
  destroy_dialog_widgets();
  fprintf(OUT, " [on_button_SIP_save2file_clicked(): 2 \n");
  set_curr_demo(curr_demo);

  // Reset textview obj's and redraw the related GUI component in notebooks
  notebook_widgets_init();
  
  recreate_notebooks_widgets();
  
  //Append the infor into the cfg window
  insert_curr_demo_info (cfg_demo_info_text_view);

  //Update the file_text_list <-
  load_files();
  
  //Just a click to get rid of block infomation in the spec displays
  if (text_SIP_file[0])
    on_dialog_show_file_text_button_press(text_SIP_file[0],
                                          NULL,NULL);

  //MSG("     ================");
  //MSG1("%s",file);
  MSG("     ================");

}


void on_button_SIP_restore_clicked (GtkButton* button,
				    gpointer user_data)
{
  GtkTextIter iter_s, iter_e;
  gchar* tmp;
  MSG(" [on_button_SIP_restore_clicked():");

  if (!text_SIP_file[0] || !text_SIP_file_buf[0]) return;
  if (!last_blk_SIP) ERR(" [on_button_SIP_restore_clicked(): last_blk_SIP none exists");

  gtk_text_buffer_get_start_iter (text_SIP_file_buf[0], &iter_s);
  gtk_text_buffer_get_end_iter (text_SIP_file_buf[0], &iter_e);

  gtk_text_buffer_begin_user_action(GTK_TEXT_BUFFER(text_SIP_file_buf[0]));

  gtk_text_buffer_delete(text_SIP_file_buf[0], &iter_s, &iter_e);
  gtk_text_buffer_get_start_iter (text_SIP_file_buf[0], &iter_s);
  gtk_text_buffer_insert (text_SIP_file_buf[0], &iter_s, 
			  last_blk_SIP, strlen(last_blk_SIP));
  
  gtk_text_buffer_end_user_action(GTK_TEXT_BUFFER(text_SIP_file_buf[0]));

  gtk_text_buffer_get_start_iter (text_SIP_file_buf[0], &iter_s);
  gtk_text_buffer_get_end_iter (text_SIP_file_buf[0], &iter_e);
  tmp = gtk_text_buffer_get_text(text_SIP_file_buf[0], &iter_s,
				 &iter_e,
				 TRUE);
  MSG(" ============");
  MSG1("%s", tmp);
  MSG(" ============");
  //Just a click to get rid of block infomation in the spec displays
  if (text_SIP_file[0]) {
    //gtk_widget_show(GTK_WIDGET(text_SIP_file[0]));
    on_dialog_show_file_text_button_press(text_SIP_file[0],
					  NULL,NULL);
  }
}

/*
 * This will 
 */
void on_button_XIP_save2file_clicked (GtkButton* button,
				      gpointer user_data)
{
  MSG(" [on_button_XIP_save2file_clicked(): XIP_save2file button clicked.");
}


/*
 * Used in ISG call
 */
int tprintf(const char* fmt,...)
{
  va_list args;
  struct tm *tstruct;
  struct timeb tb;/* for fine granulity of millisec */
 
  time_t tsec;
 
  tsec = time(NULL);
  tstruct = localtime(&tsec);
 
  ftime(&tb);
 
  fprintf(OUT,"[%02d:%02d.%d %5d] ",tstruct->tm_min,
         tstruct->tm_sec,
         tb.millitm,
         getpid());
  va_start(args, fmt);
  return vprintf(fmt, args);
}

/*
 * Stop the demo
 */
void ctrl_c_pressed(int signal_nr)
{
  on_window_main_destroy(GTK_OBJECT(window_main),NULL);
}

/*
 * After the process forked to invoke the ISG generator
 */
void wait_child_end(int signal_nr)
{
  pid_t pid;
  while ((pid = waitpid(-1,NULL,WNOHANG))>0) 
    tprintf( "ISG process (%d) has been caught to be ended\n", pid);

  popup_gencode_windows();
}

/*
 * Call isg generator here
 */
void
on_button_XIP_gencode_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  //e.g ./isg -s tests/bwprobe.xml -t templates/ECho.xml
  //Instead of running this command line, I'd rather write a script
  //and run that script.
  int i=0;
  gchar* args[2];
  pid_t pid;

  if (!RUN_ISG_SCRIPT) {
    MSG( " [on_button_XIP_gencode_clicked(): Cannot find the running script\n");
    return;
  }

  args[0] = g_strdup(RUN_ISG_SCRIPT);
  args[1] = NULL;

  pid = fork();
  if (0==pid) {
    tprintf( " [on_button_XIP_gencode_clicked(): call isg ...\n");
    while (args[i++]!=NULL)
      MSG1(" %s",args[i-1]);
    MSG("\n");
   execvp(args[0],args);
  }
  else if (-1!=pid) {
    signal(SIGCHLD, (void*)wait_child_end);
    //waitpid(pid,NULL,0);
    tprintf( " [on_button_XIP_gencode_clicked(): I forked isg\n");
  }
  else {
    tprintf( " [on_button_XIP_gencode_clicked(): error starting ISG\n");
  }

  if (args[0]) g_free(args[0]);
}

void popup_gencode_windows()
{
  int i;

  if (!GENCODE_windows_popped) {
    //Generate gencode first ......
    char str[3];
    int x = 20; int y = 280; int step = 10; int offset =0;

    gencode_file_created = TRUE;
    for (i=0;i<NR_GENCODE_FILE;i++) {
      if (load_one_file((text_gencode_file_buf[i]), GENCODE_FILE[i], "r", 
			font_size))
	{
	update_file_text_list_file(GENCODE, GENCODE_FILE[i],
		       gtk_widget_get_name(GTK_WIDGET(text_gencode_file[i])));
	update_file_text_list_text(text_gencode_file[i], 
				   text_gencode_file_buf[i],
                       gtk_widget_get_name(GTK_WIDGET(text_gencode_file[i])));
	update_file_text_list_blk_list((text_gencode_file_buf[i]),
                       gtk_widget_get_name(GTK_WIDGET(text_gencode_file[i])));
	gencode_file_created &= TRUE;
	}
      else 
	gencode_file_created &= FALSE;
    }

    MSG1( " [popup_gencode_windows(): gencode_file_created = %s\n",
	    gencode_file_created==TRUE?"TRUE":"FALSE");
    if (!gencode_file_created) {
      ERR(" [popup_gencode_windows(): windows NOT popped because gen code has not been created\n");
      return;
    }

    gencode_dialog_window = malloc(NR_GENCODE_FILE * sizeof(GtkWidget*));
    gencode_dialog_window_text = malloc(NR_GENCODE_FILE*sizeof(GtkWidget*));
    gencode_dialog_window_text_buf = malloc(NR_GENCODE_FILE*sizeof(GtkTextBuffer*));

    for (i=0;i<NR_GENCODE_FILE;i++) {
      int_to_str(str,i);

      gencode_dialog_window[i] = create_dialog_show_file (
		      GENCODE_FILE[i], x+offset,
				y-offset, &(gencode_dialog_window_text[i]),
		      &(gencode_dialog_window_text_buf[i]),
		concat(concat("gencode_dialog_window_text[",str),"]")	);
      offset += step;

      if (gencode_dialog_window[i]) {
	  update_file_text_list_file(GENCODE,GENCODE_FILE[i],
	     gtk_widget_get_name(GTK_WIDGET(gencode_dialog_window_text[i])));
	  update_file_text_list_text(gencode_dialog_window_text[i],
				    (gencode_dialog_window_text_buf[i]),
	   gtk_widget_get_name(GTK_WIDGET(gencode_dialog_window_text[i])));
	  update_file_text_list_blk_list((gencode_dialog_window_text_buf[i]),
	   gtk_widget_get_name(GTK_WIDGET(gencode_dialog_window_text[i])));
      }
    }

    GENCODE_windows_popped = TRUE;

    //Just a click to get rid of block infomation in the spec displays
    if (gencode_dialog_window_text[0])
      on_dialog_show_file_text_button_press(gencode_dialog_window_text[0],
					NULL,NULL);
  }

  for (i=0;i<NR_GENCODE_FILE;i++) {
    if (NULL != gencode_dialog_window[i]) {
      gtk_widget_show(gencode_dialog_window[i]);
    }
  }

  if (SIP_XIP_windows_popped) {
    for (i=0;i<NR_XIP_FILE;i++) {
      if (NULL != XIP_dialog_window[i]) {
	gtk_widget_show(XIP_dialog_window[i]);
      }
    }
  }

}

void
on_button_XIP_to_SIP_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  //XXX
}



/* Changeable buttons in the main Dump window */
void
on_button_dump_clear_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
#ifndef USE_STDOUT
  GtkTextIter iter1, iter2;

  if (OUT != stdout && OUT != stderr && OUT != stdin) {
    gtk_text_buffer_get_start_iter(text_dump_buf, &iter1);
    gtk_text_buffer_get_end_iter(text_dump_buf, &iter2);
    gtk_text_buffer_delete(text_dump_buf, &iter1, &iter2);

    //gtk_text_backward_delete(GTK_TEXT(text_dump), OS_file_pos);
    fclose(OUT);
    OUT = open_file(OS_FILE_NAME,"w+");
    OS_file_pos = 0;
  }
#endif
}








/*
 * cfg_window callbacks
 */
/* The file selection windows for path allocation*/
GtkWidget* file_selection_demo_src_root=NULL;
GtkWidget* file_selection_demo_isg_root=NULL;
GtkWidget* file_selection_isg_root=NULL;

/* The file selection windows for file names under /conf */
GtkWidget* file_selection_conf_demo_src_file=NULL;
GtkWidget* file_selection_conf_gencode_file=NULL;
GtkWidget* file_selection_conf_SIP_file=NULL;
GtkWidget* file_selection_conf_XIP_file=NULL;


gboolean is_directory(const gchar * path)
{
  struct stat st;
  if (stat(path, &st) == -1)
    return FALSE;
  return S_ISDIR(st.st_mode);
}


gboolean is_regfile(const gchar* path)
{
  struct stat st;
  if (stat(path, &st) == -1)
    return FALSE;
  return S_ISREG(st.st_mode);
}


void
on_text1_delete_text                   (GtkEditable     *editable,
                                        gint             start_pos,
                                        gint             end_pos,
                                        gpointer         user_data)
{

}
void
on_text1_move_cursor                   (GtkEditable     *editable,
                                        gint             x,
                                        gint             y,
                                        gpointer         user_data)
{

}


/* The radio buttons in cfg window */
void on_radio_button_demo_selection_clicked (GtkButton* button, 
					     gpointer user_data)
{
  gint i, demo_i;

  if ((GtkButton*)curr_radio_button_demo_selection == button) {
    //The same radio button as previous
    return;
  }

  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (button))) 
    {
      (GtkButton*)curr_radio_button_demo_selection = button;

      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button),
                                   TRUE );
      for (i=0;i<g_list_length(ALL_DEMO);i++) {
	if (button == (GTK_BUTTON(radio_button_demo_selection[i]))) {
	  MSG2( " [on_radio_button_demo_selection_clicked(): i=%d: %s selected", i, ((demo_info*)g_list_nth_data(ALL_DEMO,i))->name);
	  break;
	}
      }

      demo_i = i;

      /*Remove the blockXip.xml if exists (generated by previous run)*/
      for (i=0;i<NR_XIP_FILE;i++) {
	if (remove(XIP_FILE[i])==0) {
	  MSG1(" [on_radio_button_demo_selection_clicked(): %s removed\n",XIP_FILE[i]);
	}
	if (!strcmp(curr_demo->name, "UAV")) {	
	if (remove(REAL_XIP_FILE[i])==0) {
	  MSG1(" [on_radio_button_demo_selection_clicked(): %s removed\n",REAL_XIP_FILE[i]);
	}
	}
      }

      //Must be called before set_curr_demo();
      destroy_notebooks_widgets();   
      clear_text_stats();
      destroy_dialog_widgets(); 
      fprintf(OUT, " [on_radio_button_demo_selection_clicked(): 2 \n");
      set_curr_demo((demo_info*)g_list_nth_data(ALL_DEMO, demo_i));

      // Reset textview obj's and redraw the related GUI component in notebooks
      notebook_widgets_init();

      recreate_notebooks_widgets();

      //Append the infor into the cfg window
      insert_curr_demo_info (cfg_demo_info_text_view);

      /*Remove the prev blockXip.xml if exists (generated by previous run)*/
      for (i=0;i<NR_XIP_FILE;i++) {
	if (remove(XIP_FILE[i])==0) {
	  MSG1(" [on_radio_button_demo_selection_clicked(): %s removed\n",XIP_FILE[i]);
	}
      }

      if (!strcmp(curr_demo->name, "UAV")) {
	for (i=0;i<NR_XIP_FILE;i++) {
	  if (remove(REAL_XIP_FILE[i])==0) {
	    MSG1(" [on_radio_button_demo_selection_clicked(): %s removed\n",REAL_XIP_FILE[i]);
	  }
	}
      }
      /*Remove the previously generated code if exists*/
      for (i=0;i<NR_GENCODE_FILE; i++) {
	if (remove(GENCODE_FILE[i]) == 0) 
	  MSG1( " [on_radio_button_demo_selection_clicked(): %s removed\n",GENCODE_FILE[i]);
	else
	  MSG1(" [on_radio_button_demo_selection_clicked(): %s can not be removed\n",
	       GENCODE_FILE[i]);
      }

      //Update the file_text_list <-
      load_files();

      //Just a click to get rid of block infomation in the spec displays
      if (text_SIP_file[0])
	on_dialog_show_file_text_button_press(text_SIP_file[0],
					      NULL,NULL);
    } else {
      /* If control reaches here, the toggle button is up */
      MSG( " [on_radio_button_demo_selection_clicked(): else");
      
    }  
}


/*
 * Clear the text in the top window of the cfg notebook page
 */
void
on_button_cfg_demo_info_clear_clicked (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkTextIter start, end;

  gtk_text_buffer_get_start_iter(cfg_demo_info_text_buf, &start);
  gtk_text_buffer_get_end_iter(cfg_demo_info_text_buf, &end);
  gtk_text_buffer_delete(cfg_demo_info_text_buf, &start, &end);
}




/* The `Demo ISG src' button in the main cfg window*/
void
on_button_cfg_demo_isg_src_root_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
  if (!file_selection_demo_isg_root) {
    file_selection_demo_isg_root =
      gtk_file_selection_new
      ("Please choose the root path of the ISG version of the demo source");
  
    gtk_file_selection_set_filename(
			   GTK_FILE_SELECTION(file_selection_demo_isg_root),
			   (gchar*)user_data);

    gtk_signal_connect(GTK_OBJECT (
		     GTK_FILE_SELECTION(file_selection_demo_isg_root)->
		     ok_button), "clicked",
                       GTK_SIGNAL_FUNC(button_file_selection_path_clicked),
                       &file_selection_demo_isg_root);

    gtk_signal_connect(GTK_OBJECT (
		     GTK_FILE_SELECTION(file_selection_demo_isg_root)-> 
		     cancel_button), "clicked",
                       GTK_SIGNAL_FUNC(button_file_selection_path_clicked),
                       &file_selection_demo_isg_root);

    gtk_signal_connect(GTK_OBJECT(file_selection_demo_isg_root), 
		       "delete_event",
                      GTK_SIGNAL_FUNC(button_file_selection_path_delete_event),
                      &file_selection_demo_isg_root);
    
    gtk_widget_show(file_selection_demo_isg_root);
  }
}



/* The `Isg Root' button in the main cfg window*/
void
on_button_cfg_isg_root_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
  if (!file_selection_isg_root) {
    file_selection_isg_root =
      gtk_file_selection_new
      ("Please choose the root path of the ISG version of the demo source");
  
    gtk_file_selection_set_filename(
				GTK_FILE_SELECTION(file_selection_isg_root),
				(gchar*)user_data);

    gtk_signal_connect(GTK_OBJECT (
			     GTK_FILE_SELECTION(file_selection_isg_root)->
			     ok_button), "clicked",
                       GTK_SIGNAL_FUNC(button_file_selection_path_clicked),
                       &file_selection_isg_root);

    gtk_signal_connect(GTK_OBJECT (
			     GTK_FILE_SELECTION(file_selection_isg_root)->
			     cancel_button), "clicked",
                       GTK_SIGNAL_FUNC(button_file_selection_path_clicked),
                       &file_selection_isg_root);

    gtk_signal_connect(GTK_OBJECT(file_selection_isg_root),
		       "delete_event",
                      GTK_SIGNAL_FUNC(button_file_selection_path_delete_event),
                       &file_selection_isg_root);
    
    gtk_widget_show(file_selection_isg_root);
  }
}



void
on_button_cfg_demo_src_root_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
  MSG1(" [on_buttton_cfg_demo_src_root_clicked(): file_selection(%p)",
       file_selection_demo_src_root);

  if (!file_selection_demo_src_root) {
    file_selection_demo_src_root =
      gtk_file_selection_new
      ("Please choose the root path of the demo source");
  
    gtk_file_selection_set_filename(GTK_FILE_SELECTION(
				    file_selection_demo_src_root),
				    (gchar*)user_data);

    gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION
				 (file_selection_demo_src_root)->ok_button),
		       "clicked",
                       GTK_SIGNAL_FUNC(button_file_selection_path_clicked),
                       &file_selection_demo_src_root);

    gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION
			      (file_selection_demo_src_root)-> cancel_button),
		       "clicked",
                       GTK_SIGNAL_FUNC(button_file_selection_path_clicked),
                       &file_selection_demo_src_root);

    gtk_signal_connect(GTK_OBJECT(file_selection_demo_src_root), 
		       "delete_event",
                      GTK_SIGNAL_FUNC(button_file_selection_path_delete_event),
                       &file_selection_demo_src_root);
    
    gtk_widget_show(file_selection_demo_src_root);
  }
}



/* The general routine when the `delete' button in the file selection
 * windows for path choosing is clicked */
gboolean 
button_file_selection_path_delete_event (GtkWidget * widget,
					 GdkEvent * event,
					 GtkWidget** fs)
{
  gtk_widget_destroy(*fs);
  *fs = NULL;
  return TRUE;
}



/* The general routine when the `Ok' or `Cancel' button in the file selection
 * windows for path choosing is clicked */
void
button_file_selection_path_clicked(GtkButton * button, GtkWidget** fs)
{
  if (*fs) {
    const gchar *name =
      gtk_file_selection_get_filename(GTK_FILE_SELECTION(*fs));

    if (is_directory(name)) {
      if ((*fs) == file_selection_demo_src_root) {
	//strcpy(str_demo_src_root,name);
	strcpy(clist_cfg_path_value[0][1], name);
	gtk_clist_set_text(GTK_CLIST(clist_cfg_path),0,1,name);
      }
      else if ((*fs) == file_selection_demo_isg_root) {
	//strcpy(str_demo_isg_root,name);
	strcpy(clist_cfg_path_value[1][1], name);
	gtk_clist_set_text(GTK_CLIST(clist_cfg_path),1,1,name);
      }
      else if ((*fs) == file_selection_isg_root) {
	//strcpy(str_isg_root,name);
	strcpy(clist_cfg_path_value[2][1], name);
	gtk_clist_set_text(GTK_CLIST(clist_cfg_path),2,1,name);
      }
    }
    
  }

  gtk_widget_destroy(*fs);
  *fs = NULL;
  
}






/* The `Demo Src List File' button*/
void
on_button_conf_demo_src_file_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
  if (!file_selection_conf_demo_src_file) {
    file_selection_conf_demo_src_file =
      gtk_file_selection_new
      ("Choose the file contains the info of the list of demo src files");
  
    gtk_file_selection_set_filename(GTK_FILE_SELECTION
				    (file_selection_conf_demo_src_file),
				    (gchar*)user_data);

    gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION
				   (file_selection_conf_demo_src_file)->
				   ok_button), "clicked",
                     GTK_SIGNAL_FUNC(button_file_selection_conf_file_clicked),
                       &file_selection_conf_demo_src_file);

    gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION
				   (file_selection_conf_demo_src_file)->
				   cancel_button), "clicked",
                      GTK_SIGNAL_FUNC(button_file_selection_conf_file_clicked),
                       &file_selection_conf_demo_src_file);

    gtk_signal_connect(GTK_OBJECT(file_selection_conf_demo_src_file), 
		       "delete_event",
                GTK_SIGNAL_FUNC(button_file_selection_conf_file_delete_event),
                       &file_selection_conf_demo_src_file);
    
    gtk_widget_show(file_selection_conf_demo_src_file);
  }
}



/* The `GenCode List File' button clicked*/
void
on_button_conf_gen_code_file_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
  if (!file_selection_conf_gencode_file) {
    file_selection_conf_gencode_file =
      gtk_file_selection_new
      ("Choose the file contains the info of the list of generated files");
  
    gtk_file_selection_set_filename(GTK_FILE_SELECTION
				    (file_selection_conf_gencode_file),
				    (gchar*)user_data);

    gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION
				   (file_selection_conf_gencode_file)->
				   ok_button), "clicked",
                     GTK_SIGNAL_FUNC(button_file_selection_conf_file_clicked),
                       &file_selection_conf_gencode_file);

    gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION
				   (file_selection_conf_gencode_file)->
				   cancel_button), "clicked",
                      GTK_SIGNAL_FUNC(button_file_selection_conf_file_clicked),
                       &file_selection_conf_gencode_file);

    gtk_signal_connect(GTK_OBJECT(file_selection_conf_gencode_file),
		       "delete_event",
                GTK_SIGNAL_FUNC(button_file_selection_conf_file_delete_event),
                       &file_selection_conf_gencode_file);
    
    gtk_widget_show(file_selection_conf_gencode_file);
  }
}



/* The `SIP List file' clicked*/
void
on_button_conf_SIP_file_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  if (!file_selection_conf_SIP_file) {
    file_selection_conf_SIP_file =
      gtk_file_selection_new
      ("Choose the file contains the info of the list of SIP files");
  
    gtk_file_selection_set_filename(GTK_FILE_SELECTION
				    (file_selection_conf_SIP_file),
				    (gchar*)user_data);

    gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION
				   (file_selection_conf_SIP_file)->
				   ok_button), "clicked",
                     GTK_SIGNAL_FUNC(button_file_selection_conf_file_clicked),
                       &file_selection_conf_SIP_file);

    gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION
				   (file_selection_conf_SIP_file)->
				   cancel_button), "clicked",
                      GTK_SIGNAL_FUNC(button_file_selection_conf_file_clicked),
                       &file_selection_conf_SIP_file);

    gtk_signal_connect(GTK_OBJECT(file_selection_conf_SIP_file),
		       "delete_event",
                GTK_SIGNAL_FUNC(button_file_selection_conf_file_delete_event),
                       &file_selection_conf_SIP_file);
    
    gtk_widget_show(file_selection_conf_SIP_file);
  }
}



/* The `XIP List File' button clicked*/
void
on_button_conf_XIP_file_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  if (!file_selection_conf_XIP_file) {
    file_selection_conf_XIP_file =
      gtk_file_selection_new
      ("Choose the file contains the info of the list of XIP files");
  
    gtk_file_selection_set_filename(GTK_FILE_SELECTION
				    (file_selection_conf_XIP_file),
				    (gchar*)user_data);

    gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION
				   (file_selection_conf_XIP_file)->
				   ok_button), "clicked",
                     GTK_SIGNAL_FUNC(button_file_selection_conf_file_clicked),
                       &file_selection_conf_XIP_file);

    gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION
				   (file_selection_conf_XIP_file)->
				   cancel_button), "clicked",
                      GTK_SIGNAL_FUNC(button_file_selection_conf_file_clicked),
                       &file_selection_conf_XIP_file);

    gtk_signal_connect(GTK_OBJECT(file_selection_conf_XIP_file), 
		       "delete_event",
                GTK_SIGNAL_FUNC(button_file_selection_conf_file_delete_event),
                       &file_selection_conf_XIP_file);
    
    gtk_widget_show(file_selection_conf_XIP_file);
  }
}



/* The general callback function when the `delete' button in the 
 * file selection windows for conf files selection is clicked
 */
gboolean 
button_file_selection_conf_file_delete_event (GtkWidget * widget,
					 GdkEvent * event,
					 GtkWidget** fs)
{
  gtk_widget_destroy(*fs);
  *fs = NULL;
  return TRUE;
}


/* The general callback function when the `OK' or `Cancel' button in the
 * file selection windows for conf files selection is clicked
 */
void button_file_selection_conf_file_clicked(GtkButton * button, 
					     GtkWidget** fs)
{
#if 0
  int i;

  if (*fs) {
    const gchar *name =
      gtk_file_selection_get_filename(GTK_FILE_SELECTION(*fs));

    if (is_regfile(name)) {
      if ((*fs) == file_selection_conf_demo_src_file) {
	strcpy(str_conf_file_name_demo_src,name);
	gtk_entry_set_text(GTK_ENTRY(entry_conf_demo_src_file),name);

	//XXX
	//Update the file_text_list and redraw the demo_src notebook
	//and text.
      }
      else if ((*fs) == file_selection_conf_gencode_file) {
	strcpy(str_conf_file_name_gencode,name);
	gtk_entry_set_text(GTK_ENTRY(entry_conf_gen_code_file),name);
	//XXX
	//Update ...
      }
      else if ((*fs) == file_selection_conf_SIP_file) {
	strcpy(str_conf_file_name_SIP,name);
	gtk_entry_set_text(GTK_ENTRY(entry_conf_SIP_file),name);
	
	//XXX
	//Now this only works once. Needs to be upgraded to work any times
	//if the user wants to change the SIP source and thus the whole 
	//demo underneath this isg demo. i.e. the SIP notebook, # of pages
	//# of text widgets, # of scrolledwindows ... all need to be 
	//reallocated.
	if (!SIP_file_created) { 
	  i =read_src_file_list(str_conf_file_name_SIP,
			      &SIP_FILE, &NR_SIP_FILE, ISG_GENCODE_ROOT);
	  SIP_file_created = TRUE;
	  for (i = 0;i<NR_SIP_FILE;i++) {
	    if (load_one_file((text_SIP_file_buf[i]), SIP_FILE[i], "r", fixed_font))
	      {
		fprintf(OUT, " [button_file_selection_conf_file_clicked(): %d char read from %s\n",
		gtk_text_buffer_get_char_count(GTK_TEXT_BUFFER(text_SIP_file_buf[i])),SIP_FILE[i]);
		update_file_text_list_file(SIP,SIP_FILE[i],
		       gtk_widget_get_name(GTK_WIDGET(text_SIP_file[i])));    
		update_file_text_list_text(text_SIP_file[i],
					   (text_SIP_file_buf[i]),
                       gtk_widget_get_name(GTK_WIDGET(text_SIP_file[i])));
		update_file_text_list_blk_list((text_SIP_file_buf[i]),
                       gtk_widget_get_name(GTK_WIDGET(text_SIP_file[i])));
		SIP_file_created &= TRUE;
	      }
	    else {
	      SIP_file_created &= FALSE;
	    }
	  }
	}// if (!SIP_file_created)
      }
      else if ((*fs) == file_selection_conf_XIP_file) {
	strcpy(str_conf_file_name_XIP,name);
	gtk_entry_set_text(GTK_ENTRY(entry_conf_XIP_file),name);
	//XXX see SIP
	//update
	if (!XIP_file_created) {
	  i =read_src_file_list(str_conf_file_name_XIP,
			      &XIP_FILE, &NR_XIP_FILE, ISG_GENCODE_ROOT);
	  XIP_file_created = TRUE;
	  for (i = 0;i<NR_XIP_FILE;i++) {
	    if (load_one_file((text_XIP_file_buf[i]), XIP_FILE[i], "r", fixed_font))
	      {
		fprintf(OUT, " [button_file_selection_conf_file_clicked(): %d char read from %s\n",
		gtk_text_buffer_get_char_count(GTK_TEXT_BUFFER(text_XIP_file_buf[i])),XIP_FILE[i]);
		update_file_text_list_file(XIP,XIP_FILE[i],
		       gtk_widget_get_name(GTK_WIDGET(text_XIP_file[i])));    
		update_file_text_list_text(text_XIP_file[i],
					  (text_XIP_file_buf[i]),
                       gtk_widget_get_name(GTK_WIDGET(text_XIP_file[i])));
		update_file_text_list_blk_list((text_XIP_file_buf[i]),
                       gtk_widget_get_name(GTK_WIDGET(text_XIP_file[i])));
		XIP_file_created &= TRUE;
	      }
	    else {
	      XIP_file_created &= FALSE;
	    }
	  }
	}// if (!XIP_file_created) 
      }
    }// if (is_regfile()) 
  }// if (*fs) 
  gtk_widget_destroy(*fs);
  *fs = NULL;

#endif
}


  
void
on_entry_conf_demo_src_file_changed    (GtkEditable     *editable,
                                        gpointer         user_data)
{
  /*
  gchar *name =
    gtk_editable_get_chars(GTK_EDITABLE(editable),0,
			   gtk_editable_get_position(GTK_EDITABLE(editable)));
  fprintf(OUT," [on_entry_conf_demo_src_file_changed(): name: >%s<\n",name);
  strcpy(str_conf_file_name_demo_src,name);
  g_free(name);
  fprintf(OUT," [on_entry_conf_demo_src_file_changed(): str_conf_file_name_demo_src: >%s<\n\n",str_conf_file_name_demo_src);
  */
}


void
on_entry_conf_gen_code_file_changed    (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_entry_conf_SIP_file_changed    (GtkEditable     *editable,
                                        gpointer         user_data)
{

}

void
on_entry_conf_XIP_file_changed    (GtkEditable     *editable,
                                        gpointer         user_data)
{

}




#if 0
void
on_button_color_basic_clicked          (GtkButton       *button,
                                        gpointer user_data)
{
  gdouble color[3];
  GtkColorSelection* colorsel;

  fprintf(OUT, "[on_button_color_basic_clicked(): csd(%p)\n",
	  colorselectiondialog_basic);

  create_colorselectiondialog_basic();
  gtk_widget_show(colorselectiondialog_basic);

  colorsel=GTK_COLOR_SELECTION(
       GTK_COLOR_SELECTION_DIALOG(colorselectiondialog_basic)->colorsel);

  //color[0]=0;color[1]=.5; color[2]=0.9;
  //gtk_color_selection_set_color(GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(colorselectiondialog_basic)->colorsel),color);
}
#endif



void
on_button_color_highlight_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
  //gdouble color[3];
  GtkColorSelection* colorsel;

  MSG1("[on_button_color_highlight_clicked(): csd(%p)\n",
	  colorselectiondialog_highlight);

  create_colorselectiondialog_highlight();
  gtk_widget_show(colorselectiondialog_highlight);

  colorsel=GTK_COLOR_SELECTION(
       GTK_COLOR_SELECTION_DIALOG(colorselectiondialog_highlight)->colorsel);

}



void
color_changed_handler(GtkWidget* widget, GtkColorSelection* colorsel)
{
  gdouble color[3];
  GdkColor gdk_color;
  GdkColormap *colormap;

  colormap = gdk_colormap_get_system();
  //  colormap = gdk_window_get_colormap (drawingarea->window);

  gtk_color_selection_get_color (GTK_COLOR_SELECTION(colorsel),color);

  gdk_color.red = (guint16)(color[0]*65535.0);
  gdk_color.green = (guint16)(color[1]*65535.0);
  gdk_color.blue = (guint16)(color[2]*65535.0);

  if (!gdk_color_alloc (colormap, &gdk_color)) {
    ERR( "couldn't allocate color");
  }
  //  gdk_window_set_background (drawingarea->window, &gdk_color);
  if (colorsel == GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(colorselectiondialog_basic)-> colorsel)) {
    color_basic = gdk_color;
  }
  else if (colorsel == GTK_COLOR_SELECTION(
	   GTK_COLOR_SELECTION_DIALOG(colorselectiondialog_highlight)->
	   colorsel)) {
    color_highlight = gdk_color;
  }

  MSG3(" [color_changed_handler(): end..., r: %d, g: %d, b: %d ",
	  gdk_color.red,gdk_color.green,gdk_color.blue);
}




void
on_combo_font_size_focus              (GtkContainer    *container,
                                        GtkDirectionType direction,
                                        gpointer         user_data)
{
  gchar* tmp;
  tmp = (gchar*)gtk_entry_get_text(GTK_ENTRY(container));
  MSG1(" [on_combo_font_size_focus(): font size: >%s<\n",
	  tmp);
  if (!strcmp(tmp, "Large")) {
    font_size = LARGE;
  }
  else if (!strcmp(tmp, "Medium")) {
    font_size = MEDIUM;
  }
  else {
    font_size = SMALL;
  }
}





void
on_colorselectiondialog_destroy       (GtkObject       *object,

                                       GtkWidget** colorselectiondialog)
{
  gtk_widget_destroy(GTK_WIDGET(object));
  *colorselectiondialog = NULL;
}




void 
button_colorselection_delete_event (GtkButton* button,
				    GtkWidget** colorselectiondialog)
{
  MSG(" [button_colorselection_delete_event():\n");
  gtk_widget_destroy(GTK_WIDGET(*colorselectiondialog));
  *colorselectiondialog = NULL;
}




void 
button_colorselection_ok_event (GtkButton* button,
				    GtkWidget** colorselectiondialog)
{
  gdouble color[3];
  GdkColor gdk_color;
  GdkColormap *colormap;

  GtkColorSelection* cs;

  MSG(" [button_colorselection_ok_event(): \n");
  colormap = gdk_colormap_get_system();
  
  cs = GTK_COLOR_SELECTION(((GtkColorSelectionDialog*)(*colorselectiondialog))->colorsel);
  
  gtk_color_selection_get_color (cs,color);

  gdk_color.red = (guint16)(color[0]*65535.0);
  gdk_color.green = (guint16)(color[1]*65535.0);
  gdk_color.blue = (guint16)(color[2]*65535.0);

  if (!gdk_color_alloc (colormap, &gdk_color)) {
    ERR("couldn't allocate color");
  }
  
  if (0 == strcmp("colorselectiondialog_basic",
		  gtk_widget_get_name(*colorselectiondialog))) {
    color_basic = gdk_color;
  }
  else if (0==strcmp("colorselectiondialog_highlight",
		     gtk_widget_get_name(*colorselectiondialog))) {
    color_highlight = gdk_color;
  }
			  
  MSG3(" [button_color_selection_ok_event(): end..., r: %d, g: %d, b: %d \n",
	  gdk_color.red,gdk_color.green,gdk_color.blue);


  gtk_widget_destroy(GTK_WIDGET(*colorselectiondialog));
  *colorselectiondialog = NULL;
}


