
#ifndef _CALLBACKS_H
#define _CALLBACKS_H

#include <gtk/gtk.h>

extern gboolean SIP_XIP_windows_popped;
extern gboolean GENCODE_windows_popped;
extern GtkWidget** SIP_dialog_window;
extern GtkWidget** XIP_dialog_window;
extern GtkWidget** SIP_dialog_window_text;
extern GtkWidget** XIP_dialog_window_text;
extern GtkWidget** gencode_dialog_window;
extern GtkWidget** gencode_dialog_window_text;
extern GtkTextBuffer** SIP_dialog_window_text_buf;
extern GtkTextBuffer** XIP_dialog_window_text_buf;
extern GtkTextBuffer** gencode_dialog_window_text_buf;

guint on_stat_update(gpointer data);

void
on_isg_demo_destroy                    (GtkObject       *object,
                                        gpointer         user_data);

void
on_window_main_destroy                 (GtkObject       *object,
                                        gpointer         user_data);

void
article_clicked (GtkTreeSelection *selection, gpointer data);


/* The button in SIP window*/
void
on_button_SIP_to_XIP_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_checkbutton_SIP_editable_toggled    (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

/* The buttons in XIP window */
int tprintf(const char* fmt,...);

void wait_child_end(int signal_nr);

void ctrl_c_pressed(int signal_nr);

void
on_button_XIP_gencode_clicked          (GtkButton       *button,
                                        gpointer         user_data);
void popup_gencode_windows();

void
on_button_XIP_to_SIP_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_checkbutton_XIP_editable_toggled    (GtkToggleButton *togglebutton,
                                        gpointer         user_data);


void on_button_SIP_save2file_clicked (GtkButton* button,
				      gpointer user_data);

void on_button_SIP_restore_clicked (GtkButton* button,
				    gpointer user_data);

void on_button_XIP_save2file_clicked (GtkButton* button,
				      gpointer user_data);



/* The button in Dump window*/
void
on_button_dump_clear_clicked           (GtkButton       *button,
                                        gpointer         user_data);

/*
 * cfg_window callbacks
 */
//XXX Not used
void
on_text1_delete_text                   (GtkEditable     *editable,
                                        gint             start_pos,
                                        gint             end_pos,
                                        gpointer         user_data);
//XXX Not used
void
on_text1_move_cursor                   (GtkEditable     *editable,
                                        gint             x,
                                        gint             y,
                                        gpointer         user_data);

gboolean is_directory(const gchar * path);

gboolean is_regfile(const gchar* path);


void on_radio_button_demo_selection_clicked (GtkButton* button, 
					     gpointer user_data);

/* The `delete' button in the file selection window for path selection*/
gboolean 
button_file_selection_path_delete_event (GtkWidget * widget,
					 GdkEvent * event,
					 GtkWidget** fs);

void button_file_selection_path_clicked(GtkButton * button, GtkWidget** fs);


/* The `Clear' button in the main cfg window*/
void
on_button_cfg_demo_info_clear_clicked (GtkButton       *button,
				       gpointer         user_data);

/* The `Demo Src Root' button in the main cfg window*/
void
on_button_cfg_demo_src_root_clicked    (GtkButton       *button,
                                        gpointer user_data);
/* The `Demo ISG src' button in the main cfg window*/
void
on_button_cfg_demo_isg_src_root_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data);
/* The `Isg Root' button in the main cfg window*/
void
on_button_cfg_isg_root_clicked         (GtkButton       *button,
                                        gpointer         user_data);





void
on_button_conf_demo_src_file_clicked   (GtkButton       *button,
                                        gpointer         user_data);

void button_file_selection_conf_file_clicked(GtkButton * button, 
					     GtkWidget** fs);
/* The `delete' button in the file selection window for conf file 
   selection*/
gboolean 
button_file_selection_conf_file_delete_event (GtkWidget * widget,
					 GdkEvent * event,
					      GtkWidget** fs);


void
on_entry_conf_demo_src_file_changed    (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_button_conf_gen_code_file_clicked   (GtkButton       *button,
                                        gpointer         user_data);

void
on_entry_conf_gen_code_file_changed    (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_button_conf_SIP_file_clicked        (GtkButton       *button,
                                        gpointer         user_data);

void
on_entry_conf_SIP_file_changed    (GtkEditable     *editable,
                                        gpointer         user_data);

void
on_button_conf_XIP_file_clicked        (GtkButton       *button,
                                        gpointer         user_data);

void
on_entry_conf_XIP_file_changed    (GtkEditable     *editable,
                                        gpointer         user_data);







void
on_button_color_basic_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void
on_button_color_highlight_clicked      (GtkButton       *button,
                                        gpointer         user_data);

void
color_changed_handler(GtkWidget* widget, GtkColorSelection* colorsel);


void
on_combo_font_size_focus              (GtkContainer    *container,
                                        GtkDirectionType direction,
                                        gpointer         user_data);
void
on_colorselectiondialog_destroy       (GtkObject       *object,

				       GtkWidget** colorselectiondialog);

void 
button_colorselection_delete_event (GtkButton* button,
				    GtkWidget** colorselectiondialog);

void 
button_colorselection_ok_event (GtkButton* button,
				    GtkWidget** colorselectiondialog);


#endif
