

#ifndef __CM__H__
#define __CM__H__

#if defined(FUNCPROTO) || defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#ifndef ARGS
#define ARGS(args) args
#endif
#else
#ifndef ARGS
#define ARGS(args) (/*args*/)
#endif
#endif

#include "io.h"
#include "atl.h"
#ifdef	__cplusplus
extern "C" {
#endif


extern int CM_debug_flag;

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

typedef struct _CMformat_list {
    char *format_name;
    IOFieldList field_list;
}CMFormatRec, *CMFormatList;

struct _CManager;
struct _CMConnection;
struct _CMFormat;

typedef void (*CMHandlerFunc) ARGS((struct _CManager *, 
				    struct _CMConnection *,
				    void *message, void *client_data));

typedef void (*CMPollFunc) ARGS((struct _CManager *, 
				 void *client_data));

typedef void (*CMCloseHandlerFunc) ARGS((struct _CManager *, 
					 struct _CMConnection *,
					 void *client_data));

typedef struct _CManager *CManager;
typedef struct _CMConnection *CMConnection;
typedef struct _CMFormat *CMFormat;
typedef struct _CMTaskHandle *CMTaskHandle;

extern CManager CManager_create();

extern void CManager_close ARGS((CManager cm));

extern int CMfork_comm_thread ARGS((CManager cm));

extern void *CMtake_buffer ARGS((CManager cm, void *data));
extern void CMreturn_buffer ARGS((CManager cm, void *data));

extern CMConnection
CMget_conn ARGS((CManager cm, attr_list contact_list));

extern CMConnection
CMinitiate_conn ARGS((CManager cm, attr_list contact_list));

extern attr_list
CMConnection_get_attrs ARGS((CMConnection conn));

extern void
CMConnection_close ARGS((CMConnection conn));

extern void
CMConnection_add_reference ARGS((CMConnection conn));

extern int
CMcontact_self_check ARGS((CManager cm, attr_list attrs));

extern attr_list
CMget_contact_list ARGS((CManager cm));

extern CMFormat
CMregister_format ARGS((CManager cm, char *format_name,
		       IOFieldList field_list, CMFormatList format_list));
extern IOFormat
CMregister_user_format ARGS((CManager cm, IOContext context, char *format_name,
			      IOFieldList field_list, CMFormatList format_list));

extern CMFormat CMlookup_format ARGS((CManager cm, IOFieldList field_list));
extern IOFormat CMlookup_user_format ARGS((CManager cm, IOFieldList field_list));

extern IOFormat CMget_IOformat_by_name ARGS((CManager cm, IOContext context,
					     char *name));
extern IOFormat CMget_format_IOcontext ARGS((CManager cm, IOContext context,
					     void *buffer));
extern IOFormat *CMget_subformats_IOcontext ARGS((CManager cm, 
						  IOContext context,
						  void *buffer));
extern void
CMset_conversion_IOcontext ARGS((CManager cm, IOContext context,
				 IOFormat format, IOFieldList field_list,
				 int native_struct_size));

extern
IOContext CMget_user_type_context ARGS((CManager cm));
extern
void CMfree_user_type_context ARGS((CManager cm, IOContext context));

extern int
CMwrite ARGS((CMConnection conn, CMFormat format, void *data));

extern int
CMwrite_attr ARGS((CMConnection conn, CMFormat format, void *data, 
		   attr_list attrs));

extern void
CMregister_handler ARGS((CMFormat format, CMHandlerFunc handler, 
			void *client_data));

extern void
CMconn_register_close_handler ARGS((CMConnection conn, 
				    CMCloseHandlerFunc func, 
				    void *client_data));

typedef void (*CMNonCMHandler) ARGS((struct _CMConnection *,
				     int header));

extern void
CMregister_non_CM_message_handler ARGS((int header, CMNonCMHandler handler));

extern void
CMadd_poll ARGS((CManager cm, CMPollFunc func, void *client_data));

extern CMTaskHandle
CMadd_periodic ARGS((CManager cm, long period, CMPollFunc func,
		     void *client_data));

extern CMTaskHandle
CMadd_periodic_task ARGS((CManager cm, int period_sec, int period_used, 
			  CMPollFunc func, void *client_data));

extern CMTaskHandle
CMadd_delayed_task ARGS((CManager cm, int secs, int usec, CMPollFunc func,
			 void *client_data));

extern void
CMsleep ARGS((CManager cm, int secs));

extern void
CMusleep ARGS((CManager cm, int usecs));

extern void
CMremove_periodic ARGS((CMTaskHandle handle));

extern void
CMremove_task ARGS((CMTaskHandle handle));

extern 
void CMpoll_network ARGS((CManager cm));

extern 
void CMrun_network ARGS((CManager cm));

int CMCondition_get ARGS((CManager CM, CMConnection dep));
int CMCondition_wait ARGS((CManager CM, int condition));
void CMCondition_signal ARGS((CManager CM, int condition));
void CMCondition_set_client_data ARGS((CManager CM, int condition,
				       void *client_data));
void *CMCondition_get_client_data ARGS((CManager CM, int condition));
int CMCondition_has_signaled ARGS((CManager CM, int condition));
int CMCondition_has_failed ARGS((CManager CM, int condition));

extern void CMget_qual_hostname ARGS((char *buf, int len));
extern int CMlisten ARGS((CManager cm));
extern int CMlisten_specific ARGS((CManager cm, attr_list listen_info));

extern void* CMrealloc ARGS((void *ptr, int size));
extern void* CMmalloc ARGS((int size));
extern void CMfree ARGS((void *ptr));


             
#ifdef	__cplusplus
}
#endif

#endif
