/* $Id: echo.h,v 1.11 2001/04/03 16:07:36 eisen Exp $ */
/* This is the include file for dataexchange */


#ifndef __ECHO__H__
#define __ECHO__H__

#include "io.h"
#include "cm.h"

#if defined(FUNCPROTO) || defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#ifndef ARGS
#define ARGS(args) args
#endif
#else
#ifndef ARGS
#define ARGS(args) (/*args*/)
#endif
#endif

/* Channel functions */

typedef struct _EControlContext *EControlContext;
typedef struct _EChannel *EChannel;
typedef struct _ECSourceHandle *ECSourceHandle;
typedef struct _ECSinkHandle *ECSinkHandle;
typedef struct _ECDataHandle *ECDataHandle;
typedef struct _ECMultiEventQueue *ECEventQueueList;
typedef struct _ECEventRec *ECEventRec;

typedef void (*ECHandlerFunction) ARGS((void *event, int length,
					void *client_data, attr_list event_attrs));

typedef void (*ECTypedHandlerFunction) ARGS((void *event, void *client_data, attr_list event_attrs));

typedef void (*ECMultiHandlerFunction) ARGS((ECEventQueueList event_queues, 
					     void *client_data));

typedef void (*ECSubscribeFunction) ARGS((int subscribe, int subscriber_count,
					  void *client_data));

typedef void (*EventFreeFunction) ARGS((void *event_data));

typedef void (*ECRequestHandlerFunction) ARGS((ECSourceHandle handle, 
					       void *client_data));

typedef struct _ECMultiSubscribeList {
    EChannel channel;
    IOFieldList field_list;
    CMFormatList subformat_list;
}ECMultiSubscribeList, *ECMultiSubscribePtr;


extern EControlContext ECho_CM_init ARGS((CManager cm));

extern EChannel
 EChannel_create ARGS((EControlContext ec));

extern EChannel
 EChannel_create_attr ARGS((EControlContext ec, attr_list attrs));

extern void
 EChannel_destroy ARGS((EChannel chan));

extern EChannel
EChannel_typed_create ARGS((EControlContext ec, IOFieldList field_list,
			    CMFormatList format_list));

extern EChannel
 EChannel_open ARGS((EControlContext ec, char *global_name));

extern EChannel
EChannel_derive ARGS((EControlContext ec, char *chan_id, char *event_filter));

extern EChannel
EChannel_create_filtered ARGS((EControlContext ec, char *chan_id,
			       char *event_filter));

extern EChannel
EChannel_typed_derive ARGS((EControlContext ec, char *chan_id, char *event_filter,
			    IOFieldList field_list, CMFormatList format_list));

extern EChannel
EChannel_create_transformed ARGS((EControlContext ec, char *chan_id, 
				  char *event_xform, IOFieldList field_list,
				  CMFormatList format_list));

extern char *
EChannel_remote_filter ARGS((EControlContext ec, char *remote_contact_list, 
			     char *src_chan_id, char *event_filter));

extern char *
EChannel_remote_transform ARGS((EControlContext ec, 
				char *remote_contact_list, 
				char *src_chan_id, char *event_filter, 
				IOFieldList field_list, 
				CMFormatList format_list));

extern char *ECglobal_id ARGS((EChannel chan));

extern void
EChannel_subscribe_handler ARGS((EChannel chan, ECSubscribeFunction func,
				 void *client_data));

extern void
ECsubmit_event ARGS((ECSourceHandle handle, void *event, int event_length));

extern void
ECsubmit_typed_event ARGS((ECSourceHandle handle, void *event));

extern void
ECrequest_event ARGS((ECSinkHandle handle, int req_try));

extern void
ECsubmit_eventV ARGS((ECSourceHandle handle, IOEncodeVector eventv));

extern void
ECsubmit_general_event ARGS((ECSourceHandle handle, void *event,
			     int event_len, EventFreeFunction free_func));

extern void
ECsubmit_general_typed_event ARGS((ECSourceHandle handle, void *event,
				   EventFreeFunction free_func));

extern void
ECsubmit_general_eventV ARGS((ECSourceHandle handle, IOEncodeVector eventV,
			      EventFreeFunction free_func));

extern ECSinkHandle
 ECsink_subscribe ARGS((EChannel chan, ECHandlerFunction func, void *client_data));

extern ECSinkHandle
 ECsink_subscribe_context ARGS((EChannel chan, ECHandlerFunction func,
				void *client_data, EControlContext ec));

extern ECSinkHandle
 ECsink_typed_subscribe ARGS((EChannel chan, IOFieldList field_list,
			      CMFormatList format_list,
			      ECTypedHandlerFunction func, void *client_data));

extern ECSinkHandle
 ECsink_multi_subscribe ARGS((ECMultiSubscribePtr sink_specs,
			      EControlContext ec,
			      ECMultiHandlerFunction func, 
			      void *client_data));

extern ECSinkHandle
 ECsink_typed_subscribe_context ARGS((EChannel chan, IOFieldList field_list,
				      CMFormatList format_list,
				      ECTypedHandlerFunction func,
				      void *client_data, EControlContext ec));

extern ECSourceHandle
 ECsource_subscribe ARGS((EChannel chan));

extern ECSourceHandle
 ECsource_typed_subscribe ARGS((EChannel chan, IOFieldList field_list,
				CMFormatList format_list));

extern ECSourceHandle
 ECPsource_subscribe ARGS((EChannel chan, 
			   ECRequestHandlerFunction func, void *client_data));

extern ECSourceHandle 
  ECPsource_typed_subscribe ARGS((EChannel chan, IOFieldList field_list, 
				  CMFormatList format_list, 
				  ECRequestHandlerFunction func, void *client_data));

extern void
ECcancel_sink_subscribe ARGS((ECSinkHandle handle));

extern void
ECcancel_source_subscribe ARGS((ECSourceHandle handle));

extern int EChas_sinks ARGS((ECSourceHandle handle));

extern IOFieldList EChannel_get_field_list ARGS((EChannel chan));
extern CMFormatList EChannel_get_format_list ARGS((EChannel chan));

extern void ECdump_typed_event_as_XML ARGS((EChannel chan, void* event));
extern void ECdump_event_as_XML ARGS((EChannel chan, void* event));

typedef struct _ECdata_struct {
    IOFieldList data_field_list;
    CMFormatList data_subformat_list;
    void *initial_value;
}ECdata_struct, *ECdata_spec;

typedef struct _ECproto *ECproto;

#ifdef __ECL__H__
extern ECproto ECproto_create ARGS((EControlContext ec, ecl_parse_context context));
#endif
extern char *ECproto_id ARGS((ECproto proto_chan));

extern EChannel 
ECproto_derive_periodic ARGS((EControlContext ec, char *proto_id, 
			      char *filter_function,
			      IOFieldList field_list, CMFormatList format_list,
			      int microsec_period));

extern EChannel 
EChannel_derive_data ARGS((EControlContext ec, char *chan_id, 
			   char *filter_function, 
			   ECdata_spec data_spec));
extern EChannel 
EChannel_typed_derive_data ARGS((EControlContext ec, char *chan_id,
				 char *filter_function,
				 IOFieldList field_list, 
				 CMFormatList format_list,
				 ECdata_spec data_spec));

extern ECDataHandle 
EChannel_data_open ARGS((EChannel channel, IOFieldList data_field_list,
			 CMFormatList data_subformat_list));
extern void 
EChannel_data_update ARGS((ECDataHandle data_handle, void *data));

extern void
EChannel_data_close ARGS((ECDataHandle handle));

extern ECEventRec
ECQget_event_rec ARGS((ECEventQueueList list, int queue_number,
		       int event_number));

extern void *
ECEvent_get_ptr ARGS((ECEventRec event_rec));

extern int
ECtake_event_buffer ARGS((EControlContext ec, void *event));

extern void
ECreturn_event_buffer ARGS((EControlContext ec, void *event));

#endif
