#ifndef __ECL__H__
#define __ECL__H__

#if defined(FUNCPROTO) || defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#ifndef ARGS
#define ARGS(args) args
#endif
#else
#ifndef ARGS
#define ARGS(args) (/*args*/)
#endif
#endif

typedef struct sm_struct *sm_ref;

typedef struct parse_struct *ecl_parse_context;

#ifndef IOOffset
typedef struct _IOField {
    char *field_name;		/* Field name */
    char *field_type;		/* Representation type desired */
    int field_size;		/* Size in bytes of representation */
    int field_offset;		/* Offset from base to put field value */
} IOField, *IOFieldList;

#define IOOffset(p_type,field) \
	((int) (((char *) (&(((p_type)0)->field))) - ((char *) 0)))
#if defined(__STDC__) || defined(__ANSI_CPP__) || defined(_MSC_VER)
#define IOstr(s) #s
#else
#define IOstr(s) "s"
#endif
#define IOArrayDecl(type, size) IOstr(type[size])
#define IOArrayDecl2(type, size, size2) IOstr(type[size][size2])
#endif

typedef struct extern_entry {
    char *extern_name;
    void *extern_value;
} ecl_extern_entry, *ecl_extern_list;

extern ecl_parse_context new_ecl_parse_context();
extern void ecl_free_parse_context ARGS((ecl_parse_context context));
extern ecl_parse_context ecl_copy_parse_context ARGS((ecl_parse_context context));
extern void ecl_assoc_externs ARGS((ecl_parse_context context,
				    ecl_extern_list externs));
extern void ecl_add_decl_to_parse_context ARGS((const char *id, sm_ref node,
						ecl_parse_context context));

extern void ecl_add_struct_type ARGS((const char *name, 
				      IOFieldList field_list, 
				      ecl_parse_context context));

extern sm_ref ecl_build_type_node ARGS((const char *name, 
					IOFieldList field_list));

extern sm_ref
ecl_build_param_node ARGS((const char *id, sm_ref typ, int param_num));

extern void
ecl_add_param ARGS((const char *id, const char *typ, int param_num,
		    ecl_parse_context context));

extern void
ecl_set_return_type ARGS((char *typ, ecl_parse_context context));

typedef struct _ecl_code_struct {
    void (*func)();
    void *code_memory_block;
    void *data;
    int static_size_required;
    void *drisc_context;
} *ecl_code;

ecl_code ecl_code_gen ARGS((char *code, ecl_parse_context context));
int ecl_code_verify ARGS((char *code, ecl_parse_context context));
extern void ecl_code_free ARGS((ecl_code code));
int ecl_parse_for_context ARGS((char *code, ecl_parse_context context));
extern ecl_parse_context ecl_copy_context ARGS((ecl_parse_context context));
typedef void (*err_out_func_t) ARGS((void *client_data, char *string));
void ecl_set_error_func ARGS((ecl_parse_context context, 
			      err_out_func_t err_func));
void ecl_dump ARGS((ecl_code code));

#endif
